	PROGRAM Q_UTL
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&Q_UTL\&
C .nf
C .x Q_UTL>Defined
C Source:Q_UTL.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 20-JUL-87
C Revision level     :1.7
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C 
C  SEC_CHAN                     COMMON USED BY GET CHANNEL NUMBER
C                               OF FILE OPENED FOR SECTION
C  
C Accesses file(s):
C  
C    SYS$DISK:QUEUE_IDS.DAT   
C                               READ/WRITE 
C .X SYS$DISK:QUEUE_IDS.DAT>READ/WRITE
C  
C    MA_Q$PROD:Q_SECTION.QUE               
C                               WRITE/CREATE
C .X MA_Q$PROD:Q_SECTION.QUE>WRITE/CREATE
C  
C Other modules referenced:
C .SK
C .X FTN_IOSTAT>Referenced
C    FTN_IOSTAT                SUBROUTINE TO FORMAT FORTRAN IOSTATUS
C
C .X SET_DEF_PROT>Referenced
C    SET_DEF_PROT              SUBROUTINE TO SET OUR DEFAULT FILE
C                              PROTECTION TO WORLD READ/WRITE.
C  
C 
C .fill
C .SK
C Description:
C .sk    
C 	This is the maintenance process for the MA queue.  This
C program performs the following:
C .list
C .le;Allows user to create the Q section file:
C MA_Q$PROD:Q_SECTION.QUE.   This is the only way in which
C the following items can be done:
C .list
C .le;Specify the maximum number of message ID's.
C .le;Allocate storage for the queue (size of the
C Q_SECTION.QUE file)
C .le;Unload an existing queue file into a new queue file.
C The global section is first deleted, if this fails, then this unlaod can not
C be acomplished as someone is still attached to the section file and
C therefore control of the section can not be guaranteed.
C .le;Define message IDs for a new queue file.
C .els
C .le;Allows users to add message ID's to the existing Queue file.
C .le;Allow the ability to request the MA_ROUTER to 
C read a new routing database.
C .els
C 
C end.doc ****************************** end.doc  
C
C REVISON HISTRY
C
C
C 7-JUL-1987  1.7 E. LAKIA
C	PROMPT FOR MESSAGE ID FILE, DEFAULT IS STILL
C MA_Q$PROD:MESSAGE_IDS.DAT
C
C 18-MAY-1987 1.6 E. LAKAI
C	The default for the message id file is now set to
c MA_Q$PROD: instead of sys$disk.
C
C 2/23/87- E. LAKIA
C	Add support to allow user to specify the queue section 
c	file to be created.
C

	INCLUDE '($SSDEF)'	! SYSTEM SERVICES DEFINITIONS
	INCLUDE '($SECDEF)'	! SECTIONS DEFINITIONS
C
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
C
	BYTE IOPT		! OPTION SELECTED BY USER
	INTEGER*4 QUE_SIZE	! NUMBER OF BLOCKS IN SECTION QUEUE FILE
				! FOR ACTUAL MESSAGES (FREE LIST SIZE)
	INTEGER*4 MAX_IDS	! MAXIMUM NUMBER OF MESSAGE IDS IN QUEUE
	INTEGER*4 IDBLKS	! NUMBER OF BLOCKS NEEDED FOR THE MESSAGE IDS
	INTEGER*4 IDC		! ACTUAL NUMBER OF IDS FOUND IN ID FILE
	INTEGER*4 QUE_SIZE_TOTAL ! TOTAL NUMBER OF BLOCKS IN SECTION QUEUE FILE
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$DGBLSC	! DELETE GLOBAL SECTION
	INTEGER*4 SYS$CRMPSC	! CREATE AND MAP GLOBAL SECTION
	INTEGER*4 SYS$UPDSECW	! UPDATE SECTION TO FILE
	INTEGER*4 SYS$WAITFR
	INTEGER*4 STATUS
	INTEGER*4 SECT_ADDR(2)	 ! CREATED SECTION VIRTUAL ADDRESS
				 ! RETURNED TO CALLER
	INTEGER*4 VIRT_ADDR(2)   ! WHERE TO START THE MAP OF SECTION
	INTEGER*4 MSGBLKS
	INTEGER*4 IOSB(2)	 ! UPDATE SECTION STATUS BLOCK
	INTEGER*2 IOSBW(4)
	EQUIVALENCE(IOSB,IOSBW)
	INTEGER*4 IOSTAT	! FORTRAN I/O STATUS
	CHARACTER*16 MSG_ID
	INTEGER*4 LIST	! LIST FILE LUN
	CHARACTER*80 QUEUE_FILE	! Queue file name 
				! (default: MA_Q$PROD:Q_SECTION.QUE)
	INTEGER*4 FILLTH	! Length of queue section file
	INTEGER*4 QUELTH	! QUENAME  LENGTH WHEN ENTERED MANUALLY
C
	RECORD/QHDDEF/QHD	! DUMMY RECORD FOR COMPUTING OFFSETS
	INTEGER*4 IOFF		! OFFSET VARIABLE
	STRUCTURE /ID_REC/
	  CHARACTER*16 MSG_ID  ! MESSAGE ID
	  INTEGER*4 MAX_COUNT  ! MAXIMUM NUMBER TO BE ALLOWED IN QUEUE
	END STRUCTURE
C
	RECORD/ID_REC/ID_REC
	INTEGER*4 SYS$TRNLNM	! LOGICAL NAME TRANSLATION SERVICE
	INCLUDE '($LNMDEF)/LIST'
	INTEGER*4 ITMLST(10)	! ITEM LIST FOR TRANSLATE LOGICAL NAME
	INTEGER*2 ITMLSTW(20)	! WORD ADDRESSABLE
	EQUIVALENCE (ITMLST(1),ITMLSTW(1))
	BYTE SECTION_NAME(255)
	INTEGER*4 INDEX
	INTEGER*4 FLAGS
	INTEGER*4 LENGTH	! LENGTH OF GLOBAL SECTION NAME
	INTEGER*4 D_DESCP(2)	! DESCRIPTOR FOR DELETEING REGION
	INTEGER*4 K
	CHARACTER*80 IDFILENAME		! Message id Keyed file name
	INTEGER*2 IDFLTH		! length of id file name entered by user
C
C FOLLOWING COMMON USED BY SECT_NEW_CHAN SUBROUTINE TO RETURN CHANNEL
C OPENED FOR THE FILE
C
	INTEGER*2 CHANNELS	! ARRAY CONTAINING CHANNEL NUMBERS FOR
	INTEGER*4 RMSERR	! RMS ERROR
	COMMON/SECT_CHAN/CHANNELS(10),RMSERR	! ALLOW UNIT NUMBERS UP TO 10
	EXTERNAL SECT_NEW_CHAN	! SECTION CHANNEL USER OPEN ROUTINE
	INTEGER*4 SET_DEF_PROT	! SET DEFAULT PROTECTION
	INTEGER*4 SEC_FLAGS	! SECTION FLAGS
	INTEGER*4 SEC_LUN	! LOGICAL UNIT FOR SECTION CHANNEL
	INTEGER*4 ID_FILE	! LUN FOR THE MESSAGE ID FILE
	DATA SEC_LUN/1/	! MUST BE IN RANGE 1 TO 10 FOR SECT_OPEN
				! SUBROUINE
	DATA ID_FILE/2/	! LUN FOR THE MESSAGE ID FILE
	DATA LIST/3/	! LUN FOR LIST FILE

C
C START BY SETTING OUR DEFAULT FILE PROTECTION TO:
C	WORLD READ/WRITE
C
	SYS_STATUS=SET_DEF_PROT('RWED','RWED',
	1	'RWED')
C
C FIND OUT WHAT THE FELLOW WANTS TO DO
C
10	CONTINUE
	TYPE *,' Q UTILITY PROGRAM, Select desired option: '
	TYPE *,'	 C= Create new queue '
	TYPE *,'	 M= Modify MESSAGE ID definitions'
	TYPE *,'	 R= Remove current in memory queue'
	TYPE *,'	 L= List MESSAGE IDS currently defined'
	TYPE *,'	 D= Dump the contents of queue into a reload file'
	type *,' '
	TYPE *,' CONTROL Z to EXIT'
c	
	WRITE (*,100)
100	FORMAT('$Enter desired option ',/,
	1	' [C,M,R,L,D]: ')
	READ(*,110,END=90000,ERR=120)IOPT
110	FORMAT(A1)
	IOPT=IOPT .AND. (.NOT. "40)	! MAKE UPPER CASE	
	IF(IOPT .EQ. 'C' .OR. IOPT .EQ. 'M' .OR.
	1	IOPT .EQ. 'L' .OR. IOPT .EQ. 'D' .OR.
	1	IOPT .EQ. 'R')GO TO 200	! IN RANGE?
C
C ENTRY ERROR
C
120	TYPE *,' DATA ENTRY ERROR, TRY AGAIN '
	TYPE *,' CONTROL Z TO EXIT'
	GO TO 10

C
C HAVE THE DESIRED FUNCTION
C
200	IF(IOPT .EQ.'C')THEN
	   TYPE *,' CREATE FUNCTION'
205	   WRITE(*,210)
210	   FORMAT('$Enter size of new queue (in 512 disk blocks): ')
	   READ(*,220,END=90200,ERR=215)QUE_SIZE
220	   FORMAT(I6)
	   IF(QUE_SIZE .GT. 3)GO TO 230
	   TYPE *,' SIZE OF QUEUE MUST BE GREATER THAN THREE'
C
215	   TYPE *,' Queue size data entry error, try again'
	   GO TO 205
C
230	   WRITE(*,240)
240	   FORMAT('$Enter maximum number of message ID''s to allow: ')
	   READ(*,220,END=90200,ERR=250)MAX_IDS
	   GO TO 280
C
250	   TYPE *,' Maximum number of message IDs data entry error'
	   TYPE *,' Try again'
	   GO TO 230
C
C	   NOW TRY TO CREATE THE NEW QUEUE FILE
C
280	   TYPE *,' Enter file specification for the queue file'
	   TYPE *,' that is to be created, the default file is: '
	   TYPE *,' MA_Q$PROD:Q_SECTION.QUE; +1'
	   TYPE *,' Enter file name: '
C
	   READ(*,285,END=90200,ERR=250)FILLTH,QUEUE_FILE(1:FILLTH)
285	   FORMAT(Q,A<FILLTH>)
	   IF(FILLTH .EQ. 0)THEN
		QUEUE_FILE='MA_Q$PROD:Q_SECTION.QUE;'
		FILLTH=24
	   ENDIF
C
	   TYPE *,' Will now create the new queue section file'
	   TYPE *,' This may take a while as all blocks must'
	   TYPE *,' be linked together and the message IDs'
	   TYPE *,' defined in the new section file'
c
C	   CALCULATE TOTAL SIZE OF THE SECTION QUEUE
C	   NOTE: The queue header must be block aligned and
c	   	 the message ids are adjacent immediately after
c		 the queue header.
C
	   IDBLKS=((MAX_IDS * MID$K_LEN)+511)/512 ! number of blocks for
						! message id list heads
	   QUE_SIZE_TOTAL= QUE_SIZE+	! NUMBER OF MESSAGE BLOCKS
	1	(QHD$K_SIZ/512)+	! SIZE OF QUEUE HEADER IN BYTES
	1	IDBLKS			! NUMBER OF MESSAGE ID BLOCKS
C
	   TYPE *,' TOTAL SIZE OF QUEUE [BLOCKS]: ',QUE_SIZE_TOTAL
	   OPEN(UNIT=SEC_LUN,NAME=QUEUE_FILE(1:FILLTH),
	1	TYPE='NEW',
	1	RECORDSIZE=128,
	1	ACCESS='DIRECT',
	1	INITIALSIZE=QUE_SIZE_TOTAL,
	1	USEROPEN=SECT_NEW_CHAN,
	1	ERR=2000)
C
	   TYPE *,' File allocated on disk, creating region'

C
C 	   CREATE THE SECTION, HAVE THE SYSTEM MAP IT WHERE
C 	   EVER IT CAN AND GET ALL REQUIRED VIRTUAL 
C 	   ADDRESS.  THIS SECTION IS PROCESS ONLY 
C
	   SEC_FLAGS= SEC$M_WRT 		! READ/WRITE ACCESS
	2	.OR.SEC$M_EXPREG	! MAP WHEREEVER POSSIBLE
C
	   VIRT_ADDR(1)=0	! LET EXEC GET MAPPING (IN P0 SPACE)
	   VIRT_ADDR(2)=0	! MUST ZERO, INCASE CALLED MORE THAN ONCE
C
	  SYS_STATUS=SYS$CRMPSC(VIRT_ADDR, ! STARTING VIRT ADDR. TO MAP SECTION
	1	SECT_ADDR,		! ACTUAL MAPPED VIRT ADDR.
	2	%VAL(3),		! ACCESS MODE (USER)
	3	%VAL(SEC_FLAGS),	! SECTION FLAGS
	4	'Q_SECTION'	! SECTION NAME
	5	, , ,			! IDENT AND RELATIVE PAGE
	6	%VAL(CHANNELS(SEC_LUN)),  ! CHANNEL FOR SECTION FILE
	7	%VAL(QUE_SIZE_TOTAL)	! SIZE OF REGION
	8	, , , )	! START MAPPING OF VBN TO REGION, PROTECT, PFC
C
	   IF(.NOT. SYS_STATUS)THEN
		TYPE *,'Unable to create region, unable to continue'
		TYPE *,'Validate status from CRMPSC system service'
		TYPE *,'call, will delete file created and display'
		TYPE *,'status on exit'
		CLOSE(UNIT=SEC_LUN,DISPOSE='DELETE')
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	   ENDIF
C
	   TYPE *,' Section created, now linking all free blocks'
	   TYPE *,' into the free list'
	   WRITE(*,290)SECT_ADDR
290	   FORMAT(' Section mapped at: ',Z8.8,1X,Z8.8)
C
C	   Calculate the start of the message blocks
c
	   MSGBLKS= (IDBLKS*512)+	! MESSAGE ID LIST HEADS
	1	    + SECT_ADDR(1)		! START OF SECTION
	1	    + QHD$K_SIZ			! ADD SIZE OF QUEUE HEADER
C
	   WRITE(*,2200)MSGBLKS
2200	   FORMAT(' MESSAGE BLOCKS START AT: ',Z8.8)
C
	   CALL THREAD_MSG_BLOCKS(%VAL(SECT_ADDR(1)),  ! QUEUE LIST HEAD
	1	%VAL(MSGBLKS),  ! AND MESSAGE BLOCKS, THREAD THEM TOGETHER
	1	QUE_SIZE,	! NUMBER OF MESSAGE BLOCKS
	1	QUE_SIZE_TOTAL)	! TOTAL SIZE OF WHOLE QUEUE
C
	  WRITE(*,320)		! find out message id keyed  file name
	  READ(*,325,END=330)IDFLTH,IDFILENAME(1:IDFLTH)  ! get name from user
330	  IF(IDFLTH .EQ. 0)THEN
		IDFLTH=23
		IDFILENAME='MA_Q$PROD:QUEUE_IDS.DAT'
	  ENDIF
C
C 	  ACTUALLY OPEN THE KEYED MESSAGE ID FILE
C
	   OPEN(UNIT=ID_FILE,
	1	NAME=IDFILENAME(1:IDFLTH),
	1	ERR=2100,
	1	TYPE='OLD',
	1	RECL=5,
	1	ORGANIZATION='INDEXED',
	1	RECORDTYPE='FIXED',
	1	KEY=(1:16:CHARACTER),
	1	FORM='UNFORMATTED',
	1	ACCESS='KEYED')
C
D	   WRITE(*,290)SECT_ADDR
D	   TYPE *,' Message blocks threaded into free list'
D    	   TYPE *,' Adding the message id list heads from id file'
c
	   CALL STORE_MIDS(%VAL(SECT_ADDR(1)+QHD$K_SIZ),  ! START OF MSG ID LHD
	1	MAX_IDS,IDC,ID_FILE)
	   IF(IDC .LE. 0)then		! did we find some id's
		TYPE *,' QUEUE BUILD ABORTED, No messages ids defined'
		CALL SYS$EXIT(%VAL(0))
	   ENDIF
c
	   TYPE *,' Build hash table'
	   IOFF=%LOC(QHD.QHD$C_HASH)-%LOC(QHD)  ! OFFSET TO HASH TABLE
	   CALL LINK_HASH(SECT_ADDR(1),			! Start of queue
	1	%VAL(SECT_ADDR(1)+IOFF),		! start of hash table
	1	%VAL(SECT_ADDR(1)+QHD$K_SIZ),		! Start of message ids
	1	IDC)					! Actual number IDs
C	
D	   WRITE(*,290)SECT_ADDR
C
	   TYPE *,' Message ids have been added to queue file'
C
C NOW FILL IN SOME INFORMATION INTO THE HEADER OF THE QUEUE
C
	   TYPE *,' Initializing the queue file header '
	   CALL FILL_HEAD(%VAL(SECT_ADDR(1)),
	1	MAX_IDS,IDC)	! SO FAR, ONLY IDS IN FILE
	   WRITE(*,290)SECT_ADDR
	   WRITE(*,2210)
2210	   FORMAT('$ Do you wish to populate ',
	1	'the queue from a queue dump [Y/N]: ')
	   READ(*,110,END=2300)IOPT
	   IF(IOPT .EQ. 'Y' .OR. IOPT .EQ. 'y')CALL LOAD_Q(SECT_ADDR)
2300	   CONTINUE
	   TYPE *,' Checkpointing the file '
C
	   CALL MARK_SHUTDOWN(%VAL(SECT_ADDR(1)))  ! MARK THE QUEUE AS SHUTDOWN
	   SYS_STATUS=SYS$UPDSECW(SECT_ADDR,VIRT_ADDR,
	1	,,%VAL(1),IOSB,,)
	   IF (.NOT. SYS_STATUS)THEN
		TYPE *,' Update section error '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	   ENDIF
	   STATUS=SYS$WAITFR(%VAL(1))
	   TYPE *,' UPDATE SECTION STATUS: ',SYS_STATUS
	   WRITE(*,2400)SECT_ADDR,VIRT_ADDR
2400	   FORMAT(' SECTION AT: ',Z8.8,1X,Z8.8,/,
	1	  ' UPDATED: ',Z8.8,1X,Z8.8)
	   TYPE *,' IOSTATUS: ',IOSBW(1)
	   TYPE *,' FUNCTION COMPLETE, QUEUE FILE: ',QUEUE_FILE(1:FILLTH)
	   TYPE *,' EXITING--- THANKS FOR QUEUEING WITH US  '
	   CALL SYS$EXIT(%VAL(SYS_STATUS))

	ELSE IF(IOPT .EQ. 'M')THEN 	! TO CREATE/MODIFY FUNCTION
C
C ALLOW THE USER TO ADD MESSAGE ID'S
C INTO OUR KEYED FILE.  THIS FILE
C IS USED FOR SIMPLY DEFINING ALL MESSAGE
C ID'S THAT ARE TO BE QUEUED FOR THIS 
C QUEUE.  BY CHANGING THE LOGICAL NAME, OTHER
C QUEUES CAN BE DEFINED IN OTHER GROUPS, ETC.
C
C
400	   CONTINUE
	   TYPE *,'	CONTROL Z RETURNS BACK TO PREVIOUS MENU FOR ANY PROMPT'
C
C NODIFY THE CURRENT MESSAGE ID KEYED FILE.  THIS DOES
C NOT EFFECT THE IN MEMORY QUEUE (THE ACTUAL QUEUE)
C
	   WRITE(*,320)		! find out message id keyed  file name
	   READ(*,325,END=430)IDFLTH,IDFILENAME(1:IDFLTH)  ! get name from user
430	   IF(IDFLTH .EQ. 0)THEN
		IDFLTH=23
		IDFILENAME='MA_Q$PROD:QUEUE_IDS.DAT'
	   ENDIF
C
C	    ACTUALLY OPEN THE KEYED MESSAGE ID FILE
C
	   OPEN(UNIT=ID_FILE,
	1	TYPE='UNKNOWN',
	1	NAME=IDFILENAME(1:IDFLTH),
	1	ERR=2100,
	1	INITIALSIZE=15,
	1	RECL=5,
	1	ORGANIZATION='INDEXED',
	1	RECORDTYPE='FIXED',
	1	KEY=(1:16:CHARACTER),
	1	FORM='UNFORMATTED',
	1	ACCESS='KEYED')

C
C	   FIND OUT MESSAGE ID
C
425	   WRITE(*,428)
428	   FORMAT('$Enter Message Id [1:16 bytes]: ')
	   READ(*,440,END=90100)MSG_ID
440	   FORMAT(A16)
C
C          SEE IF ID ALREADY EXISTS
C
	   READ(UNIT=ID_FILE,KEY=MSG_ID,IOSTAT=IOSTAT)ID_REC
C
	   IF(IOSTAT .NE. 0)THEN ! COULDN'T FIND RECORD
	       TYPE *,' Message ID: ',MSG_ID,' Does not exist'
	       WRITE(*,450)
450	       FORMAT(' Do you wish to add it [Y/N]?: ')
	       READ(*,110,END=90100)IOPT
	       IOPT=IOPT .AND. (.NOT. "40) ! USE ONLY UPPER CASE
C
C	   ADD ?
C
	   IF(IOPT .EQ. 'Y')THEN
		 ID_REC.MSG_ID=MSG_ID	! COPY SEARCH ID INTO RECORD
455		 WRITE(*,460)
460		 FORMAT('$Enter maximum number of messages for this ID: ')
		 READ(*,470,END=90100,IOSTAT=IOSTAT)ID_REC.MAX_COUNT
470		 FORMAT(I6)
		 IF(IOSTAT .NE. 0)THEN
		    TYPE *,' INVALID ENTRY, TRY AGAIN '
		    GO TO 455
		 ENDIF
C
C		 WRITE RECORD TO MESSAGE ID KEYED FILE
C
		 WRITE(ID_FILE,IOSTAT=IOSTAT)ID_REC
		 IF(IOSTAT .NE. 0) THEN
		    CALL FTN_IOSTAT
		    TYPE *,' BAD I/O STATUS WHILE ADDING THIS ID '
		    TYPE *,' STATUS: ',IOSTAT
		    CALL SYS$EXIT(%VAL(SS$_NORMAL))
		 ENDIF
	         TYPE *,' MESSAGE ID: ',MSG_ID,' ADDED SUCCESSFULLY'
		 GO TO 425
	   ELSE
		 GO TO 425
	   ENDIF ! END OF IF FOR THE YES ANSWER TO ADD NON EXISTING ID

C
C	   MESSAGE ID ALREADY EXISTS, ASK USER IF HE WANTS:
C		1) DELETE THE ID
C		2) MODIFY THE MAXIMUM NUMBER OF MESSAGES ALLOWED
C		3) LEAVE AS IS
C
	   ELSE
490		TYPE *,' MESSAGE ID EXITS, SELECT ONE OF THE FOLLOWING: '
		TYPE *,'	1) Delete the ID'
		TYPE *,'        2) Change number of messages allowed'
		TYPE *,'        3) Leave alone'
		TYPE *,'	CONTROL Z RETURNS BACK TO PREVIOUS MENU'
		WRITE(*,500)
500		FORMAT('$Enter option [1,2,3]: ')
		READ(*,110,END=90100)IOPT
		IF(IOPT .NE. '1' .AND. IOPT .NE. '2' .AND.
	1	   IOPT .NE. '3')THEN
		   TYPE *,' INVALID OPTION, TRY AGAIN '
		   GO TO 490
		ENDIF
C
C		THE LAST READ RECORD WAS THE ONE WE JUST FOUND, THREFORE
C		WE CAN MODIFY AND DO A REWRITE OF THAT RECORD OR A DELETE
C
		IF(IOPT .EQ. '1')THEN
		   DELETE(UNIT=ID_FILE,IOSTAT=IOSTAT)
		   IF(IOSTAT .NE. 0)THEN
			CALL FTN_IOSTAT
			TYPE *,' ERROR IN DELETING MESSAGE ID '
			TYPE *,' ERROR STATUS: ', IOSTAT
			CALL SYS$EXIT(%VAL(SS$_NORMAL))
		   ENDIF
		ELSE IF (IOPT .EQ. '2')THEN  ! MODIFY, THEN CAN ONLY CHANGE NUMBER
515		   WRITE(*,520)ID_REC.MAX_COUNT
520		   FORMAT(' Current maximum record count is: ',I6,/,
	1		'$Enter new maximum record count: ')
		   READ(*,470,END=90100,IOSTAT=IOSTAT)ID_REC.MAX_COUNT
		   IF(IOSTAT .NE. 0)THEN
		      TYPE *,' INVALID ENTRY, TRY AGAIN '
		      GO TO 515
		   ENDIF
C
		   REWRITE(UNIT=ID_FILE,IOSTAT=IOSTAT)ID_REC
		   IF(IOSTAT .NE. 0)THEN
			CALL FTN_IOSTAT
			TYPE *,' BAD REWRITE STATUS: ',IOSTAT
			TYPE *,' FATAL ERORR'
			CALL SYS$EXIT(%VAL(SS$_NORMAL))
		   ENDIF
		ENDIF   ! OPTION 3, LEAVE AS IS
	     ENDIF  ! END OF IF FOR RECORD EXIST OR NOT
	     GO TO 425  ! GO ALLOW USER TO SPECIFY ANOTHER MESSAGE ID

C
C DELETE THE CURRENTLY IN PLACE GLOBAL SECTION
C 
	ELSE IF (IOPT .EQ. 'R')THEN	! REMOVE THE CURRENTLY ACTIVE QUEUE
					! SECTION
C
C 	  FIRST TRANSLATE THE GLOBAL SECTION NAME
C
C
	  ITMLSTW(1)=4	! 4 BYTES FOR INDEX
	  ITMLSTW(2)=LNM$_INDEX	! GET INDEX
	  ITMLST(2)=%LOC(INDEX)
	  ITMLST(3)=0	! NOT USED
C
	  ITMLSTW(7)=255	! LENGTH OF SECTION NAME BUFFER
	  ITMLSTW(8)=LNM$_STRING	! WANT EQUIVALENCE STRING
	  ITMLST(5)=%LOC(SECTION_NAME) ! WHERE TO PUT
	  ITMLST(6)=%LOC(LENGTH)	! NOT USED
	  ITMLST(7)=0
C
C	  ITMLSTW(13)=LNM$_LENGTH	! WANT THE LENGTH
C	  ITMLSTW(14)=4			! SINGLE LONG WORD
C	  ITMLST(8)=%LOC(LENGTH)	! WHERE TO FIND
C	  ITMLST(9)=0		! NOT USED
C
C	  ITMLST(10)=0		! TERMINATOR


	  SYS_STATUS=SYS$TRNLNM(LNM$M_CASE_BLIND,
	1	'LNM$SYSTEM_TABLE',
	1	'GBL$MA_Q_NAME',,ITMLST)
C
	  IF(.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO TRANSLATE QUEUE NAME'
		TYPE *,' FOR SYMBOL: GBL$MA_Q_NAME'
		TYPE *,' MAKE SURE NAME HAS BEEN DEFINED'
		TYPE *,' FATAL ERROR, UNABLE TO DELETE GLOBAL SECTION'
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	  ELSE
		TYPE *,' WILL ATTEMPT TO DELETE GLOBAL SECTION: '
		WRITE(*,600)(SECTION_NAME(K),K=1,LENGTH)
600		FORMAT(1X,<LENGTH>A1)
		TYPE *,' If this is not the desired Global sections'
		type *,' Enter the desired global section : '
		READ(*,620,END=90100)QUELTH,(SECTION_NAME(K),K=1,QUELTH)
620		FORMAT(Q,<QUELTH>A1)
		IF(QUELTH .GT. 0)LENGTH=QUELTH  ! USE THE OVERRIDE
	  ENDIF
C
	  FLAGS=SEC$M_SYSGBL	! GLOBAL
	  D_DESCP(1)=LENGTH	! BUILD A DESCRIPTOR
	  D_DESCP(2)=%LOC(SECTION_NAME)
	  SYS_STATUS = SYS$DGBLSC (%VAL(FLAGS), 
	1		D_DESCP,)
	  IF (.NOT.SYS_STATUS) THEN
		TYPE *,' UNABLE TO DELETE QUEUE GLOBAL SECTION'
		TYPE *,' MAKE SURE NOONE IS ATTACHED TO SECTION'
		TYPE *,' AND THAT THE QUEUE CHECKPOINT PROCESS IS'
		TYPE *,' NOT RUNNING'
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	  ENDIF

C
C LIST FUNCTION
C
	ELSEIF (IOPT .EQ. 'L')THEN
C
	  WRITE(*,320)		! find out message id keyed  file name
320	  FORMAT('$Enter message id file name',
	1	' [default: MA_Q$PROD:QUEUE_IDS.DAT]:')
	  READ(*,325,END=735)IDFLTH,IDFILENAME(1:IDFLTH)  ! get name from user
325	  FORMAT(Q,A<IDFLTH>)
735	  IF(IDFLTH .EQ. 0)THEN
		IDFLTH=23
		IDFILENAME='MA_Q$PROD:QUEUE_IDS.DAT'
	  ENDIF
C
C ACTUALLY OPEN THE KEYED MESSAGE ID FILE
C
	  OPEN(UNIT=ID_FILE,
	1	NAME=IDFILENAME(1:IDFLTH),
	1	ERR=2100,
	1	TYPE='OLD',
	1	RECL=5,
	1	ORGANIZATION='INDEXED',
	1	RECORDTYPE='FIXED',
	1	KEY=(1:16:CHARACTER),
	1	FORM='UNFORMATTED',
	1	ACCESS='KEYED')
C
C		OPEN THE LIST FILE
C
	  TYPE *,' Message id list file is:  "MESSAGE_ID.LIS"'
	  OPEN(UNIT=LIST,TYPE='NEW',NAME='MESSAGE_ID.LIS')
	  WRITE(LIST,710)
710	  FORMAT('   MESSAGE            MAXIMUM',/,
	1	       '     ID                NUMBER',/)
720	  READ(UNIT=ID_FILE,END=790)ID_REC
	  WRITE(LIST,730)ID_REC.MSG_ID,ID_REC.MAX_COUNT
730	  FORMAT(1X,A16,5X,I5)
	  GO TO 720
790	  CLOSE(UNIT=LIST)
	  CLOSE(UNIT=ID_FILE)
	  CALL SYS$EXIT(%VAL(SS$_NORMAL))

C
C DUMP QUEUE TO DUMP FILE
C
	ELSEIF (IOPT .EQ. 'D')THEN
		CALL DUMP_Q
	ENDIF	  ! END OF IF FOR CREATE, MODIFY, REPLACE, LIST, DUMPQ
	GO TO 10

C
C FILE OPEN FAILURE ON MA_Q$PROD:Q_SECTION.QUE
C
2000	CONTINUE
C
C	TRANSLATE FORTRAN CODE (GET RMS STATUS)
C
	CALL FTN_IOSTAT
	TYPE *,' File open status on new Q_SECTION file'
	TYPE *,' File name: ',QUEUE_FILE(1:FILLTH)
	CALL SYS$EXIT(%VAL(RMSERR))
C
C FILE OPEN ERROR ON QUEUE_IDS.DAT
C
2100	CALL FTN_IOSTAT
	TYPE *,' File open failure on message id file:'
	TYPE *,IDFILENAME(1:IDFLTH)
	TYPE *,' EXIT '
	CALL SYS$EXIT(%VAL(SS$_NORMAL))
C
C
C END OF FILE ENTERED TO A PROMPT
C
90000	CALL SYS$EXIT(%VAL(SS$_NORMAL))
C
C END OF FILE ENTERED, CLOSE KEY FILE AND RETURN TO MAIN MENU
C
90100	CLOSE(UNIT=ID_FILE)
	GO TO 10	! BACK TO MAIN MENU
C
C RETURN TO MAIN MENU FROM THE MODIFY MENU
C
90200	GO TO 10
	END
	SUBROUTINE THREAD_MSG_BLOCKS(Q_HEAD,MSG_BLKS,COUNT,SIZE)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&THREAD_MSG_BLOCKS\&
C .nf
C .x THREAD_MSG_BLOCKS>Defined
C Source:THREAD_MSG_BLOCKS.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 4-AUG-1986 08:16:04.34
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    Q_HEAD                     STRUCTURE/QHDDEF/                                 
C                               SECTION FILE QUEUE HEADER                         
C  
C    MSG_BLKS                   STRUCTURE/QSTDEF/                                 
C                               ARRAY OF QUEUE ELEMENTS THAT ARE TO BE            
C                               TREADED INTO THE FREE LIST                        
C 
C     COUNT                     INTEGER*4
C                               NUMBER OF MESSAGE BLOCKS
C 
C     SIZE                      INTEGER*4
C                               TOTAL SIZE OF THE REGION IN BLOCKS
C 
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    MA_Q$PROD:Q_SECTION.QUE                                                         
C                               WRITE                                             
C .X MA_Q$PROD:Q_SECTION.QUE>WRITE
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine will thread all of the message blocks 
C in the region into the free list within the queue file.  The calling 
C sequence is:
C 	CALL THREAD_MSG_BLOCKS(Q_HEAD,MSG_BLKS,COUNT)
C 
C end.doc ****************************** end.doc  

	IMPLICIT NONE
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QSTDEF)/LIST'
C
	INTEGER*4 COUNT	! NUMBER MESSAGE BLOCKS
	INTEGER*4 SIZE	! TOTAL SIZE OF REGION
	INTEGER*4 I,IJ,J
C
	RECORD/QHDDEF/Q_HEAD
	RECORD/QSTDEF/MSG_BLKS(COUNT)

C
C ZERO OUT THE QUEUE HEADER FIRST
C
	DO 10 I=1,QHD$K_SIZ
	  Q_HEAD.QHDDEF_ALL(I)=0
10	CONTINUE
C
C INIT THE QUEUE HEAD TO POINT TO THE
C FIRST FREE BLOCK, SIZE OF THE QUEUE, AND NUMBER
C OF FREE BLOCKS THAT WILL BE LINKED ON THE FREE 
C LIST CHAIN.
C
D	WRITE(*,20)%LOC(Q_HEAD)
D20	FORMAT(' THREAD MESSAGE BLOCKS QUEUE HEAD START: ',Z8.8)
	Q_HEAD.QHD$L_SIZ=SIZE	! TOTAL SIZE OF THE QUEUE
	Q_HEAD.QHD$L_FREE=COUNT	! FREE LIST SIZE
	Q_HEAD.QHD$Q_FLS(1)= %LOC(MSG_BLKS(1))-
	1	%LOC(Q_HEAD.QHD$Q_FLS(1))	! FORWARD LINK TO FIRST BLOCK
	WRITE(*,30)Q_HEAD.QHD$L_SIZ,Q_HEAD.QHD$L_FREE,
	1	Q_HEAD.QHD$Q_FLS(1)
30	FORMAT(' QHD$L_SIZ: ',Z8.8,/,
	1      ' QHD$L_FREE: ',Z8.8,/,
	1      ' QHD$Q_FLS(1):  ',Z8.8)
C
C NOW THREAD ALL OF THE BLOCKS INTO THE FREE LIST,
C (FOR UNDERSTANDING THIS, SEE THE MACRO ASSEMBLER BOOK ON 
C  SELF RELATIVE QUEUES)
C
C FIRST BLOCK
C
	MSG_BLKS(1).QST$L_FLNK=512  !  NEXT BLOCK IS 512 BYTES FORWARD
	MSG_BLKS(1).QST$L_BLNK= %LOC(Q_HEAD.QHD$Q_FLS)
	1	 -%LOC(MSG_BLKS(1))  ! BLINK RELATIVE BACK TO QUEUE HEAD
C
C NOW LINK ALL BUT LAST
C
	DO I= 2,COUNT-1
C
C	  ZERO OUT THE BLOCK
C
	  DO J=1,QST$K_SIZ
		MSG_BLKS(I).QSTDEF_ALL(J)=0
	  ENDDO
C
	  MSG_BLKS(I).QST$L_FLNK= 512 ! NEXT BLOCK RELATIVE TO THIS LINK
	  MSG_BLKS(I).QST$L_BLNK= -512 ! RELATIVE BACK LINK
	  IJ= I/1000
	  IF ((IJ*1000) .EQ. I)WRITE(*,100)%LOC(MSG_BLKS(I))
100	  FORMAT(' WORKING--LINKING MESSAGE BLOCKS AT OFFSET: ',Z8)
	END DO
C
C LINK IN LAST
C
	MSG_BLKS(COUNT).QST$L_FLNK= %LOC(Q_HEAD.QHD$Q_FLS)
	1	- %LOC(MSG_BLKS(COUNT))
	MSG_BLKS(COUNT).QST$L_BLNK=-512	! RELATIVE BACKWARD
	Q_HEAD.QHD$Q_FLS(2)=%LOC(MSG_BLKS(COUNT))-
	1	%LOC(Q_HEAD.QHD$Q_FLS)
D	WRITE(*,120)Q_HEAD.QHD$Q_FLS(2)
D120	FORMAT(' QHD$Q_FLS(2): ',Z8.8)
	RETURN
	END
	SUBROUTINE FILL_HEAD(Q_HEAD,AID,IDC)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&FILL_HEAD\&
C .nf
C .x FILL_HEAD>Defined
C Source:FILL_HEAD.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 3-ARP-1987
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    Q_HEAD                     STRUCTURE/QHDDEF/                                 
C                               HEADER OF THE QUEUE SECTION                       
C  
C    AID                        INTEGER*4                                         
C                               NUMBER OF MESSAGE ID ALLOCATED                    
C  
C    IDC                        INTEGER*4                                         
C                               ACTUAL NUMBER OF IDS IN USE                       
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine allows the update of the queue section file
C header block (defined by "QHDDEF").  In particular, the following
C items are loaded by this routine:
C .list
C .le;Last updated time (quad word of current time)
C .le;Allocated number of message ids
C .le;Current number of message ids defined
C .le;Defines the lock name for controlling access to the
C queue
C .els
C 	CALLING SEQUENCE:
C 	CALL FILL_HEAD(Q_HEAD,AID,IDC)
C end.doc ****************************** end.doc  
C
C Version 1.1  3-apr-87  
c	E. lakia add support for version number.
c
C 

	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETTIM	! SYSTEM TIME
	INTEGER*4 AID,IDC	! ALLOCATED AND ACTUAL NUMBER OF IDS 
	RECORD/QHDDEF/Q_HEAD
	INTEGER*4 I	! LOOP VARIABLE
C
	WRITE(*,100)%LOC(Q_HEAD)
100	FORMAT(' FILL HEAD, Q_ HEADER ADDRESS: ',Z8.8)
	Q_HEAD.QHD$L_AID=AID ! NUMBER OF MESSAGE IDS ALLOCATED
	Q_HEAD.QHD$L_IDC=IDC   ! NUMBER IN USE
	Q_HEAD.QHD$W_VERSION=QHD$$VERSION  ! STORE VESRIONS NUMBER
	Q_HEAD.QHD$L_STAT=0	! INIT QUEUE AS OK (WILL LATER MARK AS SHUTDOWN)
C
	SYS_STATUS=SYS$GETTIM(Q_HEAD.QHD$Q_UPD)
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' INVALID GET TIME STATUS'
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C NAME OF THE ACCESS LOCK "MOD_LCK"
C
C
	Q_HEAD.CLOCK_CNT=7	! Count of change lock name
	Q_HEAD.QHD$C_CLOCK='MOD_LCK'  ! NAME OF LOCK
	RETURN
	END
	SUBROUTINE STORE_MIDS(MDH,AID,IDC,ID_FILE)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&STORE_MIDS\&
C .nf
C .x STORE_MIDS>Defined
C Source:STORE_MIDS.MOD
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 17-jul-1987
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    MDH                        STRUCTURE/MIDDEF/ ARRAY                           
C                               ARRAY OF MESSAGE ID LIST HEADS TO BE FILLED IN    
C                               BY THIS ROUTINE                                   
C  
C    AID                        INTEGER*4                                         
C                               NUMBER OF MESSAGE IDS ALLOCATED IN THE QUEUE      
C                               (CAN STORE MORE IDS THAN ALLOCATED FOR)           
C  
C     ID_FILE                   INTEGER*4
C                               Channel assigned/open on id file

C Returns:
C  
C    IDC                         INTEGER*4
C                                NUMBER OF IDS FOUND IN MESSAGE ID FILE
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    MA_Q$PROD:QUEUE_IDS.DAT                                                         
C                               READ
C .X ma_q$prod:QUEUE_IDS.DAT>READ
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine builds the message id list heads within the
C header part of the section file being currently built.  The message
C IDs that are to be added are read sequentially from the keyed file
C that contains them, ie: ma_q$prod:QUEUE_IDS.DAT.  Prior to adding each
C message id, the number allocated is checked to make sure that we
C do not exceed the allocated number.  If so, an error message 
C is printed an no additional id's are added.
C 	The calling sequence is:
C 	CALL STORE_MIDS(MDH,AID,IDC,id_file)
C end.doc ****************************** end.doc  
c
c 1.1  17-jul-1987  E. Lakia
c	 mofified to let main line open the message id file
c

	INCLUDE '($SSDEF)'	! SYSTEM SERVICES DEFINITIONS
	INTEGER*4 AID	! ALLOCATED NUMBER OF MESSAGE IDS
	INTEGER*4 IDC	! ACTUAL NUMBER FOUND
	INTEGER*4 I,J	! LOOP VARIABLE
	INTEGER*4 IOSTAT
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
C
	RECORD/MIDDEF/MDH(AID)
C
	STRUCTURE /ID_REC/
	  CHARACTER*16 MSG_ID  ! MESSAGE ID
	  INTEGER*4 MAX_COUNT  ! MAXIMUM NUMBER TO BE ALLOWED IN QUEUE
	END STRUCTURE
C
	RECORD/ID_REC/ID_REC
C
	INTEGER*4 ID_FILE	! LUN FOR THE ID_FILE

D	WRITE(*,10)%LOC(MDH)
D10	FORMAT(' STORE_MIDS, START MHD ADDRESS: ',Z8.8)
C	
C  WE WILL SIMPLY READ THE FILE IN ASCENDING ORDER
C  INSTEAD OF KEYED ORDER UNTIL WE HIT EITHER END OF
C  FILE OR ATTEMPT  TO EXCEED AID.
C
100	DO I=1,AID	! 1 MORE SO SHOULD FAULT IF MORE IDS THAN ALLOCATED
	  READ(UNIT=ID_FILE,IOSTAT=IOSTAT,END=1000)ID_REC
D	  TYPE *,' ADDING: ',ID_REC.MSG_ID,' MAX COUNT: ',ID_REC.MAX_COUNT
D	  WRITE(*,120)%LOC(MDH(I))
D120	  FORMAT(' MESSAGE ID LIST HEAD ADDRESS: ',Z8.8)
	  IF(I .GT. AID)THEN	! TOO MANY MESSAGE IDS
	     TYPE *,' TOO MANY MESSAGE IDS '
	     TYPE *,' BUILDING TERMINATED WITHOUT ADDING ALL DEFINED IDS'
	     TYPE *,' RECREATE THE QUEUE FILE WITH MORE MESSAGE IDS'
	     CALL SYS$EXIT(%VAL(SS$_NORMAL))
 	  ENDIF
C
C COPY INFORMATION INTO THE LIST HEAD FOR THIS ID
C
	    MDH(I).MID$C_MID=ID_REC.MSG_ID	! ASCII MESSAGE ID
	    MDH(I).MID$L_FLK=0			! FORWARD LINK TO FIRST 
						! MESSAGE IN QUEUE THIS ID
	    MDH(I).MID$L_BLK=0			! BACKWARD LINK TO LAST 
						! MESSAGE IN QUEUE THIS ID
	    MDH(I).MID$L_RNA=0			! READ BUT NOT ACKNOWLEGED 
						! MESSAGE
	    MDH(I).MID$L_BRNA=0			! RNA Backward pointer
	    MDH(I).MID$W_MAX=ID_REC.MAX_COUNT	! MAXIMUM NUMBER OF MESSAGES 
						! ALLOWED THIS ID
	    MDH(I).MID$W_CNT=0			! CURRENT NUMBER IN QUEUE 
						! THIS MESSAGE ID
	    MDH(I).MID$W_QSEQ=0			! CURRENT ON QUEUE 
						! SEQUNECE NUMBER
	    MDH(I).MID$L_STAT=0			! STATUS FLAG WORD 
	    MDH(I).MID$L_CPID=0			! READER'S PID 
	    MDH(I).MID$W_NVCNT=0			! NUMBER of non-volatile 
						! messages in this ids queue
	    MDH(I).MID$W_EFN=0			! READER'S EFN TO SET 
						! IF MID$W_CNT GOES NON-ZERO
	    MDH(I).MID$L_PCB=0			! READER'S PCB
	    MDH(I).MID$L_IPID=0			! READER'S INDEX PID
	    MDH(I).MID$L_HASH=0			! FORWARD HASH LINK
	    IDC=I	! SAVE ACTUAL ALLOCATED
	ENDDO
C
C ALL DONE, PAD THE REST OF THE ID'S
C
1000	DO 300 I=IDC+1,AID
	  DO 200 J=1,MID$K_LEN
		MDH(I).MIDDEF_ALL(J)=-1
200	  CONTINUE
	  MDH(I).MID$L_STAT=MID$M_DEL  ! MARK AS HAVING BEEN DELETED
300	CONTINUE
	TYPE *,' Total number of message ids: ',IDC
	CLOSE(UNIT=ID_FILE)
	RETURN
	END
	SUBROUTINE LINK_HASH(GQA,HASH_TABLE,MID,AID)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C .c ;MODULE
C .c ;^&LINK_HASH\&
C .nf
C .x LINK_HASH>Defined
C Source:LINK_HASH.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:17-FEB-1987 08:09:16.72
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    GSA                        INTEGER*4                                         
C                               GLOBAL QUEUE SECTION STARTING VIRTUAL ADDRESS     
C  
C    MID                        RECORD/MIDDEF/                                    
C                               MESSAGE ID LIST HEADS                             
C  
C    HASH_TBL                   INTEGER*4 (128)                                   
C                               HASH TABLE FROM WITHIN THE QUEUE. QHD$C_HASH      
C  
C    AID                        INTEGER*4                                         
C                               NUMBER OF MESSAGE IDS CONTAINED IN THE MESSAGE    
C                               ID HEADERS.                                       
C  
C Returns:
C  
C  
C Other modules referenced:
C  
C .X HASH>Referenced
C    HASH                       CALL TO COMPUTE THE HASH VALUE ON THE MESSAGE ID  
C .SK
C .fill
C .SK
C Description:
C .sk 
C This subroutine will fill in the hash table in the queue header and
C also chain together any message ids into the hash chain (ie; all message
C ids that generate the same hash key).  As each message id is added
C to a hash chain, the beginning link is replaced and stored in
C the hash chain link word.  Therefore, the higher in the alphabet
C the message id, the more likely it will be at the head of the
C hash chain.
C .sk
C CALLING SEQUENCE
C .SK
C .NOFILL
C 	
C 	INTEGE*4 GSA
C 	INTEGER*4 HASH_TBAL(0:127)
C 	RECORD/MIDDEF/MID(AID)
C 	INTEGER*4 AID
C C
C 	   CALL LINK_HASH(GSA,	! Start of queue
C 	1	HASH_TBL,	! start of hash table
C 	1	MID,	! Start of message ids
C 	1	AID)	! Actual number IDs
C end.doc ****************************** end.doc  

	INTEGER*4 GQA	! GLOBAL QUEUE ADDRESS
	INTEGER*4 AID	! NUMBER OF MESSAGE IDS DEFINED
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
	RECORD/MIDDEF/MID(AID)	! MID LIST HEADS
	INTEGER*4 HASH_TABLE(0:127)	! HASH KEY TABLE
	INTEGER*4 HASH	! RETURN HASH KEY FROM CHAR. VALUE
	INTEGER*4 LINK	! LINK SAVE VARIABLE
	INTEGER*4 I,K	! INDEX VARIABLES
	INTEGER*4 MAXTHREAD  ! Longest thread
	INTEGER*4 NUMNONZERO ! Number of non zero entries in hash table
	INTEGER*2 THREADCNT(0:127) ! Length of hash chain for each hash key
C

	DO K=1,AID	! Loop for number of message ids
	  I=HASH(%REF(MID(K).MID$C_MID))  ! Compute hash value for message id
	  THREADCNT(I)=THREADCNT(I)+1	     ! Save length of hash chain
	  IF(THREADCNT(I) .GT. MAXTHREAD) MAXTHREAD=THREADCNT(I) ! Save longest
	  IF(HASH_TABLE(I) .EQ. 0)THEN	! First in this hash chain?
		HASH_TABLE(I)=%LOC(MID(K))-GQA	! link this message id in then
					        ! offset from beginning of queue
	  ELSE
		LINK=HASH_TABLE(I)	! new entries are linked in front
					! of all ready linked entries
		HASH_TABLE(I)=%LOC(MID(K))-GQA	! link this message id in
		MID(K).MID$L_HASH=LINK  ! and link to the old one at the head
	  ENDIF
d	  WRITE(*,100)MID(K).MID$C_MID,HASH_TABLE(I),I
d100	  FORMAT(' Message id: ',A16,/,
d	1	 ' Hash table entry: ',Z8.8,/,
d	1	 ' Hash key value: ',Z2.2,'  (hex)')
	ENDDO
c
c now print statistics
c
200	CONTINUE
	NUMNONZERO=0
	DO K=0,127
	   IF(THREADCNT(K) .NE. 0)NUMNONZERO=NUMNONZERO+1  ! Did hash work here?
	ENDDO
C
	TYPE *,' Longest hash chain: ',MAXTHREAD
	TYPE *,' Number of non zero hash keys: ',NUMNONZERO
	RETURN
	END
	SUBROUTINE LOAD_Q(SECT_ADDR)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&LOAD_Q\&
C .nf
C .x LOAD_Q>Defined
C Source:LOAD_Q.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:23-MAR-1987 14:34:02.04
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    SECT_ADDR                  INTEGER*4 (2)                                     
C                               GLOBAL ADDRESS OF THE TEMP GLOBAL SECTION.        
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    QUEUE_DUMP.DAT                                                               
C                               READ                                              
C .X QUEUE_DUMP.DAT>READ
C  
C Other modules referenced:
C  
C .X FTN_IOSTAT>Referenced
C    FTN_IOSTAT                 PRINTS FORTRAN/RMS ERROR STATUS                   
C                                (found in library:INLAND)
C .SK
C .fill
C .SK
C Description:
C .sk    
C This subroutine is responsible for loading the queue from a
C saved dump file.  The subroutine calls the system service
C RTR_WRITE_Q which does a write as if it were the global system
C common.  This subroutines builds its own bogus expanded region
C and fakes the system service out.  
C end.doc ****************************** end.doc  

	INTEGER*4 SECT_ADDR(2)	! Section address (starting, ending V.A.)
	INTEGER*4 Q_BLOCK(2)	! P0 expanded region
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(PEXDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'
C
	RECORD/PEXDEF/PEX	! P0 expanded region
	CHARACTER*80 LOAD_FILE_NAME  ! Name of the dump file of the queue
	INTEGER*4 LOAD_FILE_NAME_LTH	! length of the load file
	INTEGER*4 LOAD_LUN
	PARAMETER (LOAD_LUN=3)	! Lun for the dump file
c
	INTEGER*4 I	! loop variable
	INTEGER*4 MAXSIZE
	PARAMETER(MAXSIZE=4096)	! LARGEST MESSAGE TO READ
C
	STRUCTURE/INPREC/
	UNION
	MAP
		BYTE INALL(MAXSIZE+HDR$K_SIZ)
	END MAP
	MAP
		CHARACTER*16 MID	! Message id
		RECORD/HDRDEF/HDR	! Message header
		BYTE MSG(MAXSIZE)	! Data portion of message
	END MAP
	END UNION
	END STRUCTURE
C
	RECORD/INPREC/INPREC
	INTEGER*4 SYS_STATUS	! Return status
	INTEGER*4 DESCP(2)	! CHARACTER TYPE DESCRIPTOR	

C
C We will do what the system service ATTACH_Q does ourselves
c and then link all the blocks in by using the router
c entry.
c The only problem is that there is no checkpoint process,
c but that is no problem as we will checkpoint the file when
c we are all done and the service will still to the function
c as desired.
c
	Q_BLOCK(1)=%LOC(PEX)	! Fake start of expanded region
	Q_BLOCK(2)=Q_BLOCK(1)+PEX$K_LEN  ! fake end of expanded region
c
	PEX.PEX$L_SREG=Q_BLOCK(1)	! starting and ending P0 region
	PEX.PEX$L_EREG=Q_BLOCK(2)
c
	PEX.PEX$Q_GSRETADR(1)=SECT_ADDR(1) ! Where Queue is mapped
	PEX.PEX$Q_GSRETADR(2)=SECT_ADDR(2)
c
	WRITE(*,100)
100	FORMAT('$Enter saved dump file: ',
	1	'[Default: ma_q$prod:QUEUE_DUMP.DAT;]:')
	READ(*,200,END=9000)LOAD_FILE_NAME_LTH,
	1	LOAD_FILE_NAME(1:LOAD_FILE_NAME_LTH)
200	FORMAT(Q,A<LOAD_FILE_NAME_LTH>)
	IF(LOAD_FILE_NAME_LTH .EQ. 0)THEN
		LOAD_FILE_NAME='MA_Q$PROD:QUEUE_DUMP.DAT;'
		LOAD_FILE_NAME_LTH=25 	! NUMBER BYTES IN DUMP FILE NAME
	ENDIF
C
	OPEN(UNIT=LOAD_LUN,
	1	NAME=LOAD_FILE_NAME(1:LOAD_FILE_NAME_LTH),
	1	ERR=9100,TYPE='OLD',
	1	FORM='UNFORMATTED')
C
C Read each record from the load file and call system service
c to put it into the queue
c
500	CONTINUE		! Loop here until file is copied
	READ(LOAD_LUN,END=800)INPREC.MID,INPREC.HDR,
	1	(INPREC.MSG(I),I=1,INPREC.HDR.HDR$W_LEN)
	TYPE *,' Populating message id: ',INPREC.MID
	DESCP(1)=INPREC.HDR.HDR$W_LEN+HDR$K_SIZ
	DESCP(2)=%LOC(INPREC.HDR)
C
C Write it to the queue
c
	SYS_STATUS=RTR_WRITE_Q(Q_BLOCK,
	1	%DESCR(INPREC.MID),
	1	DESCP,
	1	INPREC.HDR.HDR$W_LEN,
	1	INPREC.HDR.HDR$W_TYPE)
C
	IF(SYS_STATUS .NE. %LOC(QUE_NOCHK))THEN	! error?
		TYPE *,' Error while loading the queue'
		TYPE *,' WRITE_Q_RTR status: ',SYS_STATUS
		TYpe *,' EXITING '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	GO TO 500	! GO UNTIL END OF FILE
800	RETURN
C
9000	TYPE *,' No messages will be loaded into the queue'
	RETURN
9100	TYPE *,' File open error on the load file'
	CALL FTN_IOSTAT
	RETURN
	END
	SUBROUTINE DUMP_Q
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&DUMP_Q\&
C .nf
C .x DUMP_Q>Defined
C Source:DUMP_Q.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:23-MAR-1987 09:41:16.09
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    Q_SECTION.QUE                                                                
C                               READ                                              
C .X Q_SECTION.QUE>READ
C  
C    QUEUE_DUMP.DAT                                                           
C                               CREATE
C .X QUEUE_DUMP.DAT>CRATE
C  
C Other modules referenced:
C  
C .X DUMPIT>Referenced
C    DUMPIT                     CONTAINED IN THIS PROGRAM AND IS RESPONSIBLE      
C                               FOR ACTUALLY EXTRACTING THE MESSAGES FROM THE     
C                               FILE.                                             
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This program is run to unload an existing queue file.  Each
C message id is copied from the QUEUE file into a dump file (QUEUE_DUMP.DAT)
C that may reloaded into a new queue file.  The threads are verified to
C be within range prior to the unload of the each message block.  In the
C event that a thread is not valid, then the remaining messages for
C a particualr message id are discarded (this will normally only be the
C last message for that message id) and the next message id that has
C valid messages within will be emptied.
C 	Any messages that have been read but have not been acknowleged
C (ie: outstanding RNA) are also dumped to the output file.
C 	This program is run with the DCL command: "RUN DUMP_Q".
C The only input to the program is the QUEUE file name, which
C if not specified is: "Q_SECTION.QUE".
C 
C end.doc ****************************** end.doc  

C
C THE STRUCTURE OF THE QUEUE WITHIN THE DISK FILE IS:
C
C
C HEDBLKS=QHD$K_SIZ/512 blocks for the queue header,
c			(note: currently TWO allocated).
c MIDBLKS=(QHD$L_AID*MID$K_LEN)/511 rounded upward to a whole block
c		are the message id listhead blocks
C MSGBLKS= QHD$L_SIZ blocks allocated for the actual messages.
c 
C
	INCLUDE '($SSDEF)'	! SYSTEM SERVICES DEFINITIONS
C
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	RECORD/QHDDEF/QHD	! QUEUE HEADER
	INTEGER*4 QSZ		! QUEUE FILE NAME LENGTH
	CHARACTER*80 QUENAME	! NAME OF THE QUEUE FILE TO UNLOAD
	INTEGER*4 IOSTAT	! RMS OPEN STATUS
	INTEGER*4 QUELUN	! QUEUE FILE LUN
	PARAMETER(QUELUN=1)
	INTEGER*4 IDBLKADDR(2)	! RETURN ADDRESS WHERE LISTHEAD STORAGE ALLOCATED
	INTEGER*4 DUMPIT	! SUBROUTINE TO UNLOAD QUEUE (TO FAKE FORTRAN)
	INTEGER*4 I		! LOOP VARIABLE
	INTEGER*4 IDBLOCKS	! NUMBER OF BLOCKS IN MESSAGE IDS
	INTEGER*4 SYS$EXPREG	! EXPAND REGION

C
C FIRST OPEN THE QUEUE FILE
C
	WRITE(*,100)
100	FORMAT('$Enter queue filename ',	
	1	' [Default: MA_Q$PROD:Q_SECTION.QUE; ]: ')
	READ(*,200,END=210)QSZ,QUENAME(1:QSZ)
200	FORMAT(Q,A<QSZ>)
C
210	IF(QSZ .EQ. 0)THEN
	  QUENAME='Q_SECTION.QUE;'
	  QSZ=24
	ENDIF
C
	OPEN(UNIT=QUELUN,NAME=QUENAME(1:QSZ),
	1	TYPE='OLD',
	1	RECORDSIZE=128,
	1	ACCESS='DIRECT',
	1	IOSTAT=IOSTAT,
	1	READONLY,
	1	SHARED,
	1	ERR=92000)
C
C READ THE QUEUE HEADER (NOTE: we assume queue header is only two blocks)
C
	READ(QUELUN'1)(QHD.QHDDEF_ALL(I),I=1,512)
	READ(QUELUN'2)(QHD.QHDDEF_ALL(I),I=513,QHD$K_SIZ)
d	TYPE *,' Queue size: ',QHD.QHD$L_SIZ
	TYPE *,' Number of allocated message ids: ',QHD.QHD$L_AID
	TYPE *,' Number of used message ids: ',QHD.QHD$L_IDC
d	TYPE *,' Number of free blocks: ',QHD.QHD$L_FREE
	TYPE *,' Number of used blocks: ',QHD.QHD$L_SIZ-QHD.QHD$L_FREE
C
d	WRITE(*,300)QHD.QHD$Q_FLS
d300	FORMAT(' FREE LIST HEAD: ',2(1X,Z8.8))
C
C CREATE A PLACE FOR THE MESSAGE ID LISTHEADS
C
	IDBLOCKS= ((QHD.QHD$L_AID*MID$K_LEN)+511)/512
d	TYPE *,' Number of message id listhead blocks: ',IDBLOCKS
	SYS_STATUS=SYS$EXPREG(%VAL(IDBLOCKS),  ! Number of blocks
	1	IDBLKADDR,			! return address
	1	,,)				! put in P0, user access mode
c
d	WRITE(*,400)IDBLKADDR
d400	FORMAT(' List heads mapped at: ',2(1X,Z8.8))
C
C SINCE WE NOW HAVE A UNSUPPORTED FORTRAN AREA TO READ THE 
C LISTHEAD INTO, WE WILL CALL A SUBROUTINE TO FAKE FORTRAN OUT.
C
	SYS_STATUS=DUMPIT(QUELUN,
	1	QHD,
	1	%VAL(IDBLKADDR(1)),	! fake way for easy block reading
	1	%VAL(IDBLKADDR(1)),	!   "   "   "  easy record using
	1	QHD.QHD$L_AID,		! number of message ids
	1	IDBLOCKS+(QHD$K_SIZ/512)+QHD.QHD$L_SIZ) ! largest valid record 
C					    number for queue section file
c
	CLOSE(UNIT=QUELUN)
	CALL SYS$EXIT(%VAL(SYS_STATUS))

C
C EXIT/ERRORS
C
90000	CALL SYS$EXIT(%VAL(SS$_NORMAL))
92000	TYPE *,' OPEN ERROR '
	CALL FTN_IOSTAT
	CALL SYS$EXIT(%VAL(IOSTAT))
	END
	INTEGER*4 FUNCTION DUMPIT(QUELUN,QHD,MID,BLOCKS,MIDCNT,MAXREC)
	IMPLICIT NONE
C
C This subroutine will do the actual dump of the 
c contents of the message id sub queues.
c
c QUELUN= Queue file
c QHD= Queue Header
c BLOCKS= Message Id list head storage area (used for reading)
c MID= Message ID list head storage area
c MIDCNT= Number of message ids
C MAXREC= Largest (block) record number
c
	INCLUDE '($SSDEF)'	! SYSTEM SERVICES DEFINITIONS
C
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QSTDEF)/LIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 MIDCNT	! number of message ids
	RECORD/QHDDEF/QHD	! QUEUE HEADER
	RECORD/MIDDEF/MID(MIDCNT) ! Message ids
c
	INTEGER*4 BLOCKS(128,*)  ! easy way to read the blocks
	INTEGER*4 QUELUN	! queue section file lun
	INTEGER*4 I,J,K		! index variables
	RECORD/QSTDEF/BLOCK	! Message buffer in queue
	INTEGER*4 MAXREC	! largest valid record number
	INTEGER*4 BLOCK_COUNT	! number of message id blocks
	INTEGER*4 OFF_FRST_MSG	! offset from beginning of queue for
				! first message block
	INTEGER*4 FLINK		! Forward link pointer
	INTEGER*4 MFLINK	! Message blocks forward link pointer
	INTEGER*4 NEXT_DATA_OFF ! relative offset to next data block of mesg.
	INTEGER*4 NEXT_MSG_LINK ! relative offset to next mesg for the id
	INTEGER*4 FLINK_OFF	! forward offset to next mesg
	INTEGER*4 NEXT_BLOCK	! next block of a message (blocks 3-n)
	INTEGER*4 MID_LHD	! address of current message id listhead
	INTEGER*4 LAST_DATA_LINK ! list head of the data blocks threaded
				! to the first block of a message.

C
C read the message ids into our records (BLOCKS and MID
C are equivalenced due to the way the calling stack was set up).
C
	TYPE *,' Number of message ids allocated: ',MIDCNT
	TYPE *,' Largest valid record number: ',MAXREC
	K=0
	BLOCK_COUNT=((MIDCNT*MID$K_LEN)+511)/512 ! # message id blocks
	DO I=(QHD$K_SIZ/512)+1,BLOCK_COUNT+(QHD$K_SIZ/512)
d		TYPE *,' Reading record: ',I
		K=K+1
d		WRITE(*,50)%LOC(BLOCKS(1,K))
d50		FORMAT(' Buffer: ',Z8.8)
		READ(QUELUN'I)(BLOCKS(J,K),J=1,128)
	ENDDO
	CALL OPEN_DUMP
C
C Now scan the message ids to see if any message ids are
c active and if so, go get all of the data
c
	OFF_FRST_MSG= ((BLOCK_COUNT-1)*512)+QHD$K_SIZ  ! offset to start of message blocks
	OFF_FRST_MSG= (OFF_FRST_MSG/512)+1 ! Minimum block number
	WRITE(*,80)OFF_FRST_MSG
80	FORMAT(' Message blocks start at offset: ',Z8.8)
C
	DO 9000 I=1,MIDCNT
D	  TYPE *,' ID SLOT: ',I
D	  WRITE(*,90)MID(I).MID$L_STAT
D90	  FORMAT(' MID$L_STAT: ',Z8.8)
D	  IF((MID(I).MID$L_STAT .AND. MID$M_DEL) .EQ. 0 )
D	1		TYPE *,' Checking id: ',MID(I).MID$C_MID
	  IF((MID(I).MID$L_STAT .AND. MID$M_DEL) .EQ. 0 .AND. ! not deleted?
	1	MID(I).MID$W_CNT .NE. 0)THEN		! and has messages?
		TYPE *,' Found messages for: ',MID(I).MID$C_MID
		TYPE *,' Number of messages: ',MID(I).MID$W_CNT
d		TYPE *,' Number of nonvoltile: ',MID(I).MID$W_NVCNT
c
c		First see if there is a RNA message
c
		IF(MID(I).MID$L_RNA .NE. 0)THEN	! must dump RNA first
		  TYPE *,' Message id has an oustanding RNA message'
D		  WRITE(*,85)MID(I).MID$L_RNA
D85		  FORMAT(' RNA POINTER: ',Z8.8)
		  MID(I).MID$W_CNT=MID(I).MID$W_CNT-1 ! one less mesg to unload
		  FLINK_OFF=MID(I).MID$L_RNA+ ! Offset to RNA message
	1		QHD$K_SIZ+
	1		(%LOC(MID(I).MID$L_RNA)-%LOC(MID(1)))
		  FLINK=(FLINK_OFF/512)+1	! Record number
		  IF(FLINK .GT. MAXREC .OR. FLINK .LT. OFF_FRST_MSG)THEN
			TYPE *,' RNA pointer is corrupt, will skip RNA message'
			WRITE(*,87)FLINK,FLINK_OFF
87			FORMAT(' FLINK: ',Z8.8,' FLINK_OFF: ',Z8.8)
			GO TO 100
		  ENDIF
D		  WRITE(*,87)FLINK,FLINK_OFF
		  READ(QUELUN'FLINK)BLOCK ! read first block of RNA message
		  CALL BLD_MSG_FIRST(MID(I).MID$C_MID,
	1		BLOCK.QS2$C_HDR)	! Write first block of mesg.
C
		  IF(BLOCK.QS2$L_DLNK(1) .NE. 0)THEN ! subsequent data block thd.
		     NEXT_DATA_OFF=BLOCK.QS2$L_DLNK(1)+  ! calc. relative offset
	1		FLINK_OFF+			! diff. for first block
	1		(%LOC(BLOCK.QS2$L_DLNK)-%LOC(BLOCK.QS2$L_FLNK))
		     LAST_DATA_LINK=FLINK_OFF+ ! Calc. list head beginning
	1		(%LOC(BLOCK.QS2$L_DLNK)- ! so know when to end the trav.
	1		%LOC(BLOCK.QS2$L_FLNK))  ! of data blocks of the message
120		     CONTINUE	! for subsequent data blocks (blocks 3 on)
		     NEXT_BLOCK=(NEXT_DATA_OFF/512)+1 ! RECORD NUMBER
		     IF(NEXT_BLOCK .GT. MAXREC .OR. 
	1		NEXT_BLOCK .LT. OFF_FRST_MSG)THEN
			 TYPE *,' RNA thread is corrupt, will skip RNA message'
			 GO TO 100
		     ENDIF
		   READ(QUELUN'NEXT_BLOCK)BLOCK ! read data block of RNA message
		   CALL BLD_MSG_REST(BLOCK.QST$C_MSG)
		   NEXT_DATA_OFF=NEXT_DATA_OFF+BLOCK.QS2$L_FLNK ! forward link
		   IF(NEXT_DATA_OFF .NE. LAST_DATA_LINK)GO TO 120
	         ENDIF ! SUBSEQUENT DATA BLOCKS FOR RNA MESSAGE
		ENDIF	! END OF RNA TYPE MESSAGE

C
C		UNLOAD THE NON-RNA MESSAGES
C
100		CONTINUE
		MID_LHD=((I-1)*MID$K_LEN)+QHD$K_SIZ ! List head address
					! save so know when we are at end
c
c		Start reading the messages and building a buffer
c		for later reinput into the queue
c
		FLINK_OFF=MID(I).MID$L_FLK + 	! link is relative to self
	1		QHD$K_SIZ+		! add our own relative offset
	1		(%LOC(MID(I).MID$L_FLK)-%LOC(MID(1)))
c
D		WRITE(*,300)MID(I).MID$L_FLK,FLINK_OFF
D300		FORMAT(' Link to first message: ',Z8.8,/,
D	1		' relative offset: ',Z8.8)
C
C		Loop here dequeueing messages for this id
c
350		CONTINUE
		FLINK=(FLINK_OFF/512)+1	! Read the message block
D		WRITE(*,360)FLINK_OFF,FLINK
D360		FORMAT(' Reading first block of message, offset: ',Z8.8,/,
D	1	       ' Block number: ',I6)
		IF(FLINK .LT. OFF_FRST_MSG .OR. 
	1	   FLINK .GT. MAXREC)THEN
		  WRITE(*,375)MID(I).MID$C_MID,FLINK_OFF
375		  FORMAT(' Queue link error on message id: ',A16,/,
	1		' link offset: ',Z8.8,/,
	1		' Continuing with next message id, ',
	1		' remaining messages this id are lost')
		  GO TO 9000
		ENDIF
		READ(QUELUN'FLINK)BLOCK	! read first block of  message 
		LAST_DATA_LINK=FLINK_OFF+ ! Calc. list head beginning
	1		(%LOC(BLOCK.QS2$L_DLNK)- ! so know when to end the trav.
	1		%LOC(BLOCK.QS2$L_FLNK))  ! of data blocks of the message
c
D		WRITE(*,400)BLOCK.QS2$L_FLNK,
D	1		BLOCK.QS2$L_BLNK,
D	1		BLOCK.QS2$L_DLNK(1),
D	1		LAST_DATA_LINK
D400		FORMAT(' forward next message link: ',Z8.8,/,
D	1		' backward link: ',Z8.8,/,
D	1		' forward message data link: ',Z8.8,
D	1		' Listhead for the msg data blocks: ',Z8.8)
c
		CALL BLD_MSG_FIRST(MID(I).MID$C_MID,
	1		BLOCK.QS2$C_HDR)	! Write first block of mesg.
c
		NEXT_MSG_LINK=BLOCK.QS2$L_FLNK ! Save forward offset next 
						! message in this id's queue
c
c		see if there are subsequent data message blocks to be
c		dethreaded
c
		IF(BLOCK.QS2$L_DLNK(1) .NE. 0)THEN  ! have at least one
		  NEXT_DATA_OFF=BLOCK.QS2$L_DLNK(1)+FLINK_OFF+
	1	  	(%LOC(BLOCK.QS2$L_DLNK)- ! NOTE: Subsequent blocks
	1		 %LOC(BLOCK.QST$L_FLNK)) ! have only single thread.
		  NEXT_BLOCK=(NEXT_DATA_OFF/512)+1 ! Relative block number
D		  WRITE(*,600)NEXT_DATA_OFF,NEXT_BLOCK
D600		  FORMAT(' Offset to second block of message: ',z8.8,/,
D	1		 ' block number: ',I6)
		  IF(NEXT_BLOCK .LT. OFF_FRST_MSG .OR. 
	1	   NEXT_BLOCK .GT. MAXREC)THEN
		  	WRITE(*,375)MID(I).MID$C_MID,NEXT_DATA_OFF
			GO TO 9000
		  ENDIF
		  READ(QUELUN'NEXT_BLOCK)BLOCK  ! Got second block of data
		  CALL BLD_MSG_REST(BLOCK.QST$C_MSG) ! write second block
C
C		  loop here traversing the data blocks
c
1200		  CONTINUE
		  NEXT_DATA_OFF=NEXT_DATA_OFF+  ! relative offset to next
	1		BLOCK.QST$L_FLNK	  ! data block
		  IF(NEXT_DATA_OFF .NE. 	! equell to LHD in first block
	1		LAST_DATA_LINK )THEN  ! of message? if so done
		    NEXT_BLOCK=(NEXT_DATA_OFF/512)+1 ! Record number
D		    WRITE(*,1300)NEXT_DATA_OFF,NEXT_BLOCK
D1300		    FORMAT(' Block 3 on offset: ',Z8.8,
D	1		   ' Block number: ',I6)
		    IF(NEXT_BLOCK .LT. OFF_FRST_MSG .OR. 
	1	      NEXT_BLOCK .GT. MAXREC)THEN
		  	WRITE(*,375)MID(I).MID$C_MID,NEXT_DATA_OFF
			GO TO 9000
		    ENDIF
		    READ(QUELUN'NEXT_BLOCK)BLOCK
C
		    CALL BLD_MSG_REST(BLOCK.QST$C_MSG) ! write subsequent blocks
		    GO TO 1200	! go get rest of the data blocks
		  ENDIF  ! end of block dethreading for blocks 3 on of mesg.
		ENDIF    ! end of block for block 2 of a message
c
c		Get the next message for this message id
c
		MID(I).MID$W_CNT=MID(I).MID$W_CNT-1 ! Dec. number unthreaded
D		WRITE(*,1400)NEXT_MSG_LINK,MID(I).MID$W_CNT
D1400		FORMAT(' NEXT_MSG_LINK: ',Z8.8,' MID$W_CNT: ',Z4.4)
		IF(NEXT_MSG_LINK .NE. MID_LHD .AND.
	1		MID(I).MID$W_CNT .GT. 0)THEN	! got another message?
D		  TYPE *,' Getting next message in this id s thread'
D		  TYPE *,' Number remaining: ',MID(I).MID$W_CNT
		  FLINK_OFF=NEXT_MSG_LINK+FLINK_OFF 
		  GO TO 350			! Go get all of it's blocks
		ENDIF
	  ENDIF  ! end of if block for message id has something in it.
9000	CONTINUE
	DUMPIT=SS$_NORMAL
	RETURN
	END
	SUBROUTINE OPEN_DUMP
	IMPLICIT NONE
C
C This subroutine has three entries:
C	entry 1 used to open dump output file
c	entry 2 used to write the first block of the message
c		contains the header of the message
c	entry 3 used to write remaining blocks and will do
c 		the actual write to the output file
c
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QSTDEF)/LIST'
	INTEGER*4 MAXMSG	! LARGEST MESSAGE WE WILL DEQUEUE FROM QUEUE
	PARAMETER (MAXMSG=10*512) ! 
	STRUCTURE/OUTREC/
		CHARACTER*16 MID	! message id
		RECORD/HDRDEF/HDR	! Message header
		BYTE MSG(MAXMSG)	! Buffer for largest message
	END STRUCTURE
C
	STRUCTURE/HEDBLK/
	   RECORD/HDRDEF/HDR	 ! header part
	   BYTE MSG(QS2$K_MSGL)  ! Message part
	END STRUCTURE
	RECORD/HEDBLK/HEDBLK	! First block of message from queue
c
	RECORD/OUTREC/OUTREC	! Output file record
	INTEGER*4 MSGSIZE	! Size of message
	INTEGER I
	INTEGER*4 OUTMSGSIZE	! number of bytes in output buffer
	INTEGER*4 IOUT		! OUTPUT DUMP LUN
	PARAMETER (IOUT=2)
	INTEGER*4 IOSTAT	! RMS ERROR STATUS
	BYTE QSTBLK(QST$K_MSGL)
	CHARACTER*16 MID	! message id
	CHARACTER*80 DMPFILE	! dump file name
	INTEGER*2 DMPFLTH	! number bytes in dump file name

c
c open our output file
c
	WRITE(*,100)
100	FORMAT('$ Enter dump file name ',
	1	'[Default: MA$Q_PROD:QUEUE_DUMP.DAT]:')
	READ(*,110,END=150)DMPFLTH,DMPFILE(1:DMPFLTH)
110	FORMAT(Q,A<DMPFLTH>)
C
150	IF(DMPFLTH .EQ. 0)THEN
		DMPFILE='MA$Q_PROD:QUEUE_DUMP.DAT'
		DMPFLTH=26
	ENDIF
	OPEN (UNIT=IOUT,
	1	NAME=DMPFILE(1:DMPFLTH),
	1	TYPE='NEW',
	1	FORM='UNFORMATTED',
	1	ERR=90000,
	1	IOSTAT=IOSTAT)
	RETURN
C
C OPEN ERROR
C
90000	TYPE *,' Unable to open dump file, status: ',IOSTAT
	CALL SYS$EXIT(%VAL(IOSTAT))
	RETURN

	ENTRY BLD_MSG_FIRST(MID,HEDBLK)
C
C Have a new message, save the byte count from the header 
c so will know when we are done
c
	IF(HEDBLK.HDR.HDR$W_LEN .GT. MAXMSG)THEN
		TYPE *,' Too large a message found, size: ',
	1		HEDBLK.HDR.HDR$W_LEN
		TYPE *,' Largest size supported: ',MAXMSG
		CALL SYS$EXIT
	ENDIF
	MSGSIZE=HEDBLK.HDR.HDR$W_LEN ! KEEP LOCAL COPY OF MESSAGE SIZE
	OUTREC.MID=MID	! Save the message id
	OUTMSGSIZE=0	! Init our output message size 
c
	OUTREC.HDR=HEDBLK.HDR  ! Move the header to output record
D	TYPE *,' Writing id: ',OUTREC.MID
D	TYPE *,' Source node: ',OUTREC.HDR.HDR$C_SNM
D	TYPE *,' Size of message: ',OUTREC.HDR.HDR$W_LEN
c
c copy the this block to the output
c
	IF(MSGSIZE .LE. QS2$K_MSGL)THEN	! only single block in message?
	   DO I=1,MSGSIZE
		OUTREC.MSG(I)=HEDBLK.MSG(I)
	   ENDDO
	   WRITE(IOUT)OUTREC.MID,OUTREC.HDR,
	1	(OUTREC.MSG(I),I=1,OUTREC.HDR.HDR$W_LEN)
D	   TYPE *,' Record written '
	ELSE
	   DO I=1,QS2$K_MSGL
		OUTREC.MSG(I)=HEDBLK.MSG(I)
	   ENDDO
	  OUTMSGSIZE=QS2$K_MSGL
	ENDIF
	RETURN

	ENTRY BLD_MSG_REST(QSTBLK)
C
C
D	TYPE *,' BLD_MSG_REST, output size so far: ',OUTMSGSIZE
D	TYPE *,' Remaining: ',MSGSIZE-OUTMSGSIZE
	IF((MSGSIZE-OUTMSGSIZE) .GT. QST$K_MSGL)THEN  ! Is this the last block?
	  DO I=1,QST$K_MSGL			! no, then copy block
		OUTREC.MSG(OUTMSGSIZE+I)=QSTBLK(I) ! move to output record
	  ENDDO
	  OUTMSGSIZE=OUTMSGSIZE+QST$K_MSGL  ! add number moved so far
	ELSE
	  DO I=1,MSGSIZE-OUTMSGSIZE		! add last block
		OUTREC.MSG(OUTMSGSIZE+I)=QSTBLK(I) ! move to output record
	  ENDDO
	  WRITE(IOUT)OUTREC.MID,OUTREC.HDR,
	1	(OUTREC.MSG(I),I=1,OUTREC.HDR.HDR$W_LEN)
D	   TYPE *,' Record written '
	ENDIF
	RETURN
	END
	SUBROUTINE MARK_SHUTDOWN(QHD)
C
C THIS SUBROUTINE SIMPLY MARKS THE QUEUE WITH EMPTY.
C
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	RECORD/QHDDEF/QHD
	QHD.QHD$L_STAT=QHD$M_SHUTDOWN  ! MARK QUEUE AS SHUT DOWN
	RETURN
	END
