	PROGRAM		RT_WORK_ALL
	IMPLICIT        NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&ROUTE_DATABSE_MAINTANANCE\&
C .nf
C .x ROUTE_DATABSE_MAINTANANCE>Defined
C Source:ROUTE_DATABSE_MAINTANANCE.MOD
C Designer           :PHILIP D LEVIN
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 17-DEC-1986 15:08:35.26
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    MESSAGE_ID.DAT                                                               
C                               READ/WRITE/CREATE                                 
C .X MESSAGE_ID.DAT>READ/WRITE/CREATE
C  
C    NODE_DESCR.DAT                                                               
C                               READ/WRITE/CREATE                                 
C .X NODE_DESCR.DAT>READ/WRITE/CREATE
C  
C    ROUTE_DATABASE_(NODENAME).MAR                                                
C                               READ/WRITE/DELETE                                 
C .X ROUTE_DATABASE_(NODENAME).MAR>READ/WRITE/DELETE
C  
C    ROUTE_DATABASE_MASTER.DAT                                                    
C                               READ/WRITE/CREATE/DELETE                          
C .X ROUTE_DATABASE_MASTER.DAT>READ/WRITE/CREATE/DELETE
C  
C    REPORTFILE.LIS                                                               
C                               WRITE/CREATE                                      
C .X REPORTFILE.LIS>WRITE/CREATE
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C      	This program is designed to maintain the rout database for 
C the routing and queing softwarte package.  This program will be 
C responcable for node and message maintinance as we as report printing.
C The following describes the major functions that may be performed
C .ls
C .le;The first function  that is to be perfromed is to ask the user what
C he wishes to do.  Several menus will be provided to help the user along
C this path.
C .le;The first possible user function is to creat the files that will
C be used.  The user will choose a create function option.  This option 
C will set the files
C .le;the user has the option of maintaning  message ids.  His maintinance 
C options are to add a message id, delete a message id, change a node
C destination of a message id.
C .le;The user has the option of maintaning the nodes on the system.  He
C may choose to do add a node, or delete  a node.
C .le;The user has the option to print reports that can be generated out
C of the information stored in the node and message files.  He may
C generate a full databse report, a node report, or message report.
C .le;The user has the option of building a new database for the node.
C He enters the node name and the program generates the database for him
C .els
C end.doc ****************************** end.doc  
C
C   DECLERATIONS
C
C   THIS IS THE DEFINITION OF THE MESSAGE ID RECORD
C
	STRUCTURE/MESSAGE_ID/
 	  UNION
	    MAP
              CHARACTER*16    MES_C_MESSAGE_ID ! MESSAGE ID  PRIMARY KEY
	      CHARACTER*6     MES_C_PRIM_NODE  ! PRIMARY NODE IT CALLS
	      CHARACTER*6     MES_C_PATH_NODE(6) ! THE PATH MESSAGE TAKES
	      INTEGER*4       MES_I_MESSAGE_SIZE
	           				 ! MESSAGE SIZE
	      INTEGER*4       MES_I_BITTARRAY(0:31)
						 ! THE BIT ARRAY CONTAINING 
			               		 ! THE NODE NUMBERS A MESSAGE
	    END MAP
	    MAP
	      CHARACTER*16    TABLE_KEY
	      CHARACTER*10    FILLER
	      INTEGER*4       BIT_POS_TABLE(0:31)  ! THE TABLE OF OPEN BITS
	    END MAP
	  END UNION

	END STRUCTURE

	RECORD/MESSAGE_ID/ ID_REC
C
C    THIS IS THE DEFINITION OF THE NODE DESCRIPTION RECORD
C
	STRUCTURE/NODE_DESCRIPTION/
	CHARACTER*6	NODE_C_PRIME_NAME ! PRIMARY NAME   PRIME KEY
	CHARACTER*6	NODE_C_SEC_NAME   ! WHERE MESSAGE IS ROUTED 
					  ! IF RPIMARY FAILS
	CHARACTER*80    NODE_C_DESCRIPTION! TEXT DESCRIPTION OF NODE
	CHARACTER*3	NODE_C_TYPE       ! RSX,VMS,OTHER
	INTEGER*4       NODE_I_MESS_ACCESSED
					  ! NUMBER OF MESSAGES THIS
					  ! NODE TRIES TO TALK TO
	INTEGER*4       NODE_I_LARGEST_MESS
					  ! THE LARGEST POSSIBLE OUTGOING
					  ! MESSAGE THAT IS USED
	INTEGER*4	NODE_I_INPSZ	  ! LARGEST POSIBLE INCOMING
					  ! MESSAGE SIZE
	INTEGER*4	NODE_I_BIT_NUM    ! THE BIT NUMBER IN THE ARRAY
					  ! IS THE SECONDARY INDEX KEY
	END STRUCTURE

	RECORD/NODE_DESCRIPTION/ ND_REC
C
C    THIS IS THE DECRIPTION OF THE ROUTE_DATABASE_MASTER RECORD
C


	STRUCTURE/MASTER_RECORD/

	INTEGER*4	MASTER_I_P_KEY	! A PRIMARY KEY THAT IS ONLY
					! TO SET UP THE FILE
	CHARACTER*6     MASTER_C_NODE_NAME
					! THE NODE NAME OF THE RECORD
					! WE ARE SEARCHING FOR
	CHARACTER*16	MASTER_C_MESS_ID! THE MESSAGE ID OF THE 
					! ASSOCIATED RECORD
	END STRUCTURE

	RECORD/MASTER_RECORD/MAST_REC
C
C    THIS IS A DESCRIPTION OF THE ROUTE_DATABASE_(NODENMAE).MAR FILE
C
	CHARACTER*30 	RTN_C_OUTLINE 	  ! A LINE OF INFORMATION 
					  ! TO BE PLACED IN THE FILE
C
C    THIS IS THE OUTPUT RECORD FORMAT
C
	STRUCTURE/OUT_LINE/
	CHARACTER*1    CARCONTROL
	CHARACTER*80   OUTPUTTEXT
	END STRUCTURE

	RECORD/OUT_LINE/ OUT_LINE_REC


C
C    REPORT LINE STRUTURE
C
	STRUCTURE/REP_L/
	CHARACTER*16  MES_ID
	CHARACTER*6   NODE_NAME
	INTEGER*4     MES_LENGTH
	CHARACTER*1   SEND_NODE(1024)
	END STRUCTURE
C
	RECORD/REP_L/R_REC

C    PROCESS VARIABLES
C
	INTEGER*4  IOSTATUS
	LOGICAL*1  EOFILE     ! DUMMY VARIABLE UISED FOR LOOPING
	LOGICAL*1  SEC_PASS   ! MARKER FOR PRINTING DATABASE

C    FILE NAME VARIABLES
C
C
	STRUCTURE/FILE_NEW/
	UNION
	  MAP
	    CHARACTER*15  NAME_PRE	! PREFIX FOR FILE NAME
	    CHARACTER*6   BLD_C_NODE	! FILE THAT IS TO BE BUILT
	    CHARACTER*4   NAME_SUFIX	! SUFIX FOR FILE NAME
	  END MAP
	  MAP
	    CHARACTER*25  FILE_NAME	! FULL FILE SPECIFICATION
	  END MAP
	END UNION
	END STRUCTURE

	RECORD/FILE_NEW/FN

	INTEGER*4    MAX_OUT_SIZE	! THE LARGEST OUTGOING MESSAGE
	INTEGER*4    MAX_OUT_COUNT	! THE NUMBER OF OUTGOING MESS
	INTEGER*4    MAX_RESPONCE	! THE LARGES RESPONCE BUFFER
	CHARACTER*6  PREV_NAME		! NAME OF PERVIOUS NODE
	CHARACTER*6  SAVE_NAME		! NAME OF PREVIOUS NODE
	CHARACTER*6  SAVE_SECOND	! THE ECONDARY NODE NAME
	LOGICAL*1    GOODTYPE		! VARIABLE USED TO CHECK TYPE INPUT
	INTEGER*2    IDENT_DAY		! DAY FOR MAKING IDENT
	INTEGER*2    IDENT_MONTH	! MONTH FOR MAKING IDENT
	INTEGER*2    IDENT_YEAR		! YEAR FOR MAKING IDEENT



C    TASK PROCESSING VARIABLES
C
	CHARACTER*1  C_CHECK		! MENU VARIABLE
	CHARACTER*1  CHAR_DO		! MENU VARIABLE
	INTEGER*4    C_DO		! MENU VARIABLE
	CHARACTER*4  C_MESSAGE_SIZE	! MESSAGE SIZE AS CHARACTER
	INTEGER*4    FB_COUNTER		! COUNTER FOR BIT SETTING
	INTEGER*4    FB_INDEX		! THE INDEX FOR BIT
	INTEGER*4    FB_OFFSET		! THE BIT OFFSET
	INTEGER*4    FB_LOOP		! THE 
	CHARACTER*1  FB_NULL(16)	! THE NULL KEY FOR MESSASGE
	CHARACTER*16 FB_NULL_KEY	! THE NULL KEY FOR MESSAGE
	EQUIVALENCE  (FB_NULL_KEY,FB_NULL)
	LOGICAL*1    FB_FOUND		! INDACTES BIT TEST
	INTEGER*4    IHOLD_M_S          ! HOLD THE MESSAGE SIZE TO CHECK
	CHARACTER*4  CHOLD_M_S 		! HOLD MESSAGE SIZE AS CHARACTER
	LOGICAL*1    P_FILE             ! LOGICAL TO TELL IF NODE NAME 
					! CHANGED
	CHARACTER*6  SAVE_PRIME		! HOLD NAME IN ADD
	CHARACTER*16 HOLD_M_N 		! MHOLD THE MESSAGE NAME
	CHARACTER*6  NEW_SECOND		! THE NEW SECOND NAME
	CHARACTER*3  HOLD_TYPE		! THE OLD TYPE
	CHARACTER*3  NODE_TYPE		! TELLS IF VMS OR RSX
	INTEGER*4    P_SIZE
	INTEGER*4    POSITION		! THE POSITION IN THE ARRAY


C
C    REPORT PRINTING VARIABLES
	
	INTEGER*4   SYS_STATUS	! STATUS OF GET TIME
	INTEGER*4    SYS$EXIT	! SYSTEM EXIT
	INTEGER*4    SYS$ASCTIM	! SYSTEM SERVICE TO ACCESS TIME
	CHARACTER*23 VAX_TIME	! 
	BYTE	     TAB
	DATA	     TAB/'09'X/
	INTEGER*4    PAGE
	INTEGER*4    L_COUNT
	INTEGER*4    C_INX
	CHARACTER*16 MES_OUT(4)
	CHARACTER*6  NODE_OUT(10)
	INTEGER*4    I         ! A COUNTER
	INTEGER*4    MESSAGE_NUMBER     ! A INDEX FOR DIRECT ACCES READ
	INTEGER*4    MAX_NODES 		! NUMBER OF NODES USED
	INTEGER*4    P_OFFSET		! AN INDEX FOR ARAYS
	INTEGER*4    TRUE_OFFSET 	! AN INDEX FOR R_REC
	INTEGER*4    MESSAGE_COUNT    ! MESSAGES THAT HAVE BEEN PRINTED
	INTEGER*4    J			! AN INNDEX
	INTEGER*4    SEND_INX		! INDEX TO TRACK THE POSITION YOUR IN
	LOGICAL*1    GOT_ONE		! INDECATES RECORD HAS NEADED NODE
	INTEGER*4    TOTAL_MESSAGES     ! THE NUMBER OF MESSAGES IN THE
					! DIRECT ACCESS FILE
	LOGICAL*1    FIRST_TIME         ! A SWITCH FOR THE MESSAGE REPORT
					! PRINTING
	CHARACTER*20 MSG_F		! HOLD A NAME FOR REPORT

C    ARRAYS
C
	CHARACTER*6  PRINT_POSITION(12) ! LINE TO BE OUTPUTED
	CHARACTER*6  NODE_NAMES(1024)	! A LIST OF THE NODE NAMES
	INTEGER*4    NODE_NUMBERS(1024)    ! A TABLE THAT EQUATES NAMES TO
					! BIT POSITIONS
	INTEGER*4    BLOCK_NUMBER(0:86)	! HOLDS THE INDEXES FOR DIRECT
					! READING OF RECORDS
	CHARACTER*1  NODE_NAME_ARAY(6,1024)
					! NAMES FOR PRINTIUN REPORT
	CHARACTER*6 NODE_NAME_H         ! THE INCOMING NODE NAME
	CHARACTER*1  NODE_NAME_P(6)     ! A CHARACTER ARAY OF THE NODE NAME
	EQUIVALENCE (NODE_NAME_H,NODE_NAME_P)

	INTEGER*4    COUNTER		! THE NUMBER OF LEGAL OPTIONS
	PARAMETER(COUNTER=3)		! NUMBER OF OPTIONS
	CHARACTER*3  OPTIONS(3)		! TYPE OF NODES
	DATA (OPTIONS(I),I=1,COUNTER)/'VMS','RSX','OTR'/	

C    INCLUDE FILES AND NEEDED STORAGE FOR SCREEN PROCESSING
C
	INCLUDE      'FDVDEF'
	INTEGER*4    WORKSPACE(3)	! GENERAL WORKSPACE
	INTEGER*4    TCA(3)		! TERMINAL CONTROLE AREA
	INTEGER*4    MES_STATUS         ! STATUS OF FORMS SERVICE
C
	CHARACTER*1  C_CHOISE_MENU	! CHOISE FOR MENU
	INTEGER*4    I_CHOISE_MENU      ! CHOISE FOR MENU 
					! AS INTEGER 
	INTEGER*4    TERMINATOR		! I DONT KNOW IF I NEED YET     

C     THIS IS USED TO GENERAT THE NULL KEY
	
	DO 10 FB_LOOP=1,16
	  FB_NULL(FB_LOOP)=CHAR('0'X)
10      CONTINUE

C    THIS IS USED TO SET UP THE DUMMY VARIABLER

	EOFILE = .FALSE.
	
C    This module is used to set up the form driver routines.
c
	CALL FDV$ATERM(%DESCR(TCA),12,7)! ATACH TO TERMINAL
	CALL STATUS_CHECKER
	CALL FDV$AWKSP(%DESCR(WORKSPACE),500)
	CALL STATUS_CHECKER
	CALL FDV$LOPEN('SUBSET',8)
	CALL STATUS_CHECKER
	
C    This module will be used to determine which function the user
C    wishes to perform.  Simple the module will display the two 
C    top levels of menus and direct the program to the individual 
C    sections of code that perform the task.  Each individual task
C    will have the ability to repeat itself.  Once the user ends the
C    task the program will bring you back to the menu you were in.
C
C    MAIN MENUE

1000	CALL FDV$CDISP('MAIN')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
1001	CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'MAIN_OPTION')
	READ (C_CHOISE_MENU,'(I1)') I_CHOISE_MENU
	IF (I_CHOISE_MENU .LT. 1 .OR. I_CHOISE_MENU .GT. 5) THEN
	  CALL FDV$PUTL('VALUE OUT OF RANGE, REENTER')	
          GOTO 1001
	ENDIF
	GOTO(2000,1025,4000,5000,9999) I_CHOISE_MENU

C    THIS IS THE MENU FOR EDITTING AND THE BRANCHING ASSOCIATED WITH IT
C    3000 = NODE 3500 = MESSAGE 1000 = EXIT TO PREVIOUS MENU

1025	CALL FDV$CDISP('EDITTING')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
1026	CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'EDIT_CHOISE')
	READ (C_CHOISE_MENU,'(I1)') I_CHOISE_MENU
	IF (I_CHOISE_MENU .LT. 1 .OR. I_CHOISE_MENU .GT. 3) THEN
	  CALL FDV$PUTL('VALUE OUT OF RANGE, REENTER')	
          GOTO 1026
	ENDIF
	GOTO(3000,3500,1000) I_CHOISE_MENU

C    This  module will be used to create the initial files used 
C    in this process
C
2000	CALL FDV$CDISP('CREATING')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
2001	CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'CREATION_OPTION')
	READ (C_CHOISE_MENU,'(I1)') I_CHOISE_MENU
	IF (I_CHOISE_MENU .LT. 1 .OR. I_CHOISE_MENU .GT. 2) THEN
	  CALL FDV$PUTL('VALUE OUT OF RANGE, REENTER')	
          GOTO 2001
	ENDIF
	IF (I_CHOISE_MENU .EQ. 1) THEN

C    OPEN THE MESSAGE ID FILE FOR THE FIRST TIME CREATE IT

 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='NEW',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9901,IOSTAT=IOSTATUS)


C    PLACE THE FIRST RECRD IN IT WITH A NULL MESSAGE ID
C    SET ALL THE BITS IN THE BIT ARRAY TO ZERO
 
	DO 2100 FB_INDEX=0,32    ! 32 BITS AT A TIME
	  ID_REC.BIT_POS_TABLE(FB_INDEX) = '00000000'X
2100	CONTINUE

	ID_REC.TABLE_KEY = FB_NULL_KEY	
	WRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9905)ID_REC 

C    CLOSE THE FILE

	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)

C    OPEN THE NODE DESCRIPTION FILE  CREATE IT

 
	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='NEW',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9903,
     4    IOSTAT=IOSTATUS)

C    CLOSE THE FILE

	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	ENDIF  ! IF CHOICE WAS ONE
	GOTO 1000

C    THIS MODULE IS THE MENU FOR NODE EDITTING AND TRANSFER OF CONTROLE

3000	CALL FDV$CDISP('NODE_EDIT')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
3001	CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'NODE_CHOISE')
	READ (C_CHOISE_MENU,'(I1)') I_CHOISE_MENU
	IF (I_CHOISE_MENU .LT. 1 .OR. I_CHOISE_MENU .GT. 4) THEN
	  CALL FDV$PUTL('VALUE OUT OF RANGE, REENTER')	
          GOTO 3001
	ENDIF
	GOTO(3100,3300,3400,1025) I_CHOISE_MENU


C    This module is used to add a node to the router database.
C    The node name isadded to the list and we place any messages 
C    in it.  We also update the NODE_DESCR.DAT file.  This update 
C    will be performed by questions asked of the user. The user must 
C    enter the node name first. He will  be prompted  to enter a 
C    secondary node name. He must also enter a node description,node 
C    type and node address.

C    OPEN THE FILES FOR USE

3100 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9911,IOSTAT=IOSTATUS)

	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9903,
     4    IOSTAT=IOSTATUS)

C    DISPLAY THE SCREEN

	CALL FDV$CDISP('ADD_NODE')
	CALL STATUS_CHECKER

C    GET THE NODE NAME AND CHECK TO SEE IF IT EXISTS

3110	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,
     1               TERMINATOR,'NODE_C_PRIME_NAME')

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=3120)ND_REC
	CALL FDV$PUTD('NODE_C_PRIME_NAME')
	CALL FDV$PUTL('THIS NODE ALREADY EXISTS ENTER AGAIN')
	GO TO 3110

C    SAVE THE NEW NODE NAME
C    CHECK TO SEE IF ASECONDARY NODE EXIST AND TO SEE IF ITS VALID

3120	SAVE_NAME=ND_REC.NODE_C_PRIME_NAME   
	GOTO 3117

3115    CALL FDV$PUTL('THIS NODE DOESN''T EXIST ENTER IT FIRST')
	CALL FDV$PUTD('NODE_C_SEC_NAME')

3117	CALL FDV$GET(ND_REC.NODE_C_SEC_NAME,
     1		     TERMINATOR,'NODE_C_SEC_NAME')

	IF (ND_REC.NODE_C_SEC_NAME.EQ.'      ')THEN
	  GOTO 3118
	END IF  ! = EMPTY

	ND_REC.NODE_C_PRIME_NAME=ND_REC.NODE_C_SEC_NAME

C    SAVE THE SECOND NODE NAME TO PUT INTO REC AFTER READ

	SAVE_SECOND=ND_REC.NODE_C_SEC_NAME

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=3115)ND_REC

C    PUT BACK THE SECOND NODE NAME

	ND_REC.NODE_C_SEC_NAME=SAVE_SECOND

C    PUT BACK THE NEW PRIMARY NODE NAME

3118 	ND_REC.NODE_C_PRIME_NAME=SAVE_NAME


C    GET THE REST OF THE NODE INFORMATION

	GOODTYPE=.FALSE.
3119	CALL FDV$PUTD('NODE_C_TYPE')
	CALL FDV$GET(ND_REC.NODE_C_TYPE,
     1  	     TERMINATOR,'NODE_C_TYPE')
	DO I=1,COUNTER
	  IF (ND_REC.NODE_C_TYPE.EQ.OPTIONS(I))THEN
	    GOODTYPE=.TRUE.
	  END IF
	END DO

	IF (.NOT. GOODTYPE)THEN
	  CALL FDV$PUTL('NODE TYPE INVALID    RENTER')
	  GOTO 3119
	END IF

 	CALL FDV$GET(ND_REC.NODE_C_DESCRIPTION,
     1		     TERMINATOR,'NODE_C_DESCRIPTION')

C    GIVE A CHANCE TO EXIT

	C_CHECK=' '
	CALL FDV$DISP('DO_IT')
	CALL FDV$GET(C_CHECK,TERMINATOR,'C_CHECK')
	IF (C_CHECK .NE. 'Y' .AND. C_CHECK .NE. 'y')THEN
	  GOTO 3130
	ENDIF

C    FIND A EMPTY BIT ARRAY POSSITION AND ASSIGN IT TO THE NODE
	ID_REC.TABLE_KEY=FB_NULL_KEY
	READ(UNIT=1,KEY=ID_REC.TABLE_KEY,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=9907)ID_REC

	FB_LOOP = 0
	FB_FOUND = .TRUE.
	DO WHILE ( FB_FOUND)
	FB_LOOP = FB_LOOP +1      ! SET UP A COUNTER WILL BE BIT NUMBER
	FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK
	FB_FOUND = BJTEST(ID_REC.BIT_POS_TABLE(FB_INDEX),FB_OFFSET)
	ENDDO

C    THE FIRST EMPTY BIT IS AT THE ARRAYS FB_INDEX AND FB_OFFSET
C    SET THE BIT TO 1 AND ENTER THE FB_LOOP NUMBER IN THE BIT_POSITION
C    FEILD IN THE ND_REC



	ID_REC.BIT_POS_TABLE(FB_INDEX) = JIBSET
     1    (ID_REC.BIT_POS_TABLE(FB_INDEX),FB_OFFSET)

	REWRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9908)ID_REC

C    FILL IN THE REST OF THE INFORMATION

	ND_REC.NODE_I_BIT_NUM = FB_LOOP   ! TELL IT ITS BIT POSITION


	ND_REC.NODE_I_MESS_ACCESSED = 0   ! NUM OF IDS RECIEVED
	ND_REC.NODE_I_LARGEST_MESS  = 0   ! LARGEST OUTGOING ID
	ND_REC.NODE_I_INPSZ         = 0   ! LARGEST INCOMING ID


C    WRITE THE RECORD OUT TO THE FIELD BY THE PRIME KEY NODE NAME


	WRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9906)ND_REC

C    CLOSE THE FILES

3130	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)

C    GO BACK TO CALLING MENU

	GOTO 3000

C    This module is used to delete a node from the router database.
C    The list of message IDs associated with 
C    that node must be updated.  We must also delete the node and 
C    description from the NODE_DESCR.DAT file.  The only input into 
C    this module is the node name to be deleted.  This comes from the 
C    user.
C

C    OPEN THE FILES FOR USE

3300 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9911,IOSTAT=IOSTATUS)

	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9903,
     4    IOSTAT=IOSTATUS)

3301	CALL FDV$CDISP('DELETE_NODE')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,
     1               TERMINATOR,'DNODE_C_PRIME_NAME')

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=3340)ND_REC

C    GIVE A CHANCE TO EXIT

	C_CHECK=' '
	CALL FDV$DISP('DO_IT')
	CALL FDV$GET(C_CHECK,TERMINATOR,'C_CHECK')
	IF (C_CHECK .NE. 'Y' .AND. C_CHECK .NE. 'y')THEN
	  GOTO 3350
	ENDIF


C   SEQUETIALY READ THE MESSAGE ID FILE FIND THE MESSAGES THAT USE THIS NODE

	DO WHILE (.NOT. EOFILE)
	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9909,END=3320)ID_REC
   	IF (ID_REC.MES_C_PRIM_NODE.EQ.ND_REC.NODE_C_PRIME_NAME)THEN
	  CALL FDV$PUTL
     1	    ('THIS NODE CAN NOT BE DELETED IT''S A TARGET NODE')
	  GOTO 3350
	END IF
C
C    CHECK TO SEE IF THE NODE IS PART OF A PATH DON'T DELETE IF IT IS
C
	DO I=1,6
	  IF (ID_REC.MES_C_PATH_NODE(I).EQ.ND_REC.NODE_C_PRIME_NAME)THEN
	    CALL FDV$PUTL
     1	    ('THIS NODE CAN NOT BE DELETED IT''S A PATH NODE')
	    GOTO 3350
	  END IF
 	END DO    ! 1 TO 6

	ENDDO     ! NOT EOFILE


C   CLEAR THE BIT POSITION IN THE NULL RECORD

	ID_REC.TABLE_KEY=FB_NULL_KEY
	READ(UNIT=1,KEY=ID_REC.TABLE_KEY,KEYID=0,
     1	IOSTAT=IOSTATUS,ERR=9909)ID_REC

	ID_REC.BIT_POS_TABLE(FB_INDEX)=JIBCLR
     1     (ID_REC.BIT_POS_TABLE(FB_INDEX),FB_OFFSET)

	REWRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9910)ID_REC

C   CLEAR THE BIT POSITION IN THE MESSAGE IDS

3320	FB_LOOP = ND_REC.NODE_I_BIT_NUM
	FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK

        DO WHILE (.NOT. EOFILE)
	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9909,END=3330)ID_REC

	ID_REC.MES_I_BITTARRAY(FB_INDEX)=JIBCLR
     1     (ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)

	REWRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9910)ID_REC
	END DO ! LOOP THROUGH FILE SEQUENTIALY

3330	DELETE (UNIT=2,IOSTAT=IOSTATUS,ERR=9908)
	CALL FDV$PUTL('NODE DELETED')
	CALL LIB$WAIT(5.)
	
	GOTO 3350

C    IF THE NODE DOESNT EXIST TELL THE USER

3340    CALL FDV$PUTL('NODE DOESN''T EXIST')
	CALL LIB$WAIT(5.)


C    CLOSE THE FILES

3350	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)

C    GO BACK TO CALLING MENU

	GOTO 3000 

C    THIS IS USEDTO EDIT NODE INFORMATION ALL FEILDS MAY BE CHANGED AS 
C    LONG AS THE NODE NAME STAYS UNIQUE.  THE RULES FOR ALL OTHER FEILDS
C    MUST BE MAINTAINED.  

3400 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9911,IOSTAT=IOSTATUS)

	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9903,
     4    IOSTAT=IOSTATUS)

C    DISPLAY THE SCREEN

	CALL FDV$CDISP('EDIT_NODE_I')
	CALL STATUS_CHECKER
	CALL FDV$PUT ('ENTER  NAME  TO  EDIT','EN_MESSAGE')


C    GET THE NODE NAME AND CHECK TO SEE IF IT EXISTS

3410	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,
     1               TERMINATOR,'EN_C_PRIME_NAME')

	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'QUIT')THEN
	  GOTO 3490
	END IF

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,      
     1	  ERR=3409)ND_REC
	SAVE_NAME=ND_REC.NODE_C_PRIME_NAME
	GOTO 3417

C    NO RECORD HAVE THE PERSON REENTER

3409	CALL FDV$PUTL('THERE  ARE NO NODE NAMED THIS REENTER')
	GOTO 3410

C    GET THE NEW NODE NAME IF IT IS THE SAME SKIP TO SECONDARY
C    NODE NAME ROUTINE.  IF NOT SET PROCESS FLAG FOR CHANGE THE
C    MESSAGE ID FILE.

3417	CALL FDV$PUT('ENTER NEW INFORMATION','EN_MESSAGE')
	CALL FDV$PUT(ND_REC.NODE_C_PRIME_NAME,'EN_C_PRIME_NAME')
	CALL FDV$PUT(ND_REC.NODE_C_SEC_NAME,'EN_C_SEC_NAME')
	CALL FDV$PUT(ND_REC.NODE_C_TYPE,'EN_C_TYPE')
	CALL FDV$PUT(ND_REC.NODE_C_DESCRIPTION,'NODE_C_DESCRIPTION')
	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,
     1               TERMINATOR,'EN_C_PRIME_NAME')

	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'QUIT')THEN
	  GOTO 3490
	END IF

	IF (ND_REC.NODE_C_PRIME_NAME.EQ.SAVE_NAME)THEN
	  P_FILE=.FALSE.
	  GOTO 3440
	ELSE
	  P_FILE=.TRUE.
	  READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     2    IOSTAT=IOSTATUS,
     1	  ERR=3440)ND_REC

C    AFTER READING THE NEW NODE NAME 
C    IF ERR YOU HAVE THE NEW NAME IN PLACE AND IT OK
C    IF YOU READ THE RECORD IT ALLREADY EXIST AND YOU DONT WANT TO
C    RENAME TO THIS.  YOU HAVE CHANGED THE INFORMATION SO GO BACK AND
C    READ THE ORIGINAL RECORD. 

	  CALL FDV$PUTL('THIS RECORD EXISTS REENTER OR QUIT')
	  P_FILE=.FALSE.
	  ND_REC.NODE_C_PRIME_NAME=SAVE_NAME ! FOR THE ORIGINAL ONE
	  READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     2    IOSTAT=IOSTATUS,
     1	  ERR=9937)ND_REC
	  GO TO 3417
	ENDIF

C    SAVE THE PRIME NODE NAME AND THE SECONDARY NODE NAME
C    GET THE NEW SECONDARY NODE NAME.  IF THE OLD AND NEW ARE
C    EQUIL SKIP TO THE NEXT STEP.  IF NOT READ THE FILE TO MAKE SHURE
C    THE NODE IS ON THE SYSTEM.  PUT BACK THE ORIGINAL RECORD THEN
C    PUT THE NEW NAME IN THE RECORD.

3440	SAVE_PRIME=ND_REC.NODE_C_PRIME_NAME
	SAVE_SECOND=ND_REC.NODE_C_SEC_NAME

3441	CALL FDV$GET(ND_REC.NODE_C_SEC_NAME,
     1    TERMINATOR,'EN_C_SEC_NAME')

	IF (ND_REC.NODE_C_SEC_NAME.EQ.'QUIT')THEN
	  GOTO 3490
	END IF

	IF (ND_REC.NODE_C_SEC_NAME.EQ.'      ')THEN
	  SAVE_SECOND=ND_REC.NODE_C_SEC_NAME
	  GOTO 3450
 	END IF

	IF (SAVE_SECOND.EQ.ND_REC.NODE_C_SEC_NAME)THEN
	  GOTO 3450
	END IF

C    READ THE FILE
	
	NEW_SECOND=ND_REC.NODE_C_SEC_NAME
	ND_REC.NODE_C_PRIME_NAME=ND_REC.NODE_C_SEC_NAME
	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=3445)ND_REC

C    IF IT READ GOOD YOU ARE HEAR.  PLACE THE ORIGINAL RECORD BACK IN
C    BY READING IT

 	ND_REC.NODE_C_PRIME_NAME=SAVE_PRIME
	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=9936)ND_REC
	SAVE_SECOND=NEW_SECOND
	GOTO 3450
 
C    BAD READ NO NODE CANT DO
	
3445	CALL FDV$PUTL('THIS IS A NON EXISTANT NODE REENTER')
	GOTO 3441

C    PUT THE NAMES BACK IN THE RECORD

3450	ND_REC.NODE_C_PRIME_NAME=SAVE_PRIME
	ND_REC.NODE_C_SEC_NAME=SAVE_SECOND

C   THE RECORD IS THE SAME AS IT WAS WITH UP DATED PRIM AND SEC NAMES

C   GET NEW NODE TYPE INFORMATION

	GOODTYPE=.FALSE.
3459	CALL FDV$GET(HOLD_TYPE,
     1  	     TERMINATOR,'EN_C_TYPE')
	DO I=1,COUNTER
	  IF (HOLD_TYPE.EQ.OPTIONS(I))THEN
	    GOODTYPE=.TRUE.
	    ND_REC.NODE_C_TYPE=HOLD_TYPE
	  END IF
	END DO

	IF (.NOT. GOODTYPE)THEN
	  CALL FDV$PUT(ND_REC.NODE_C_TYPE,'EN_C_NODE')
	  GOTO 3459
	END IF

 	CALL FDV$GET(ND_REC.NODE_C_DESCRIPTION,
     1		     TERMINATOR,'NODE_C_DESCRIPTION')

C    GIVE A CHANCE TO EXIT

	C_CHECK=' '
	CALL FDV$DISP('DO_IT')
	CALL FDV$GET(C_CHECK,TERMINATOR,'C_CHECK')
	IF (C_CHECK .NE. 'Y' .AND. C_CHECK .NE. 'y')THEN
	  GOTO 3490
	ENDIF
	
C    THE USER WANTS THE OPERATION DONE
C    1  WRITE THE NEW RECORD TO THE FILE
C    2  IF NODE NAME CHANGED SCAN THE MESSAGES AND CHANGE IT 
C       TO THE NEW TARGET NAME
C    3  PUT OLD NAME IN AND DELETE THE OLD RECORD (SAVE_NAME)
C    

C    1
	IF(P_FILE)THEN
 	  WRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9935)ND_REC
	ELSE
 	  REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9936)ND_REC
	ENDIF


C    2
	IF (P_FILE)THEN

	ID_REC.MES_C_MESSAGE_ID=FB_NULL_KEY
	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=3715)ID_REC

C    READ THE FILE
	
	DO WHILE (.NOT. EOFILE)
	
	  READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9936,END=3489)ID_REC
	  IF (ID_REC.MES_C_PRIM_NODE.EQ.SAVE_NAME)THEN           ! THE OLD TARGET
	    ID_REC.MES_C_PRIM_NODE=ND_REC.NODE_C_PRIME_NAME  ! THE NEW TARGET
	    REWRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9937)ID_REC   ! WITH NEW TARGET
	  ELSE
	    DO I=1,6
	      IF(ID_REC.MES_C_PATH_NODE(I).EQ.SAVE_NAME)THEN
	 	ID_REC.MES_C_PATH_NODE(I)=ND_REC.NODE_C_PRIME_NAME
	      END IF ! PATH SAME AS OLD
	    END DO   ! DO 
	    REWRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9937)ID_REC   ! WITH NEW TARGET

	  END IF   ! ID = SAVE   HAS OLD TARGET

	END DO     ! WHILE TO LOOP FILE	  
	

3489	ND_REC.NODE_C_PRIME_NAME=SAVE_NAME
	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,IOSTAT=IOSTATUS,
     1	  ERR=9936)ND_REC
	DELETE(UNIT=2,IOSTAT=IOSTATUS,ERR=9938)

	ND_REC.NODE_I_BIT_NUM=1
	READ (UNIT=2,KEY=ND_REC.NODE_I_BIT_NUM,KEYID=1,
     1    IOSTAT=IOSTATUS,ERR=9937)ND_REC

	DO WHILE (.NOT. EOFILE)
	READ (UNIT=2,IOSTAT=IOSTATUS,ERR=9937,END=3490)ND_REC
	IF (ND_REC.NODE_C_SEC_NAME.EQ.SAVE_NAME)THEN
	  ND_REC.NODE_C_SEC_NAME=SAVE_PRIME
	END IF

	END DO     ! <>EOFILE

	END IF     ! P_FILE

C    CLOSE THE FILES

3490	CLOSE(UNIT=2,STATUS='KEEP',IOSTAT=IOSTATUS,ERR=9937)
	CLOSE(UNIT=1,STATUS='KEEP',IOSTAT=IOSTATUS,ERR=9937)  
	GOTO 3000

C    THIS IS THE MENU USED TO EDIT MESSAGE IDS
C    3600 = ADD ID, 3700 = DELETE ID, 3800 = ADD/DELETE NODE FROM ID
C
3500	CALL FDV$CDISP('MESSAGE_EDIT')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
3501	CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'MESSAGE_CHOISE')
	READ (C_CHOISE_MENU,'(I1)') I_CHOISE_MENU
	IF (I_CHOISE_MENU .LT. 1 .OR. I_CHOISE_MENU .GT. 4) THEN
	  CALL FDV$PUTL('VALUE OUT OF RANGE, REENTER')	
          GOTO 3501
	ENDIF
	GOTO(3600,3700,3800,1025) I_CHOISE_MENU

C    This module is used to add a message ID.  When adding the message ID,
C    the MESSAGE_ID.DAT file is updated. The bit array which is used to 
C    store the locations of sending nodes must be updated. The user 
C    enters the message Id and target node through the editing screens.  
C    He must also enter a secondary node if there is one and the message 
C    length. We then ask the user who sends the message  and set those
C    bits in the bittarray for the message.
C

3600 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9912,IOSTAT=IOSTATUS)

	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9913,
     4    IOSTAT=IOSTATUS)

3610	CALL FDV$CDISP('ADD_MESSAGE')
	CALL STATUS_CHECKER
3615	CALL FDV$GET(ID_REC.MES_C_MESSAGE_ID,
     1                TERMINATOR,'AMES_C_MESSAGE_ID')
	IF(ID_REC.MES_C_MESSAGE_ID.EQ.'QUIT')THEN
	  GOTO 3680
	END IF

C   READ THE MESSAGE ID IF FOUND DO ERROR ROUTINE

	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1     IOSTAT=IOSTATUS,ERR=3630)ID_REC
	CALL FDV$PUTD('AMES_C_MESSAGE_ID')
	CALL FDV$PUTL('THIS MESSAGE EXISTS ALREADY')
	GOTO 3615

C   READ PRIME NODE DO NODE ERROR

3620    CALL FDV$PUTL('NO NODE EXIST YOU MUST ADD IT FIRST')
	CALL FDV$PUTD('AMES_PRIME_NODE')

3630	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,TERMINATOR,
     1     'AMES_PRIME_NODE')

	IF(ND_REC.NODE_C_PRIME_NAME.EQ.'QUIT')THEN
	  GOTO 3680
	END IF

	ID_REC.MES_C_PRIM_NODE=ND_REC.NODE_C_PRIME_NAME

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1     IOSTAT=IOSTATUS,ERR=3620)ND_REC

3650	CALL FDV$GET(C_MESSAGE_SIZE,TERMINATOR,'AMES_C_MESSAGE_SIZE')
	READ (C_MESSAGE_SIZE,3651)ID_REC.MES_I_MESSAGE_SIZE
3651    FORMAT(I4)
	IF (ID_REC.MES_I_MESSAGE_SIZE .LE. 0 .OR. 
     1      ID_REC.MES_I_MESSAGE_SIZE .GT. 1024) THEN
	  CALL FDV$PUTL ('SIZE OUT OF RANGE')
	  GOTO 3650
	ENDIF

C    CHECK TO SEE IF IT IS THE LAGEST INPUTED MESSAGE

	IF (ID_REC.MES_I_MESSAGE_SIZE.GT.ND_REC.NODE_I_INPSZ)THEN
	  ND_REC.NODE_I_INPSZ=ID_REC.MES_I_MESSAGE_SIZE
	  REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9926)ND_REC
	ENDIF


	
C    GET THE NODES THIS MESSAGE COMES FROM
C    UBDATE THE NODE VARIABLE MESSAGES ACCESSED
C    SET THE BITS IN THE MESSAGE

C    CLEAR THE BIT POSITIONS

3652	DO 3653 FB_INDEX=0,32    ! 32 BITS AT A TIME
	  ID_REC.MES_I_BITTARRAY(FB_INDEX) = '00000000'X
3653	CONTINUE
	GOTO 3670

3660	CALL FDV$PUTL('THIS NODE IS NON EXISTENT')
	CALL FDV$PUTD('AMES_C_F_NODE_TWO')

3670	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,TERMINATOR,
     1   'AMES_C_F_NODE_TWO')
	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'NOMORE') THEN
	  GO TO 3671
	ENDIF

C   CHECK TO SEE IF THE USER TRIES TO ENTER THE A SENDING THE SAME
C   AS THE TARGET NODE DON'T LET HIM/HER DO IT

 	IF(ND_REC.NODE_C_PRIME_NAME.EQ.ID_REC.MES_C_PRIM_NODE)THEN
          CALL FDV$PUTL('SENDING NODE CAN NOT BE SAME AS TARGET NODE')
 	  CALL FDV$PUTD('AMES_C_F_NODE_TWO')
          GOTO 3670
	END IF

            READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=3660)ND_REC


C    MOVE TO THE UPER DISPLAY POSITION

	    CALL FDV$PUT(ND_REC.NODE_C_PRIME_NAME,'AMES_C_F_NODE')
	    CALL FDV$PUTD('AMES_C_F_NODE_TWO')

C    SET THE BITS

	    FB_LOOP = ND_REC.NODE_I_BIT_NUM
	    FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	    FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK
	    ID_REC.MES_I_BITTARRAY(FB_INDEX) = JIBSET
     1         (ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)

C    UPDATE THE NODE FEILD FOR MESSAGES ACCESSED


	    ND_REC.NODE_I_MESS_ACCESSED =ND_REC.NODE_I_MESS_ACCESSED + 1
	    IF (ID_REC.MES_I_MESSAGE_SIZE.GT.ND_REC.NODE_I_LARGEST_MESS)
     1        THEN
	      ND_REC.NODE_I_LARGEST_MESS=ID_REC.MES_I_MESSAGE_SIZE
	    ENDIF  ! ID MESS SIZE>ND MESS SIZE

	REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9915)ND_REC

	GOTO 3670

C    DO THE PATH ROUTINE
C
3671	DO J=1,6				! EMPTY THE POSITIONS
	  ID_REC.MES_C_PATH_NODE(J)='      '
	END DO  

	I=1			        	! SET THE IDEX COUNTER
	GOTO 3673				! SKIP OVER ERROR
C
C     ERROR ON GET
C
3672	CALL FDV$PUTL('THIS NODE IS NON EXISTANT')
	CALL FDV$PUTD('AMS_ROUTING_TWO')

3673    CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,TERMINATOR,
     1    'AMS_ROUTING_TWO')

	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'NOMORE') THEN
	  GO TO 3679
	ENDIF
			
C    CHEC TO SEE IF THEY HAVE ENTER MORE ROUTS THAN WE CAN HANDEL

   	IF (I.EQ.7)THEN
	  CALL FDV$PUTL('YOU TRIED ENTERING TO MANY PATH NODES EXITING')
	  GOTO 3680
	ENDIF


C    CHECK TO SEE IF THE ROUTING NODE IS THE SAME AS THE TARGET NODE

 	IF(ND_REC.NODE_C_PRIME_NAME.EQ.ID_REC.MES_C_PRIM_NODE)THEN
          CALL FDV$PUTL('ROUTING NODE CAN NOT BE SAME AS TARGET NODE')
 	  CALL FDV$PUTD('AMS_ROUTING_TWO')
          GOTO 3673
	END IF

            READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=3672)ND_REC


C    MOVE TO THE UPER DISPLAY POSITION

	    CALL FDV$PUT(ND_REC.NODE_C_PRIME_NAME,'AMS_ROUTING_ONE')
	    CALL FDV$PUTD('AMS_ROUTING_TWO')


C    UPDATE THE NODE FEILD FOR MESSAGES ACCESSED

	    ND_REC.NODE_I_MESS_ACCESSED =ND_REC.NODE_I_MESS_ACCESSED + 1
	    IF (ID_REC.MES_I_MESSAGE_SIZE.GT.ND_REC.NODE_I_LARGEST_MESS)
     1        THEN
	      ND_REC.NODE_I_LARGEST_MESS=ID_REC.MES_I_MESSAGE_SIZE
	    ENDIF  ! ID MESS SIZE>ND MESS SIZE

	REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9915)ND_REC

C    PLACE THE NAME IN THE ROUTING NODE FIELDS OF THE MESSAGE ID REC


	ID_REC.MES_C_PATH_NODE(I)=ND_REC.NODE_C_PRIME_NAME
	I=I+1

 	GOTO 3673  

C    WRITE OUT THE NEW RECORD

3679	WRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9914)ID_REC

C    CLOSE THE FILES

3680	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)
	GOTO 3500

C    This module is used to delete messages from the MESSAGE_ID.DAT file.
C    When deleting a message ID, you must delete the the Id record.
C    The user will enter the 16 character Message ID from the edit screen.
C
3700 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9916,IOSTAT=IOSTATUS)

	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9917,
     4    IOSTAT=IOSTATUS)

3710	CALL FDV$CDISP('DELETE_MESSAGE')
	CALL STATUS_CHECKER
	GOTO 3720

3715	CALL FDV$PUTL('NO SUCH MESSAGE EXISTS')
	CALL FDV$PUTD('DMES_C_MESSAGE_ID')

3720	CALL FDV$GET(ID_REC.MES_C_MESSAGE_ID,
     1               TERMINATOR,'DMES_C_MESSAGE_ID')

	IF (ID_REC.MES_C_MESSAGE_ID.EQ.'QUIT')THEN
	  GOTO 3730
	END IF

C    READ THE MESSAGE FILE TO MAKE SHURE THE MESSAGE EXIST AND
C    SCAN THE BIT MAP SO THAT THE NODE FILES MESSAGES ACCESSED 
C    MAY BE UPDATED

	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=3715)ID_REC

C    GIVE A CHANCE TO EXIT

	C_CHECK=' '
	CALL FDV$DISP('DO_IT')
	CALL FDV$GET(C_CHECK,TERMINATOR,'C_CHECK')
	IF (C_CHECK .NE. 'Y' .AND. C_CHECK .NE. 'y')THEN
	  GOTO 3730
	ENDIF

C    SCAN THE BITS

	FB_LOOP = 0
	DO WHILE (FB_LOOP.LE.1024)
	  FB_FOUND = .FALSE.
	  FB_LOOP = FB_LOOP +1      !
	  FB_INDEX = FB_LOOP/32     !
	  FB_OFFSET = MOD(FB_LOOP,32)  !
	  FB_FOUND = BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	  IF (FB_FOUND) THEN
	    ND_REC.NODE_I_BIT_NUM = FB_LOOP
	    READ(UNIT=2,KEY=ND_REC.NODE_I_BIT_NUM,KEYID=1,
     1	      IOSTAT=IOSTATUS,ERR=9918)ND_REC
	    ND_REC.NODE_I_MESS_ACCESSED = 
     1	       ND_REC.NODE_I_MESS_ACCESSED - 1 ! SET BACK THE COUNTER 
	    REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9919)ND_REC
	  END IF  !FB_FOUND
	ENDDO  ! LOOP < 1024

C    DELETE THE MESSAGE RECORD

	DELETE(UNIT=1,IOSTAT=IOSTATUS,ERR=9920)

C    CLOSE THE FILES

3730	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)
	GOTO 3500

C    This module allows the user to change the destination of a message.
C    The MESSAGE_ID.DAT file is accessed so the bit array map off sending 
C    nodes may be changed. The user will supply the message id and the 
C    node names.
C
3800 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)

	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9917,
     4    IOSTAT=IOSTATUS)

	CALL FDV$CDISP('ADD_DEL_M_N')
	CALL STATUS_CHECKER
	CALL FDV$PUT('ENTER NAME OF MESSAGE','AD_MESSAGE')
	GOTO 3820

3810    CALL FDV$PUTL('NO SUCH MESSAGE ID')
	CALL FDV$PUTD('ADMES_C_MESSAGE_ID')

3820	CALL FDV$GET(ID_REC.MES_C_MESSAGE_ID,
     1               TERMINATOR,'ADMES_C_MESSAGE_ID')
							! MESSAGE
	IF(ID_REC.MES_C_MESSAGE_ID.EQ.'QUIT')THEN
	  GOTO 3399
	END IF
C
C    SAVE THE MESSAGE ID
C
	HOLD_M_N=ID_REC.MES_C_MESSAGE_ID
C
C    READ THAT ID

	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=3810)ID_REC

	CALL FDV$PUT('ENTER NEW INFORMATION','AD_MESSAGE')
	CALL FDV$PUT(ID_REC.MES_C_PRIM_NODE,'AD_N_N')
	
	WRITE(CHOLD_M_S,'(I4)')ID_REC.MES_I_MESSAGE_SIZE
	CALL FDV$PUT(CHOLD_M_S,'AD_M_S')

C    POSSITION THE CURSER AT THE BEGINING OF THE MESSAGE ID SO THE
C    USER CAN CHANG THE NAME. PLACE THE NEW NAME INTO THE MESSAGE ID
C    READ THE NAME  IF ITS AN ERROR GO ON WITH THE NEW NAME.  IF IT
C    READS TELL THE USER IT CANN'T BE USED AND REREAD THE ORIGINAL
C    RECORD (THATS WHY WE SAVED THE NAME) SO WE GET THE CORRECT INFORMATION
C    BACK 

3825	CALL FDV$GET(ID_REC.MES_C_MESSAGE_ID,
     1               TERMINATOR,'ADMES_C_MESSAGE_ID')
	
	IF(ID_REC.MES_C_MESSAGE_ID.EQ.'QUIT')THEN
	  P_FILE=.FALSE.
	  GOTO 3399
	END IF

C    CHECK TO SEE IF THE USER CHANGED ANYTHING  IF THEY DIDN'T CHANGE
C    SKIP THE CHANGE ROUTINE.  IF THEY DID DO THE CHANGES

	IF (ID_REC.MES_C_MESSAGE_ID.EQ.HOLD_M_N)THEN
	  P_FILE=.FALSE.
	  GOTO 3822
	END IF

	P_FILE=.TRUE.
	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=3822)ID_REC

C    SUCSESFULLY READING THE RECORD MEANS THE NAME IS OUT THER
C    TELL USER GET BACK THE RECORD YOU WANT TO WORK WITH GO BACK TO 
C    TO THE FIRST STEP

	P_FILE=.FALSE.
	CALL FDV$PUTL('THIS MESSAGE ALREADY EXISTS   RENTER  ')
	CALL LIB$WAIT(3.)
	ID_REC.MES_C_MESSAGE_ID=HOLD_M_N
	CALL FDV$PUT(ID_REC.MES_C_MESSAGE_ID,'ADMES_C_MESSAGE_ID')
	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=9938)ID_REC
	GOTO 3825

C    GET A NEW TARGET NODE NAME IF THER IS ONE
C    READ THE NAME IF ERR CALL ERROR ROUTINE NO NODE

3821	CALL FDV$PUTL('NO SUCH NODE REENTER')
	CALL FDV$PUT(ID_REC.MES_C_PRIM_NODE,'AD_N_N')

3822    CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,
     1               TERMINATOR,'AD_N_N') 


	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'QUIT')THEN
	  GOTO 3399
	END IF

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=3821)ND_REC

	ID_REC.MES_C_PRIM_NODE=ND_REC.NODE_C_PRIME_NAME


C   CHECK THE MESSAGE SIZE TO SEE IF IT IS VALID

3823	CALL FDV$GET(C_MESSAGE_SIZE,TERMINATOR,'AD_M_S')
	READ (C_MESSAGE_SIZE,3651)IHOLD_M_S
	IF (IHOLD_M_S .LE. 0 .OR. 
     1      IHOLD_M_S .GT. 1024) THEN
	  CALL FDV$PUTL ('SIZE OUT OF RANGE')
          CALL FDV$PUT(CHOLD_M_S,'AD_M_S')
	  GOTO 3823
	ELSE
	  ID_REC.MES_I_MESSAGE_SIZE=IHOLD_M_S
	ENDIF
	
C    CHECK TO SEE IF IT IS THE LAGEST INPUTED MESSAGE

	IF (ID_REC.MES_I_MESSAGE_SIZE.GT.ND_REC.NODE_I_INPSZ)THEN
	  ND_REC.NODE_I_INPSZ=ID_REC.MES_I_MESSAGE_SIZE
	  REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9926)
	ENDIF

	GOTO 3840

C    CHECK TO SEE WHAT OPERATION ARE TO PERFORMED ON THE SENDING NODES
C    KEEP PERFORMING SENDING NODE OPERATIONS UNTIL THE USER TELLS YOU TO
C    STOP OR SKIPS THEM

3830	CALL FDV$PUTL('NO SUCH NODE REENTER')
	CALL FDV$PUTD('AD_NODE_NAME')
        CALL FDV$PUTD('AD_OPTION_NUM')

3840	CALL FDV$GET(CHAR_DO,TERMINATOR,'AD_OPTION_NUM')
						
        READ(CHAR_DO,'(I1)')C_DO

	IF (C_DO .LT. 1 .OR. C_DO .GT. 3)THEN
	    CALL FDV$PUTL('VALUE OUT OF RANGE REENTER')
	    GOTO 3840 
    	ENDIF

	IF (C_DO .EQ. 1) THEN
	  GOTO 3389
	END IF

	GOTO 3385

C    READ THE NAME IF ERR CALL ERROR ROUTINE NO NODE


3385    CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,
     1               TERMINATOR,'AD_NODE_NAME') 


	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'QUIT')THEN
	  GOTO 3399
	END IF

	READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=3830)ND_REC

	IF(ND_REC.NODE_C_PRIME_NAME.EQ.ID_REC.MES_C_PRIM_NODE)THEN
 	  CALL FDV$PUTL
     1  ('YOU CAN NOT PERFORM SENDING OPERATIONS WITH A TARGET NODE')
	  CALL FDV$PUTD('AD_NODE_NAME')
          CALL FDV$PUTD('AD_OPTION_NUM')
	  GOTO 3840
	END IF    ! NODE = TARGET


C    ADD A SENDING NODE

	IF (C_DO .EQ. 2)THEN

C    SET THE BITS

	    FB_LOOP = ND_REC.NODE_I_BIT_NUM
	    FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	    FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK
	    ID_REC.MES_I_BITTARRAY(FB_INDEX) = JIBSET
     1         (ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)

C    UPDATE THE NODE FEILD FOR MESSAGES ACCESSED

	    ND_REC.NODE_I_MESS_ACCESSED = ND_REC.NODE_I_MESS_ACCESSED + 1
	    IF (ID_REC.MES_I_MESSAGE_SIZE.GT.ND_REC.NODE_I_LARGEST_MESS)
     1        THEN
	      ND_REC.NODE_I_LARGEST_MESS=ID_REC.MES_I_MESSAGE_SIZE
	    ENDIF  ! ID MESS SIZE>ND MESS SIZE

	REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9915)ND_REC


    	    CALL FDV$PUTL('THIS WAS ADD  TO THE SENDING NODES')	

	ENDIF  ! IF C_DO = 2

C    IF WE WANT TO DELETE A SENDING NODE FROM MESSAGE ID

	IF (C_DO .EQ. 3) THEN

	    FB_LOOP = ND_REC.NODE_I_BIT_NUM
	    FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	    FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK
	    ID_REC.MES_I_BITTARRAY(FB_INDEX) = JIBCLR
     1         (ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	    ND_REC.NODE_I_MESS_ACCESSED = 
     1	       ND_REC.NODE_I_MESS_ACCESSED - 1 ! SET BACK THE COUNTER 

	    REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9915)ND_REC

	    CALL FDV$PUTL('THIS NODE WAS DELETED FROM SENDING NODES')

	ENDIF  ! C DO =3 
	
C    LOOP BACK AND CHECK TO SEE IF THEY WANT TO GO AGAIN

	GOTO 3840

C    GIVE A CHANCE TO EXIT


C    DO THE PATH ROUTINE
C
C    CHECK TO SEE IF IF YOU WANT TO CHANGE THE PATH

3389    CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'AD_ROUTING_CHOICE')
	IF (C_CHOISE_MENU.NE.'Y')THEN
	  GOTO 3898
	END IF

C    YES THE PATH IS TO BE CHANGED

	I=1
			        	! SET THE IDEX COUNTER
C    CEAR THE PATH ARRAY
	
	DO J=1,6
	  ID_REC.MES_C_PATH_NODE(J)='      '
	END DO

	GOTO 3893				! SKIP OVER ERROR
C
C     ERROR ON GET
C
3892	CALL FDV$PUTL('THIS NODE IS NON EXISTANT')
	CALL FDV$PUTD('AD_ROUTING_NODE_TWO')

3893    CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,TERMINATOR,
     1    'AD_ROUTING_NODE_TWO')

	IF (ND_REC.NODE_C_PRIME_NAME.EQ.'NOMORE') THEN
	  GO TO 3898
	ENDIF
			
C    CHEC TO SEE IF THEY HAVE ENTER MORE ROUTS THAN WE CAN HANDEL

   	IF (I.EQ.7)THEN
	  CALL FDV$PUTL('YOU TRIED ENTERING TO MANY PATH NODES EXITING')
	  GOTO 3399
	ENDIF


C    CHECK TO SEE IF THE ROUTING NODE IS THE SAME AS THE TARGET NODE

 	IF(ND_REC.NODE_C_PRIME_NAME.EQ.ID_REC.MES_C_PRIM_NODE)THEN
          CALL FDV$PUTL('ROUTING NODE CAN NOT BE SAME AS TARGET NODE')
 	  CALL FDV$PUTD('AD_ROUTING_NODE_TWO')
          GOTO 3893
	END IF

            READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=3892)ND_REC


C    MOVE TO THE UPER DISPLAY POSITION

	    CALL FDV$PUT(ND_REC.NODE_C_PRIME_NAME,'AD_ROUTING_NODE_ONE')
	    CALL FDV$PUTD('AD_ROUTING_NODE_TWO')


C    UPDATE THE NODE FEILD FOR MESSAGES ACCESSED

	    ND_REC.NODE_I_MESS_ACCESSED =ND_REC.NODE_I_MESS_ACCESSED + 1
	    IF (ID_REC.MES_I_MESSAGE_SIZE.GT.ND_REC.NODE_I_LARGEST_MESS)
     1        THEN
	      ND_REC.NODE_I_LARGEST_MESS=ID_REC.MES_I_MESSAGE_SIZE
	    ENDIF  ! ID MESS SIZE>ND MESS SIZE

	REWRITE(UNIT=2,IOSTAT=IOSTATUS,ERR=9915)ND_REC

C    PLACE THE NAME IN THE ROUTING NODE FIELDS OF THE MESSAGE ID REC


	ID_REC.MES_C_PATH_NODE(I)=ND_REC.NODE_C_PRIME_NAME
	I=I+1

 	GOTO 3893  

3898	C_CHECK=' '
	CALL FDV$DISP('DO_IT')
	CALL FDV$GET(C_CHECK,TERMINATOR,'C_CHECK')
	IF (C_CHECK .NE. 'Y' .AND. C_CHECK .NE. 'y')THEN
	  GOTO 3399
	ENDIF


	IF (P_FILE)THEN
	  WRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9915)ID_REC
	  ID_REC.MES_C_MESSAGE_ID=HOLD_M_N
	  READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1      IOSTAT=IOSTATUS,ERR=9938)ID_REC
	  DELETE(UNIT=1,IOSTAT=IOSTATUS,ERR=9915)
	ELSE
	  REWRITE(UNIT=1,IOSTAT=IOSTATUS,ERR=9915)ID_REC
	ENDIF

3399	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)
	GOTO 3500


C    THIS MODULE IS USED TO CONTROLE WHERE THE REPORT PRINT OPTIONS
C    4200 = FULL DB 4500 = BY NODE  4800 = BY MESSAGE

4000	CALL FDV$CDISP('REPORTING')
	CALL STATUS_CHECKER
	C_CHOISE_MENU = '0'
4001	CALL FDV$GET(C_CHOISE_MENU,TERMINATOR,'REPORT_CHOISE')
	READ (C_CHOISE_MENU,'(I1)') I_CHOISE_MENU
	IF (I_CHOISE_MENU .LT. 1 .OR. I_CHOISE_MENU .GT. 4) THEN
	  CALL FDV$PUTL('VALUE OUT OF RANGE, REENTER')	
          GOTO 4001
	ENDIF
	GOTO(4200,4500,4800,1000) I_CHOISE_MENU


C    This module provides a detailed listing of the database contents.
C    Since there are 1024 nodes which we will be able to track the 
C    output of this report will be segmented. This module will access 
C    the MESSAGE_ID.DAT file.  It will the search the bit array for nodes
C    and mark the corresponding location. 
C
4200	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9917,
     4    IOSTAT=IOSTATUS)

 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)

	OPEN (UNIT=3,FILE='DATABASE_REPORT.LIS',STATUS='NEW',
     1  RECORDSIZE=133,ERR=9931)

	OPEN(UNIT=4,FILE='WORK_FILE',STATUS='NEW',
     1    ACCESS='DIRECT',RECORDTYPE='FIXED',FORM='UNFORMATTED',
     3    ORGANIZATION='RELATIVE',
     2    RECORDSIZE=1050,IOSTAT=IOSTATUS,ERR=9939)


C    GET THE TIME FOR THE REPORT

	SYS_STATUS = SYS$ASCTIM(,
     1 				! ADDRESS OF WORD TO RECIVE THE LENGTH
     2				! OF THE OUTPUT STRING
     3		      VAX_TIME, ! ADDRESS OF CHARACTER STRING DISCRIPTOR 
     4				! THAT RECIVES THE CONVERTED STRING
     7		      ,,)
	IF (.NOT. SYS_STATUS) THEN
            CALL SYS$EXIT(%VAL(SYS_STATUS))
	END IF
	PAGE=0

	CALL FDV$CDISP('ALL_FILES')
	CALL STATUS_CHECKER
	CALL FDV$GET(C_CHECK,TERMINATOR,'ALL_CHOICE')
	IF (C_CHECK .NE. 'Y' .AND. C_CHECK .NE. 'y')THEN
	  GOTO 4301
	ENDIF
	CALL FDV$PUT('DATABASE_REPORT.LIS IS NOW BEING CREATED',
     1   'ALL_MES')

C    LOAD THE NAME ARAY WITH BLANKS

	DO I=1,1024
	  DO J=1,6
	    NODE_NAME_ARAY(J,I)=' '
	  END DO
	END DO

C    LOAD THE NODE_NAMES ARRAY WITH BLANKS

	DO I=1,1024
	  NODE_NAMES(I)='      '
	END DO

C    LOAD THE ARAYS WITH THE NODE INFORMATION


	DO I=1,1024
	
          READ(UNIT=2,IOSTAT=IOSTATUS,ERR=9937,END=4220)ND_REC
	  NODE_NUMBERS(I)=ND_REC.NODE_I_BIT_NUM
	  NODE_NAME_H=ND_REC.NODE_C_PRIME_NAME
	  NODE_NAMES(I)=ND_REC.NODE_C_PRIME_NAME


C    PUT NAME TOGETHER

	  DO J=1,6
	    NODE_NAME_ARAY(J,I)=NODE_NAME_P(J)
	  END DO

	  MAX_NODES=I

	ENDDO


C    READ THE MESSAGES SEQUENTIALY GET RID OF FIRST REECORD


4220	ID_REC.MES_C_MESSAGE_ID=FB_NULL_KEY
	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=3715)ID_REC

	MESSAGE_NUMBER=0


	

C    SET UP A LOOP

	IF (.NOT. EOFILE) THEN

C    READ A RECORD AND TRANSLATE THE DATA TO THE NEW REC

	
C    CLEAR THE STORAGE LOCATIONS

4225	DO I=1,1024
	  R_REC.SEND_NODE(I)=' '
	END DO

C    READ EACH RECORD GET BASIC INFORMATION PUT IN THE TEMPERARY
C    RECORD SO IT MAY BE USED LATTER TO GENERATE THE REPORT

	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9934,END=4240)ID_REC
	R_REC.MES_ID=ID_REC.MES_C_MESSAGE_ID
	R_REC.NODE_NAME=ID_REC.MES_C_PRIM_NODE
	R_REC.MES_LENGTH=ID_REC.MES_I_MESSAGE_SIZE


C    PUT THE ROUTING NODES IN THE TEMPERARY RECORD

	DO I=1,6
	  DO J=1,1023
	    IF(ID_REC.MES_C_PATH_NODE(I).EQ.NODE_NAMES(J)
     1        .AND.NODE_NAMES(J).NE.'      ')THEN
	      R_REC.SEND_NODE(J)='R'
	    END IF
	  END DO
	END DO


C    CHECK EACH BIT POSSITION TO SEE IF A NODE EXITS

	DO  FB_LOOP=1,1024
	  FB_INDEX=FB_LOOP/32
	  FB_OFFSET=MOD(FB_LOOP,32)
	  FB_FOUND=BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	  IF (FB_FOUND) THEN
	    DO I=1,1024
	      IF(NODE_NUMBERS(I).EQ.FB_LOOP)THEN
	        R_REC.SEND_NODE(I)='X'

	      END IF  ! NODE NUMBER
	    END DO    ! 1 TO MAX NODES
	  END IF      ! FBFOUND
        END DO ! FB_LOOP
C   WRITE OUT THE RECORD

	
	MESSAGE_NUMBER=MESSAGE_NUMBER+1

	WRITE(UNIT=4,REC=MESSAGE_NUMBER,IOSTAT=IOSTATUS,ERR=9935)R_REC

	GOTO 4225
	END IF        ! NOE EOFILE

C   INITIALIZE THE POSITIONS FOR PRINTIONG
C   CHECK TO SEE THAT RECORDS EXISTS

4240    IF (MESSAGE_NUMBER.EQ. 0)THEN
	  CALL FDV$PUTL('NO MESSAGES EXIST,  CHECK DATA FILES')
	  CALL LIB$WAIT (5.)
	  GOTO 4301
	END IF

	DO I=1,85
	  BLOCK_NUMBER(I)=1
	END DO

	TOTAL_MESSAGES=MESSAGE_NUMBER
	P_OFFSET=0
	MESSAGE_COUNT=0
	TRUE_OFFSET=0
	MESSAGE_NUMBER=1
	GOT_ONE=.FALSE.

	

	GOTO 4250

C    CALCULATE THE POSSITION TO LOOK AT IN THE RECORD

4245	IF(MESSAGE_NUMBER.GT.TOTAL_MESSAGES)THEN

		
	  MESSAGE_COUNT=12
	  IF (P_OFFSET.EQ.(MAX_NODES/55))THEN
	    GOTO 4300
	  ENDIF

	END IF  ! MESSAGE NUMBER
C    IF TRUE FORCES A NEW SECTION TO START

     	IF(MESSAGE_COUNT.EQ.12)THEN

	
	  P_OFFSET=P_OFFSET+1
	  TRUE_OFFSET=P_OFFSET*55
	  IF(TRUE_OFFSET.GT.MAX_NODES)THEN
	    P_OFFSET=0
	    TRUE_OFFSET=0
	  END IF  ! OFSET > MAX
	  MESSAGE_COUNT=0
	  MESSAGE_NUMBER=BLOCK_NUMBER(P_OFFSET)
	  GOT_ONE=.FALSE.
	END IF  ! MESSAGE COUNT > 12

C    READ A RECORD AN SEE IF THE NODES ARE IN OUR RANGE

4250  	 READ(UNIT=4,REC=MESSAGE_NUMBER,IOSTAT=IOSTATUS,
     1    ERR=9933)R_REC

	DO I=1,55
	  PRINT_POSITION(I)=' '
	END DO

	I=0
C	IF (P_OFFSET.EQ.0)THEN
C	  TRUE_OFFSET=TRUE_OFFSET+1
C	ENDIF

	DO SEND_INX=TRUE_OFFSET+1,TRUE_OFFSET+55
	  I=I+1

	  IF (R_REC.SEND_NODE(SEND_INX).EQ.'X')THEN
	    GOT_ONE=.TRUE.
	    PRINT_POSITION(I)='S'
	  END IF !  SEND NODE
	  
	  IF (R_REC.SEND_NODE(SEND_INX).EQ.'R')THEN
	    PRINT_POSITION(I)='R'
	  END IF !  SEND NODE

	END DO   !  CHECKING POSSITTIONS

C    IF YOU HAVE A RECORD THAT WORKS PRINT IT
     
	IF (GOT_ONE)THEN
	  IF(MESSAGE_COUNT.EQ.0)THEN
            PAGE=PAGE+1
	    WRITE(3,4221)PAGE
4221        FORMAT('1',T51,'MESSAGE ID ROUTING MAP TABLE',T120,'PAGE=',
     1      I4.4)     
	    WRITE(3,4226)VAX_TIME
4226	    FORMAT(' ',T51,'AS OF ',A23)
	    WRITE(3,4222)
4222        FORMAT(' ',' ')

C    LOOP THROUGH PUTTING NAME IN THE HEADING

	    DO I=1,6
ccccccccc	      WRITE(3,4230)
4230	      FORMAT(' ',20(' '),55('!',1X),'!')
C
C    PUT IN TITLE INFO

	      IF (I .EQ. 1)THEN
	 	MSG_F = ' SENDING NODES >>>> '
	      END IF  ! =1

	      IF (I .EQ. 2)THEN
	 	MSG_F = '                    '
	      END IF  ! =2

	      IF (I .EQ. 3)THEN
	 	MSG_F = ' V   MESSAGE ID   V '
	      END IF  ! =3

	      IF (I .EQ. 4)THEN
	 	MSG_F = ' V  TARGET NODE   V '
	      END IF  ! =4

	      IF (I .EQ. 5)THEN
	 	MSG_F = ' V    ID SIZE     V '
	      END IF  ! =5

	      IF (I .EQ. 6)THEN
	 	MSG_F = '                    '
	      END IF  ! =6


C    PUT NODE INFORMATION HERE WITHOUT CARRIGE RETURN
C
	      WRITE(3,4234)MSG_F,(NODE_NAME_ARAY(I,J),J=TRUE_OFFSET+1,
     1          TRUE_OFFSET+55)
4234 	      FORMAT(' ',A20,'!'55(A1,'!'))
	    END  DO  ! 6 HEADING LINES

	    WRITE(3,4231)
4231        FORMAT(' ',20('-'),55('+-'),'+')
	    MESSAGE_COUNT=0

	  END IF ! MESSAGE_COUNT = 0
C
C    WRITE LINE FROM LOADED INFORMATION
C
cccccccc	  WRITE(3,4230)
	  WRITE(3,4237)R_REC.MES_ID
4237	  FORMAT(' ',T3,A16,T22,'!',55(1X,'!'))
CCCCCCCC	  WRITE(3,4230)
	  WRITE(3,4235)R_REC.NODE_NAME,(PRINT_POSITION(J),J=1,55) 
				
4235	  FORMAT(' ',T8,A6,T22,'!',55(A1,'!'))
CCCCCCCC	  WRITE(3,4230)
	  WRITE(3,4236)R_REC.MES_LENGTH
4236	  FORMAT(' ',T9,I4.4,T22,'!',55(1X,'!'))
	  WRITE(3,4231)
	  MESSAGE_COUNT=MESSAGE_COUNT+1
	  GOT_ONE=.FALSE.

	END IF  ! GOT ONE

C    SET RECORD COUNTERS

	MESSAGE_NUMBER=MESSAGE_NUMBER+1
	BLOCK_NUMBER(P_OFFSET)=MESSAGE_NUMBER
	GOTO 4245    


C    INITIALIZE SECOND HALF OF REPORT

4300	L_COUNT=66


C    READ THE MESSAGES SEQUENTIALY GET RID OF FIRST REECORD


	ID_REC.MES_C_MESSAGE_ID=FB_NULL_KEY
	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS)ID_REC

C    SET UP A LOOP

	IF (.NOT. EOFILE) THEN

4280	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9934,END=4298)ID_REC

C    CHECK TO SEE IF ANY NODES EXISTS

	  DO I=0,31
	
	    IF (ID_REC.MES_I_BITTARRAY(I).NE.0)THEN
	      GOTO 4280
	    END IF  ! <>0

	  END DO  ! 0 TO 31


C    PRINT OUT ANY UNASSIGNED MESSAGE IDS

	  IF (L_COUNT.GT.60)THEN

            PAGE=PAGE+1
	    WRITE(3,4221)PAGE
	    WRITE(3,4226)VAX_TIME
	    WRITE(3,4285)
4285	    FORMAT('0',T56,'UNASSIGNED MESSAGES')
	    WRITE(3,4286)
4286	    FORMAT('0',' ')
	    WRITE(3,4289)
4289        FORMAT(' ',T15,'MESSAGE ID',T32,'TARGET',T40,'SIZE')
	    L_COUNT=0
 
	  END IF ! L COUNT > 60

	  WRITE(3,4290)ID_REC.MES_C_MESSAGE_ID,ID_REC.MES_C_PRIM_NODE,
     1      ID_REC.MES_I_MESSAGE_SIZE
4290	  FORMAT(' ',T12,A16,T32,A6,T40,I4.4)
	  L_COUNT=L_COUNT+1
	  GOTO  4280

	END IF !  NOT EOFILES

4298	WRITE(3,4299)
4299    FORMAT('0',T59,'END OR REPORT')

C     CLOSE THE FILES

4301    CLOSE(UNIT=4,STATUS='DELETE',ERR=9938)
	CLOSE(UNIT=3,STATUS='KEEP',ERR=9925)
	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)

	GOTO 4000

C    NODE REPORT
C   This module allows you to print out all message IDs
C   that are accesses by or access a specific node.
C

4500	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9917,
     4    IOSTAT=IOSTATUS)


C    GET THE TIME FOR THE REPORT

	SYS_STATUS = SYS$ASCTIM(,
     1 				! ADDRESS OF WORD TO RECIVE THE LENGTH
     2				! OF THE OUTPUT STRING
     3		      VAX_TIME, ! ADDRESS OF CHARACTER STRING DISCRIPTOR 
     4				! THAT RECIVES THE CONVERTED STRING
     7		      ,,)
	IF (.NOT. SYS_STATUS) THEN
            CALL SYS$EXIT(%VAL(SYS_STATUS))
	END IF

	FIRST_TIME=.TRUE.
	PAGE=0


C    DISPLAY THE SCREEN AND CHECK FOR A VALID NODE

	CALL FDV$CDISP('BY_NODE')
	CALL STATUS_CHECKER
	GOTO 4520

4510    CALL FDV$PUTL('NO SUCH NODE REENTER OR QUIT')

4520	CALL FDV$PUTD('BY_NODE_NAME')

	CALL FDV$GET(ND_REC.NODE_C_PRIME_NAME,TERMINATOR,'BY_NODE_NAME')
	IF (ND_REC.NODE_C_PRIME_NAME .EQ. 'QUIT  ')THEN
	  GOTO 4605
	END IF 

	IF (FIRST_TIME)THEN
       	  OPEN (UNIT=3,FILE='NODE_REPORT.LIS',STATUS='NEW',ERR=9931)
	  CALL FDV$PUT('YOU ARE NOW CREATING  NODE_REPORT.LIS',
     1   'BN_MES')
	  FIRST_TIME=.FALSE.
	END IF
	

        READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=4510)ND_REC
	FB_LOOP=ND_REC.NODE_I_BIT_NUM

C    PLACE THE NEW NODE ON A NEW PAGE WITH HEADING AND NODE INFORMATION

	PAGE=PAGE+1
	L_COUNT=0
	WRITE(3,4521)PAGE
4521    FORMAT('1',T58,'NODE REPORT FOR',T120,'PAGE=',I4.4)
	WRITE(3,4522)ND_REC.NODE_C_PRIME_NAME
4522    FORMAT(' ',T63,A6)	
	WRITE(3,4526)VAX_TIME
4526	FORMAT(' ',T51,'AS OF ',A23)
	WRITE(3,4527)ND_REC.NODE_C_SEC_NAME,ND_REC.NODE_C_TYPE
4527	FORMAT('0',T10,'THIS NODE HAS A SECONDARY NAME OF ',A6,' AND IS A ',
     1   A3,' TYPE NODE')
C	WRITE(3,29)ND_REC.NODE_I_BIT_NUM
C29	FORMAT('0','NODE BIT NUMBER IS ',I8)
	WRITE(3,4528)ND_REC.NODE_C_DESCRIPTION
4528    FORMAT(' ',T10,'IT IS DESCRIBED AS FOLLOWS : ',A70)
	L_COUNT=L_COUNT+6

C     FIND ALL MESSAGES THAT HAVE THIS AS A TARGET NODE
C     PRINT ALL TARGET NODES
C     GET RID OF NULL RECORD IN ID FILE

C     INITALIZE THE VARIABLES

 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)

	DO 4529 C_INX= 1,4
	  MES_OUT(C_INX)='                '
4529	END DO  ! C INX
	C_INX=0

	WRITE (3,4530)
4530    FORMAT('0',T47,'MESSAGES THAT ARE RECEIVED BY THIS NODE')
	WRITE (3,4539)
4539	FORMAT(' ')
	L_COUNT=L_COUNT+3

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=5500)ID_REC

	DO WHILE (.NOT. EOFILE)

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=4540)ID_REC
	IF (ID_REC.MES_C_PRIM_NODE .EQ. ND_REC.NODE_C_PRIME_NAME)THEN
	  C_INX=C_INX + 1
	  MES_OUT(C_INX)=ID_REC.MES_C_MESSAGE_ID
	  IF (C_INX.EQ.4)THEN
	    WRITE(3,4531)MES_OUT(1),MES_OUT(2),MES_OUT(3),MES_OUT(4)
4531	    FORMAT(' ',T13,A16,14X,A16,14X,A16,14X,A16)

	    IF(L_COUNT.GT.60)THEN
        	PAGE=PAGE+1
        	L_COUNT=0
        	WRITE(3,4521)PAGE
		WRITE(3,4522)ND_REC.NODE_C_PRIME_NAME
	 	WRITE(3,4533)
4533  		FORMAT(' ',T61,'CONTINUED')
		WRITE(3,4530)
		WRITE(3,4539)
		L_COUNT=6
	    END IF  ! L COUNT > 60
			      
	    DO 4532 C_INX= 1,4
	      MES_OUT(C_INX)='                '
4532	    END DO  ! C INX

	    C_INX=0
	  END IF  ! C_INX = 4

	END IF  !  NODES EQUIL

	END DO  ! WHILE NOT EOFILE

4540	WRITE(3,4531)MES_OUT(1),MES_OUT(2),MES_OUT(3),MES_OUT(4)
  
	CLOSE(UNIT=1,STATUS='KEEP')

C    THAT END THE FIRST PASS THROUH THE FILE FOR TARGET NODES
C    NOW SEE WHAT MESSAGES WE SEND
C    INITALIZE THE VARIABLES
C    REOPEN THE FILE SO YOU CAN READ FROM THE BEGINING

 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)

	DO 4550 C_INX= 1,4
	  MES_OUT(C_INX)='                '
4550	END DO  ! C INX
	C_INX=0

	WRITE (3,4551)
4551    FORMAT('0',T48,'MESSAGES THAT ARE SENT BY THIS NODE')
	WRITE(3,4539)

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=4560)ID_REC

	DO WHILE (.NOT. EOFILE)

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=4560)ID_REC

C   THIS IS THE BIT CHECK    

	FB_FOUND = .FALSE.
	FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK
	FB_FOUND = BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	IF (FB_FOUND) THEN
	  C_INX=C_INX + 1
	  MES_OUT(C_INX)=ID_REC.MES_C_MESSAGE_ID
	  IF (C_INX.EQ.4)THEN
	    WRITE(3,4531)MES_OUT(1),MES_OUT(2),MES_OUT(3),MES_OUT(4)

	    IF(L_COUNT.GT.60)THEN
        	PAGE=PAGE+1
        	L_COUNT=0
        	WRITE(3,4521)PAGE
		WRITE(3,4522)ND_REC.NODE_C_PRIME_NAME
	 	WRITE(3,4533)
		WRITE(3,4551)
		WRITE(3,4539)
		L_COUNT=6
	    END IF  ! L COUNT > 60

	    DO 4552 C_INX= 1,4
	      MES_OUT(C_INX)='                '
4552	    END DO  ! C INX
	    C_INX=0
	  END IF  ! C_INX = 4

	END IF  ! FB_FOUND  

	END DO  ! WHILE NOT EOFILE

4560	WRITE(3,4531)MES_OUT(1),MES_OUT(2),MES_OUT(3),MES_OUT(4)
  
	CLOSE(UNIT=1,STATUS='KEEP')

C     THAT ENDS THE SECOND PASS 
C    PASS THREE IS USED TO REPORT THE MESSAGES THAT ARE ROUTED THROUGH
C    THIS NODE.  WE READ THE FILE ONE MORE TIME.  IF THE NODE NAME WE
C    ARE REPORTING FOR IS ONE OF THE ROUTING NODES WE PRINT OUT THE
C    MESSAGE ID.

C     INITALIZE THE VARIABLES

 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)

	DO 4579 C_INX= 1,4
	  MES_OUT(C_INX)='                '
4579	END DO  ! C INX
	C_INX=0

	WRITE (3,4580)
4580    FORMAT('0',T47,'MESSAGES THAT ARE ROUTED BY THIS NODE')
	WRITE (3,4539)
	L_COUNT=L_COUNT+3

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=5500)ID_REC

	DO WHILE (.NOT. EOFILE)

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=4590)ID_REC

	DO I=1,6

	IF (ID_REC.MES_C_PATH_NODE(I) .EQ. ND_REC.NODE_C_PRIME_NAME)THEN
	  C_INX=C_INX + 1
	  MES_OUT(C_INX)=ID_REC.MES_C_MESSAGE_ID
	  IF (C_INX.EQ.4)THEN
	    WRITE(3,4531)MES_OUT(1),MES_OUT(2),MES_OUT(3),MES_OUT(4)

	    IF(L_COUNT.GT.60)THEN
        	PAGE=PAGE+1
        	L_COUNT=0
        	WRITE(3,4521)PAGE
		WRITE(3,4522)ND_REC.NODE_C_PRIME_NAME
	 	WRITE(3,4533)
		WRITE(3,4530)
		WRITE(3,4539)
		L_COUNT=6
	    END IF  ! L COUNT > 60
			      
	    DO 4582 C_INX= 1,4
	      MES_OUT(C_INX)='                '
4582	    END DO  ! C INX

	    C_INX=0
	  END IF  ! C_INX = 4

	END IF  !  NODES EQUIL

	END DO  ! I=1,6

	END DO  ! WHILE NOT EOFILE

4590	WRITE(3,4531)MES_OUT(1),MES_OUT(2),MES_OUT(3),MES_OUT(4)
  
	CLOSE(UNIT=1,STATUS='KEEP')
	GOTO 4520

C    CLOSE FILES

4605	CLOSE(UNIT=3,STATUS='KEEP',ERR=9925)
	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)
   	GOTO 4000

C   This option allows the user to print the source or sources of a 
C   message ID and its destination node.  The bit array of sources will 
C   be searched and corresponding names will be printed for the nodes. 
C   The user will supply the message id to be searched for.
C
4800 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)


	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9917,
     4    IOSTAT=IOSTATUS)



C    GET THE TIME FOR THE REPORT

	SYS_STATUS = SYS$ASCTIM(,
     1 				! ADDRESS OF WORD TO RECIVE THE LENGTH
     2				! OF THE OUTPUT STRING
     3		      VAX_TIME, ! ADDRESS OF CHARACTER STRING DISCRIPTOR 
     4				! THAT RECIVES THE CONVERTED STRING
     7		      ,,)
	IF (.NOT. SYS_STATUS) THEN
            CALL SYS$EXIT(%VAL(SYS_STATUS))
	END IF
	L_COUNT=61
	PAGE=0
	FIRST_TIME=.TRUE.

4810	CALL FDV$CDISP('BY_MESSAGE')
	CALL STATUS_CHECKER
	GOTO 4820

4815	CALL FDV$PUTL('NO SUCH MESSAGE EXISTS')
	CALL FDV$PUTD('BY_MESS_ID')

4820	CALL FDV$PUTD('BY_MESS_ID')
	CALL FDV$GET(ID_REC.MES_C_MESSAGE_ID,
     1               TERMINATOR,'BY_MESS_ID')

	IF (ID_REC.MES_C_MESSAGE_ID.EQ.'QUIT')THEN
	  GOTO 4900
	END IF

	IF (FIRST_TIME)THEN
          OPEN(UNIT=3,FILE='MESSAGE_REPORT.LIS',STATUS='NEW',ERR=9931)
	  CALL FDV$PUT('YOU ARE NOW CREATING  MESSAGE_REPORT.LIS',
     1    'BM_MES')
	  FIRST_TIME=.FALSE.
	END IF	


	IF (L_COUNT .GT.  50)THEN

	PAGE=PAGE+1
	WRITE(3,4821)PAGE
4821    FORMAT('1',T51,'MESSAGE REPORT FOR STORED DATA',T120,'PAGE=',
     1   I4.4)     
	WRITE(3,4826)VAX_TIME
4826	FORMAT(' ',T51,'AS OF ',A23)
	L_COUNT=2

	END IF

C    READ THE MESSAGE FILE TO MAKE SHURE THE MESSAGE EXIST AND
C    SCAN THE BIT MAP SO THAT THE NODE FILES MESSAGES ACCESSED 
C    MAY BE PRINTED

	READ(UNIT=1,KEY=ID_REC.MES_C_MESSAGE_ID,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=4815)ID_REC

C    SET THE PRINT POSITIONS BLANK

	DO 4830 C_INX=1,10
	  NODE_OUT(C_INX)='      '
4830    END DO
	C_INX=0

C    PRINT OUT THE BAICS

	WRITE(3,4850)ID_REC.MES_C_MESSAGE_ID
4850	FORMAT('0',T5,'MESSAGE ID : ',A16)
	WRITE(3,4851)ID_REC.MES_C_PRIM_NODE,ID_REC.MES_I_MESSAGE_SIZE
4851    FORMAT(' ',T10,'HAS A TARGET NODE OF : ',A6,
     1    ' AND IS ',I4,' BYTES LONG')
	L_COUNT = L_COUNT + 3

C    CHECK TO SEE WHAT NODES THE MESSAGE IS ROUTED THROUGH

	WRITE(3,4853)
4853	FORMAT('0',T10,'IT IS ROUTED THROUGH THESE NODES:')
	WRITE(3,4854)(ID_REC.MES_C_PATH_NODE(I),I=1,6)
4854    FORMAT(' ',T10,6(A6,6X))

C    CHECK TO SEE WHO SENT IT ORIGINALY

	WRITE(3,4852)
4852    FORMAT(' ',T10,'AND IS SENT BY THE FOLLOWING NODES : ')

C    SCAN THE BITS

	FB_LOOP = 0
	DO WHILE (FB_LOOP.LE.1024)
	  FB_FOUND = .FALSE.
	  FB_LOOP = FB_LOOP +1      !
	  FB_INDEX = FB_LOOP/32     !
	  FB_OFFSET = MOD(FB_LOOP,32)  !
	  FB_FOUND = BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)

	  IF (FB_FOUND) THEN
	    ND_REC.NODE_I_BIT_NUM = FB_LOOP


	    READ(UNIT=2,KEY=ND_REC.NODE_I_BIT_NUM,KEYID=1,
     1	      IOSTAT=IOSTATUS,ERR=9918)ND_REC

C    SPACE TO FILL IN SENDING NODE TO OUTPUT RECORD

	    C_INX=C_INX+1
	    NODE_OUT(C_INX)=ND_REC.NODE_C_PRIME_NAME
	    IF (C_INX.EQ.10)THEN
	      WRITE (3,4860)(NODE_OUT(I),I=1,10)
4860          FORMAT(T10,10(A6,6X))
	      L_COUNT = L_COUNT + 1
	      DO 4861 C_INX=1,10
		NODE_OUT(C_INX)='      '
4861	      END DO
	      C_INX=0
	    END IF

	  END IF  !FB_FOUND
	ENDDO  ! LOOP < 1024

	WRITE (3,4860)(NODE_OUT(I),I=1,10)
	L_COUNT = L_COUNT + 1
	GOTO 4820

4900	CLOSE(UNIT=3,STATUS='KEEP',ERR=9925)
	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)
	GOTO 4000

C    This module is used to build the database.  In our case the data base
C    is nothing more that a MAR FILE.
C
5000 	OPEN(UNIT=1,FILE='MESSAGE_ID.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',
     2    RECORDTYPE='FIXED',FORM='UNFORMATTED',RECORDSIZE=282,
     3    KEY=(1:16:CHARACTER),ERR=9921,IOSTAT=IOSTATUS)


	OPEN(UNIT=2,FILE='NODE_DESCRIP.DAT',STATUS='OLD',
     1    ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=111,
     3    KEY=(1:6:CHARACTER,108:111:INTEGER),ERR=9917,
     4    IOSTAT=IOSTATUS)
	

	OPEN(UNIT=3,FILE='ROUTE_DATA_MASTER.DAT',STATUS='SCRATCH',
     1	  ORGANIZATION='INDEXED',ACCESS='KEYED',RECORDTYPE='FIXED',
     2    FORM='UNFORMATTED',RECORDSIZE=80,
     3    KEY=(1:4:INTEGER,5:10:CHARACTER),ERR=9923)


C    GET THE TIME FOR THE REPORT

	SYS_STATUS = SYS$ASCTIM(,
     1 				! ADDRESS OF WORD TO RECIVE THE LENGTH
     2				! OF THE OUTPUT STRING
     3		      VAX_TIME, ! ADDRESS OF CHARACTER STRING DISCRIPTOR 
     4				! THAT RECIVES THE CONVERTED STRING
     7		      ,,)
	IF (.NOT. SYS_STATUS) THEN
            CALL SYS$EXIT(%VAL(SYS_STATUS))
	END IF

C    DISPLAY THE SCREEN AND CHECK FOR A VALID NODE

	CALL FDV$CDISP('BUILD_BASE')
	CALL STATUS_CHECKER
	GOTO 5020

5010    CALL FDV$PUTL('NO SUCH NODE REENTER OR QUIT')
	CALL FDV$PUTD('BUILD_NAME')

C   CHECK TO SEE IF THE USER WANTS TO QUIT

5020	CALL FDV$GET(FN.BLD_C_NODE,TERMINATOR,'BUILD_NAME')
	ND_REC.NODE_C_PRIME_NAME=FN.BLD_C_NODE
	IF (FN.BLD_C_NODE .EQ. 'QUIT  ')THEN
	  GOTO 5605
	END IF 

C  READ THE NODE TO SEE IF ITS GOOD

        READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1    IOSTAT=IOSTATUS,ERR=5010)ND_REC

C    CHECK TO SEE IF IT IS A BUILDABLE NODE

	IF (ND_REC.NODE_C_TYPE.EQ.'OTR')THEN
	  CALL FDV$PUTL('A DATABASE FOR THIS NODE CAN NOT BE CREATED')
	  CALL LIB$WAIT(5.)
	  CALL FDV$PUTD('BUILD_NAME')
	  GOTO 5020
	ELSE
	  NODE_TYPE=ND_REC.NODE_C_TYPE
	ENDIF


	FB_LOOP=ND_REC.NODE_I_BIT_NUM  ! SET THE BIT POSITION FOR SEARCH


C    SET UP THE FILE NAME THAT WILL BE USED FOR THE REPORT. ADD A PREFIX
C    AND SUFFIX TO THE ENTERED FILE NAME.  DISPLAY IT FOR THE USER

	FN.NAME_PRE   ='ROUTE_DATABASE_'
	FN.NAME_SUFIX ='.MAR'

	CALL FDV$PUT('YOU ARE CREATING ','BB_MES')
	CALL FDV$PUT(FN.FILE_NAME,'BB_NAME')

C    OPEN THE FILE THAT WILL HOLD THE DATABASE.  USE THE FILENAME YOU
C    HAVE JUST CREATEAD.  THIS IS SO WE CAN HAVE DIFFERENT FILE NAMES
C    FOR EACH ROUTER

	OPEN(UNIT=4,FILE=FN.FILE_NAME,STATUS='NEW',
     1    CARRIAGECONTROL='LIST',ERR=9924)

C    THIS SETS UP A DUMMY RECORD FOR THE MASTER FILE SO THE SECONDARY
C    KEY MAY BE USED TO READ BY.  PRIMARY KEY IS TRASH

	MAST_REC.MASTER_I_P_KEY=0
	MAST_REC.MASTER_C_NODE_NAME='      '
	WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9927)MAST_REC

C    THIS IS THE LOGIC FOR SCANNING THE FILES TO SEE IF THE NODE 
C    WE ARE IN THE PROCESS OF BUILDING IS USED AS A ROUTING NODE
C    IS USED AS A TARGET NODE OR IS A SENDING NODE

C    INITIALISE THE COUNTERS USED TO HOLD THE NUMBER OF MESSAGES
C    SENT BY THE NODE WE ARE BUILDING AND THE MAXIMUN SIZE

	MAST_REC.MASTER_I_P_KEY=0
	MAX_OUT_SIZE=0
	MAX_OUT_COUNT=0
	MAX_RESPONCE=MAX_OUT_COUNT

C 	GET RID OF NULL RECORD IN ID FILE BECAUSE IT IS USED TO HOLD
C    ALL THE NODES AND IT WOULD DESTROY THE DATABASE

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=5500)ID_REC

C    SET UP A LOOP TO DO THE PROCESSING IN

	DO WHILE (.NOT. EOFILE)

C    READ THE RECORDS

 	READ(UNIT=1,IOSTAT=IOSTATUS,ERR=9926,END=5500)ID_REC
	


C    DETURMEN IF YOU ARE A TARGET NODE OR IF YOU ARE A SOURCE NODE

C    TARGET?

	IF (ID_REC.MES_C_PRIM_NODE.EQ.FN.BLD_C_NODE)THEN
	  GOTO 5200					! TARGET
	ENDIF

C    ROUTING?

	DO J=1,6
	  IF (ID_REC.MES_C_PATH_NODE(J).EQ.FN.BLD_C_NODE)THEN
	    POSITION=J
	    GOTO 5050
	  END IF
	END DO

C    SENDING?

	IF (ID_REC.MES_C_PRIM_NODE.NE.FN.BLD_C_NODE)THEN
	  GOTO 5100
	END IF	

C    IF YOU ARE IN THE FIRST POSITION
C    YOU MUST MUST CHECK THE BITMAP TO SEE WHO SENDS YOU.
C    IF YOU ARE IN POSITION 2 THROUGH 6 YOU COME FROM THE POSITION
C    BEHIND YOU   IE. 1 TO 5 MENERATE A EMPTY NODE STATEMENT
C    ONCE YOU HAVE FOUND OUT WHO SENDS YOU DETURMEN WHERE TO ROUT IT
C    TO IT ISNOT NESSASARLY THE TARGET NODE.
C    CHECK THE POSSITION IN THE ARRAY ONE AFTER YOU.  IF IT IS NOT
C    BLANK IT IS THE TARGET NODE.
C    IF IT IS BLANK OR YOU FIND YOU ARE IN THE SIXTH POSITION THE TARGET
C    NODE IS THE ID_REC.MES_C_PRIM_NODE 

C    LOOK AHEAD IN THE ARRAY AND SEE WHO YOU PASS THE MESSAGE TO
 
5050 	IF (POSITION.EQ.6.OR.
     1     ID_REC.MES_C_PATH_NODE(POSITION+1).EQ.'      ')THEN
	  MAST_REC.MASTER_C_NODE_NAME = ID_REC.MES_C_PRIM_NODE
	  MAST_REC.MASTER_C_MESS_ID = ID_REC.MES_C_MESSAGE_ID
	  MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	  WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC
	ELSE
	  MAST_REC.MASTER_C_NODE_NAME = 
     1      ID_REC.MES_C_PATH_NODE(POSITION+1)
	  MAST_REC.MASTER_C_MESS_ID = ID_REC.MES_C_MESSAGE_ID
	  MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	  WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC
	  
	END IF

C    UPDATE THE MESSAGE ACCESSED INFORMATION 

	  MAX_OUT_COUNT = MAX_OUT_COUNT + 1
	  IF (MAX_OUT_SIZE.LT.ID_REC.MES_I_MESSAGE_SIZE)THEN
	    MAX_OUT_SIZE = ID_REC.MES_I_MESSAGE_SIZE
	  END IF  ! SIZE

C    NOW LOOK TO SEE WHO SENT YOU IF YOU ARE IN POSSITION ONE SCAN THE 
C    BITTARRAY FOR THE SENDING ELSE TAKE THE POSITION BEFOR YOU

 	IF (POSITION.EQ.1)THEN
	I=0
	DO WHILE (I.LT.1024)
	  I=I+1
	  FB_FOUND = .FALSE.
	  FB_INDEX = I/32     ! FIND THE INDEX FOR THE ARRAY
	  FB_OFFSET = MOD(I,32)  !THE BIT POSIYION TO CHECK
	  FB_FOUND = BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	  IF (FB_FOUND) THEN
	    ND_REC.NODE_I_BIT_NUM=I
	    READ (UNIT=2,KEY=ND_REC.NODE_I_BIT_NUM,KEYID=1,
     1        IOSTAT=IOSTATUS,ERR=9939)ND_REC

	    MAST_REC.MASTER_C_NODE_NAME = ND_REC.NODE_C_PRIME_NAME
	    MAST_REC.MASTER_C_MESS_ID = '                '
	    MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	    WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC

	  END IF
	END DO

	ELSE

C    TAKE THE POSITION BEHIND YOU AND MAKE IT THE SENDING NODE

	  MAST_REC.MASTER_C_NODE_NAME = I
     1	    D_REC.MES_C_PATH_NODE(POSITION-1)
	  MAST_REC.MASTER_C_MESS_ID = '                '
          MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	  WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC

	END IF ! 
	
	GOTO 5300 


C   I CHECK FOR SENDING NODES IF I AM NOT PART OF THE PATH
C   	  

C   SCAN THE BIT TO SEE IF YOU SEND ANY MESSAGES TO THIS NODE

5100	FB_FOUND = .FALSE.
	FB_INDEX = FB_LOOP/32     ! FIND THE INDEX FOR THE ARRAY
	FB_OFFSET = MOD(FB_LOOP,32)  !THE BIT POSIYION TO CHECK
	FB_FOUND = BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	IF (FB_FOUND) THEN
	  MAST_REC.MASTER_C_MESS_ID = ID_REC.MES_C_MESSAGE_ID
	  MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	  IF (ID_REC.MES_C_PATH_NODE(1).NE.'      ')THEN
	    MAST_REC.MASTER_C_NODE_NAME=ID_REC.MES_C_PATH_NODE(1)
	  ELSE
            MAST_REC.MASTER_C_NODE_NAME = ID_REC.MES_C_PRIM_NODE
	  ENDIF

	  WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC

	END IF

C    UPDATE THE MESSAGE ACCESSED INFORMATION 

	IF (FB_FOUND)THEN
	  MAX_OUT_COUNT = MAX_OUT_COUNT + 1
	  IF (MAX_OUT_SIZE.LT.ID_REC.MES_I_MESSAGE_SIZE)THEN
	    MAX_OUT_SIZE = ID_REC.MES_I_MESSAGE_SIZE
	  END IF  ! SIZE
	END IF ! FB_FOUND

	GOTO 5300

C   I AM A TARGET NODE

C   CHECK THE PATH ARRAY TO SEE IF A ROUTING NODE SENDS YOU IF NOT
C   SCAN THE BIT TO SEE WHO SENDS THE MESSAGE TO YOU

5200    POSITION=0
	DO J=1,6
	  IF (ID_REC.MES_C_PATH_NODE(J).NE.'      ')THEN
	    POSITION=J
	  END IF
	END DO

	IF (POSITION.NE.0)THEN
	  MAST_REC.MASTER_C_NODE_NAME=ID_REC.MES_C_PATH_NODE(POSITION)
	  MAST_REC.MASTER_C_MESS_ID = '                '
	  MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	  WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC


C   NOT IN PATH SCAN THE BITTS

	ELSE
	I=0

	DO WHILE (I.LT.1024)
	I=I+1
	FB_FOUND = .FALSE.
	FB_INDEX = I/32     ! FIND THE INDEX FOR THE ARRAY
	FB_OFFSET = MOD(I,32)  !THE BIT POSIYION TO CHECK
	FB_FOUND = BJTEST(ID_REC.MES_I_BITTARRAY(FB_INDEX),FB_OFFSET)
	IF (FB_FOUND) THEN
	  ND_REC.NODE_I_BIT_NUM=I
	  READ (UNIT=2,KEY=ND_REC.NODE_I_BIT_NUM,KEYID=1,
     1      IOSTAT=IOSTATUS,ERR=9939)ND_REC

	  MAST_REC.MASTER_C_NODE_NAME = ND_REC.NODE_C_PRIME_NAME
	  MAST_REC.MASTER_C_MESS_ID = '                '
	  MAST_REC.MASTER_I_P_KEY = MAST_REC.MASTER_I_P_KEY + 1

	  WRITE(UNIT=3,IOSTAT=IOSTATUS,ERR=9928)MAST_REC

	END IF

	END DO  ! WHILE  I < 1024


	END IF  ! END OF LOOP ASSOCIATED WITH EACH INPUT RECORD

5300	END DO  ! WHILE NOT EOFILE LOOP FOR READING


C    PRINT OUT THE ROUT DATABASES HEADER INFORMATION

5500	WRITE(4,5517)TAB,FN.BLD_C_NODE
5517	FORMAT(A1,' .TITLE RTRDBS FOR NODE ',A6)

C    PRINT OUT AN IDENT FOR THE DATABASE THE IDENT IS THE DAY
C    MONTH YEAR THE DATABASE WAS CREATED

	CALL IDATE(IDENT_MONTH,IDENT_DAY,IDENT_YEAR)
	WRITE(4,5514)TAB,IDENT_DAY,IDENT_MONTH,IDENT_YEAR
5514	FORMAT(A1,' .IDENT /',I2.2,I2.2,I2.2,'/')       


        WRITE(4,5501,IOSTAT=IOSTATUS,ERR=9929)TAB
5501    FORMAT(A1,' .LIBRARY /MA_Q$DEF:QUEUE.MLB/')
	WRITE(4,5513)
	WRITE(4,5510,IOSTAT=IOSTATUS,ERR=9929)TAB
5510    FORMAT(';',A1,' THIS IS THE ROUTE DATABASE')
	WRITE(4,5511,IOSTAT=IOSTATUS,ERR=9929)TAB,FN.BLD_C_NODE
5511    FORMAT(';'A1,' FOR NODE: ',A6)
	WRITE(4,5512,IOSTAT=IOSTATUS,ERR=9929)TAB,VAX_TIME
5512	FORMAT(';'A1,' CREATED  ON: 'A23)
	WRITE(4,5513)


	IF(NODE_TYPE.EQ.'VMS')THEN
	  WRITE(4,5502,IOSTAT=IOSTATUS,ERR=9929)TAB
5502      FORMAT(A1,' RTBUFDEF- ')
	  WRITE(4,5503,IOSTAT=IOSTATUS,ERR=9929)TAB,MAX_OUT_SIZE
5503      FORMAT(A1,' MAX_OUT_MSG_SIZE=',I5.5,'-')
	  WRITE(4,5504,IOSTAT=IOSTATUS,ERR=9929)TAB,MAX_OUT_COUNT
5504      FORMAT(A1,' MAX_OUT_MSG_COUNT=',I5.5)
	  WRITE(4,5513)
	ELSE
	  WRITE(4,5520)TAB,MAX_OUT_SIZE,MAX_OUT_COUNT
5520	  FORMAT(A1,' RTRDEF MXSZ=',I5.5,',MXOT=',I5.5)
	  WRITE(4,5513)
	END IF

C   READ THE MASTER FILE BY THE SECOND KEY NODE
C   READ THE FIRST RECORD TO SET UP A SEQUENTIAL READ

	MAST_REC.MASTER_C_NODE_NAME = '      '
	PREV_NAME = MAST_REC.MASTER_C_NODE_NAME


	READ (UNIT=3,KEY=MAST_REC.MASTER_C_NODE_NAME,KEYID=1,
     1    IOSTAT=IOSTATUS,ERR=9930)MAST_REC


	SEC_PASS=.FALSE.

	DO WHILE (.NOT. EOFILE)

	PREV_NAME = MAST_REC.MASTER_C_NODE_NAME
	READ (UNIT=3,IOSTAT=IOSTATUS,ERR=9931,END=5600)MAST_REC


	IF (PREV_NAME .NE. MAST_REC.MASTER_C_NODE_NAME.AND.SEC_PASS)THEN 

    
	  WRITE(4, 5505,IOSTAT=IOSTATUS,ERR=9929)TAB
5505	  FORMAT(A1,' ROUTE ')
	  WRITE(4,5513)
5513	  FORMAT('; ')
	ENDIF	


	IF (PREV_NAME .NE. MAST_REC.MASTER_C_NODE_NAME)THEN     
	  IF (NODE_TYPE.EQ.'VMS')THEN
	    WRITE(4,5506,IOSTAT=IOSTATUS,ERR=9929)TAB,
     1        MAST_REC.MASTER_C_NODE_NAME
5506        FORMAT(A1,' NODE PRINODE=',A6,',-')
	

C    SEE IF A SECONDARY NODE NAME EXISTS
	    ND_REC.NODE_C_PRIME_NAME=MAST_REC.MASTER_C_NODE_NAME
            READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=9939)ND_REC
	      IF (ND_REC.NODE_C_SEC_NAME.NE.'      ')THEN
	        WRITE(4,5508)TAB,ND_REC.NODE_C_SEC_NAME
5508            FORMAT(A1,'      SECONODE=',A6,',-')
	      END IF  ! = BLANK
	    WRITE(4,5533)TAB,ND_REC.NODE_I_INPSZ
5533	    FORMAT(A1,'      INPSIZ=',I4.4)

	  ELSE
	    ND_REC.NODE_C_PRIME_NAME=MAST_REC.MASTER_C_NODE_NAME
	    READ(UNIT=2,KEY=ND_REC.NODE_C_PRIME_NAME,KEYID=0,
     1        IOSTAT=IOSTATUS,ERR=9939)ND_REC
	      IF(ND_REC.NODE_C_SEC_NAME.NE.'      ')THEN
	    	WRITE(4,5522)TAB,MAST_REC.MASTER_C_NODE_NAME,
     1     	  ND_REC.NODE_C_SEC_NAME,ND_REC.NODE_I_INPSZ
5522		FORMAT(A1,'NODE PRI=<',A6,'>,SEC=<',A6,'>,SIZ=',I4.4)
	      ELSE
		WRITE(4,5523)TAB,MAST_REC.MASTER_C_NODE_NAME,
     1		ND_REC.NODE_I_INPSZ
5523		FORMAT(A1,'NODE PRI=<'A6,'>,SIZ=',I4.4)
	      ENDIF                        !       ='      '

	  END IF  ! VMS

	END IF    ! CHANGE NODES

C    CHECK TO SEE IF THE NODE ROUTES ANY MESSAGE (CHECK MESSAGE FIELD)

	IF (MAST_REC.MASTER_C_MESS_ID .NE. '                ') THEN
	  IF (NODE_TYPE.EQ.'VMS')THEN
	    WRITE(4,5507)TAB,MAST_REC.MASTER_C_MESS_ID
5507	    FORMAT(A1,' ROUTE        <',A16,'>')
	  ELSE
	    WRITE(4,5527)TAB,MAST_REC.MASTER_C_MESS_ID
5527	    FORMAT(A1,' ROUTE     ID=<',A16,'>')
	  END IF ! VMS
	ENDIF

	SEC_PASS=.TRUE.
	END DO

C    PLACE THE FINAL ROUTE STATEMENT IN AND PLACE THE END STATEMENT IN THE
C    FILE FOR THE DATABASE

5600    WRITE(4,5601,IOSTAT=IOSTATUS,ERR=9929)TAB
5601    FORMAT(A1,' ROUTE ')	

	IF(NODE_TYPE.EQ.'RSX')THEN
	  WRITE(4,5603)TAB
5603	  FORMAT(A1,'NODE')
	END IF

	WRITE(4,5602)TAB
5602	FORMAT(A1,' .END')	

5605	CLOSE(UNIT=4,STATUS='KEEP',ERR=9926)
	CLOSE(UNIT=3,STATUS='DELETE',ERR=9925)
	CLOSE(UNIT=2,STATUS='KEEP',ERR=9904)
	CLOSE(UNIT=1,STATUS='KEEP',ERR=9902)
	GOTO 1000

C    This module is used to finish the process.  Close and clean up what
c    you have used

C    ERROR DETECTION 

9901    TYPE*,'ERROR DECTION IN OPEN MESSAGE IDIN CREATION'
	GOTO 9998
9902    TYPE*,'ERROR DECTION IN CLOSE MESSAGE ID IN CREATION'
	GOTO 9998
9903    TYPE*,'ERROR DECTION IN OPEN NODE DATA IN CREATION'
	GOTO 9998
9904    TYPE*,'ERROR DECTION IN CLOSE NODE DATA IN CREATION'
	GOTO 9998
9905    TYPE*,'ERROR DETECTION IN WRITE NULL RECORD TO FILE'
	GOTO 9998
9906    TYPE*,'ERROR DETECTION IN WRITE RECORD IN ADD A NODE'
	GOTO 9998
9907	TYPE*,'ERROR DETECTED IN WRITE NULL RECIN ADD A NODE'
	GOTO 9998
9908	TYPE*,'ERROR DETECTED IN DELETE NODE'
	GOTO 9998
9909	TYPE*,'ERROR DETECTED IN READ ID DELETE NODE'
	GOTO 9998
9910	TYPE*,'ERROR DETECTED IN REWRITE ID IN DELETE NODE'
	GOTO 9998
9911	TYPE*,'ERROR DETECTED IN OPEN IN ADD A NODE'
	GOTO 9998
9912	TYPE*,'ERROR DETECTED IN OPEN IN ADD MES'
	GOTO 9998
9913	TYPE*,'ERROR DETECTED IN OPEN ND IN ADD MESS'
	GOTO 9998
9914	TYPE*,'ERROR DETECTED IN WRITE MESS ID'
	GOTO 9998
9915	TYPE*,'ERROR DETECTED IN REWRITE ND IN ADD MESS'
	GOTO 9998
9916	TYPE*,'ERROR DETECTED IN OPEN IN DELETE MES'
	GOTO 9998
9917	TYPE*,'ERROR DETECTED IN OPEN ND IN DELETE MES'
	GOTO 9998
9918	TYPE*,'ERROR DETECTED IN READ IN DELETE MESS'
	GOTO 9998
9919	TYPE*,'ERROR DETECTED IN REWRITE IN DELETE MESS'
	GOTO 9998
9920	TYPE*,'ERROR DETECTED IN DELETE IN DELETE MESS'
	GOTO 9998
9921	TYPE*,'ERROR DETECTED IN OPEN IN A/D MESS'
	GOTO 9998
9922	TYPE*,'ERROR DETECTED IN OPEN IN A/D MESS'
	GOTO 9998
9923	TYPE*,'ERROR DETECTED IN OPEN ROUT MAST IN BUILD'
	GOTO 9998
9924	TYPE*,'ERROR DETECTED IN '
	GOTO 9998
9925	TYPE*,'ERROR DETECTED IN '
	GOTO 9998
9926	TYPE*,'ERROR DETECTED IN READ ID REC SEQENTIALY'
	GOTO 9998
9927	TYPE*,'ERROR DETECTED IN WRITE ROUTE MAST IN BUILD'
	GOTO 9998
9928	TYPE*,'ERROR DETECTED IN 5100 WRITE UNIT 3 MAST REC'
	GOTO 9998
9929	TYPE*,'ERROR DETECTED IN 9929'
	GOTO 9998
9930	TYPE*,'ERROR DETECTED IN READ IN MAST REC AT SET UP SEQ READ'
	GOTO 9998
9931	TYPE*,'ERROR DETECTED IN 9931'
	GOTO 9998
9932	TYPE*,'ERROR DETECTED IN 9932'
	GOTO 9998
9933	TYPE*,'ERROR DETECTED IN 9933'
	GOTO 9998
9934	TYPE*,'ERROR DETECTED IN 9934'
	GOTO 9998
9935	TYPE*,'ERROR DETECTED IN 9935'
	GOTO 9998
9936	TYPE*,'ERROR DETECTED IN 9936'
	GOTO 9998
9937	TYPE*,'ERROR DETECTED IN 9937'
	GOTO 9998
9938	TYPE*,'ERROR DETECTED IN 9938'
	GOTO 9998
9939	TYPE*,'ERROR DETECTED IN 9939'
	GOTO 9998

9998	CALL FDV$LCLOS
	CALL FDV$DWKSP
	CALL FDV$CLEAR_VA
	CALL FDV$DTERM
	CALL FTN_IOSTAT
	TYPE*, 'IO STATUS: ',IOSTATUS
	STOP	
9999	CALL FDV$LCLOS
	CALL FDV$DWKSP
	CALL FDV$CLEAR
	CALL FDV$CLEAR_VA
	CALL FDV$DTERM
	CALL EXIT
	STOP
	END

C    THIS SUBROUTINE IS USED TO CHECK THE STATUS OF ALL IO OPERATIONS
C    IT GETS THE STATUS WITH A FDV$STAT AND  CHECKS. IF BAD DETACHES THE 
C    TERMINAL
C
	SUBROUTINE  STATUS_CHECKER 

	IMPLICIT    NONE
	INTEGER*4   TCA(3)              ! TERMINAL CONTROLE AREA
	INTEGER*4   FMSSTATUS		! STATUS OF FMS COMMANDS
	INTEGER*4   RMSSTATUS		! RMS STATUS
	INCLUDE      'FDVDEF'

C    CALL THE FMS SERVICE TO GET THE STATUSES
	
	CALL FDV$STAT(FMSSTATUS, RMSSTATUS)

C    CHECK THE FMS STATUS
C    IF ZERO OR LESS THERE IS AN ERROR.  DETACH THE TERMINAL GIVE IT TO
C    THE USER.  PRINT THE ERROR MESSAGES.  DO A FORTRAN STOP
	IF (FMSSTATUS.LE. 0) THEN
	  CALL  FDV$DTERM(%DESCR(TCA))
	  TYPE *,'FDV ERROR DETECTED IN CHECK'
	  TYPE *,'FMS STATUS: ',FMSSTATUS
	  IF  (FMSSTATUS .EQ. FDV$K_IOL .OR. 
     1         FMSSTATUS .EQ. FDV$K_IOR)
     2        TYPE*,'RMS STATUS:',RMSSTATUS
	  STOP
	ENDIF
	RETURN
	END
