	PROGRAM DIRECTORY_EXTRACT
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&DIRECTORY_EXTRACT\&
C .nf
C .x DIRECTORY_EXTRACT>Defined
C Source:DIRECTORY_EXTRACT.FOR
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C Date of last update: 24-JUN-1985 
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C    SOURCE_DIRECTORY.DAT                  
C                               READ                                              
C .X SOURCE_DIRECTORY.DAT>READ
C  
C    THIS FILE CONTAINS OUTPUT FROM THE                                           
C    DCL COMMAND:  "DIRECTORY *.FOR; /COL:1/OUTPUT=SOURCE_DIRECTORY.DAT
C 
C    MODULE.DRR
C                                WRITE
C .X MODULE.DRR>WRITE 
C    This file contains the device, directory and file name
C    for files  that are to be scanned by EXTRACT for 
C    generating a document with documentation on each
C    defined module within each program.
C 
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This program takes the output from the DCL DIRECTORY
C command and puts it in an output file:  MODULE.DRR which
C should be passed on to the task:  "EXTRACT".
C 
C end.doc ****************************** end.doc  

C
C The ouput from the DCL DIRECTORY command, was
c ( as actually unsaved into this program):
c
c          1111111111222222222233333333334  
c 1234567890123456789012345678901234567890   column
c
c Directory SYS$SYSDEVICE:[PEOPLE.LAKIA]
c 
c COM.FOR;2          
c DIRECTORY_EXTRACT.FOR;2
c
c Total of 2 files.
c

	CHARACTER*80 DIR_LINE	! UP TO 80 CHARACTER DIRECTORY LINE
C			 NOTE, WON'T BE ANY LARGER AS WE SET MAX ON FILE OPEN
C			 AND DIRECTORY ASSUMES AN 80 CHAR. SCREEN
	CHARACTER*80 DIR_DEV	! DIRECTORY AND DEVICE NAME
	CHARACTER*80 OUT_FILE   ! OUTPUT FILE NAME
	INTEGER DIRECTORY_COUNT ! NUMBER OF UNIQUE DIRECTORIES
	INTEGER FILE_COUNT	! NUMBER OF UNIQUE FILES
	INTEGER*2 dirlth	! LENGTH OF DIRECTORY STRING
	INTEGER*2 ILNTH		! LENGHT OF INPUT RECORD
C
C
C
	DATA ITI/5/	! TERMINAL INPUT
	DATA IDIR/2/	! DIRECTORY INPUT FILE LUN
	DATA IDRR/3/	! OUTPUT DRR FILE
	DATA FILE_COUNT/0/ ! NUMBER OF FILES ENCOUNTERED
	DATA DIRECTORY_COUNT/0/	! NUMBER OF UNIQUE DIRECTORIES ENCOUTERED

C
C OPEN THE DIRECTORY LISTING FILE
C FROM THE DCL "DIRECTORY COMMAND"
C
	OPEN(UNIT=IDIR,NAME='SOURCE_DIRECTORY',
	1	TYPE='OLD',DISPOSE='DELETE',
	2	ACCESS='SEQUENTIAL',ERR=9000,
	3	RECORDSIZE=80)
C
C OPEN OUR OUTPUT DIRECTORY FILE TO BE USED BY EXTRACT
C
	OPEN(UNIT=IDRR,NAME='MODULE.DRR',TYPE='NEW',
	1	RECORDSIZE=80,ACCESS='SEQUENTIAL',
	2	ERR=9100,CARRIAGECONTROL='LIST')
C
C READ A RECORD FROM THE DIRECTORY FILE
C
500	READ(IDIR,600,END=9200)ILNTH,DIR_LINE(1:ilnth)
600	FORMAT(Q,A<ilnth>)

C
C NOW DETERMINE IF WE HAVE:
C	1)  A DEVICE AND DIRECTORY STRING RECORD
C	2)  A BLANK LINE
C	3)  A LINE WITH ONE OR MORE FILENAMES 
C	4)  SUMMARY LINE, IE:  Total of 2 files
C
	IF(ILNTH.EQ.0 .OR. DIR_LINE(1:1) .EQ. ' ') GO TO 500 ! SKIP BLANK LINES
C
	IF(INDEX(DIR_LINE,'Directory') .GT. 0 .and.
	1	INDEX(DIR_LINE,']') .GT. 0 .AND.
	2	INDEX(DIR_LINE,'[') .GT. 0) THEN	! HAVE A NEW DIRECTORY

C
C		SAVE THE DEVICE AND DIRECTORY NAME FOR ALL
C		FILE UNTIL WE FIND A NEW DIRECTORY AND DEVICE
C		RECORD.
C
		DO 750 IS = ILNTH, 1, -1		! SCAN FOR BLANK
			IF(DIR_LINE(IS:IS) .NE. '[')GO TO 750 ! END OF DIR. STR?
			DIRLTH=(ILNTH-IS+1)	! SIZE OF DIRECTORY STRING
			DIR_DEV(1:DIRLTH)=DIR_LINE(IS:ILNTH) ! COPY DIRECTORY
			DIRECTORY_COUNT=DIRECTORY_COUNT+1
			GO TO 500		! GET NEXT RECORD
750		CONTINUE
	ELSE
		IF(INDEX(DIR_LINE,'Total of').GT.0 .OR.
	1		INDEX(DIR_LINE,'Grand total') .GT. 0
	1		) GO TO 500 ! SKIP SUMMARY
C
C		WRITE EACH FILE NAME WITH THE DEVICE AND DIRECTORY
C		PRECEEDING IT.
C
		IF((DIRLTH+ILNTH).GT.80)THEN
			TYPE 775,DIR_DEV(1:DIRLTH),
	1		DIR_LINE(1:ILNTH)
775			FORMAT(' DIRECTORY/FILE TOO LONG:',/,
	1			1x,A<DIRLTH>,/,1x,A<ILNTH>)
			GO TO 820	! SKIP THE FILE
		ENDIF
C
		WRITE(IDRR,800)DIR_DEV(1:DIRLTH),DIR_LINE(1:ILNTH)
800		FORMAT(A<DIRLTH>,A<ILNTH>)
820		FILE_COUNT=FILE_COUNT+1
	ENDIF
	GO TO 500

C
C FILE OPEN ERRORS
C
9000	TYPE 9010
9010	FORMAT(' Unable to open input file:  SOURCE_DIRECTORY.DAT')
	CALL LIB$STOP(%VAL(1))
C
9100	TYPE 9110
9110	FORMAT(' Unable to open output file:  MODULE.DRR')
	CALL LIB$STOP(%VAL(1))
C
9200	TYPE 9210,FILE_COUNT,DIRECTORY_COUNT
9210	FORMAT(1X,I5,' files defined in ',I5,' directories')
	CLOSE(UNIT=IDRR)
	CLOSE(UNIT=IDIR,DISPOSE='DELETE')
	END
