	PROGRAM FIND_SERVICE
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&FIND_SERVICE\&
C .nf
C .x FIND_SERVICE>Defined
C Source:FIND_SERVICE.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:24-FEB-1987 09:21
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C .X ROUTE_DATABASE>Common
C    ROUTE_DATABASE             MA-ROUTER DATABASE                                
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG MESSAGES/ERRORS                               
C                                (found in library:INLAND)
C  
C .X GET_SERVICE>Referenced
C    GET_SERVICE                CALLED TO ACTUALLY FIND THE SERVICE ON REMOTE     
C                               NODE. (USE SUBR. SO CAN PASS GLOBAL SECTION       
C                               ADDRESS).                                         
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This program is requested by a create process from the MA_ROUTER 
C program.   When this process is started, it maps to the MA_ROUTER's 
C routing database and scans for any NRBs (nodes) that show that
C the primary node is a Logical node name and that a logical
C connection is not present.   The process then calls 
C SYCLU2::TASK=SERVICE with the desired logical name to find what
C node the service is currently on.  If this is successful, the
C NRB for this node  is modified to point to this node.
C IE: if the logical name is "PROD  ", and after calling the
C service on SYCLU2, the node that is performing this is
C SY880A, then the NRB$C_SECNODE will be filled in with
C the SY880A node name.
C 	This process must run at the same uic as the MA_Router
C as the global section is only group global.
C end.doc ****************************** end.doc  

	INCLUDE 'FIND_SERVICE.INC/LIST'
	INCLUDE '($SSDEF)'
	INCLUDE '($SECDEF)'
	INTEGER*4 INET		! LUN/CHANNEL FOR NETWORK
	CHARACTER*6 NODE	! NODE NAME
	INTEGER*4 IOSTAT	! DECNET OPEN STATUS
	INTEGER*4 I,J,K		! LOOP VARIABLE
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS LONG WORD
	INTEGER*4 SYS$MGBLSC	! MAP GLOBAL SECTION	
	INTEGER*4 SYS$EXIT	! EXIT PROCESS
	INTEGER*4 NRBCOUNT	! NUMBER OF NRB'S ENCOUNTERED
	INTEGER*4	GLB_VRT_ADDR(2)		! VIRTUAL ADDRESS OF THE
						! GLOBAL SECTION NAME
	INTEGER*4	MAPPED_ADDR(2)		! ADDRESS MAPPED BY SYS$MGBLSC
	INTEGER*4	SECTION_FLAGS		! FLAG MASK SPECIFYING THE TYPE
						! OF SECTION TO BE MAPPED
	INTEGER*4 RELPAG		! RELATIVE PAGE IN SECTION
	INTEGER*4 OPR_FAO_MSG
	INTEGER*4 FNS_FOUNDSERVICE	! MESSAGE FOR CONSOLE
	EXTERNAL FNS_FOUNDSERVICE	
C
	STRUCTURE/IOSTATUS/
	 UNION
	   MAP
	     INTEGER*4 LW(2)
           END MAP
C
	   MAP
	     INTEGER*2 COND	! CONDITION VALUE
	     INTEGER*2 TRANS	! TRANSFER BYTE COUNT
	     INTEGER*4 SPEC	! DEVICE SPECIFIC
	   END MAP
	 END UNION
	END STRUCTURE
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(NRBID)/LIST'
C
C THIS COMMON IS MAPPED BY THE MAP GLOBAL SECTION
C AND WILL BE USED TO FIND THE NRB.
C
C
C STRUCTURE OF ROUTING DATABASE HEADER IS:
C	.LONG   VERSION NUMBER
C	.LONG	FLAG
C	.LONG   OFFSET TO RESPONSE BUFFERS LIST
C	.LONG   OFFSET TO OUTPUT BUFFERS LIST
C	.LONG	NUMBER OF MESSAGE IDS THAT WILL BE ROUTED
C	.REPT	NUMBER OF NRBS
C	.LONG 	OFFSET TO NRB (I)
C	.ENDR
C	.LONG	0
C 
	INTEGER*4 VERSION
	INTEGER*4 FLAG
	INTEGER*4 RESPOFF
	INTEGER*4 NBRIDS
	INTEGER*4 OTBUFOFF
	INTEGER*4 NRBLST(125)	! ALLOW FOR UP TO 100 NODES AND FILL TO 1 BLOCK
	INTEGER*4 FILL
	COMMON/NRBLST/VERSION,FLAG,RESPOFF,OTBUFOFF,NBRIDS,NRBLST,FILL
C
C THE FOLLOWING STRUCTURE WILL BE MAPPED TO A SINGLE NRB
C
C
	RECORD/NRBDEF/NRB
	RECORD/NRBID/NRBID
	INTEGER*4 BLOCK(128)	! make sure don't overflow anything
	COMMON/NRB/NRB,NRBID(10),BLOCK
C
	DATA INET/1/

C
C ATTACH TO THE GLOBAL SECTION
C AND MAP THE NRBLST COMMON TO IT.
C
	SECTION_FLAGS = SEC$M_WRT	! WRITE ACCESS
	GLB_VRT_ADDR(1)=%LOC(VERSION)	! BEG. V.A. TO MAP (USE NRBLST COMMON)
	GLB_VRT_ADDR(2)=%LOC(NRBLST(125)) ! END V.A. TO MAP
D	TYPE *,' MAPPING ROUTEING DATABASE HEADER '
D	WRITE (*,300)GLB_VRT_ADDR
D300	FORMAT(' START VA: ',Z8,' END VA: ',Z8)
C
	SYS_STATUS = SYS$MGBLSC(
	1	   GLB_VRT_ADDR,	      	! STARTING VIRTUAL ADDRESS
	1	   MAPPED_ADDR,			! ACTUAL ADDRESS MAPPED BY SYSTEM
	1	   ,
	1	   %VAL(SECTION_FLAGS),		! SECTION FLAGS OPTIONS
	1	   'ROUTE_DBS_SECT',,)		! USER DEFINED SECTION NAME
C
D	WRITE(*,300)MAPPED_ADDR
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO MAP THE ROUTING DATABASE LISTHEAD'
		TYPE *,' MAKE SURE YOU ARE AT THE SAME GROUP AS THE'
		TYPE *,' MA_ROUTER AND THAT MA_ROUTER IS ACTIVE'
		TYPE *,' EXIT REASON: '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
D	WRITE(*,400)VERSION,FLAG
D400	FORMAT(' DATABASE VERSION: ',Z8.8,' FLAG: ',Z8.8)
C
C LOOP FOR EACH NRB
C
	I=1		! INIT FOR FIRST NRB
1000	CONTINUE
	IF(NRBLST(I) .EQ. 0)THEN
D		TYPE *,' NO MORE NRBs, TOTAL NUMBER OF NRBS IS: ',NRBCOUNT
		CALL SYS$EXIT(%VAL(SS$_NORMAL))
	ENDIF
	NRBCOUNT=NRBCOUNT+1	! INCREMENT NUMBER OF NRBS
D	TYPE *,' MAPPING NRB: ',NRBCOUNT
D	WRITE (*,1010)NRBLST(I)
D1010	FORMAT(' NRB OFFSET: ',Z8)
C
	GLB_VRT_ADDR(1)=%LOC(NRB)	! BEG. V.A. TO MAP (USE NRB COMMON)
	GLB_VRT_ADDR(2)=(%LOC(NRBID(10))+511)	! END V.A. TO MAP
	GLB_VRT_ADDR(2)=GLB_VRT_ADDR(2) .AND. (.NOT. "377) ! MAP EVEN BLOCK

C
	RELPAG=NRBLST(I)/512	! RELATIVE PAGE FOR THIS NRB
				! NOTE: NRB's are page aligned
C
D	WRITE (*,1015)RELPAG
D1015	FORMAT(' RELATIVE PAGE: ',Z8)
D	WRITE (*,300)GLB_VRT_ADDR
	SYS_STATUS = SYS$MGBLSC(
	1	   GLB_VRT_ADDR,	      	! STARTING VIRTUAL ADDRESS
	1	   MAPPED_ADDR,			! ACTUAL ADDRESS MAPPED BY SYSTEM
	1	   ,
	1	   %VAL(SECTION_FLAGS),		! SECTION FLAGS OPTIONS
	1	   'ROUTE_DBS_SECT',		! USER DEFINED SECTION NAME
	1          , %VAL(RELPAG))		! RELATIVE PAGE
C
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO MAP THE ROUTING DATABASE NRB'
		TYPE *,' MAKE SURE YOU ARE AT THE SAME GROUP AS THE'
		TYPE *,' MA_ROUTER AND THAT MA_ROUTER IS ACTIVE'
		TYPE *,' EXIT REASON: '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
D	WRITE(*,300)MAPPED_ADDR
C
C	PRINT OUT THE PRIMARY AND SECONDARY NODE NAMES
C
C
D	WRITE (*,1175)NRB.NRB$C_CURNODE
D1175	FORMAT(/,' CURRENT NODE: ',A)
D	WRITE (*,1100)NRB.NRB$C_PRINODE
D1100	FORMAT(//,' PRIMARY NODE: ',A)
D	WRITE(*,1200)NRB.NRB$C_SECNODE
D1200	FORMAT(' SECONDARY NODE: ',A)
D	WRITE(*,1300)NRB.NRB$L_FLAGS
D1300	FORMAT(' FLAGS: ',Z8.8)

C
C FOR EACH NODE THAT IS NOT AVAILABLE AND THE LOGICAL NODE
C NAME TYPE IS PRESENT, THEN REQUEST FROM OUR BROTHERS
C AT SYSTEM OR SOMEWHERE ELSE, THE APPROIATE NAME OF THE
C NODE WE ARE TO CONNECT WITH.
C
	I=I+1	! NEXT NRB INDEX
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_PRILOG)
	1	 .EQ. 0)GO TO 1000   ! NOT OF CORRECT TYPE
C
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_LNKAVL)
	1	 .NE. 0)GO TO 1000   ! LINK IS AVAILABLE, LEAVE AS IS
C
C WE HAVE A LINK DOWN, TAKE THE LOGICAL NAME (NRB$C_PRINODE) AND
C CHANGE TO LOGICAL NODE NAME TO A MATCHING SERIVICE AVAILABLE
C FROM OUR BROTHERS AT SYSTEMS.  WOULD HAVE DONE THIS WITH A LOGICAL
C BUT FELT THAT MAINTAINING A LOGICAL IS JUST AS BAD AS MAINTAINING 
C AN INCLUDE FILE AND NOT AS EASY TO UNDERSTAND.
C
	DO J=1, SERVICE_COUNT  ! LOOP FOR NUMBER OF SERVICES (ACTUALLY
				! NUMBER OF UNIQUE NODES
D	  TYPE *,' LOGICAL_NODE(J)  ',LOGICAL_NODE(J)
D	  TYPE *,' NRB.NRB$C_PRINODE  ', NRB.NRB$C_PRINODE
	  IF(NRB.NRB$C_PRINODE .EQ. LOGICAL_NODE(J) )THEN  ! MATCH LOGICAL NODES
C
C 	 	FOUND THE DESIRED LOGICAL NODE NAME, NOW REQUEST FROM
C		SYSTEMS ASKING FOR WHERE THIS SERVICE IS SUPPORTED.
C
C		$ OPEN/READ/WRITE NETWORK_STREAM SYCLU2::"TASK=WHATSWHERE"
C		$ WRITE NETWORK_STREAM "''P1'"
C		$ READ NETWORK_STREAM DATA
C
		TYPE *,' LOGICAL NODE: ',LOGICAL_NODE(J)
		TYPE *,' SERVICE NAME: ',SERVICE_NAME(J)
C
		OPEN(UNIT=INET,NAME='SYCLU2::"TASK=WHATSWHERE"',
	1		ERR=9000,IOSTAT=IOSTAT,TYPE='OLD')
C
		WRITE(INET,800)SERVICE_NAME(J)
800		FORMAT('WHATNODES ',A20)
		READ(INET,810)NODE
810		FORMAT(A6)
		TYPE *,' SERVICING NODE: ',NODE
		IF(NODE .NE. 'ERROR ')
	1		NRB.NRB$C_SECNODE=NODE	! MODIFY IN ROUTING DATABASE
d		SYS_STATUS=OPR_FAO_MSG(FNS_FOUNDSERVICE,
d	1		%DESCR(SERVICE_NAME(J)),%DESCR(NODE))
		CLOSE (UNIT=INET)
		GO TO 1000
	  ENDIF
	ENDDO
	GO TO 1000
C
C NETWORK ERROR
C
9000	TYPE *,' UNABLE TO ACCESS NETWORK TO FIND SERVICE'
	CALL SYS$EXIT(%VAL(IOSTAT))
	END
