	OPTIONS/EXTEND
	INTEGER*4 FUNCTION CON_TIMER_AST(NRB,R0,R1,PC,PSL)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&CON_TIMER_AST\&
C .nf
C .x CON_TIMER_AST>Defined
C Source:CON_TIMER_AST.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 7-JUL-1986 09:41:08.95
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NODE REQUEST BLOCK OF NODE CONNECTION TIMEOUT     
C                               OCCURRED ON.                                      
C    R0                         INTEGER*4                                         
C                               SAVED R0 FROM AST                                 
C  
C    R1                         INTEGER*4                                         
C                               SAVED R1 FROM AST                                 
C  
C    PC                         INTEGER*4                                         
C                               SAVED PC FROM AST                                 
C  
C    PSL                        INTEGER*4                                         
C                               SAVED PSL FROM AST                                
C  
C Returns:
C  
C Accesses common(s):
C 
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MA_ROUTER COMMON PARAMETERS SHARED THROUGHTOUT    
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG MESSAGE TO CONSOLE                            
C                                (found in library:INLAND)
C  
C .X PUSH_EVENT_QUE>Referenced
C    PUSH_EVENT_QUE             USED TO PUSH CONNECT EVENT INTO THE EVENT QUEUE   
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called when a timer expires while attempting to
c connect to a remote node.  The NRB is passed of the node that the timer
c expired for.  This is not the DECNET connect timeout but rather one
c that we set for ourselves.  This routine will deassign the channel number
c if present (may not be present if inital attemp also failed).  
c Push event so that
c mainline will attempt to reconnect in an orderly fashion.
c 	The calling sequence is via the SETIMR system service call
c where the AST address is us, and the NRB is the REQID.
c  
C end.doc ****************************** end.doc  

	INTEGER*4 R1,R0,PSL,PC	! AST PARAMETERS THAT WE DON'T USE IN FORTRAN
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
	INCLUDE 'EVENT_Q.INC/NOLIST'
	RECORD /EVENT_ENTRY/EVENT
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS_STATUS2
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$DASSGN	! DEASSIGN CHANNEL
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 PUSH_EVENT_QUE ! PLACE EVENT IN QUEUE

C
C DEBUG, LOG THE NODE
C
D	SYS_STATUS=OPR_FAO_MSG(RTR_CONTIMAST,NRB.NRB$Q_NCBDES)
C
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_CONTIMER) .EQ. 0)RETURN
		! AS WAS QUEUED BUT BECAUSE OF OTHER AST BEING
		! SERVICED (SUCH AS ONE THAT MAY CANCEAL THE MARKTIME,
		! THIS ROUTINE COULD STILL HAVE BEEN PENDING.  THREFORE
		! IGNORE THIS AST IF IT HAPPENS.
C
	IF(NRB.NRB$L_CHAN .NE. 0)THEN
	   SYS_STATUS=SYS$DASSGN(%VAL(NRB.NRB$L_CHAN))
	   IF(.NOT. SYS_STATUS)THEN
		MSGDESC(1)=512
		SYS_STATUS2=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS2=OPR_FAO_MSG(RTR_DEAFAL,MSGDESC)
		SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	    ENDIF
	ENDIF
C
C PLACE EVENT INTO THE QUEUE
C
	NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .AND.
	1	(.NOT. NRB$M_CONTIMER)  ! SET TIMER NOT ACTIVE
	EVENT.EVENT=CON_TIMEOUT	! CONNECT TIMEOUT EVENT
	EVENT.NRBADD=%LOC(NRB)  ! PASS NRB
	SYS_STATUS=PUSH_EVENT_QUE(EVENT)
C
D	SYS_STATUS=OPR_FAO_MSG(RTR_CONTMO,NRB.NRB$Q_NCBDES)
	RETURN
	END
