	OPTIONS/EXTEND
	INTEGER*4 FUNCTION GET_OUT_MESG(BUF,NRB,NRBID)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&GET_OUT_MESG\&
C .nf
C .x GET_OUT_MESG>Defined
C Source:GET_OUT_MESG.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 8-MAY-87
C Revision level     :1.4
C  
C .C ;Formal Parameter List
C Receives:
C  
C    BUF                        STRUCTURE/BUFDEF/                                 
C                               BUFFER THAT IS TO RECIEVE THE MESSAGE FROM QUEUE  
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB THAT THIS MESSAGE IS BEING ROUTED TO          
C  
C    NRBID                      STRUCTURE/NRBID/                                  
C                               NRBID MESSAGE ID ROUTING ENTRY IN NRB             
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MA ROUTET LOCAL GLOBAL COMMON                     
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG ERRORS TO OPERATOR CONSOLE                    
C                                (found in library:INLAND)
C  
C .X READ_Q>Referenced
C    READ_Q                     GET A MESSAGE FROM THE QUEUE                      
C                                (found in library:QUEUE)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called to fill in a buffer
C allocated from the output buffer pool of buffers.  This
C subroutine simply gets the message from the queue (message
C id comes from NRBID$C_MSGID) into the message buffer and
C fills in all the poop needed to do the QIO.  The subroutine
c then actually does the QIO.
C  
C .literal
C CALLING SEQUENCE
C  
C      INTEGER*4 GET_OUT_MSG
C      INTEGER*4 SYS_STATUS
C      SYS_STATUS=GET_OUT_MSG(%VAL(BUF_ADDR),NRB,NRBID)
C 
C .end literal
C 	If the status returned is not valid, then the buffer
C should be deallocated by the calling routine as we could not
C get a message from the queue.
C 	NOTE:  
C	THIS SUBROUTINE MUST BE CALLED WITH AST'S LOCKED OUT
C AS THE OUTPUT LINK SEQUENCE NUMBER IS MODIFIED BY THIS ROUTINE.
C 
C end.doc ****************************** end.doc  
C
C 1.8  5/8/87  E. LAKIA
C	Added support for a read error from the queue (ie: set
c 	the MID$M_QUERDERR bit in MID$L_STAT.  We use to only
c	set the no route bit,  however, this gives more information.
c

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBID)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUEMSG)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(BUFDEF)/LIST'
C
	RECORD/NRBID/NRBID
C
	RECORD/NRBDEF/NRB	
C
C STRUCTURE OF THE BUFFER FOR OUTPUT THAT WE ARE BUILDING (BUFDEF)
C
	RECORD/BUFDEF/BUF
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 STATUS2
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 SYS$QIO	! QIO TO NETWORK
	INTEGER*4 SYS$GETTIM	! GET CURRENT SYSTEM TIME
	INTEGER*4 Q_DESCP(2)	! READ FROM QUEUE DESCRIPTOR
	INTEGER*4 ISIZE		! SIZE OF OUTPUT BUFFER TO NETWORK

C
C GET A MESSAGE FROM THE QUEUE
C
	Q_DESCP(1)=BUF_SIZE-	! BUILD A DESCRIPTOR (BYTE COUNT)
	1	(%LOC(BUF.BUF$S_MSG.HDR)-%LOC(BUF))
	Q_DESCP(2)=%LOC(BUF.BUF$S_MSG.HDR)	! ADDRESS
C
	BUF.BUF$S_MSG.MGH$C_MID=NRBID.NRBID$C_MSGID	! LOAD MESSAGE ID
	BUF.BUF$S_MSG.MGH$L_IDX=1+	! INDEX INTO NRBID LIST
	1	((%LOC(NRBID)-%LOC(NRB))-NRB$L_SIZ)/NRBID$L_SIZE
C
	GET_OUT_MESG=READ_Q(Q_BLOCK,	! Q BLOCK FROM ATTACH
	1	NRBID.NRBID$C_MSGID,	! MESSAGE ID
	1	Q_DESCP, ! MESSAGE BUFFER DESCRIPTOR ( WHERE MESSAGE GOES)
	1	NRBID.NRBID$L_RNA,	! READ NOT ACKNOWLEGED 
	1	NRBID.NRBID$L_IDX)	! INDEX WHEN WE STARTED UP
C
	IF(GET_OUT_MESG .NE. SS$_NORMAL .AND.		! WAS READ FROM
	1  GET_OUT_MESG .NE. %LOC(QUE_SUCCESS))THEN	! QUEUE SUCCESSFUL?
C
D	      TYPE *,' UNABLE TO READ MESSAGE FROM QUEUE '
D	      TYPE *,' MESSAGE ID: ',NRBID.NRBID$C_MSGID
D	      WRITE(*,100)GET_OUT_MESG
D100	      FORMAT(' STATUS FROM READ_Q: ',Z8)
	      CALL MARK_QUERROR(NRBID)	! MARK MESSAGE ID WITH AN ERROR 
	      IF(GET_OUT_MESG .EQ. %LOC(QUE_SHUTDOWN)) ! QUEUE SHUT DOWN?
	1	   CALL SYS$EXIT(%VAL(GET_OUT_MESG))  ! YES THEN SHUTDOWN
C
	      MSGDESC(1)=512
	      STATUS2=SYS$GETMSG(%VAL(GET_OUT_MESG),MSGDESC(1),
	1	MSGDESC,,)
	      STATUS2=OPR_FAO_MSG(RTR_QREAD,
	1	  MSGDESC,NRBID.NRBID$C_MSGID,NRB.NRB$C_CURNODE)
C
C	      MARK THE MESSAGE AS NOT ROUTABLE 
C
	      CALL MARK_NOROUTE(NRB,BUF,Q_BLOCK) ! BUF WAS INITIALIZED WITH
						 ! THE NRBID INDEX ABOVE
	      RETURN
	ENDIF
C
C FILL IN THE POOP NEEDED FOR LINKING
C
115	CONTINUE
	BUF.BUF$L_NRB=%LOC(NRB)	! LINK TO NRB
C
C NRB LINK SEQUENCE NUMBER OUT BOUND MUST BE DONE WITH AST LOCKOUT
C 	( WE ASSUME THAT THIS SUBROUTINE IS CALLED DURING SUCH A
C	  CONTDITION)
C
	NRB.NRB$W_LNKSEQO=NRB.NRB$W_LNKSEQO+1	! INCREMNET LINK SEQUENCE #
	IF (NRB.NRB$W_LNKSEQO .GT. 9999)NRB.NRB$W_LNKSEQO=1 ! WRAP
	BUF.BUF$S_MSG.MGH$W_LSQ=NRB.NRB$W_LNKSEQO ! LINK SEQUENCE NUMBER
	BUF.BUF$S_MSG.HDR.HDR$C_SNM=OUR_NODE(1:6)	! SOURCE NODE NAME
	BUF.BUF$S_MSG.HDR.HDR$C_DNM=NRB.NRB$C_CURNODE(1:6) ! DESTINATION NODE NAME
C
D	TYPE *,' WRITING MESSAGE TO NETWORK: '
D	TYPE *,' MGH$C_MID: ',BUF.BUF$S_MSG.MGH$C_MID
D	TYPE *,' MGH$L_IDX: ',BUF.BUF$S_MSG.MGH$L_IDX

C
	SYS_STATUS=SYS$GETTIM(BUF.BUF$S_MSG.HDR.HDR$Q_OFFQT) ! OFF QUEUE TIME

c
c NOW DO THE ACTUAL QIO TO THE NETWORK
C
	ISIZE= %LOC(BUF.BUF$S_MSG.HDR)	! CALC. SIZE OF MESSAGE
	1	-%LOC(BUF.BUF$S_MSG)	! LENGTH OF ROUTER PREAMBLE (22 BYTES?)
	ISIZE=BUF.BUF$S_MSG.HDR.HDR$W_LEN ! ADD HEADER SIZE AND 
	1	+ ISIZE +HDR$K_SIZ	  ! MESSAGE SIZE
D	TYPE *,' TOTAL MESSAGE SIZE: ',ISIZE
	SYS_STATUS=SYS$QIO(,		! EVENT FLAG
	1  %VAL(NRB.NRB$L_CHAN),	! CHANNEL
	1  %VAL(IO$_WRITEVBLK),		! FUNCTION CODE
	1  %REF(BUF.BUF$Q_STS),		! NETWORK WRITE STATUS BLOCK ADDRESS
	1  %VAL(WRITE_NET_AST_ADD),	! AST ROUTINE
	1  %REF(BUF),		 ! AST PARAMETER= MESSAGE BLOCK
	1  %REF(BUF.BUF$S_MSG),  ! BUFFER (STARTS AFTER STATUS AND NRB)
	1  %VAL(ISIZE),,,,)      ! SIZE
C
	IF(.NOT. SYS_STATUS)THEN	! QIO NOT ACCEPTED?
		MSGDESC(1)=512
		STATUS2=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		STATUS2=OPR_FAO_MSG(RTR_NETWTQIO,
	1	  NRB.NRB$C_CURNODE,MSGDESC)
		CALL DISCONNECT_NODE(NRB)
	ELSE
D		STATUS2=OPR_FAO_MSG(RTR_NTOUTMSG,	! STATUS MESSAGE
D	1		NRBID.NRBID$C_MSGID,	! ID
D	1		NRB.NRB$C_CURNODE,		! NODE
D	1		%VAL(NRBID.NRBID$L_RNA), ! READ NOT ACK
D	1		BUF)			! BUFFER ADDRESS
D	        TYPE *,' QIO TO NETWORK SUCCESSFULL, MARKING I/O IN PROGRESS'
D		TYPE *,' NRB ADDRESS: ',%LOC(NRB)
D		TYPE *,' BUF ADDRESS: ',%LOC(BUF)
D		TYPE *,' Q_BLOCK ADDRESS; ',%LOC(Q_BLOCK)
D		WRITE(*,2000)Q_BLOCK
D2000		FORMAT(2(1X,Z8))
C
		CALL MARK_IOPENDING(NRB,BUF,Q_BLOCK)	! SET I/O PENDING
	ENDIF
	GET_OUT_MESG=SYS_STATUS
	RETURN
	END

