	INTEGER*4 FUNCTION GET_Q_EVENT(EVENT_NUMBER,INDEX)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&GET_Q_EVENT\&
C .nf
C .x GET_Q_EVENT>Defined
C Source:GET_Q_EVENT.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update:27-JUN-86
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C    GET_Q_EVENT                INTEGER*4     
C                               STATUS OF GETTING AN ENTRY SS$_NORMAL, GOT ONE
C                               ELSE SS$_ENDOFILE
C                               OR 0 IF EVENT QUEUE IS EMPTY  
C    INDEX                      INTEGER*4 
C                               INDEX TO THE EVENT STRUCTURE FOR THIS EVENT
C   EVENT_NUMBER                INTEGER*4
C                               EVENT NUMBER FROM EVENT RECORD
C  
C Accesses common(s):
C   
C    EVENT_Q                    EVENT COMMON USED TO STORE EVENTS
C .X EVENT_Q>REFERENCED 
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C .FILL
C 	This function subroutine will look at the queued
C events that have been queued and return the next
C available entry and update any queue pointers.  If
C there are no more entries in the queue, then "SS$_ENDOFILE"
C is return otherwise: "SS$_NORMAL".
C .nofill
C  
C CALLING SEQUENCE: 
C  
C sys_status=GET_Q_EVENT(EVENT_NUMBER,INDEX)
C  
C .fill
C end.doc ****************************** end.doc  

	include '($ssdef)'
	INCLUDE '($IODEF)'
	INCLUDE 'EVENT_Q.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC'
	RECORD/EVENT_ENTRY/EVENT
	INTEGER*4 INDEX
	INTEGER*4 EVENT_NUMBER

c
c get the entry for the caller
c
	if(event_count .eq. 0)then
		GET_Q_EVENT=SS$_ENDOFFILE	! return no event status
		return
	else
		index=event_remove		! return index
		event_count=event_count-1	! decrment number in queue
		GET_Q_EVENT=SS$_NORMAL		! return good status
		event_remove=event_remove+1	! update removal pointer
		if(event_remove .gt. que_siz) event_remove=1	! wrap queue?
		EVENT_NUMBER=EVENT_QUE(INDEX).EVENT
		return
	endif
	END
	INTEGER*4 FUNCTION PUSH_EVENT_QUE(EVENT)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&PUSH_EVENT_QUE\&
C .nf
C .x PUSH_EVENT_QUE>Defined
C Source:PUSH_EVENT_QUE.for
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update: 06-JUL-86
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    EVENT                      STRUCTURE
C                               EVENT TO BE PUSHED ONTO THE EVENT STACK 
C  
C Returns:
C  
C    PUSH_EVENT_QUE             INTEGER*4                               
C                               SS$_NORMAL IF SUCESSFUL OR SS$_MBFULL IF
C                               EVENT QUEUE FULL.                       
C  
C Accesses common(s):
C  
C .X EVENT_Q>Common
C    EVENT_Q                    EVENT COMMON TO STORE QUEUED EVENTS
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This module will take an event and push it onto the
C the fifo stack of events to be serviced by the main line 
C program.  If there are too many events, then the subroutine
C will return full status.  The pointers to the 
C queue are updated on successful updates.  The wake up event
c flag is then set to wake up the mainline code.
C .nofill
C  
C CALLING SEQUENCE: 
C  
C  sys_status= PUSH_EVENT_QUE(EVENT)
C  
C .FILL
C 
C end.doc ****************************** end.doc  

	include '($ssdef)'
	include 'EVENT_Q.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC'
	INCLUDE 'MA_ROUTER_COMMON.INC'
	INTEGER*4 SYS_STATUS
	INTEGER*4 OPR_FAO_MSG	! CONSOLE LOG MESSAGE
	integer*4 SYS$EXIT	! EXIT
	INTEGER*4 SYS$SETEF	! SET EVENT FLAG
	INTEGER*4 SYS$GETMSG
	RECORD /EVENT_ENTRY/EVENT
c
c add this request if rooom
c
	if(event_count .eq. QUE_SIZ) then	! queue full?
	  push_event_que=ss$_mbfull 	! return full code
	  SYS_STATUS=OPR_FAO_MSG(RTR_EVQFUL,%val(event.event))  ! LOG THE FACT
	else
	  event_count=event_count+1	! increment number in queue
	  event_que(event_insert)=event  ! copy event
	  event_insert=event_insert+1	   ! update insert pointer
	  if(event_insert .gt. QUE_SIZ)event_insert=1  ! wrap insert pointer
	  push_event_que=ss$_normal	   ! good status
	endif
C
C SIGNIFCANT EVENT HAS OCCURRED AND WE SHOULD WAKE THE MAINLINE
C
	SYS_STATUS=SYS$SETEF(%VAL(WAKE_EFN)) ! NEED TO WAKE HOST
	IF(.NOT. SYS_STATUS)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_WAKEFN,MSGDESC)
		SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	RETURN
	END
