$!	K I T I N S T A L . C O M
$!
$!************************************************************
$!
$!	This procedure installs MAQ SOFTWARE on VMS using VMSINSTAL
$!
$!	Setup error handling
$!
$!
$ ON CONTROL_Y THEN VMI$CALLBACK CONTROL_Y
$ ON WARNING THEN GOTO ERR_EXIT
$ IF P1 .EQS. "VMI$_INSTALL" THEN GOTO INSTALL
$ IF P1 .EQS. "VMI$_IVP" THEN EXIT VMI$_SUCCESS
$ EXIT VMI$_UNSUPPORTED
$!
$ INSTALL:
$!
$!	Let VMSINSTAL know that all replaced files are to be purged.
$!
$ VMI$CALLBACK SET PURGE YES
$!
$!	At this point, the files have been restored from saveset A
$!
$ TYPE SYS$INPUT

	The distribution files have been restored from the saveset.

	The installation procedure is continuing...

$! 
$!
$!----------
$!
$! Question and answer time with the installer
$!
$ CHECK_DISK:
$!
$! Find out which disk the base kit is to be installed on
$!
$	MAQ_DEV_DEF = F$TRNLNM("SYS$SYSDEVICE")
$	VMI$CALLBACK ASK MAQ_DEV -
	" Which disk will hold the VAX MAQ Directories" -
		"''MAQ_DEV_DEF'" N
$ 	IF MAQ_DEV .EQS. "" THEN MAQ_DEV= MAQ_DEV_DEF
$	MAQ_DEV == MAQ_DEV - ":" + ":"
$	IF F$GETDVI(MAQ_DEV,"EXISTS") THEN GOTO CHECK_CLASS
$	VMI$CALLBACK MESSAGE W NODEVICE -
	"That device doesn't exist on your system"
$
$ CHECK_SELECT:
$	VMI$CALLBACK ASK A$ "Do you want to selet another device" -
	"NO" B
$	If A$ then goto CHECK_DISK
$	EXIT VMI$_FAILURE
$ CHECK_CLASS:
$	IF F$GETDVI(MAQ_DEV,"DEVCLASS") .EQ. 1 THEN GOTO CHECK_MOUNTED
$	VMI$CALLBACK MESSAGE W NOTDISK "Device must be a disk"
$	GOTO CHECK_SELECT
$ CHECK_MOUNTED:
$	IF F$GETDVI(MAQ_DEV,"MNT") .EQ. 1 THEN GOTO CHECK_SPACE
$	VMI$CALLBACK MESSAGE W NOTMOUNTED - 
	"That device isn't mounted"
$	GOTO CHECK_SELECT
$ CHECK_SPACE:
$
$!
$	VMI$CALLBACK ASK MAQ_DIR -
	"Enter the directory name for the MAQ kit files" "MA_Q" N
$	IF MAQ_DIR .EQS. "" THEN MAQ_DIR= "[MA_Q]"
$	maq_dir == maq_dir - "[" - "]"
$ TYPE SYS$INPUT

	The following two questions are used to select which
	user codes for the user written system services are
	not currently being used.  If this is the only
	system service installed on your system, then the
	default value of -1024 is ok.  Otherwise, you
	must know what other user written system service
	codes are currently in use by the other user
	written system services that a user processes might
	link to.  The VMS image activator supports the
	connection of  up to 42 different user written system
	services linked into a process.  Remember, not all
	vendors are kind enough to tell you how they 
	implemented  a product.   
	( -1 to -1024) Is valid for the system service code.
		If you find bogus system service errors being returned, 
	then probably, two kernal or executive mode dispatchers are 
	trying 	to dispatch the same code.

$ KERNAL_BASE:
$	VMI$CALLBACK ASK MAQ_KBASE -
	"Enter USER KERNAL MODE DISPATCHER base code (default: -1024)" -
	"-1024" N
$	IF MAQ_KBASE .EQS. "" THEN MAQ_KBASE= "-1024"
$	MAQ_TST=F$INTEGER(MAQ_KBASE)
$	IF MAQ_TST .GE. -1024 .AND. MAQ_TST .LT. 0 THEN GOTO EXEC_BASE
$	TYPE SYS$INPUT
		RANGE OF THE KERNAL BASE CODES IS -1 TO -1024 INCLUSIVE
		PLEASE TRY AGAIN
$ GOTO KERNAL_BASE
$!
$!
$ EXEC_BASE:
$	VMI$CALLBACK ASK MAQ_EBASE -
	"Enter USER EXECUTIVE MODE DISPATCHER base code (default: -1024)" -
	"-1024" N
$	IF MAQ_EBASE .EQS. "" THEN MAQ_EBASE= "-1024"
$	MAQ_TST=F$INTEGER(MAQ_EBASE)
$	IF MAQ_TST .GE. -1024 .AND. MAQ_TST .LT. 0 THEN GOTO GETFACILITY
$	TYPE SYS$INPUT
 		RANGE OF THE KERNAL BASE CODES IS -1 TO -1024 INCLUSIVE
		PLEASE TRY AGAIN
$ 	GOTO EXEC_BASE

$ GETFACILITY:
$ TYPE SYS$INPUT
	The facility code for the QUE service and the Routing process
error messages are selected by the following question. The user
should be aware that the message codes are in the range of 1 to 2047.
The actual value is suppose to be assigned by digital but since this
code does not come from digital, we aren t able to or desire to go
through the hassle.  Instead we, will let you select the factility
number.  One should be aware, as should all users of the queue
service (not really a problem with the router) what factility number
was choosen.  If a user selects the same number, then the translation
of error messages can be all messed up (ie: QUESUC may translate to a
user defined facility code that means:  BADINPUT).  The normal
standard defined facility codes for digital products can be found in
the QUEMSG macro. 

	The system manager may choose to add the error codes for
the queue service for all users.  For an indivual user, the following
command will define all of the queue service error codes.

	SET MESSAGE MA_Q$DEF:QUEMSG.EXE

$VMI$CALLBACK ASK MAQ_FACILITY -
 "Enter the QUEUE SERVICE facility number (1 to 2047) [default=9]: "-
	"9" N
$!
$ IF MAQ_FACILITY .EQS. "" THEN MAQ_FACILITY= "9"
$ MAQ_TEST=F$INTEGER(MAQ_FACILITY)
$ IF MAQ_TEST .GE. 1 .AND. MAQ_TEST .LE. 2047 THEN GOTO GOTFACILITY
$ TYPE SYS$INPUT
	You have entered an invalid facility number, I will
tell you again what this is all about
$ GOTO GETFACILITY
$!
$ GOTFACILITY:
$	VMI$CALLBACK ASK MAQ_LARGEST -
 "Enter largest message to allow to be written to the queue (default: 4096)" -
	"4096" N
$	IF MAQ_LARGEST .EQS. "" THEN MAQ_LARGEST= "4096"
$	MAQ_LARGEST=F$INTEGER(MAQ_LARGEST)
$	IF MAQ_LARGEST .GT. 0  THEN GOTO GOT_LARGEST
$	TYPE SYS$INPUT
	
	The largest size message is used to reasonability test on
the callers message size.  You should set this to the size of the
largest message that you want to allow a caller to place in the queue.
Failure to make it large enough will require that you reinstall this KIT,
or at least reassemble, link, and intall the system service.

$GOT_LARGEST:
$!
$ SSDISPDIR:
$ TYPE SYS$INPUT
	The user written system service will be placed in the 
top directory.  If this is not a clustered system, it should be placed
in SYS$LIBRARY.  If you choose not to place it in the SYS$LIBRARY
you will have to define the system wide logical SSDISP and point
it to the directory entered such that the image activator can
find the service (the image activator will by default search 
SYS$LIBRARY).   IE: if you decide to leave it at say the top 
directory entered above, the symbol ssdisp would be defined as:

	DEFINE SSDISP MA_Q$PROD


		*****WARNING******

YOU MUST ALSO DELETE THE COPY OF SSDISP.EXE AT THE SYS$LIBRARY
ACCOUNT BEFORE YOU MOVE THIS ONE TO IT IF THIS IS NOT A CLUSTERED
SYSTEM. Otherwise, it will be found inadverently by processes
before you move the new one to it.  Running incompatible versions
of the system service and a new queue may cause system crashes!!!!!!


$!
$!
$! End of question/answer period
$!
$ GOFORIT:
$	vmi$callback message I MILLERTIME -
 "Interaction section is complete - installation continuing"
$!
$!----------
$!
$! Define the MAQ logicals
$!
$! SET VERIFY
$	define/process MAQ_TOP "''MAQ_DEV'[''MAQ_DIR']"
$	define/process MAQ "''MAQ_DEV'[''MAQ_DIR'.]"
$	define/process MAQ_SYSSERV MAQ:[SYSSERV]
$	define/process MAQ_ROUTE MAQ:[ROUTE]
$	define/process MAQ_CRUPD MAQ:[CRUPD]
$	define/process MAQ_SUBROUTINES MAQ:[SUBROUTINES]
$	define/process MAQ_DEF MAQ:[DEF]
$	define/process MAQ_EXAMPLE MAQ:[EXAMPLE]
$	define/process MAQ_DBS MAQ:[DBS]
$!
$! Create our directories
$!
$ vmi$callback message i directory  "Creating top directory"
$! TOP DIRECTORY [MA_Q] (or whatever user called it)
$!
$	If F$search("''maq_dev'[000000]''maq_dir'.DIR") .eqs. "" then -
	vmi$callback create_directory user "''maq_dev'[''maq_dir']" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.CRUPD]
$!
$ vmi$callback message i directory  "Creating queue and checkpoint directory"
$	If F$search("''maq_dev'[000000.''maq_dir']CRUPD.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.crupd]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.DEF]
$!
$ vmi$callback message i directory  "Creating definition directory"
$	If F$search("''maq_dev'[000000.''maq_dir']DEF.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.def]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.DOCUMENTATION]
$!
$ vmi$callback message i directory  "Creating documentation directory"
$	If F$search(-
	"''maq_dev'[000000.''maq_dir']DOCUMENTATION.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.documentation]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.ROUTE]
$!
$ vmi$callback message i directory  "Creating route directory"
$	If F$search("''maq_dev'[000000.''maq_dir']ROUTE.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.route]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.SUBROUTINES]
$!
$ vmi$callback message i directory  "Creating subroutine/library directory"
$	If F$search(-
	"''maq_dev'[000000.''maq_dir']SUBROUTINES.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.subroutines]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.SYSSERV]
$!
$ vmi$callback message i directory  "Creating system service directory"
$	If F$search("''maq_dev'[000000.''maq_dir']SYSSERV.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.sysserv]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! SUB DIRECTORY [MA_Q.DBS ]
$!
$ vmi$callback message i directory  "Creating DBS directory"
$	If F$search("''maq_dev'[000000.''maq_dir']DBS.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.DBS]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"


$!
$! SUB DIRECTORY [MA_Q.EXAMPLE]
$!
$ vmi$callback message i directory  "Creating EXAMPLE directory"
$	If F$search("''maq_dev'[000000.''maq_dir']EXAMPLE.DIR") .eqs. "" then -
	vmi$callback create_directory user -
	"''maq_dev'[000000.''maq_dir'.example]" -
	"/protection=(s:rwed,o:rwed,w:rwe)"
$!
$! Fill in the directories 
$!
$!
$! TOP DIRECTORY
$!
$ vmi$callback message i loading "Copying  top directory"
$ VMI$CALLBACK PROVIDE_FILE MAQ$ MA$Q.COM MAQ_TOP:
$!
$! DEFINITION DIRECTORY
$!
$ vmi$callback message i loading "Copying definition  directory"
$ VMI$CALLBACK PROVIDE_FILE MAQ$ BUFDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ BUFDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ HDRDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ HDRDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ MGHDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ MGHDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ MIDDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ MIDDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NETMSG.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NRBDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NRBDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NRBID.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NRBID.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ PEXDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ PEXDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QEXDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QEXDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QHDDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QHDDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QSTDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QSTDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUECONST.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEMSG.MSG MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEUE.MLB MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEUE.TLB MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ ROUTEMAC.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ RSPBUF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ RSPDEF.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ RSPDEF.MAR MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ RSPLST.TXT MAQ:[DEF]
$!
$! DOCUMENTATION DIRECTORY
$!
$ vmi$callback message i loading "Copying documentation directory"
$ VMI$CALLBACK PROVIDE_FILE MAQ$ PROGRAMMER_MANUAL.COM MAQ:[DOCUMENTATION]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ PROGRAMMER_MANUAL.RNO MAQ:[DOCUMENTATION]
$!
$! SUBROUTINE DIRECTORY
$!
$ vmi$callback message i loading "Copying subroutine/library directory"
$ VMI$CALLBACK PROVIDE_FILE MAQ$ INLAND.OLB MAQ:[SUBROUTINES]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEUE.OLB MAQ:[SUBROUTINES]
$!
$! ROUTE DIRECTORY
$!
$ vmi$callback message i loading "Copying route directory"
$ VMI$CALLBACK PROVIDE_FILE MAQ$ ROUTE_DATABASE.COM MAQ:[ROUTE]
$!
$! EXAMPLE DIRECTORY
$!
$ VMI$CALLBACK MESSAGE I loading "EXAMPLE DIRECTORY"
$ VMI$CALLBACK PROVIDE_FILE MAQ$ ROUTE_DATABASE.MAR MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ RTR.COM MAQ_TOP:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ RUN_QUEUE_CHKR.COM MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEUE_DEF.DAT MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ START_ALL.COM MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ FIND_SERVICE_MSG.MSG MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ FIND_SERVICE.FOR MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ FIND_SERVICE.COM MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ FIND_SERVICE.INC MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NETMSG.FOR MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ NETMSG.COM MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ SHUTDOWN_QUEUE.FOR MAQ_EXAMPLE:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ SHUTDOWN_QUEUE.COM MAQ_EXAMPLE:
$!
$! DBS DIRECTORY
$!
$ VMI$CALLBACK MESSAGE I LOADING "DBS DIRECTORY"
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ RT_WORK_ALL.EXE MAQ_DBS:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ SUBSET.FLB MAQ_DBS:
$!
$!
$! 
$! The source directories, DEF, CRUPD, SYSSERV, ROUTE require
$! that we build things prior to the copy to the above 
$! directories.
$!-----------------------------------------------------
$! Build the queue service message definition file and
$! update the queue library.
$!
$! This command file will envoke the message utililty
$! and then link the output of the message utility to
$! get the values for the error code/messages for the
$! system service message codes for the queueing software.
$!
$ OPEN/WRITE MA_Q$PPP VMI$KWD:QUEMSG.PRE
$ WRITE MA_Q$PPP ".TITLE QUESRV Error and warning messages for queueing applications"
$ WRITE MA_Q$PPP "	.IDENT	/2.1/"
$ WRITE MA_Q$PPP ".FACILITY QUESRV,",'MAQ_FACILITY',"/PREFIX=QUE_"
$ CLOSE MA_Q$PPP
$!
$ VMI$CALLBACK MESSAGE I MESSAGE " Building QUEMSG"
$MESSAGE VMI$KWD:QUEMSG.PRE+VMI$KWD:QUEMSG.MSG/OBJ=VMI$KWD:QUEMSG.OBJ
$!
$ VMI$CALLBACK MESSAGE I MESSAGE " Linking QUEMSG"
$LINK VMI$KWD:QUEMSG/MAP=VMI$KWD:QUEMSG.MAP/SHAREABLE/EXE=VMI$KWD:QUEMSG.EXE
$ VMI$CALLBACK MESSAGE I MESSAGE " Parsing QUEMSG"
$!
$! NOW PARSE THE MAP AND FIND ALL OF THE QUEMSG
$! TYPE SYMBOL DEFINITIONS AND CREATE A FORTRAN INCLUDE
$! FILE THAT CAN BE PLACED IN A TEXT FILE.
$!
$! NOTE:  The image file generated here can be used to supplement the
$!        users message file for DCL, ie:  SET MESSAGE QUEMSG.EXE
$!
$!
$ OPEN/WRITE MAQ$OUTFILE VMI$KWD:QUEMSGVAL.TXT
$ WRITE MAQ$OUTFILE "C"
$ WRITE MAQ$OUTFILE "C QUEMSGVAL MESSAGE AND ERROR STATUS FORTRAN DEFINITION FILE"
$ WRITE MAQ$OUTFILE "C CREATED ON: ",F$TIME()
$ WRITE MAQ$OUTFILE "C"
$!
$ OPEN/WRITE MAQ$OUTFILE2 VMI$KWD:QUEMSG.TXT
$ WRITE MAQ$OUTFILE2 "C"
$ WRITE MAQ$OUTFILE2 "C QUEMSG MESSAGE AND ERROR STATUS FORTRAN DEFINITION FILE"
$ WRITE MAQ$OUTFILE2 "C CREATED ON: ",F$TIME()
$ WRITE MAQ$OUTFILE2 "C"
$!
$ OPEN/WRITE MAQ$OUTFILE3 VMI$KWD:QUEMSG.PL1
$ WRITE MAQ$OUTFILE3 "/*"
$ WRITE MAQ$OUTFILE3 " QUEMSG.PL1"
$ WRITE MAQ$OUTFILE3 " QUEMSG AND ERROR STATUS PL1 DEFINITION FILE"
$ WRITE MAQ$OUTFILE3 " CREATED ON: ",F$TIME()
$ WRITE MAQ$OUTFILE3 "*/"
$!
$!
$ OPEN/READ MAQ$INFILE VMI$KWD:QUEMSG.MAP
$!
$! JUST LOOP UNTIL WE HIT AN END OF FILE ON THE MAP FILE
$!
$READ_LUP:
$READ/END_OF_FILE=DONE  MAQ$INFILE MAPRECORD
$ RECSIZE=F$LENGHT(MAPRECORD)
$!
$! SEE IF ANY QUE_ TYPE VARIABLES IN THIS RECORD
$!
$RESTREC:
$IBEG= F$LOCATE("QUE_",MAPRECORD)
$IF IBEG .EQ. RECSIZE THEN GOTO READ_LUP
$! 
$! FOUND ONE, FIND END OF STRING AND THE VALUE
$!
$REST= RECSIZE - IBEG
$MAPRECORD=F$EXTRACT(IBEG,REST,MAPRECORD)
$RECSIZE=F$LENGHT(MAPRECORD)
$IEND= F$LOCATE(" ",MAPRECORD)
$IF IEND .EQ. 0 THEN IEND=RECSIZE
$ILTH=IEND 
$SYM= F$EXTRACT (0,ILTH,MAPRECORD)
$!
$! FIND THE VALUE
$!
$ VP=IEND-1
$BLKLUP:
$ VP=VP+1 
$BLK = F$EXTRACT(VP,1,MAPRECORD)
$IF BLK .EQS. " " THEN GOTO BLKLUP
$ VALUE= F$EXTRACT (VP,8,MAPRECORD)
$!
$! WRITE TO OUT TWO TYPE OF INCLUDE FILES FOR THE FORTRAN PROGRAMMER.
$! FIRST FILE IS FOR THE ONE LIKE FORTRAN INCLUDE FILES, AND
$! THE SECOND IS FOR THOSE WHO WERE THE FIRST USESRS OF OUR
$! SOFTWARE AND USED THE PERCENT LOC VALUES.
$!
$WRITE MAQ$OUTFILE "	INTEGER*4 ",SYM
$WRITE MAQ$OUTFILE "	PARAMETER(" ,SYM, "='" ,VALUE, "'X)"
$!
$ WRITE MAQ$OUTFILE2 "	INTEGER*4 ",SYM
$ WRITE MAQ$OUTFILE2 "	EXTERNAL ",SYM
$! PL/1
$ WRITE MAQ$OUTFILE3 "  DECLARE ",SYM," FIXED BINARY(31) GLOBALREF VALUE;"
$MAPRECORD=F$EXTRACT(IBEG+1,RECSIZE-1,MAPRECORD)
$RECSIZE=F$LENGHT(MAPRECORD)
$IF RECSIZE .LE. 0 THEN GOTO READ_LUP
$GOTO RESTREC
$DONE:
$ CLOSE MAQ$OUTFILE
$ CLOSE MAQ$OUTFILE2
$ CLOSE MAQ$OUTFILE3
$ CLOSE MAQ$INFILE
$!---------------------------------------------------------------
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEMSG.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEMSGVAL.TXT MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEMSG.PL1 MAQ:[DEF]
$ VMI$CALLBACK PROVIDE_FILE MAQ$ QUEMSG.EXE MAQ:[DEF]
$ LIBR VMI$KWD:QUEUE.OLB/REPLACE VMI$KWD:QUEMSG.OBJ
$!
$! Build system service and menu process
$!
$ ALINK = "SYSSERV"
$ vmi$callback message i link "ASSEMBLING and LINKING ''ALINK'"
$ OPEN/WRITE MAQ$P VMI$KWD:SSDISP_PRE.MAR
$ WRITE MAQ$P ";"
$ WRITE MAQ$P "; KERNAL AND EXECUTIVE BASE CODES"
$ WRITE MAQ$P ";"
$ WRITE MAQ$P "KCODE_BASE=",'MAQ_KBASE'
$ WRITE MAQ$P "ECODE_BASE=",'MAQ_EBASE'
$ WRITE MAQ$P "MAX_MSG_SIZE=",'MAQ_LARGEST'  
$ WRITE MAQ$P "	.LIBRARY ""VMI$KWD:QUEUE.MLB""	; Queueing definitions:"
$ CLOSE MAQ$P
$!
$! ASSEMBLE SYSTEM SERVICE
$!
$ MAC VMI$KWD:SSDISP_PRE.MAR+VMI$KWD:SSDISP.MAR/OBJECT=VMI$KWD:SSDISP.OBJ/LIS
$ VMI$CALLBACK MESSAGE I PRINT "SSDISP.LIS Will be spooled to system printer"
$ VMI$CALLBACK PRINT_FILE VMI$KWD:SSDISP.LIS
$!
$ LINK /PROTECT /NOTRACEBACK /NOSYSSHR /SHARE=VMI$KWD:SSDISP -
/MAP=VMI$KWD:SSDISP /EXE=VMI$KWD:SSDISP /FULL SYS$INPUT/OPTIONS
!
!	Options file for the link of User System Service example.
!
!
!	Create a separate cluster for the transfer vector.
!
CLUSTER=TRANSFER_VECTOR,,,VMI$KWD:SSdisp.obj
!
GSMATCH=LEQUAL,1,1
!
	VMI$KWD:QUEUE/LIBRARY
	VMI$KWD:INLAND/LIBRARY
	VMI$ROOT:[SYSEXE]SYS.STB/SELECTIVE
$EOD
$ VMI$CALLBACK MESSAGE I PRINT "SSDISP.MAP Is being spooled to system printer"
$ VMI$CALLBACK PRINT_FILE VMI$KWD:SSDISP.MAP
$!
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ SSDISP.EXE MAQ_TOP:
$ VMI$CALLBACK PROVIDE_FILE MAQ$ MENU.FOR MAQ:[SYSSERV]
$!
$ALINK = "MENU"
$ vmi$callback message i link "LINKING ''ALINK'"
$!
$! MENU
$!
$ LINK VMI$KWD:menu /MAP=VMI$KWD:MENU -
/EXE=VMI$KWD:MENU /FULL,SYS$INPUT/OPTIONS
!
!	Options file 
	VMI$KWD:SSDISP/SHARE
	VMI$KWD:QUEUE.OLB/LIBRARY
$!
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ MENU.EXE MAQ_TOP:
$!
$! Build the checkpoint process
$!
$ALINK = "QUEUE_CHKR"
$ vmi$callback message i link "LINKING ''ALINK'"
$ LINK VMI$KWD:QUEUE_CHKR/EXE=VMI$KWD:QUEUE_CHKR,SYS$INPUT/OPTION
	VMI$KWD:KNL_SECT_OPEN,-
	VMI$KWD:QUEUE_CHKR_MSG,-
	VMI$KWD:QUEUE.OLB/LIBRARY,-
	VMI$KWD:INLAND.OLB/LIBRARY,-
	VMI$ROOT:[SYSEXE]SYS.STB/SELECTIVE_SEARCH
$EOD
$!
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ QUEUE_CHKR.EXE MAQ_TOP:
$!
$! Q_UTL PROCESS
$!
$ALINK = "Q_UTL"
$ vmi$callback message i link "LINKING ''ALINK'"
$ LINK VMI$KWD:Q_UTL/EXE=VMI$KWD:Q_UTL,SYS$INPUT/OPTION
	VMI$KWD:HASH,-
	VMI$KWD:SECT_NEW_CHAN,-
	VMI$KWD:QUEUE.OLB/LIBRARY,-
	VMI$KWD:SSDISP/SHARE,-
	VMI$KWD:INLAND.OLB/LIBRARY
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ Q_UTL.EXE MAQ_TOP:
$!
$! ROUTER DIRECTORY
$!
$ALINK = "MA_ROUTER"
$!
$! BUILD THE MA_ROUTER MESSAGE FILE FIRST
$!
$! Set facility code to one plus that for the service
$!
$ MAQ$RTRFACILITY=F$INTEGER(MAQ_FACILITY) +1 
$ vmi$callback message i Mesg "Creating message file"
$ OPEN/WRITE MAQ$PPP VMI$KWD:MA_ROUTER_MSG.PRE
$ WRITE MAQ$PPP "	.TITLE	MA_ROUTER MESSAGE FILE"
$ WRITE MAQ$PPP "	.IDENT	/2.0/"
$ WRITE MAQ$PPP ".FACILITY MA_ROUTER,",'MAQ$RTRFACILITY',"/PREFIX=RTR_"
$ CLOSE MAQ$PPP
$ MESSAGE VMI$KWD:MA_ROUTER_MSG.PRE+VMI$KWD:MA_ROUTER_MSG.MSG-
	/OBJ=VMI$KWD:MA_ROUTER_MSG.OBJ
$!
$ vmi$callback message i link "LINKING ''ALINK'"
$ LINK VMI$KWD:MA_ROUTER/EXE=VMI$KWD:MA_ROUTER,SYS$INPUT/OPTION
	VMI$KWD:MA_ROUTER_MSG,-
	VMI$KWD:ACK_LAST_WRITE,-
	VMI$KWD:ALC_OUT_BUF,-
	VMI$KWD:ALC_RESP_BUF,-
	VMI$KWD:BUILD_REMOTE_CONNECT_NCB,-
	VMI$KWD:BUILD_RESP,-
	VMI$KWD:BUILD_ROUTE_TABLE,-
	VMI$KWD:CHK_LNK_SEQ,-
	VMI$KWD:CMP_NAME,-
	VMI$KWD:CONNECT_NODE,-
	VMI$KWD:CONNECT_NODE_AST,-
	VMI$KWD:CON_TIMER_AST,-
	VMI$KWD:DEA_OUT_BUF,-
	VMI$KWD:DEA_RESP_BUF,-
	VMI$KWD:DISCONNECT_NODE,-
	VMI$KWD:FIND_ROUTE_MSG,-
	VMI$KWD:GET_NODE_NAME,-
	VMI$KWD:GET_OUT_MESG,-
	VMI$KWD:GET_Q_EVENT,-
	VMI$KWD:LHD_ADD,-
	VMI$KWD:MAP_IDS,-
	VMI$KWD:MARK_FULL,-
	VMI$KWD:MARK_AVAIL,-
	VMI$KWD:MA_MBX_AST,-
	VMI$KWD:MA_ROUTER_EXIT_HAN,-
	VMI$KWD:MA_R_INIT,-
	VMI$KWD:NET_AST,-
	VMI$KWD:NET_READ,-
	VMI$KWD:NET_READ_RESP_AST,-
	VMI$KWD:NEW_ROUTING_MAP,-
	VMI$KWD:NODE_TO_NRB,-
	VMI$KWD:OUTPUT_NET,-
	VMI$KWD:PUT_BACK,-
	VMI$KWD:READ_MBX_NW,-
	VMI$KWD:READ_NET_AST,-
	VMI$KWD:REM_NODE_CON,-
	VMI$KWD:ROUTE_SECTION_OPEN,-
	VMI$KWD:UNFULL_AST,-
	VMI$KWD:WRITE_NET_AST,-
	VMI$KWD:SSDISP/SHAREABLE,-
	VMI$KWD:QUEUE.OLB/LIBRARY,-
	VMI$KWD:INLAND.OLB/LIBRARY,-
	VMI$ROOT:[SYSEXE]SYS.STB/SELECTIVE_SEARCH
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ MA_ROUTER.EXE MAQ_TOP:
$!
$! RTIN, RTOUT
$!
$ALINK = "RTIN"
$ vmi$callback message i link "LINKING ''ALINK'"
$ LINK /EXE=VMI$KWD:RTIN SYS$INPUT/OPTIONS
	PSECT_ATTR = NRB,PAGE
	PSECT_ATTR = NRBLST,PAGE
	VMI$KWD:RTIN
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ RTIN.EXE MAQ_TOP:
$ALINK = "RTOUT"
$ vmi$callback message i link "LINKING ''ALINK'"
$ LINK /EXE=VMI$KWD:RTOUT SYS$INPUT/OPTIONS
	PSECT_ATTR = NRB,PAGE
	PSECT_ATTR = NRBLST,PAGE
	VMI$KWD:RTOUT
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ RTOUT.EXE MAQ_TOP:
$!  THIS SECTION HAS BEEN COMMENTED OUT BECAUSE IT DIES ON THE KIT INSTALL
$! VERIFY_Q
$!
$ ALINK = "VERIFY_Q"
$ VMI$CALLBACK MESSAGE I LINK " LINKING '' ALINK'"
$ LINK/EXE=VMI$KWD:VERIFY_Q SYS$INPUT/OPTIONS
	VMI$KWD:VERIFY_Q,-
	VMI$KWD:SSDISP/SHAREABLE,-
	VMI$KWD:INLAND.OLB/LIB,-
	VMI$KWD:QUEUE.OLB/LIB
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ VERIFY_Q.EXE MAQ_TOP:
$!
$! NRBDMP
$!
$ALINK = "NRBDMP"
$ vmi$callback message i link "LINKING ''ALINK'"
$ LINK /EXE=VMI$KWD:NRBDMP SYS$INPUT/OPTIONS
	PSECT_ATTR = NRB,PAGE
	PSECT_ATTR = NRBLST,PAGE
	VMI$KWD:NRBDMP
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ NRBDMP.EXE MAQ_TOP:
$!
$! FIND SERVICE
$!
$ ALINK="FIND_SERVICE"
$ VMI$CALLBACK MESSAGE I Link "Linking ''ALINK'"
$ LINK /EXE=VMI$KWD:FIND_SERVICE SYS$INPUT/OPTIONS
	PSECT_ATTR = NRB,PAGE
	PSECT_ATTR= NRBLST,PAGE
	VMI$KWD:FIND_SERVICE,-
	VMI$KWD:FIND_SERVICE_MSG,-
	VMI$KWD:QUEUE.OLB/LIB,-
	VMI$KWD:INLAND.OLB/LIB
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ FIND_SERVICE.EXE MAQ_TOP:
$!
$ ALINK="BLAST_Q"
$ VMI$CALLBACK MESSAGE I Link "Linking ''ALINK'"
$ LINK /EXE=VMI$KWD:BLAST_Q SYS$INPUT/OPTIONS
	VMI$KWD:BLAST_Q,-
	VMI$KWD:SSDISP/SHAREABLE,-
	VMI$KWD:INLAND.OLB/LIB,-
	VMI$KWD:QUEUE.OLB/LIB
$EOD
$ VMI$CALLBACK PROVIDE_IMAGE MAQ$ BLAST_Q.EXE MAQ_TOP:
$!
$!
$! Build the MAQ startup file
$!
$	VMI$CALLBACK MESSAGE I BLDCOM "Creating MAQ startup procedure"
$
$	open/write MAQ$W VMI$KWD:MA_Q_START.COM
$ w_date = "''f$cvtime(,,""weekday"")'"+" ''f$cvtime(,""ABSOLUTE"",""DATE"")'"
$	write MAQ$W "$!"
$	write MAQ$W "$!	  MAQ Startup procedure"
$	write MAQ$W "$!   ** Created by MAQ install procedure on ''w_date' **"
$	write MAQ$W "$!"
$	write MAQ$W "$! Top level directory "
$	write MAQ$W "$!"
$	write MAQ$W "$	ASSIGN/SYSTEM ''MAQ_DEV'[''MAQ_DIR'.] MA_Q" 
$	write MAQ$W "$!"
$	write MAQ$W "$! Installed System Service shared image"
$	write MAQ$W "$!"
$	write MAQ$W "$	ASSIGN/SYSTEM SYS$SYSROOT:[SYSLIB]SSDISP MA_Q$SSDISP"
$	write MAQ$W "$!"
$	write MAQ$W "$! Queue definitions for router"
$	write MAQ$W "$!"
$	write MAQ$W "$	ASSIGN/SYSTEM ''MAQ_DEV'[''MAQ_DIR']QUEUE_DEF.DAT QUEDEF"
$	write MAQ$W "$!"
$	write MAQ$W "$! Define the global section name "
$	write MAQ$W "$!"
$	write MAQ$W "$	ASSIGN/SYSTEM EARLS_QUEUE GBL$MA_Q_NAME"
$	write MAQ$W "$!"
$	write MAQ$W "$! Production (top directory)"
$	write MAQ$W "$!"
$	write MAQ$W "$	ASSIGN/SYSTEM ''MAQ_DEV'[''MAQ_DIR'] MA_Q$PROD"
$	write MAQ$W "$!"
$	write MAQ$W "$! For everyone to build, compile, and link etc."
$	write MAQ$W "$!"
$	write MAQ$W "$	ASSIGN/SYSTEM MA_Q:[DEF] MA_Q$DEF"
$	write MAQ$W "$	ASSIGN/SYSTEM MA_Q:[SUBROUTINES] MA_Q$LIB"
$	write MAQ$W "$!"
$	WRITE MAQ$W "$! The following is left for your convience, "
$	WRITE MAQ$W "$! uncomment if you left the service at the"
$	WRITE MAQ$W "$! at the top directory "
$	WRITE MAQ$W "$! "
$	write MAQ$W "$! DEFINE SSDISP MA_Q$PROD"
$!
$	close MAQ$W
$ 	SET PROTECTION=(OWNER:RWED,GROUP=RWED,WORLD:RWED,SYSTEM:RWED) -
		VMI$KWD:MA_Q_START.COM
$	VMI$CALLBACK PROVIDE_FILE MAQ$ MA_Q_START.COM MAQ_EXAMPLE:
$!
$!----------
$!
$ TYPE SYS$INPUT

Your installation is now complete.  After exiting from VMSINSTAL:

	1. You should modify SYS$MANAGER:SYSTARTUP.COM if you want
           to restart MA_Q at system reboot time.
	   This is easiest done by creating an account for this
           software and submiting the command file STARTUP_ALL.COM
	   to the batch queue on system bootstrap with this
	   user account, ie: SUBMIT/BATCH/USER=MA_Q [MA_Q]STARTUP_ALL

	   The command file STARTUP_ALL.COM is at the example directory
           as is all of the executable images.   This command file
	   will 1) Install the system service, 2) Startup the
           system service, 3) Startup the MA_ROUTER.

        3. The command file MA_Q_START.COM must be executed prior to
	   any of the other command files as it defines system wide
	   logicals (Also in example directory).  I recommend that this
	   command file be called from the system startup command file.

	4. The system service has been placed in the top directory.  It
	   should be moved to:  SYS$SYSROOT:[SYSLIB] if this is not a
	   clustered system.

	5. Create a new queue and populate with any messages that you
	   dumpted from the old queue.

	6. Bootstrap the computer and start everything up.

$!
$!
$!
$ EXIT VMI$_SUCCESS
$!
$!	End of MAQ installation
$!
$ ERR_EXIT:
$!
$!
$!	End of MAQ KITINSTAL.COM
$!
$ S = $STATUS
$ IF F$VERIFY() THEN SET VERIFY
$ EXIT S
