	OPTIONS/EXTEND
	INTEGER*4 FUNCTION MAP_IDS(NRB,MSG_ID_LIST)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&MAP_IDS\&
C .nf
C .x MAP_IDS>Defined
C Source:MAP_IDS.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:23-SEP-86
C Revision level     :1.4
C  
C .C ;Formal Parameter List
C Receives:
C 
C  
C      NRB                      STRUCTURE
C                               NODE ROUTING BLOCK STRUCTURE
C 
C    MSG_ID_LIST                STRUCTURE                                         
C                               A STRUCTURE LIST CONTAINING MESSAGE ID AND A      
C                               LONG WORD TO BE FILLED IN WITH INDEX INTO THE     
C                               QUEUE REGION FOR THE MESSAGE ID LISTHEAD.         
C  
C Returns:
C  
C    MAP_IDS                    INTEGER*4                                         
C                               STATUS                                            
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
c 
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                USED TO LOG MESSAGE TO OPERATOR CONSOLE           
C                                (found in library:INLAND)
c .X CONNECT_READ>Referenced
c    CONNECT_READ              USED TO GET THE MESSAGE ID INDEX AND
C                              TO CONNECT US IN AS THE READER OF THIS 
C                              MESSAGE ID.
C                                (found in library: QUEUE)
C
C .X LHD_ADD>Referenced
c    LHD_ADD                    Kernal subroutine used to get the
c                               actual address from the index
c                               passed by the GET_MID_INDEX.
C 
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is passed the tail end part of a NRB
C within the Route_dbs.  This subroutine simply takes each
C message id and finds it in the queue.   If found, the index
C to the message id list head is stored in the long word
C following the message id.  If it can not be found, then
C an error message is printed and the entry is left zero to
C denote that it was not found.
C 	Calling sequence:
C  
C SYS_STATUS=MAP_IDS(NRB,MSG_ID_LIST)
C 
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($PSLDEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBID)/LIST'
C	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUEMSG)/LIST'  (MESSAGE DEFINITIONS)
	INTEGER I
	INTEGER*4 SYS_STATUS
	INTEGER*4 CONNECT_READ	! CONNECT FOR AS READER FOR MESSAGE ID
	INTEGER*4 LHD_ADD	! GET ADDRESS INTO REGION (KERNAL CODE SUBR)
C
	RECORD /NRBDEF/NRB
	RECORD /NRBID/MSG_ID_LIST(*)

	TYPE *,' MAP_IDS '
	TYPE *,' NODE: ',NRB.NRB$C_PRINODE
	TYPE *,' NUMBER OF IDS: ',NRB.NRB$L_IDCNT
C
	IF(NRB.NRB$L_IDCNT .EQ. 0)THEN
		NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .OR. NRB$M_NOMSG !  SET NO OUTBOUND 
		TYPE *,' MARKING NRB WITH NO OUT BOUND IDS',NRB.NRB$L_FLAGS
		MAP_IDS=SS$_NORMAL			! MESSAGE IDS
		RETURN	
	ENDIF
C
	DO 100 I=1,NRB.NRB$L_IDCNT ! NUMBER OF MESSAGE ID'S ROUTED TO THIS NODE
	   TYPE *,' MESSAGE ID: ',MSG_ID_LIST(I).NRBID$C_MSGID
C
C	   SEE IF IT IS IN THE QUEUE
C
	   SYS_STATUS=CONNECT_READ(Q_BLOCK,  ! QUEUE SPECIAL BLOCK
	1	MSG_ID_LIST(I).NRBID$C_MSGID,  ! MESSAGE ID WE ARE CONNECTING
	1	MESG_EFN,  ! EFN FLAG TO SET WHEN ID QUEUE GOES FROM 0 TO 1
	1	MSG_ID_LIST(I).NRBID$L_IDX)	! ITS INDEX
	   IF(.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO FIND MESSAGE ID IN QUEUE'
		TYPE *,' STATUS: ',SYS_STATUS
		MSG_ID_LIST(I).NRBID$L_LHD=0	    ! ZERO, NO INDEX
	   ELSE
		MSG_ID_LIST(I).NRBID$L_LHD=	! GET POINTER TO MID LHD
	1		LHD_ADD(MSG_ID_LIST(I).NRBID$L_IDX)  ! IN QUEUE
	 	TYPE *,' INDEX IS: ',MSG_ID_LIST(I).NRBID$L_IDX
		TYPE *,' REGION ADDRESS FOR INDEX: ',MSG_ID_LIST(I).
	1		NRBID$L_LHD
	   ENDIF
100	CONTINUE
	MAP_IDS=SS$_NORMAL
	RETURN
	END
