	OPTIONS/EXTEND
	INTEGER*4 FUNCTION NET_AST(NRB,R0,R1,PC,PSL)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&NET_AST\&
C .nf
C .x NET_AST>Defined
C Source:NET_AST.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 06-APR-87
C Revision level     :1.3
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE                                         
C                               NODE ROUTING BLOCK (STATUS ABOUT A PARTICULAR     
C                               NODE.  MAY ALSO BE FOR THE UNSOLICITED 
C                               CONNECTS.
C  
C    R0                         INTEGER*4                                         
C                               SAVED R0 FROM AST                                 
C  
C    R1                         INTEGER*4                                         
C                               SAVED R1 FROM AST                                 
C  
C    PC                         INTEGER*4                                         
C                               SAVED PC FROM AST                                 
C  
C    PSL                        INTEGER*4                                         
C                               SAVED PSL FROM AST                                
C  
C Returns:
C  
C Accesses common(s):
C 
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MA_ROUTER COMMON PARAMETERS SHARED THROUGHTOUT    
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG MESSAGE TO CONSOLE                            
C                                (found in library:INLAND)
C  
C .X PUSH_EVENT_QUE>Referenced
C    PUSH_EVENT_QUE             USED TO PUSH EVENTS INTO THE EVENT QUEUE   
C 
C .X CONNECT_NODE>Referenced
C    CONNECT_NODE               USED TO CONNECT THE REMOTE NODE
C 
C .X BUILD_REMOTE_CONNECT_NCB>Referenced
C    BUILD_REMOTE_CONNECT_NCB   Use to build the NCB for a unsolicited
c                               connect attempt.
C .X DISCONNECT_NODE>Referenced
c    DISCONNECT_NODE            Call to disconnect a node
c  
c .X NODE_TO_NRB>Referenced
c    NODE_TO_NRB                From an unsolicited network message,
c                               take node name and find our nrb for it.
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called by the system AST services when
C a the network mailbox has mail in it.  The typical letters are
c for requesting a logical link, disconnecting a logical link,
c and network shutdown.  
c 
C 	Calling Sequence is via the ast parameter in QIO,
c there are no ast parameters passed, however, the buffer 
c is contained within the ma_router common.
c 
C .nofill
C  
C  SYS_STATUS=SYS$QIO(...%VAL(IO$_READVB),...,NET_AST,,....)
c  
C end.doc ****************************** end.doc  

	INTEGER*4 R1,R0,PSL,PC	! AST PARAMETERS THAT WE DON'T USE IN FORTRAN
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
C
	INCLUDE 'EVENT_Q.INC/NOLIST'
	RECORD/EVENT_ENTRY/EVENT
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS_STATUS2
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$DASSGN	! DEASSIGN CHANNEL
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 SYS$SETEF	! SET EVENT FLAG
	INTEGER*4 SYS$CREPRC	! CREATE PROCESS
	INTEGER*4 CONNECT_NODE	! TO ACCEPT CONNECTION
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 NET_BUF_DESCP(2) ! DESCRIPTOR SO CAN PRINT NETWORK BUFFER
	INTEGER*4 NAME_COUNT	! NUMBER OF BYTES IN NAME PART OF MESSAGE
	INTEGER*4 NRBADD	! NRB ADDRESS
	INTEGER*4 BUILD_REMOTE_CONNECT_NCB 
	INTEGER*4 FLAGS		! NRB FLAGS 
	INTEGER*4 PUSH_EVENT_QUE	! PUSH EVENT INTO EVENT QUEUE
	INTEGER*4 NODE_TO_NRB	! GET NRB ADDRESS FROM NDOE NAME
	INTEGER*4 ICNT		! NUMBER OF CHARACTERS IN NAME FIELD OF MESSAGE

C
C DEBUG
C
	NAME_COUNT=NRB.NRB$B_NETMSG(5)	! NUMBER OF BYTES IN NAME COUNTED STRING
	NET_BUF_DESCP(1)=NRB.NRB$B_NETMSG(NAME_COUNT+6)  ! INFO BUFFER SIZE
	NET_BUF_DESCP(2)=%LOC(NRB.NRB$B_NETMSG(NAME_COUNT+7)) ! START OF BUFFER
d	SYS_STATUS=OPR_FAO_MSG(RTR_NETAST,NET_BUF_DESCP,NRB.NRB$Q_NCBDES,
d	1	%VAL(NRB.NRB$W_NETMSG(1)))
C
	IF(.NOT. NRB.NRB$Q_MBXSTS.COND)THEN	! QIO READ ERROR?
		IF((NRB.NRB$L_FLAGS .AND. NRB$M_DWN) .NE. 0)RETURN  ! ALREADY
						    ! DOWN?, IGNORE
		MSGDESC(1)=512
		SYS_STATUS2=SYS$GETMSG(%VAL(NRB.NRB$Q_NETSTS.COND),
	1		MSGDESC(1),MSGDESC,,)
		SYS_STATUS2=OPR_FAO_MSG(RTR_RDNETMBX,MSGDESC,
	1		NRB.NRB$Q_NCBDES)
		GO TO 5000	! GO READ AGAIN
	ENDIF
C
C FIND OUT WHAT KIND OF MESSAGE WAS RECEIVED
C
	IF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_ABORT .OR.
	1	NRB.NRB$W_NETMSG(1) .EQ. MSG$_DISCON .OR.
	1	NRB.NRB$W_NETMSG(1) .EQ. MSG$_EXIT  .OR.
	1	NRB.NRB$W_NETMSG(1) .EQ. MSG$_PATHLOST .OR.
	1	NRB.NRB$W_NETMSG(1) .EQ. MSG$_NODEINACC .OR.
	1	NRB.NRB$W_NETMSG(1) .EQ. MSG$_THIRDPARTY
	1	)THEN  
C
C		THE NRB FOR THE LOGICAL LINK THAT WAS ABORTED,
C		DISCONNECTED, ETC.  IF
C		THERE IS A CHANNEL ASSIGNED, DEASSIGN IT, MARK THE
C		LINK AS NOT AVAILABLE AND SET CONNECT RETRY TIMER.
C
	     IF(NRB.NRB$L_CHAN .NE. 0)		   ! CHANNEL ASSIGNED?
	1		CALL DISCONNECT_NODE(NRB)  ! YES, DISCONNECT THE NODE
	    EVENT.EVENT=LINK_TERM ! EVENT IS LINK TERMINATED 
	    EVENT.NRBADD=%LOC(NRB) ! NRB ADDRESS
	    SYS_STATUS=PUSH_EVENT_QUE(EVENT)  ! PLACE IN QUEUE
	    RETURN	! DON'T DO QIO AGAIN

	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_CONFIRM)THEN 
C
C		CONNECT CONFIRM 
C		LET THE QIO FOR THE CONNECT HANDLE THIS MESSAGE
C		THEREFORE, JUST ISSUE ANOTHER QIO AND RETURN
C

	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_CONNECT)THEN
C		INBOUND CONNECT INITIATE 
C		IF WE ARE IN THE PROCESS OF TRYING TO CONNECT WITH THE REMOTE
C		THEN TELL REMOTE THAT WE ARE NOT ACCEPTING THE CONNECTION.
C		THIS IS A BASIC RACE TO SEE WHO CAN CONNECT FIRST (RANDOM
C		CONNECT TIMES WILL MAKE SURE THAT SOMEONE WILL CONNECT FIRST
C		LATER); OTHERWISE ASSIGN A LOGICAL LINK AND CONNECT TO THE NODE
C 		AND CANCEAL THE MARK TIME FOR THE CONNECT.
C
C
C		FIND THE NRB FOR THE REQUESTING NODE
C
	   ICNT=NRB.NRB$B_NETMSG(5)	! LENGTH OF NAME PART
	   SYS_STATUS=NODE_TO_NRB(NRB.NRB$B_NETMSG(ICNT+7),  ! START AT INFO
	1		NRBADD,FLAGS)
C
	   IF(.NOT. SYS_STATUS .OR. ((FLAGS .AND. 	! UNKNOWN NODE OR
	1	(NRB$M_ATM .OR. NRB$M_CON .OR. NRB$M_SHUTDOWN)) 
	1		.NE. 0))THEN	! ARE WE TRYING? OR CONNECTED?
		SYS_STATUS2=SYS$QIO( 	! YES, THEN TELL HIM NO! NO!
	1		,		! EVENT FLAG
	1		%VAL(NRB.NRB$L_CHAN),  ! CHANNEL
	1		%VAL(IO$_ACCESS .OR. IO$M_ABORT), ! FUNCTION
	1		NRB.NRB$Q_NETSTS,	! I/O STATUS BLOCK
	1		,,, 		! NO  AST ADDRESS 
	1		,,,,)		! NO PARAMETERS
		IF(.NOT. SYS_STATUS2)THEN
			  MSGDESC(1)=512
			  SYS_STATUS2=SYS$GETMSG(%VAL(SYS_STATUS2),MSGDESC(1),
	1			MSGDESC,,)
			  SYS_STATUS2=OPR_FAO_MSG(RTR_NETREJ,MSGDESC)
		ENDIF
		IF(SYS_STATUS .EQ. %LOC(RTR_CONUNODE) .AND.  ! DO WE NEED TO 
	1	  PRILOG_COUNT .NE. 0)THEN		     ! REQUEST LOGICAL
							     ! NODE TRANSLATION
		  SYS_STATUS2=SYS$CREPRC(,	! PID
	1			IMAGE_NAME,	! REQUEST FIND SERVICE
	1			SYSINPUT,	! PROCESS SYS$INPUT
	1			SYSOUTPUT,	! PROCESS SYS$OUTPUT
	1			SYSERROR,	! PROCESS SYS$ERROR
	1			,,	! PRIV, QUOTA
	1			PROC_NAME,
	1			,,,)	! BASE PRI, UIC, MBX UNIT, STATUS
	   	  IF(.NOT. SYS_STATUS2 .AND.	! BAD STATUS ?
	1	    SYS_STATUS2 .NE. SS$_DUPLNAM)THEN !(DUPLICATE NAME IS OK)
		    MSGDESC(1)=512
	 	    SYS_STATUS2=SYS$GETMSG(%VAL(SYS_STATUS2),
	1	    MSGDESC(1),MSGDESC,,)
	  	    SYS_STATUS2=OPR_FAO_MSG(RTR_CREPRC,MSGDESC)
		   ENDIF
		ENDIF
	   ELSE 						! WE AREN'T 
	        sys_status=BUILD_REMOTE_CONNECT_NCB(
	1		NRB.NRB$B_NETMSG(ICNT+6),%VAL(NRBADD))  ! BUILD NCB
C
		SYS_STATUS=CONNECT_NODE(%VAL(NRBADD))	! CONNECT NODE
		   IF(.NOT. SYS_STATUS)THEN
			  MSGDESC(1)=512
			  SYS_STATUS2=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1			MSGDESC,,)
			  SYS_STATUS2=OPR_FAO_MSG(RTR_NETREJ,MSGDESC)
		   ENDIF
	    ENDIF

	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_INTMSG)THEN
C		INTERRUPT MESSAGE - UNSOLICITED DATA 
C		LOGGED THE DATA, HOWEVER, AT THIS TIME HAVE NO
C		USE FOR IT AND SHOULD NOT HAPPEN.
C
	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_PROTOCOL)THEN
C		PROTOCOL ERROR 
C		LOG THE ERROR, BUT QIO READ/WRITE SHOULD HANDLE 
C		ERROR RECOVERY.
C
	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_TIMEOUT
	1	.OR. NRB.NRB$W_NETMSG(1) .EQ. MSG$_REJECT)THEN
C
C		CONNECT TIMEOUT  OR CONNECT REJECT
C		LET THE QIO FOR THE CONNECT HANDLE THIS MESSAGE
C		AND SIMPLY RETURN HERE WITHOUT POSTING ANOTHER READ
C		ON THE MAILBOX.
C
		RETURN
	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_NETSHUT)THEN
C
C		Network shutting down 
C		Disconnect all logical links and mark all
c		nodes as not available.  Push event into the
c		event queue to have all nodes disconnected
c
		SYS_STATUS=PUSH_EVENT_QUE(NET_DOWN)
		RETURN	! if shutting down, don't read anymore

	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_NODEACC)THEN
C
C		Node has become accessible 
C
	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_EVTAVL)THEN
C		Events are available to EVL 
c		Who cares
c
	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_EVTRCVCHG)THEN
C		Event receiver database change 
c		That's a nice, but I don't care
c
	ELSEIF (NRB.NRB$W_NETMSG(1) .EQ. MSG$_EVTXMTCHG)THEN
C		Event transmitter database change 
c		That's a nice, but I don't care
	ENDIF

C
C PLACE READ ON THE NETWORK MAILBOX TO GET THE DISCONNECT MESSAGES
C AND THE CONNECT CONFIRMATION MESSAGES FROM THE REMOTE
C
5000	CONTINUE
	IF(NRB.NRB$L_NETMBX .EQ. 0)RETURN ! CONNECT AST OR SOMETHING ELSE
					  ! HAS OCCURRED SINCE FIRST SET UP
	SYS_STATUS=SYS$QIO(
	1	,			! EVENT FLAG
	1	%VAL(NRB.NRB$L_NETMBX),	! CHANNEL ASSIGNED TO NETWORK MBX
	1	%VAL(IO$_READVBLK ), 	! READ FUNCTION
	1	NRB.NRB$Q_MBXSTS,		! I/O STATUS BLOCK	
	1	%VAL(NET_AST_ADD),	! AST ADDRESS
	1	NRB,			! AST PARAMETER= NRB
	1	NRB.NRB$B_NETMSG,	 ! BUFFER TO READ LETTER INTO
	1	%VAL(NET_MBX_SIZE),,,,)		 ! SIZE OF LETTER BUFFER
C
	IF(.NOT. SYS_STATUS)THEN
		MSGDESC(1)=512
		SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_NETMBX,MSGDESC)
		RETURN
	ENDIF
	RETURN
	end
