	PROGRAM NRBDMP
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&NRBDMP\&
C .nf
C .x NRBDMP>Defined
C Source:NRBDMP.FOR
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 25-feb-1987
C Revision level     :1.3
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This is a simple program that allows the user to dump
C a typical NRB from the routing database currently installed
C in the system.  The routing database that is used is the one
C currently installed in the group that the caller is running
C from.   The MA_ROUTER must be running.
C end.doc ****************************** end.doc  

C
	INCLUDE '($SSDEF)'
	STRUCTURE/IOSTATUS/
	 UNION
	   MAP
	     INTEGER*4 LW(2)
           END MAP
C
	   MAP
	     INTEGER*2 COND	! CONDITION VALUE
	     INTEGER*2 TRANS	! TRANSFER BYTE COUNT
	     INTEGER*4 SPEC	! DEVICE SPECIFIC
	   END MAP
	 END UNION
	END STRUCTURE
C
	BYTE A			! ANSWER VARIABLE
	INTEGER*4 I,J,K		! LOOP VARIABLE
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS LONG WORD
	INTEGER*4 SYS$MGBLSC	! MAP GLOBAL SECTION	
	INTEGER*4 SYS$EXIT	! EXIT PROCESS
	INTEGER*4 RELPAG	! RELATIVE PAGE		
	INTEGER*4 NRBCOUNT	! NUMBER OF NRB'S ENCOUNTERED
	INTEGER*4	GLB_VRT_ADDR(2)		! VIRTUAL ADDRESS OF THE
						! GLOBAL SECTION NAME
	INTEGER*4	MAPPED_ADDR(2)		! ADDRESS MAPPED BY SYS$MGBLSC
	INTEGER*4	SECTION_FLAGS		! FLAG MASK SPECIFYING THE TYPE
						! OF SECTION TO BE MAPPED
C

C
C THIS COMMON IS MAPPED BY THE MAP GLOBAL SECTION
C AND WILL BE USED TO FIND THE NRB.
C
C
C STRUCTURE OF ROUTING DATABASE HEADER IS:
c	.long	VERSION AND RELEASE
C	.LONG 	FLAG
C	.LONG   OFFSET TO RESPONSE BUFFERS LIST
C	.LONG   OFFSET TO OUTPUT BUFFERS LIST
C	.LONG	NUMBER OF MESSAGE IDS THAT WILL BE ROUTED
C	.REPT	NUMBER OF NRBS
C	.LONG 	OFFSET TO NRB (I)
C	.ENDR
C	.LONG	0
C 
	INTEGER*4 RESPOFF
	INTEGER*4 OTBUFOFF
	INTEGER*4 NBRIDS
	INTEGER*4 NRBLST(125)	! ALLOW FOR UP TO 100 NODES AND FILL TO 1 BLOCK
	INTEGER*4 FILL
	INTEGER*4 FLAG
	INTEGER*4 VERSION
	COMMON/NRBLST/VERSION,FLAG,RESPOFF,OTBUFOFF,NBRIDS,NRBLST,FILL
C
C THE FOLLOWING STRUCTURE WILL BE MAPPED TO A SINGLE NRB
C
C
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(NRBID)/LIST'
	RECORD/NRBDEF/NRB
	RECORD/NRBID/NRBID
	INTEGER*4 BLOCK(128)	! make sure don't overflow anything
	COMMON/NRB/NRB,NRBID(10),BLOCK

C
C ATTACH TO THE GLOBAL SECTION
C AND MAP THE NRBLST COMMON TO IT.
C
	SECTION_FLAGS = 0
C
	GLB_VRT_ADDR(1)=%LOC(VERSION)	! BEG. V.A. TO MAP (USE NRBLST COMMON)
	GLB_VRT_ADDR(2)=%LOC(NRBLST(125)) ! END V.A. TO MAP
D	TYPE *,' MAPPING ROUTEING DATABASE HEADER '
D	WRITE (*,300)GLB_VRT_ADDR
D300	FORMAT(' START VA: ',Z8,' END VA: ',Z8)
C
	SYS_STATUS = SYS$MGBLSC(
	1	   GLB_VRT_ADDR,	      	! STARTING VIRTUAL ADDRESS
	1	   MAPPED_ADDR,			! ACTUAL ADDRESS MAPPED BY SYSTEM
	1	   ,
	1	   %VAL(SECTION_FLAGS),		! SECTION FLAGS OPTIONS
	1	   'ROUTE_DBS_SECT',,)		! USER DEFINED SECTION NAME
C
D	WRITE(*,300)MAPPED_ADDR
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO MAP THE ROUTING DATABASE LISTHEAD'
		TYPE *,' MAKE SURE YOU ARE AT THE SAME GROUP AS THE'
		TYPE *,' MA_ROUTER AND THAT MA_ROUTER IS ACTIVE'
		TYPE *,' EXIT REASON: '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	WRITE (*,340)VERSION
340	FORMAT(' Current version of installed database: ',Z8.8)
C
C PRINT OUT THE NAME OF EACH NRB  (PRINT PRIMARY AND
C SECONDARY NODE NAMES) AND ASK USER IF THIS IS THE CORRECT
C NODE.  THIS WILL REQUIRE THAT WE MAP THE NRB.  
C
	NRBCOUNT=0	! ACTUAL NUMBER OF NRBS
	I=1		! NRB LIST INDEX
1000 	CONTINUE	! LOOP FOR NUMBER OF NRBS
	IF(NRBLST(I) .EQ. 0)THEN
		TYPE *,' NO MORE NRBs, TOTAL NUMBER OF NRBS IS: ',NRBCOUNT
		CALL SYS$EXIT(%VAL(SS$_NORMAL))
	ENDIF
	NRBCOUNT=NRBCOUNT+1	! INCREMENT NUMBER OF NRBS
D	TYPE *,' MAPPING NRB: ',NRBCOUNT
D	WRITE (*,1010)NRBLST(I)
D1010	FORMAT(' NRB OFFSET: ',Z8)
C
	GLB_VRT_ADDR(1)=%LOC(NRB)	! BEG. V.A. TO MAP (USE NRB COMMON)
	GLB_VRT_ADDR(2)=(%LOC(NRBID(10))+511)	! END V.A. TO MAP
	GLB_VRT_ADDR(2)=GLB_VRT_ADDR(2) .AND. (.NOT. "377) ! MAP EVEN BLOCK

C
	RELPAG=NRBLST(I)/512	! RELATIVE PAGE FOR THIS NRB
				! NOTE: NRB's are page aligned
C
D	WRITE (*,1015)RELPAG
D1015	FORMAT(' RELATIVE PAGE: ',Z8)
D	WRITE (*,300)GLB_VRT_ADDR
	SYS_STATUS = SYS$MGBLSC(
	1	   GLB_VRT_ADDR,	      	! STARTING VIRTUAL ADDRESS
	1	   MAPPED_ADDR,			! ACTUAL ADDRESS MAPPED BY SYSTEM
	1	   ,
	1	   %VAL(SECTION_FLAGS),		! SECTION FLAGS OPTIONS
	1	   'ROUTE_DBS_SECT',		! USER DEFINED SECTION NAME
	1          , %VAL(RELPAG))		! RELATIVE PAGE
C
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' UNABLE TO MAP THE ROUTING DATABASE NRB'
		TYPE *,' MAKE SURE YOU ARE AT THE SAME GROUP AS THE'
		TYPE *,' MA_ROUTER AND THAT MA_ROUTER IS ACTIVE'
		TYPE *,' EXIT REASON: '
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
D	WRITE(*,300)MAPPED_ADDR
C
C	PRINT OUT THE PRIMARY AND SECONDARY NODE NAMES
C
C
	WRITE (*,1175)NRB.NRB$C_CURNODE
1175	FORMAT(/,' CURRENT NODE: ',A)
	WRITE (*,1100)NRB.NRB$C_PRINODE
1100	FORMAT(//,' PRIMARY NODE: ',A)
	WRITE(*,1200)NRB.NRB$C_SECNODE
1200	FORMAT(' SECONDARY NODE: ',A)
	WRITE(*,1300)NRB.NRB$L_FLAGS
1300	FORMAT(' NRB STATUS: ',Z8,/,' MEANINGS: ')
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_DWN).NE. 0)
	1	TYPE *,'        Remote linkdown'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_RTM).NE. 0)
	1	TYPE *,'	Connect retry timer active'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_ATM).NE. 0)
	1	TYPE *,'	Local connect for remote node in progress'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_DRQ).NE. 0)
	1	TYPE *,'	Local disconnect of remote node in progress'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_CON).NE. 0)
	1	TYPE *,'	Logical connection established with remote'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_RNRQC).NE. 0)
	1	TYPE *,'	Remote requested logical connection, granted'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_SEC).NE. 0)
	1	TYPE *,' 	Connection is with alternate node'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_LNKAVL).NE. 0)
	1	TYPE *,' 	Link is available'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_CONTIMER).NE. 0)
	1	TYPE *,'	Connect timer is active for this node'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_SHUTDOWN).NE. 0)
	1	TYPE *,'	Decnet (routing) services shutting down'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_NOMSG).NE. 0)
	1	TYPE *,'	No outbound messages routed from this node'
	IF((NRB.NRB$L_FLAGS .AND. NRB$M_PRILOG) .NE. 0)
	1	TYPE *,' 	Primary node name is a logical node name'
c	

	WRITE(*,1400)NRB.NRB$W_LNKSEQO,NRB.NRB$W_LNKSEQI
1400	FORMAT(' OUTBOUND SEQUENCE NUMBER: ',I5,
	1      '  INBOUND SEQUENCE NUMBER: ',I5)
C
	WRITE(*,1410)NRB.NRB$C_ACC
1410	FORMAT(' ACCESS CONTROL STRING(FROM DATABASE): ',A)
	TYPE *,' REMOTE NCB: ',NRB.NRB$C_REMNCB
C
	WRITE(*,1420)NRB.NRB$L_CHAN
1420	FORMAT(' CURRENT ASSIGNED CHANNEL NUMBER [HEX]: ',Z8)
C

C
C	PRINT OUT THE NRBID FOR THE FIRST TEN MESSAGE ID OR UP TO 
C	NUMBER SPECIFIED
C
	WRITE(*,1423)
1423	FORMAT('$Ready for the NRBID s?')
	READ(*,2010,END=9000)A
	J=NRB.NRB$L_IDCNT
	IF(J .GT. 10)J=10	! ONLY MAPPED FIRST 10
	DO 2000 K=  1,J
	   TYPE *,' MESSAGE ID: ', NRBID(K).NRBID$C_MSGID
	   WRITE(*,1500)NRBID(K).NRBID$L_LHD
1500	   FORMAT(' NRBID$L_LHD: ',Z8)
	   WRITE(*,1600)NRBID(K).NRBID$L_RNA
1600	   FORMAT(' NRBID$L_RNA: ',Z8)
	   WRITE(*,1700)NRBID(K).NRBID$L_IDX
1700	   FORMAT(' NRBID$L_IDX: ',Z8)
2000	CONTINUE
	i=i+1
	TYPE *,' Enter <carraige return to see next NRB'
	READ(*,2010,END=9000)A
2010	FORMAT(A1)
	GO TO 1000
C
C EXIT
C
9000	CALL EXIT
	END
