	OPTIONS/EXTEND
	SUBROUTINE OUTPUT_NET(NRB,NRBID)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&OUTPUT_NET\&
C .nf
C .x OUTPUT_NET>Defined
C Source:OUTPUT_NET.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Copy Right: Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:14-AUG-1986
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB THAT OUTPUT IS TO OCCURR FOR                  
C  
C    NRBID                      STRUCTURE/NRBID/                                  
C                               MESSAGE ID ENTRY IN THE NRB THAT HAS DATA TO      
C                               BE OUTPUT                                         
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           LOCAL COMMON FOR MA_ROUTER                        
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                ERROR MESSAGES                                    
C                                (found in library:INLAND)
C  
C  
C .X ALC_OUT_BUF>Referenced
C    ALC_OUT_BUF                ALLOCATE AN OUTPUT BUFFER                         
C 
C .X DEA_OUT_BUF>Referenced
c    DEA_OUT_BUF                DEALLOCATE AN OUTPUT BUFFER, 
C                               IN CASE OF AN ERROR
C 
C .X GET_OUT_MESG>Referenced
c    GET_OUT_MESG	        FILLS IN ALLOCATED BUFFER WITH A MESSAGE
C                               FROM THE QUEUE ALONG WITH OTHER POOP
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is responsible for getting a message from the
C queue and sending it out to decnet.  The subroutine allocates an
C output buffer (should be able to since the routine that calls us
C checked to make sure that one was available).  
C .literal
C CALLLING SEQUENCE:
C 	SYS_STATUS=OUTPUT_NET(NRB,NRBID)
C .END LITERAL
C 
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBID)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUECONST)/LIST'
C
	RECORD/NRBID/NRBID
C
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 ALC_OUT_BUF	! ALLOCATE AN OUTPUT BUFFER
	INTEGER*4 DEA_OUT_BUF	! DEALLOCATE OUTPUT BUFFER
	INTEGER*4 BUF_ADDR	! ALLOCATED OUTPUT BUFFER ADDRESS
	INTEGER*4 GET_OUT_MESG  ! FILL IN BUF

C
C
C
	TYPE *,' WORK FOUND FOR NODE: ',NRB.NRB$C_CURNODE
	TYPE *,' MESSAGE ID: ',NRBID.NRBID$C_MSGID
C
C GET A BUFFER
C
	SYS_STATUS=ALC_OUT_BUF(NRB,%VAL(BUF_INUSE),
	1	%VAL(BUF_ADD_LST),BUF_ADDR)
C
	IF(.NOT. SYS_STATUS)THEN	! SUCCESSFUL ALLOCATION ?
		SYS_STATUS=OPR_FAO_MSG(%VAL(SYS_STATUS))
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	WRITE (*,100)BUF_ADDR
100	FORMAT(' OUTPUT BUFFER ADDRESS: ',Z8)
C
C GET A MESSAGE AND PUT IT INTO THE BUFFER AND
C HAVE IT QUEUED TO THE NETWORK
C
	SYS_STATUS=GET_OUT_MESG(%VAL(BUF_ADDR),NRB,NRBID) 
C
	IF(.NOT. SYS_STATUS)THEN ! DEALLOCATE THE BUFFER
		CALL DEA_OUT_BUF(BUF_ADDR,%VAL(BUF_INUSE)) ! DEALOCATE BUFFER
	ENDIF
	RETURN
	END
