	PROGRAM QIT
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;PROGRAM
C .c ;^&QIT\&
C .nf
C .x QIT>Defined
C Source:QIT.MOD
C Designer           :EARL LAKIA (IPACT)
C Author             :Earl Lakia
C  
C Date of last update: 9-AUG-1988
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk
C 	This is a simple utility that allows anyone at
C the DCL level to request a message be placed into
c MA_QUEUE and ROUTING software.  The DCL command is:
c .sk
c .nofill
c      QIT/ID:messag_id[/TIME] "up to 160 character message"
c .fill
c .sk
c 	The "/TIME" is an optional parameter that if specified,
c will translate the message using SYS$BINTIM (see system services
c manual for description of SYS$BINTIM), and write the
c message to the passed message id.  The following are possible
c calls (the quotes are required syntax):
c .sk
c .nofill
c 	QIT/ID:STOCK_AVERAGE/TIME "-- 01:00:00.00"
C	QIT/ID:STOCK_AVERAGE/TIME "09-AUG-1988 01:00:00.00"
c .fill
C end.doc ****************************** end.doc  

        INTEGER*4 CLI$GET_VALUE ! Get value of a switch
	INTEGER*4 CLI$PRESENT   ! see if a switch is present
	INTEGER*4 SYS$BINTIM
	INTEGER*4 STATUS	! System service status
	CHARACTER*16 MESGID	! Message ID
	INTEGER*4 IDLEN	! number characters in message id
	INTEGER*4 MESGLEN   ! length of user message
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSGVAL)'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QEXDEF)'
	RECORD/QEXDEF/QBX
C
	STRUCTURE/MESSAGE/
	UNION
	MAP
		INTEGER*4 TIME(2)
	END MAP
	MAP
		CHARACTER*162 MESSAGE	! user message
	END MAP
	END UNION
	END STRUCTURE
C
	RECORD/MESSAGE/MESSAGE
	LOGICAL TIME
c
c

	STATUS=CLI$GET_VALUE('MESGID', ! Get the output file
	1               MESGID,
	1               IDLEN)
	IF(.NOT. STATUS)THEN
		TYPE *,' Bad get of MESSAGE_ID NAME '
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
C
C Get message
C
	STATUS=CLI$GET_VALUE('MESSAGE', ! Get the output file
	1               MESSAGE.MESSAGE,
	1               MESGLEN)
	IF(.NOT. STATUS)THEN
		TYPE *,' Bad get of MESSAGE'
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
C
C See if user entered the time switch
c
        IF(CLI$PRESENT('TIME'))THEN
		TIME=.TRUE.
		STATUS=SYS$BINTIM(MESSAGE.MESSAGE(2:MESGLEN-1),
	1		MESSAGE.TIME)
		IF(.NOT. STATUS)THEN
			TYPE *,' Invalid time entered: ',
	1			MESSAGE.MESSAGE(2:MESGLEN-1)
			CALL SYS$EXIT(%VAL(STATUS))
		ENDIF
	ELSE
		TIME=.FALSE.
	ENDIF
C
c Actually attach to queue and write the message
c
	STATUS=ATTACH_QE(QBX)
	IF (.NOT. STATUS) THEN
		TYPE *,'Error attaching to queue'
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
c
	IF(TIME)THEN
		STATUS=WRITE_QREC(QBX,MESGID,MESSAGE.TIME,8,0)
	ELSE
		STATUS=WRITE_Q(QBX,MESGID,
	1		MESSAGE.MESSAGE(2:MESGLEN-1),
	1		MESGLEN-2,0)
	ENDIF
	IF(.NOT. STATUS)THEN
		TYPE *,' Unable to write to message id: ',MESGID
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
c
C detach from queue
c
	STATUS=DETACH_Q(QBX)
	IF(.NOT. STATUS) THEN
		TYPE *,'Unable to detach from queue'
		CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
	CALL SYS$EXIT(%VAL(STATUS))
	END
