	PROGRAM SHUTDOWN_QUEUE
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&SHUTDOWN_QUEUE\&
C .nf
C .x SHUTDOWN_QUEUE>Defined
C Source:SHUTDOWN_QUEUE.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:16-MAR-1987 08:44:28.01
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X ATTACH_QE>Referenced
C    ATTACH_QE                  ATTACH TO SYSTEM DEFAULT QUEUE 
C                                (found in library:QUEUE.OLB)
C  
C .X SHUTDOWN_Q>Referenced
C    SHUTDOWN_Q                 TO DO ACTUAL SHUTDOWN          
C                                (found in library:QUEUE.OLB)
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                OPERATOR CONSOLE MESSAGES      
C                                (found in library:INLAND)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This program is a skelton program that simply attaches to the
C default queue on the system and marks the queue as shutdown.  This 
C program may be added as part of the shutdown proceedure for a particular
C node.  If more than a single node is present, then this program must 
C modified for that node.  To run this program, the DCL command 
C "RUN SHUTDOWN_QUEUE" is used.  The SHUTDOWN_Q service requires that
C the user have SYSPRV.
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
c
c Define the QUEUEING specific values
c
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QEXDEF)/LIST'
C
	RECORD /QEXDEF/QEX	! Q_BLOCK with exit handler
	INTEGER*4 STATUS	! RETURN STATUS
	INTEGER*4 SYS$EXIT	! SYSTEM EXIT
	INTEGER*4 OPR_FAO_MSG	! CONSOLE LOG MESSAGE
C
C ALL WE HAVE TO DO IS ATTACH THE QUEUE AND THE REQUEST THAT
C IT BE SHUTDOWN
C
	STATUS=ATTACH_QE(QEX)
C
	IF( .NOT. STATUS)THEN
		TYPE *,' Unable to attach to the queue'
		STATUS=SYS$EXIT(%VAL(STATUS))
	ENDIF
C
	TYPE *,' Default queue attached'
c
	STATUS=SHUTDOWN_Q(QEX)
	IF(.NOT. STATUS)THEN
		TYPE *,' Unable to shutdown the queue'
		STATUS=SYS$EXIT(%VAL(STATUS))
	ENDIF
	TYPE *,' Queue successfully shutdown'
	STATUS=OPR_FAO_MSG(%VAL(STATUS))
	END
