	OPTIONS/EXTEND
	INTEGER*4 FUNCTION WRITE_NET_AST(BUF,R0,R1,PC,PSL)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&WRITE_NET_AST\&
C .nf
C .x WRITE_NET_AST>Defined
C Source:WRITE_NET_AST.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:02-SEP-86
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C  ASTPRM                       STRUCTURE/BUFDEF/
C                               Buffer structure that has pointers
C                               to the NRB, I/O status block, ect.
C  
C    R0                         REGISTER                                          
C                               SAVED R0 FROM AST                                 
C  
C    R1                         REGISTER                                          
C                               SAVED R1 FROM AST                                 
C  
C    PC                         REGISTER                                          
C                               SAVED PC FROM AST                                 
C  
C    PSL                        REGISTER                                          
C                               SAVED PSL FROM AST                                
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           ROUTER COMMON                                     
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                LOG MESSAGES                                      
C                                (found in library:INLAND)
C  
C .X DEA_OUT_BUF>Referenced
C    DEA_OUT_BUF                DEALLOCATE AN OUTPUT BUFFER   
c 
c .X MARK_RESP_PEND>Referenced
C    MARK_RESP_PEND             USED TO CLEAR I/O PENDING AND SET
C                               RESPONSE PENDING FOR THIS MESSAGE ID.
C 
C .x PUT_BACK>Referenced
c    PUT_BACK                   PUT READ BUT NOT ACKNOWLEGED MESSAGE
C                               BACK ON QUUE
C 
C .X AT_ADD>Referenced
c    AT_ADD                     Used to get a value with the NRBID
c 
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called becuase a write QIO has completed.  The
C remote node router however has not acknowleged the message.  However, we
C can deallocate the buffer.  If the remote router fails to get the
C message (disconnects) or remote node queue full, then either
C the read ast for that node or the disconnect error must replace the
C read but not acknowleged message back into the queue.
C 	The subroutine is responsible for the following:
C .list
C .le;Clear the I/O pending bit in the Message ID list head
C .le;Set the response pending bit in the Message ID list head
C .le;Deallocate the buffer
C .le;Set wakeup for the mainline such that this buffer may be used
C by someone else.
C .els
C 	The calling sequence is:
C .LITERAL
C 	WRITE_NET_AST(ASTPRM,R0,R1,PC,PSL)
C .END LITERAL
C 	Where: ASTPRM is the buffer structure that has
C the I/O status block and pointer to the NRB, etc.
C end.doc ****************************** end.doc  

	INTEGER*4 R1,R0,PSL,PC	! AST PARAMETERS THAT WE DON'T USE IN FORTRAN
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(BUFDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBID)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QUECONST)/LIST'
	RECORD/BUFDEF/BUF
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$DASSGN	! DEASSIGN CHANNEL
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
	INTEGER*4 PUSH_EVENT_QUE ! PLACE EVENT IN OUR QUEUE
	INTEGER*4 DISCONNECT_NODE ! DISCONNECT A LOGICAL LINK
	INTEGER*4 AT_ADD	! GET VALUE AT ADDRESS
	INTEGER*4 PUT_BACK	! PLACE RNA POINTER BACK ON FRONT OF QUEUE
	INTEGER*4 RNA		! READ NOT ACK. POINTER FROM NRBID
	INTEGER*4 NRBID		! NRBID ADDRESS
	INTEGER*4 IDX		! INDEX FROM NRBID

D	SYS_STATUS=OPR_FAO_MSG(RTR_WRITECOMP,	! LOG FACT THAT WE RAN
D	1	BUF.BUF$S_MSG.HDR.HDR$C_DNM,
D	1	BUF.BUF$S_MSG.MGH$C_MID,
D	1	%VAL(BUF.BUF$Q_STS.COND))
C
	IF( .NOT. BUF.BUF$Q_STS.COND )THEN	! WRITE QIO ERROR
	   MSGDESC(1)=512
	   SYS_STATUS=SYS$GETMSG(%VAL(BUF.BUF$Q_STS.COND),
	1	MSGDESC(1),MSGDESC,,)
	   SYS_STATUS=OPR_FAO_MSG(RTR_NTWRTERR,
	1	MSGDESC,
	1	BUF.BUF$S_MSG.HDR.HDR$C_SNM,
	1	BUF.BUF$S_MSG.MGH$C_MID)

C
C	   SINCE WE WEREN'T SUCCESSFUL, DISCONNECT THE NODE,
C	   BACKOUT THE READ NOT ACKNOWLEGED POINTER,
C
	   CALL DISCONNECT_NODE(%VAL(BUF.BUF$L_NRB))  ! DISCONNECT NODE
C
C 	   CLEAR THE I/O PENDING BIT IN THE MESSAGE ID HEADER
C
	   CALL MARK_NOPEND(%VAL(BUF.BUF$L_NRB),BUF,Q_BLOCK)
C
C	   BACKUP THE READ NOT ACKNOWLEGED POINTER 
C
	   CALL PUT_BACK(BUF.BUF$S_MSG.MGH$C_MID,
	1	BUF.BUF$S_MSG.MGH$L_IDX,
	1	%VAL(BUF.BUF$L_NRB+NRB$L_SIZ),
	1	%VAL(BUF.BUF$L_NRB))
C
	   CALL DEA_OUT_BUF(%LOC(BUF),%VAL(BUF_INUSE)) ! DEALLOCATE BUFFER
	   RETURN
	ENDIF

C
C GOOD write , NOW WE WILL HAVE TO MARK THE MESSAGE ID HEADER WITH
C RESPONSE PENDING AND CLEAR THE I/O PENDING BIT, AND ALSO
C DEALLOCATE THE OUTPUT BUFFER.
C 
	CALL MARK_RESP_PEND(%VAL(BUF.BUF$L_NRB),BUF,Q_BLOCK) ! SET NO I/O 
				! PENDING AND RESPONSE IS  PENDING
	CALL DEA_OUT_BUF(%LOC(BUF),%VAL(BUF_INUSE)) ! DEALLOCATE BUFFER
	RETURN	! DONE, WAIT FOR THE RESPONSE FROM REMOTE NODE
	END
