	OPTIONS/EXTEND
	INTEGER*4 FUNCTION ALC_OUT_BUF(NRB,USE,ADD,RESP_ADD)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&ALC_OUT_BUF\&
C .nf
C .x ALC_OUT_BUF>Defined
C Source:ALC_OUT_BUF.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:15-JUL-1986 13:47:28.85
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    NRB                        STRUCTURE/NRBDEF/                                 
C                               NRB FOR NODE THAT NEEDS A RESPONSE BUFFER         
C  
C    USE                        LIST OF IN USE FLAGS (0= FREE, 1= NOT FREE)
C  
C    ADD                        LIST OF ADDRESSES OF AVAILABLE RESPONSE
C                               BUFFERS
C Returns:
C  
C    OUT_BUF_ADDR               INTEGER*4                                         
C                               ADDRESS OF THE RESPONSE BUFFER                    
C  
C Accesses common(s):
C 
C MA_ROUTER_COMMON              GLOBAL COMMON FOR MA_ROUTER
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                ERROR MESSAGES                                    
C                                (found in library:INLAND)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called to allocate an output buffer
C from the available buffers.  If there are no buffers
C available, then a message is output to the console and
C a status of RTR_NORSPBUF is returned to the caller. 
C 	The callling sequence is:
C .nofill
C      record/nrbdef/nrb
C      sys_status=ALC_OUT_BUF(nrb,USE,ADD,BUF_ADDR)
C  
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 OPR_FAO_MSG	! OPERATOR MESSAGES
C
	BYTE USE(BUF_COUNT)	! LIST OF  IN USE RESPONSE BUFFERS FLAGS
	INTEGER*4 ADD(BUF_COUNT) ! LIST OF ADDRESS OF RESPONSE BUFFERS
	INTEGER*4 RESP_ADD	! RETURNED RESPONSE BUFFER ADDRESS
	INTEGER*4 I		! LOOP VARIABLE
	RECORD/NRBDEF/NRB

C
C FIND OUT IF WE CAN FIND ONE.  START WITH THE LAST RESP POINTER
C SO WE SCAN IN A CIRCULAR FASHION WITH THE BELIEF THAT THE
C OLDEST PREVIOUSLY USED BUFFER OUGHT TO BE FREE BY NOW.
C
	IF(BUF_AVAIL .LE. 0) THEN
		ALC_OUT_BUF=%LOC(RTR_NORSPBUF)
		RETURN
	ENDIF
C
C SHOULD BE SOME, LOOK
C
	DO I=1,BUF_COUNT
	   IF(LAST_BUF .LT. 1 .OR. LAST_BUF .GT. BUF_COUNT)
	1	LAST_BUF=1	! CYCLE AROUND?
	   IF(USE(LAST_BUF) .EQ. 0)THEN
		RESP_ADD=ADD(LAST_BUF)
		LAST_BUF=LAST_BUF+1	! POINT TO NEXT 
		IF(LAST_BUF .GT. BUF_COUNT)LAST_BUF=1
		BUF_AVAIL=BUF_AVAIL-1	! DECREMENT NUMBER AVAILABLE
		ALC_OUT_BUF=SS$_NORMAL
		RETURN
	   ELSE
		LAST_BUF=LAST_BUF+1	! SEE IF NEXT AVAILABLE
	   ENDIF
	END DO
C
C  COULDN'T FIND A FREE ONE
C
	ALC_OUT_BUF=%LOC(RTR_NORSPBUF)
	SYS_STATUS=OPR_FAO_MSG(RTR_NORSPBUF,NRB.NRB$C_CURNODE)
	RETURN
	END
