	OPTIONS/EXTEND
	INTEGER*4 FUNCTION BUILD_REMOTE_CONNECT_NCB(ACC_STRING,NRB)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&BUILD_REMOTE_CONNECT_NCB\&
C .nf
C .x BUILD_REMOTE_CONNECT_NCB>Defined
C Source:BUILD_REMOTE_CONNECT_NCB.MOD
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 8-JUL-1986 14:53:24.62
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    ACC_STRING                 COUNTED STRING                                    
C                               ACCESS CONTROL FROM NETWORK MESSAGE               
C  
C    NRB                        STRUCTURE                                         
C                               MATCHING NODE NAME FOR THE REMOTE CONNECT REQ.    
C  
C Returns:
C  
C    BUILD_REMOTE_CONNECT_NCB   INTEGER*4                                         
C                               RETURN STATUS                                     
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called to set up the NRB for a remote
C node which is requesting a connection.  The bit NRB$M_RNRQC is
C set such that a connect will be attempted with this
C access control string in stead of the normal access control string.
c 	The access control string is actually recieved in the dummy
c NRB set up by the router for all unsolicited connection requests.  
c The true NRB was found by (node_to_NRB) and is passed to us.  We simply
c copy the access control string into the true NRB.
C 	Calling sequence:
C .nofill
C .sk
C   SYS_STATUS=BUILD_REMOTE_CONNECT_NCB(ACC_STRING,NRB)
C end.doc ****************************** end.doc  

	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! NRB FOR THE UNSOLICITED CONNECT
	INTEGER*4 ICNT,I
	BYTE  ACC_STRING(*)	! COUNTED ACCESS CONTROL STRING
C
C

	ICNT=ACC_STRING(1)	! GET NUMBER OF BYTES 
C
	DO 100 I=1,ICNT
		NRB.NRB$C_REMNCB(I:I)=CHAR(ACC_STRING(I+1)) ! COPY NODE, ETC. 
100	CONTINUE
C
C APPEND THE TRAILING " 
C
	NRB.NRB$C_REMNCB(ICNT+1:ICNT+1)='"'
C
C NOW SET UP THE DESCRIPTOR
C
	NRB.NRB$Q_NCBDES(1)=ICNT+1	! COUNT
	NRB.NRB$Q_NCBDES(2)=%LOC(NRB.NRB$C_REMNCB)  ! ADDRESS
	NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .AND. (.NOT. NRB$M_ATM) 
				! CLEAR FLAG SHOWING WE ARE REQUESTING LINK
	NRB.NRB$L_FLAGS=NRB.NRB$L_FLAGS .OR. NRB$M_RNRQC 
				! SET REMOTE REQUESTING THE LOGICAL LINK 
				! AND NOT US
	RETURN
	END
