	OPTIONS/EXTEND
	INTEGER*4 FUNCTION MA_MBX_AST(ZERO,R0,R1,PC,PSL)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&MA_MBX_AST\&
C .nf
C .x MA_MBX_AST>Defined
C Source:MA_MBX_AST.FOR
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:26-aug-86
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    AST_PRM                    INTEGER*4         
C                               AST PARAMETER FROM THE QIO (=0) 
C  
C    R0                         REGISTER     
C                               SAVED R0 PRIOR TO AST DELIVERY 
C  
C    R1                         REGISTER    
C                               SAVED R1 PRIOR TO AST DELIVERY  
C  
C    PC                         REGISTER  
C                               SAVED PC PRIOR TO AST DELIVERY 
C  
C    PSL                        REGISTER 
C                               PROCESSOR STATUS LONG WORD PRIOR TO AST
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           THE BUFFER FOR THE MAILBOX READ AND THE STATUS    
C                               BLOCK ARE CONTAINED.                              
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X PUSH_EVENT_QUE>Referenced
C    PUSH_EVENT_QUE             USED TO PUSH THE EVENT ONTO THE FIFO EVENT QUEUE  
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                USED TO LOG MESSAGES TO OPERATOR CONSOLE          
C                                (found in library:INLAND)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called when the QIO on the our
C ROUTING mailbox has completed.  The I/O status block and the
C buffer are in the common.  If status is successful, then
C store the event into the event queue, otherwise, log
c the error for later program fixing and ignore the message.
c 
C end.doc ****************************** end.doc  

	INTEGER*4 ZERO	! AST PARAMETER
	INTEGER*4 R0,R1,PSL,PC	! REGISTERS SAVED BEFORE CALLING AST
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($PSLDEF)'
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'EVENT_Q.INC/LIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 OPR_FAO_MSG	! SEND FAO MESSAGE TO OPERATOR
	INTEGER*4 SYS$GETMSG
	INTEGER*4 SYS$QIO	! QIO SERVICE
	INTEGER*4 PUSH_EVENT_QUE ! PLACE EVENT IN OUR QUEUE

C
C CHECK THE STATUS OF THE QIO
C
	IF (.NOT. MBX_STATUS.COND .OR.
	1	MBX_STATUS.TRANS .EQ. 0)THEN	! GOOD STATUS?
		SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),MSGDESC(1),
	1	MSGDESC,,)
		SYS_STATUS=OPR_FAO_MSG(RTR_QIORDERR,MSGDESC)
		RETURN
	ENDIF
C
C HAVE A MESSAGE, STORE IN EVENT QUEUE
C
	SYS_STATUS=PUSH_EVENT_QUE(NEW_DBS) ! NEW DATABASE RECEIVED,
					   ! TELL MAINLINE TO EXIT
					   ! THIS LETS ALL ASTS COMPLETE
					   ! FIRST.
	RETURN  ! SINCE WE WON'T BE CONTINUING AFTER MAINLINE
		! FINDS ABOUT THIS, WE DON'T NEED TO REISSUE THE QIO.
	END
