	OPTIONS/EXTEND
	INTEGER*4 FUNCTION NET_READ_RESP_AST(RSP,R0,R1,PC,PSL)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&NET_READ_RESP_AST\&
C .nf
C .x NET_READ_RESP_AST>Defined
C Source:NET_READ_RESP_AST.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:04-AUG-86
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C    RSPBUF                     STRUCTURE/RSPDEF/
C                               RESPONSE BUFFER AND LINK ETC. NEEDED TO DEALLOCATE
C  
C    R0,R1,PC,PSL               REGISTERS                                         
C                               SAVED REGISTERS FROM AST                          
C  
C Returns:
C  
C Accesses common(s):
C  
C .X MA_ROUTER_COMMON>Common
C    MA_ROUTER_COMMON           MA_ROUTER COMMON                                  
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X OPR_FAO_MSG>Referenced
C    OPR_FAO_MSG                ERROR MESSAGES                                    
C                                (found in library:INLAND)
C  
C .X DISCONNECT_NODE>Referenced
C    DISCONNECT_NODE            USED TO DISCONNECT NODE IN THE EVENT OF DECNET    
C                               ERROR                                             
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is called when the write QIO for the
C response to a read has been output and the response buffer
C can now be deleted.  If the status was successful, then 
C simply deallocate the response buffer.  Otherwise, 
C disconnect the node because of the decnet error and
C the log it.
C end.doc ****************************** end.doc  

	INTEGER*4 R1,R0,PSL,PC	! AST PARAMETERS THAT WE DON'T USE IN FORTRAN
	INCLUDE '($SSDEF)'
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)/NOLIST'	! MESSAGE DEFINITIONS
	INCLUDE 'MA_ROUTER_COMMON.INC/NOLIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(RSPDEF)/LIST'
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$GETMSG	! GET SYSTEM MESSAGE
	INTEGER*4 SYS$QIO	! QIO FOR NETWORK MAILBOXES
	INTEGER*4 SYS$EXIT	! EXIT
	INTEGER*4 OPR_FAO_MSG
	INTEGER*4 DISCONNECT_NODE ! DISCONNECT A LOGICAL LINK
C
	RECORD/RSPDEF/RSP

C
C SEE IF OUR STATUS WAS OK.
C
D	SYS_STATUS=OPR_FAO_MSG(RTR_RSPAST,
D	1	%VAL(RSP.RSP$Q_STS.COND))	! TELL SOMEONE WE RAN
C
	IF (.NOT. RSP.RSP$Q_STS.COND)THEN	! QIO ERROR?
	   MSGDESC(1)=512
	   SYS_STATUS=SYS$GETMSG(%VAL(RSP.RSP$Q_STS.COND),
	1	MSGDESC(1),MSGDESC,,)
	   SYS_STATUS=OPR_FAO_MSG(RTR_NETRDERR,MSGDESC)
C
	   IF(RSP.RSP$Q_STS.COND .NE. SS$_INSFMEM .AND.	! FATAL ERROR?
	1	RSP.RSP$Q_STS.COND .NE. SS$_PROTOCOL)THEN
		CALL DISCONNECT_NODE(%VAL(RSP.RSP$L_NRB)) ! YES, DISCONNECT
	   ENDIF
	ENDIF

C
C NO MATER WHAT WE MUST RELEASE THE RESPONSE BUFFER
C
	CALL DEA_RESP_BUF(RSP.RSP$L_BUFIDX,	! INDEX OF ONE TO FREE
	1	%VAL(RESP_INUSE))		! ADDRESS OF IN USE LIST
	RETURN
	END
