$!
$! START THE MA QUEUING AN ROUTING SOFTWARE COMMAND FILE
$!
$!
$ TYPE SYS$INPUT
 This command file performs the following:
  If the system is already on line (MA$Q present) is running:
	1) Stops the MA_ROUTER process in MA$Q batch queue (if active)
	2) Stops the QUEUE_CHKR process in MA$Q batch queue (if active)
	3) Requests Q_UTL to remove the currenlty installed section file.
  otherwise:
	1) Creates the MA$Q batch queue if not present
  in either case:
	1) Defines system logicals
	2) Installs the system service
	3) Starts the Queue check point process (QUEUE_CHKR) in MA$Q
	   batch queue.
	4) Starts the router process (MA_ROUTER) in the MA$Q
	   batch queue.
$ SET NOON
$ SET PROCESS/PRIV=ALL
$!
$! THE LOGICALS SHOULD BE DEFINED
$!
$ TOP = F$TRNLNM("MA_Q$PROD")
$ IF TOP .NES "" THEN GOTO GOTLOG
$ TYPE SYS$INPUT
	LOGICALS ARE NOT SETUP CORRECTLY
$ EXIT
$ GOTLOG:
$! 
$! Set to top directory
$!
$ SET DEF MA_Q$PROD
$!
$! Find out if our batch queue is present
$!
$ START/QUEUE MA$Q
$ IF $STATUS THEN GOTO NOBATCHQ
$!
$!  We must be online, therefore stop our poop
$!
$ STOP/QUEUE/RESET MA$Q
$!
$! Remove the currently installed queue
$!
$RUN Q_UTL
R
$EOD
$!
$!
$! System not online, or fall through from above.
$! Restart the batch queue, install service, etc.
$!
$ NOBATCHQ:
$!
$! INSTALL SERVICE
$!
$ OLDPRIV="CMKRNL,CMEXEC,SYSNAM,GRPNAM,ALLSPOOL,DETACH,DIAGNOSE,LOG_IO,GROUP,ACNT,PRMCEB,PRMMBX,PSWAPM,ALTPRI,SETPRV,TMPMBX,WORLD,MOUNT,OPER,EXQUOTA,NETMBX,VOLPRO,PHY_IO,BUGCHK,PRMGBL,SYSGBL,PFNMAP,SHMEM,SYSPRV,BYPASS,SYSLCK,SHARE,UPGRADE,DOWNGRADE,GRPPRV
$ SET PROC/PRIV=CMKRNL
$ IF  $STATUS THEN GOTO GOTPRIV
$ TYPE SYS$INPUT
	Insuficient privelege to install the service.  Run from a
priveleged account.
$ EXIT
$ GOTPRIV:
$ INSTALL :== $SYS$SYSTEM:INSTALL/COMMAND
$ install
REMOVE SYS$SYSROOT:[SYSLIB]SSDISP
CREATE SYS$SYSROOT:[SYSLIB]SSDISP-
	/share-
	/PROTECT-
	/PURGE-
	/PRIV=(PHY_IO,CMKRNL,-
	CMEXEC,LOG_IO,OPER,BUGCHK,-
	SYSGBL,SYSNAM,PRMGBL,SYSLCK,SHARE)
$!
$! START UP BATCH QUEUE
$!
$ SET DEF MA_Q$PROD
$!
$ @MA$Q
$!
$! Submit the queue checker to our batch queue (at elevated 
$!	realtime priority)
$!
$ PURGE MA_Q$PROD:QUEUE_CHKR.LOG/KEEP=2
$!
$ SUBMIT/QUEUE=MA$Q-
	/LOG=MA_Q$PROD:QUEUE_CHKR.LOG-
	/NOPRINT-
	/PRIORITY=17-
	/NOPRINT -
	 MA_Q$PROD:RUN_QUEUE_CHKR
$!
$! Submit the router process to our batch queue 
$!
$ PURGE MA_ROUTER.LOG/KEEP=2
$
$ SUBMIT/QUEUE=MA$Q-
	/PRIORITY=4-
	/LOG=MA_Q$PROD:MA_ROUTER.LOG-
	/AFTER="+0:0:20"-
	/NOPRINT -
	MA_Q$PROD:RTR
$!
$! Tell everyone that all is ok
$!
$! REPLY/ENABLE
$! REPLY/ALL/BELL " MA ROUTER FUNCTIONS ARE ENABLED "
