	FUNCTION ATTACH_SECTION(SECTION_NAME, VIRT_ADDR)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&ATTACH_SECTION\&
C .nf
C .x ATTACH_SECTION>Defined
C Source:ATTACH_SECTION1.MOD
C TO BECOME PART OF LIBRARY:PRODUCTION
C Designer           :EARL LAKIA
C Author             :
C Date of last update:10-OCT-1985 12:14:50.68
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    SECTION_NAME               CHARACTER*(*)
C                               THIS IS THE NAME OF THE GLOBAL SECTION THAT       
C                               THE USER WISHES TO ATTACH TO.                     
C  
C Returns:
C  
C    VIRT_ADDR(2)               INTEGER*4                                         
C                               THIS ARRAY CONTAINS THE STARTING VIRTUAL          
C                               ADDRESS FOR THE GLOBAL SECTION AND THE            
C                               LENGTH IN THE SECOND LONG WORD.                   
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C
C .X CHAR_TRNC>Referenced	
C    CHAR_TRNC			OBTAIN THE LENGTH OF CHARACTER DESCRIPTOR 
C    			        OF THE SECTION NAME STRING FOR USE BEFORE SYSTEM
C				SERVICE CALL.
C
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine allows the calling program to attach and
C map to the desired global section.  The calling sequence is:
C  
C .nofill
C  
C       INTEGER*4 SYS_STATUS
C       INTEGER*4 ATTACH_SECTION
C       CHARACTER*15 SECT_NAME/'GBL_SECTION'/
C       INTEGER*4 VIRT_ARRAY(2)
C  
C       SYS_STATUS=ATTACH_SECTION(SECT_NAME,VIRT_ARRAY)
C  
C       IF(.NOT. SYS_STATUS)THEN
C             POSSIBLE ERRORS ARE: SECTION NOT PRESENT,
C             INSUFFICIENT VIRTUAL ADDRESS SPACE, ETC..
C       ENDIF
C .FILL
C 	The user should consult the system service
C manual for the "$MGBLSC" for any errors and the
C source code of this module.  
C 
C end.doc ****************************** end.doc  


	IMPLICIT NONE

	INCLUDE 'SYS$LIBRARY:FORSYSDEF ($SSDEF)'   ! DEFINES RETURN STATUS
	INTEGER*4	SYS$MGBLSC		! OBTAIN MAPPED GLOBAL SECTION
	INCLUDE '($SECDEF)'			! SECTION DEFINITIONS

	CHARACTER*(*)	SECTION_NAME		! GLOBAL SECTION NAME
		
	INTEGER*4	VIRT_ADDR(2)		! VIRTUAL ADDRESS TO BE 
						! PASSED BACK
	INTEGER*4	GLB_VRT_ADDR(2)		! VIRTUAL ADDRESS OF THE
						! GLOBAL SECTION NAME
	INTEGER*4	MAPPED_ADDR(2)		! ADDRESS MAPPED BY SYS$MGBLSC
	INTEGER*4	SYS_STATUS		! SYSTEM SERVICE RETURN STATUS

	INTEGER*4	SECTION_FLAGS		! FLAG MASK SPECIFYING THE TYPE
						! OF SECTION TO BE MAPPED
	INTEGER*4	ATTACH_SECTION		! FUNCTION RETURN
	
	INTEGER*2	LENGTH			! LENGTH OF SECTION NAME STRING


	! OBTAIN THE ACTUAL LENGTH OF THE STRING DESCRIPTOR WITHOUT TRAILING
	! SPACES.  STRING IS RID OF TRAILING SPACES.
	LENGTH = LEN(SECTION_NAME)
	CALL CHAR_TRNC(SECTION_NAME, SECTION_NAME, LENGTH, LENGTH)

C   SYSTEM MAPS THE SECTION GLOBALLY WITH A READ/WRITE SECTION.  ALSO,
C   THE GLOBAL SECTION IS MAPPED INTO THE FIRST AVAILABLE SPACE.	

	SECTION_FLAGS = SEC$M_WRT		! PAGES ARE READ/WRITE
	1		.OR. SEC$M_EXPREG	! MAP IN FIRST AVAILABLE SPACE

	SYS_STATUS = SYS$MGBLSC(
	1	   GLB_VRT_ADDR,	      	! STARTING VIRTUAL ADDRESS
	1	   MAPPED_ADDR,			! ACTUAL ADDRESS MAPPED BY SYSTEM
	1	   ,
	1	   %VAL(SECTION_FLAGS),		! SECTION FLAGS OPTIONS
	1	   SECTION_NAME,		! USER DEFINED SECTION NAME
	1          , )
	
D	TYPE *, 'MAPPED ADDRESS AFTER SYS$MGBLSC CALL:  ', MAPPED_ADDR

	VIRT_ADDR(1) = MAPPED_ADDR(1)		! ACTUAL MAPPED STARTING ADDRESS
	VIRT_ADDR(2) = MAPPED_ADDR(2)		! ACTUAL MAPPED ENDING ADDRESS

D	TYPE *, 'SYS_STATUS = ', SYS_STATUS

	ATTACH_SECTION = SYS_STATUS

	RETURN
	END

