	SUBROUTINE CHAR_TRNC(STRING,DSTRING,ISIZE)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&CHAR_TRNC\&
C .nf
C .x CHAR_TRNC>Defined
C Source:CHAR_TRNC.FOR
C TO BECOME PART OF LIBRARY:USER
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C Date of last update:12-JUN-1985
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    STRING                     CHARACTER*(*)                           
C                               THIS IS THE STRING WHICH IS TO BE TRUNCATED FROM  
C                               IT DEFAULT VALUE.                                 
C  
C    STRING                     CHARACTER *(*)                                    
C                               THIS PARAMETER IS REPEATED A SECOND TIME SUCH     
C                               THAT IT MAY BE REFERENCED DIFFERENTLY BY THE      
C                               SUBROUTINE.  
C
C    LENGTH                     INTEGE*2
C                               ON INPUT THIS SHOULD BE SET TO THE LARGEST
C                               DEFAULT SIZE FOR THE CHARACTER STRING.
C  
C Returns:
C  
C    LENGTH                     INTEGER*2                                         
C                               THIS IS THE FINIAL SIZE OF THE CHARACTER STRING   
C                               AFTER TRUNCATION.                                 
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
c
C Description:
C .sk    
C 	This subroutine is passed a character string and it will
C scan backward from the length parameter until it finds a none
C blank field.  The resulting length then is placed in the
C character descriptor for the character string.  The use of
C the string parameter twice is needed such that the
C character string descriptor can be reached.
C .TP 10
C .NOFILL
C  
C  EXAMPLE:
C          CHARACTER*80 NAME
C          NAME='EARL LAKIA'
C          ISIZE=80
C     C
C 	 TYPE *,NAME  ! THIS WILL PRINT:
C     C			 "EARL LAKIA FOLLOWED BY 70 SPACES"
C          CALL CHAR_TRN(NAME,NAME,ISIZE)
C          TYPE *,NAME  ! THIS WILL PRINT ONLY:  "EARL LAKIA"
C 
C .FILL
C end.doc ****************************** end.doc  

C
C VARIABLE DEFINITION
C
	IMPLICIT NONE
	CHARACTER *(*)STRING	! STRING TO BE TRUNCATED
	INTEGER*2 ISIZE		! SIZE BEFORE TRUNC, RETURN AFTER
	INTEGER*2 ILOOP,ICNT
	INTEGER*2 DSTRING(4)	! STRING DESCRIPTOR
C
C TRY TO FIND A NON BLANK STARTING FROM THE END
C
	IF(ISIZE.LE.0)RETURN	! SOMETHING NOT KOSHER
	DSTRING(1)=ISIZE	! RESET SO CAN TEST NEW SIZE
	ICNT=ISIZE
C
	ISIZE=0		! ASSUME ALL BLANK, IE: NULL STRING
	DO 100 ILOOP=ICNT,0,-1
		IF(STRING(ILOOP:ILOOP).EQ.' '
	1	.OR.STRING(ILOOP:ILOOP).EQ.CHAR(0))GO TO 100
		ISIZE=ILOOP
		GO TO 200	! END OF STRING
100	CONTINUE
200	CONTINUE
	DSTRING(1)=ISIZE
	RETURN
	END
