C	INTEGER*4 FUNCTION DEF_VAX_DATE(DATE,HOUR,MINUTES)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&DEF_VAX_DATE\&
C .nf
C .x DEF_VAX_DATE>Defined
C Source:DEF_VAX_DATE.MOD
C TO BECOME PART OF LIBRARY:PRODUCTION
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C Date of last update:21-DEC-1985 11:03:16.30
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    HOUR                       INTEGER*4                                         
C                               CURRENT TIME (HOURS)                              
C  
C    MINUTES                    INTEGER*4                                         
C                               CURRENT TIME MINUTES                              
C  
C Returns:
C  
C    DATE                       CHARACTER*11
C                               DEFAULT DATE OF THE FORM: DD-MMM-YYYY             
C  
C    DEF_VAX_DATE               INTEGER*4                                         
C                               SYMBOLIC ERROR CODE DENOTEING SUCCESS OR FAILURE  
C                               IN DETERMINING A DEFAULT DATE. THIS SUBROUTINE    
C                               SHOULD BE ABLE TO RETURN A DEFAULT DATE UNLESS    
C                               THE INPUT PARAMETERS ARE INVALID.                 RETURN
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C .TP 20
C Description:
C .sk    
C 	This subroutine is used to get a date stamp when only
C a time stamp is available.  The following algothrim is used:
C .nofill
C  
C GET CURRENT TIME
C IF(CURRENT TIME >= HOUR) THEN
C   IF(TIME DIFFERENCE < 1.0 HOURS) THEN
C      USE CURRENT DATE
C   ELSE 
C      ADD ONE DAY TO CURRENT DATE
C   ENDIF
C ELSE
C   IF(TIME DIFFERENCE < 1.0 HOURS )THEN
C     USE CURRENT DATE
C   ELSE
C     USE CURRENT DATE LESS ONE DAY
C   ENDIF
C ENDIF
C .FILL
C 	 The calling sequence is:
C .SK 
C .nofill
C     INTEGER*4 STATUS
C     INTEGER*4 DEF_VAX_DATE
C     INTEGER*4 MINUTES, HOUR
C     CHARACTER DATE*11
C C 
C     STATUS=DEF_VAX_DATE(DATE,HOUR,MINUTES)
C .FILL
C .SK 2
C end.doc ****************************** end.doc  

	IMPLICIT NONE
	INCLUDE '($SSDEF)'
	INTEGER*4 DAYS_PER_MONTH(12)	! NUMBER OF DAYS IN A MONTH
	INTEGER*4 LEAP_YEAR		! LEAP YEAR FLAG
	INTEGER DD			! CURRENT DAY, 
	INTEGER YY			! CURRENT YEAR(LAST TWO DIGITS), 
	INTEGER MM			! CURRENT MONTH
	INTEGER CUR_MM			! CURRENT MINUTE
	INTEGER CUR_HH			! CURRETN HOUR
	INTEGER CUR_TIME		! REAL SECONDS SINCE MIDNIGHT
	CHARACTER*3 ASC_MON(12)		! MONTHS IN ASCII
	CHARACTER*2 CENTURY		! CENTURY (19, OR 20) OPTMISTIC HUH?
	INTEGER*4 HOUR			! PASSED HOUR
	INTEGER*4 MINUTES		! PASSED MINUTES
	CHARACTER*11 DATE		! RETURNED DATE
	REAL TIME			! CALCULATE TIME IN SECONDS
	INTEGER*4 DEF_VAX_DATE		! ONLY UNTIL MAKE THIS A FUNCTION
C
C
	DATA DAYS_PER_MONTH/
	1	31,28,31,30,31,30,31,31,30,31,30,31/
C
	DATA ASC_MON/'Jan','Feb','Mar','Apr','May',
	1	'Jun','Jul','Aug','Sep','Oct',
	1	'Nov','Dec'/

	TYPE *,' ENTER HOURS, MINUTES'
	ACCEPT *,HOUR,MINUTES
C
C VERIFY THE CALLING ARGUMENTS
C
	IF(HOUR .LT. 0 .OR. HOUR .GT. 23
	1   .OR. MINUTES .LT. 0 .OR.
	1   MINUTES .GT. 59) THEN
C		DEF_VAX_DATE=SS$_BADARG
		STOP
C		RETURN
	ENDIF
C
C GET THE CURRENT DATE
C
	CALL IDATE(MM,DD,YY)
	TYPE *,' CURRENT MONTH/DAY/YEAR: ',MM,'/',DD,'/',YY
	TYPE *,' PASSED TIME: ',HOUR,':',MINUTES
	IF(YY .LT. 85) THEN 	! MOST CASES DAYS WILL BE THE SAME
		CENTURY='20'	! CALCULATE THIS NOW.
	ELSE
		CENTURY='19'
	ENDIF
C
C GET THE CURRENT TIME
C
	CUR_TIME=SECNDS(0.0)
	CUR_HH= CUR_TIME/3600.0		! 60 MINUTES/HOUR * 60 SECONDS/MINUTE
	CUR_MM= (CUR_TIME-(CUR_HH*3600.0))/60.0		! 60 SECOND/MINUTE
	TYPE *,' CURRENT TIME HH:MM ',CUR_HH,':',CUR_MM
	TIME=(HOUR*3600.0)+(MINUTES*60.0)	! PASSED TIME IN SECONDS
C
	LEAP_YEAR= .NOT. (YY .AND. "3 ) ! IS THIS A LEAP YEAR?


C
C NOW TRY TO FORM DEFAULT DATE
C
	IF(CUR_TIME .GE. TIME)THEN
	  IF(ABS(CUR_TIME -TIME ) .LT. 3600.0)THEN	! LESS THAN 1 HOUR ?
C		DATE= CURRENT DATE
		DEF_VAX_DATE=SS$_NORMAL
		TYPE *,' DD, ASC_MON(MM), CENTURY, YY: ',
	1		DD, ASC_MON(MM),CENTURY,YY
		WRITE(DATE,FMT='(I2.2,1H-,A3,1H-,A2,I2.2)')DD,
	1		ASC_MON(MM),CENTURY,YY
		TYPE *,' USEING CURRENT DATE: ',DATE
C		RETURN
		STOP
	  ELSE
C		DATE= DATE PLUS 1 DAY
		DD=DD+1	! ADD ONE TO THE DAY
		IF(MM .EQ. 12. AND. DD. EQ. 31) THEN	! NEW YEAR CUSP
			MM=1
			YY=YY+1
			DD=1
		ELSE IF(DD .GT. DAYS_PER_MONTH(MM))THEN	! MONTH CUSP
			IF(LEAP_YEAR .NE. 0 .AND. 
	1		  MM .EQ. 2 .AND.
	1		  DD .EQ. 29) THEN  ! LEAP YEAR?
			  DD=29		! YES, ADD DAY TO FEBRUARY
			ELSE
			  DD=1		! OTHERWISE A NEW MONTH
			  MM=MM+1
		 	ENDIF
		ENDIF
		IF(YY .GT. 99)YY=0	! CENTURY CUSP?
		IF(YY .LT. 85)THEN
			CENTURY='20'
		ELSE
			CENTURY='19'
		ENDIF
		TYPE *,' DD, ASC_MON(MM), CENTURY, YY: ',
	1		DD, ASC_MON(MM),CENTURY,YY
		WRITE(DATE,FMT='(I2.2,1H-,A3,1H-,A2,I2.2)')DD,
	1		ASC_MON(MM),CENTURY,YY
	 	TYPE *,' DATE IS TOMORROW: ',DATE
		DEF_VAX_DATE=SS$_NORMAL
C		RETURN
		STOP
	  ENDIF

C
	ELSE
	  IF(ABS(CUR_TIME-TIME) .LT. 3600.0)THEN	! LESS THAN 1 HOUR?
C	  	DATE= CURRENT DATE
		TYPE *,' DD, ASC_MON(MM), CENTURY, YY: ',
	1		DD, ASC_MON(MM),CENTURY,YY
		WRITE(DATE,FMT='(I2.2,1H-,A3,1H-,A2,I2.2)')DD,
	1		CENTURY,ASC_MON(MM),YY
		TYPE *, 'USEING CURRENT DATE: ',DATE
		DEF_VAX_DATE=SS$_NORMAL
		STOP
C		RETURN

C
	   ELSE
C		DATE= DATE-1
		DD=DD-1		! SUBSTRACT OFF A DAY
C
		IF(DD .EQ . 0)THEN	! MONTH CUSP?
		  MM=MM-1		! BACK UP TO PREVIOUS MONTH
		  IF(MM .EQ. 0)THEN	! YEAR CUSP?
			DD=31
			MM=12
			YY=YY-1
			IF(YY .LT. 0)YY=99	! CENTURY CUSP?
		   ELSE
		        IF(MM .EQ. 2 .AND. LEAP_YEAR .NE. 0)THEN
				DD=29		! LEAP YEAR?
			ELSE
				DD=DAYS_PER_MONTH(MM)	! LAST DAY OF MONTH
			ENDIF
		   ENDIF
		ENDIF
		IF(YY .LT. 85)THEN
			CENTURY='20'
		ELSE
			CENTURY='19'
		ENDIF
		TYPE *,' DD, ASC_MON(MM), CENTURY, YY: ',
	1		DD, ASC_MON(MM),CENTURY,YY
		WRITE(DATE,FMT='(I2.2,1H-,A3,1H-,A2,I2.2)')DD,
	1		ASC_MON(MM),CENTURY,YY
		TYPE *,' DATE IS YESTERDAY',DATE
		DEF_VAX_DATE=SS$_NORMAL
C		RETURN
		STOP
	   ENDIF
	ENDIF
	END
