	LOGICAL*4 FUNCTION IFSET(BITARY,IBIT)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&IFSET\&
C .nf
C .x IFSET>Defined
C Source:IFSET.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 6-NOV-1986 12:27:18.69
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C 
C BITARY                        BYTE
C                               Array of bits
c 
c IBIT                          INTEGER*4
C                               Desired bit to set within array.
C  
C Returns:
C 
C IFSET                         LOGICAL*4
C                               .TRUE.  IF BIT WAS SET
C                               .FALSE. IF NOT SET
C 
C .SK
C .fill
C .SK
C Description:
C .sk    
C
C 	This subroutine is used to status a single bit within
c a BITARRAY.  The value of the bit is returned as a logical
c true or false.
C 
C      BITARY= BYTE BIT ARRAY
C        IBIT= BIT TO TEST (0 is first bit)
C 
C      CALLING SEQUENCE:
C 
C 	LOGICAL*4 IFSET
C 
C 	IF(IFSET(BITARY,IBIT))THEN
C 		TYPE *,' BIT WAS SET'
C 	ELSE
C 		TYPE *,' BIT WAS NOT  SET'
C 	ENDIF
C 
C .ELT
C end.doc ****************************** end.doc  

	BYTE BYTMSK(0:7)	! SINGLE BYTE MASK
	BYTE BITARY(0:*)	! BIT ARRAY FROM USER
	INTEGER*4 IBIT	! BIT TO TEST
	INTEGER*4 IR	! REMAINDER BIT
	INTEGER*4 IB	! BYTE BIT IS IN
C
	DATA BYTMSK/'1'X,'2'X,'4'X,'8'X,'10'X,'20'X,'40'X,'80'X/
c	
	IB=IBIT/8		! GET BYTE THAT CONTAINS BIT
	IR= IBIT- (IB*8)	! GET BIT WITHIN BYTE
C
	IF((BITARY(IB) .AND. BYTMSK(IR)) .NE. 0)THEN
		IFSET=.TRUE.	! BIT WAS SET
	ELSE
		IFSET=.FALSE.	! BIT WASN'T SET
	ENDIF
	RETURN
	END
