
	INTEGER*4 FUNCTION NON_BLANK_LEN(STRING,ISTRING)
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&NON_BLANK_LEN\&
C .nf
C .x NON_BLANK_LEN>Defined
C Source:NON_BLANK_LEN.MOD
C TO BECOME PART OF LIBRARY:INLAND
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C 	      Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 1-JUL-1986 09:10:24.88
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    STRING                     CHARACTER                                         
C                               STRING TO BE SCANNED FOR FIRST NON BLANK CHARACTER
C  
C Returns:
C  
C    NON_BLANK_LEN              INTEGER*4                                         
C                               RETURN THE LENGTH OF THE STRING                   
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is used to find the first non blank or null 
C character position from the end of the string.  If the string
C contained the following: "ABCDEFG            ", then the
C subroutine would return 7.
C 	CALLING SEQUENCE:
C .NOFILL
C .SK
C      INTEGER*4 NON_BLANK_LEN
C      INTEGER*4 LENGTH
C      CHARACTER*20 STRING
C      DATA STRING/'ABCDEFGH                  '/
C C
C      LENGTH=NON_BLANK_LEN(STRING,STRING)
C .FILL
C 	NOTE: The string argument is entered twice.
C end.doc ****************************** end.doc  

	INTEGER*4 ISTRING(2)	! STRING DESCRIPTOR
	CHARACTER STRING(*)	! STRING TO SCAN
	INTEGER*4 I
	INTEGER*2 STR_SIZ
C
	STR_SIZ= ISTRING(1) .AND. "377
D	TYPE *,' STRING LENGTH: ',STR_SIZ
D	TYPE *,' STRING: ',(STRING(I),I=1,STR_SIZ)
C
	DO 100 I = STR_SIZ,1,-1	! LOOP FOR NUMBER OF CHARACTERS
	  IF(STRING(I) .NE. ' ' .AND.
	1	STRING(I) .NE. CHAR(0))THEN
		NON_BLANK_LEN=I
		RETURN
	  ENDIF
100	CONTINUE
	NON_BLANK_LEN=0
	RETURN
	END
