	integer*4 function set_def_prot(owner,group,world)

C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&SET_DEF_PROT\&
C .c ;^&RES_DEF_PROT\&
C .nf
C .x SET_DEF_PROT>Defined
C .X RES_DEF_PROT>Defined
C Source:SET_DEF_PROT.MOD
C TO BECOME PART OF LIBRARY:PRODUCTION
C Designer           :EARL LAKIA
C Author             :Earl Lakia
C Date of last update: 3-DEC-1985 12:13:38.38
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C    OWNER                      CHARACTER*4                                       
C                               CHARACTER STRING FROM 1 TO 4 CHARACTERS           
C                               DENOTEING DESIRED DEFAULT PROTECTION, IE:         
C                               (R= READ, W= WRITE, E= EXECUTABLE, D= DELETE)     
C  
C 
C    GROUP                      CHARACTER*4                                       
C                               DESITED GROUP PROTECTION                          
C  
C    WORLD                      CHARACTER*4                                       
C                               DESIRED WORLD PROTECTION                          
C Returns:
C  
C    SET_DEF_PROT               INTEGER*4                                         
C                               FUNCTION RETURN FROM THE STATUS OF THE            
C                               RMS SET DEFAULT PROTECTION CALL.                  
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X NULL_TEST>Referenced
C    NULL_TEST                  DETERMINES IF A PARAMETER IS PRESENT OR NOT.      
C                                (found in library:PRODUCTION)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This function allows the caller to set the default file
C protection attributes for the running process prior to openning
C any files.  Most commonly, greater privelege such as allowing
C world read/write and delete priveleges might be given to
C files being created by the process.
C .nofill
C  
C CALLING SEQUENCE:
C  
C   SYS_STATUS=SET_DEF_PROT('RWE','RWE','RWED')
C  
C .FILL
C 	The subroutine res_def_prot is used to restore the
C protection to that prior to this call.
C .nofill
C  
C CALLING SEQUENCE:
C  
C   CALL RES_DEF_PROT
C
C end.doc ****************************** end.doc  


c
c local variables
c
	implicit none

	integer*4 mth$jishft		! function - shift bits
	integer*4 sys$setdfprot		! set protection
	integer*4 sys_status		! system service return status
	integer*4 res_def_prot		! function - restore old protection
	include '($ssdef)'
	include	'($rmsdef)'

	include '($xabprodef)/list'

	include '($xabdef)/list'

	integer*2  new_prot	! new protection
	integer*2  old_prot	! old protection
	integer*4  i		! do loop parameter
	logical*4  null_test	! determines if parameter was null or not
	integer*4  offset
	integer    own		! 4 bits for owner protection
	integer    grp		! 4 bits for group protection
	integer    wld		! 4 bits for world protection

	character    owner	! user passed owner string ('rwed')
	character    group	! user passed group string ('rwed')
	character    world	! user passed world string ('rwed')

c
c get old protection and store in old_prot
c
	set_def_prot = sys$setdfprot(%val(0),old_prot)
	if (.not. set_def_prot) return 	! able to get old protection?
D	write(*, 5) old_prot
D5	format(' first sys$setdfprot call is ', z4.4)

c
c parse each owner, group, and world
c
	new_prot = old_prot			! start with old = new protection
	own = .not. mth$jishft("17,1)		! assume all access
	grp = .not. mth$jishft("17,2)	
	wld = .not. mth$jishft("17,3)	

	if (owner(1:1) .ne. ' ') then		! owner specified?
	   do i = 1, len(owner)
c	        
	     if (owner(i:i) .eq. 'R' .OR.
	1		OWNER(i:i) .eq. 'r') then
		  own = own .or. xab$m_noread
	     else if (owner(i:i) .eq. 'W' .or.
	1		owner(i:i) .eq. 'w') then
		  own = own .or.xab$m_nowrite
	     else if (owner(i:i) .eq. 'E' .or.
	1		owner(i:i) .eq. 'e') then
		  own = own .or.xab$m_noexe
	     else if (owner(i:i) .eq. 'D' .or.
	1		owner(i:i) .eq. 'd') then
		  own = own .or.xab$m_nodel
	     end if
	   enddo
c
c
	else if (group(1:1) .ne. ' ') then	! group specified
	   do i = 1, len(group)
c
	     if (group(i:i) .eq. 'R' .or.
	1	  group(i:i) .eq. 'r') then 
		  grp = grp .or. xab$m_noread
	     else if (group(i:i) .eq. 'W' .or.
	1	   group(i:i) .eq. 'w') then
		  grp = grp .or. xab$m_nowrite
	     else if (group(i:i) .eq. 'E' .or.
	1	    group(i:i) .eq. 'e') then
		  grp = grp .or. xab$m_noexe
	     else if (group(i:i) .eq. 'D' .or.
	1	    group(i:i) .eq. 'd') then
		  grp = grp .or. xab$m_nodel
	     end if
	   enddo
c
c
	else if (world(1:1) .ne. ' ') then	! world specified
	   do i = 1, len(world)
c
	     if (world(i:i) .eq. 'R' .or.
	1	 world(i:i) .eq. 'r') then 
		  wld = wld .or. xab$m_noread
	     else if (world(i:i) .eq. 'W' .or.
	1	 world(i:i) .eq. 'w')  then
		  wld = wld .or. xab$m_nowrite
	     else if (world(i:i) .eq. 'E' .or.
	1	 world(i:i) .eq. 'e') then
		  wld = wld .or. xab$m_noexe
	     else if (world(i:i) .eq. 'D' .or.
	1	 world(i:i) .eq. 'd') then
		  wld = wld .or. xab$m_nodel
	     end if
	   enddo
	endif

c
c set the new desired protection for the process
c note:  the variables grp,wld, own are the "not" of
c the desired protection.
c
	new_prot = new_prot .and. (
	1  (.not. (wld * xab$v_wld * 2)) .or.
	1  (.not. (grp * xab$v_grp * 2)) .or.
	1  (.not. (own * xab$v_own * 2)) )
d	write(*, 100) new_prot
d100	format(' new protection status: ',z4.4)
c
	set_def_prot = sys$setdfprot (new_prot,%val(0)) ! set desired protection
	return

	entry res_def_prot(sys_status)
c
c set new protection back to what it was suppose to be
c
	sys_status =  sys$setdfprot(old_prot,%val(0))	! set it back
	return
	end
