	program slides
C
C	PROGRAM TO GENERATE SLIDES ON A VT100
C	MODELED AFTER A PROGRAM THAT WAS SEEN ON A COMPUTER AT DECUS
C
C	WRITTEN BY ART MCCLINTON 
C		MITRE CORPORATION
C		1820 DOLLEY MADISON BLVD
C		MCLEAN VA 22102
C		(703) 827-6356
C
C	Commands for SLIDE generation program:
C
C   (all commands preceded by command character (.); multiple commands may
C    appear on one line by appending them, ie:  .c.r.d)
C
C	A 		Process the file again forever
C	B		Turn on BOLD
C	C 		Clear screen
C	F		Turn on Blink(flash)
C	H 		Double size line
C	L 		Standard size line
C	N 		Normal video screen
C 	P 		Clear screen (page) set center mode
C	R 		Reverse video screen
C	S 		Synch for photograph (Wait until user types a terminator)
C	U		Turn on Underscore
C	V		TiTle Underline (Insert a line of all underscores)
C	W 		Double wide line (default)
C	X 		Do not center following lines
C	Y 		Center following lines
C	$ 		Write sequence of escape sequences (.$[7m$[0m for example)
C	    			Whole line is escape sequences with $ replacing esc
C
C	;	 can be used to insert comment lines.
C	
C
C	FUTURE PLANS FOR THIS PROGRAM
c	add constant offset to center text 
c	add macro capability to make easier to use
c	modifiy print program to automatically print double column
c	Watch your future DECUS Sigtapes
c
	LOGICAL CENTER,REVERSE
	Character*20 filename
	character*8 lastlinedate
	BYTE LINE(80),LINE_SIZE,esc,BLANK
	data esc/"033/,BLANK/1H /
	num_screen=0
	write(6,91)
91	format('+Enter Filename:')
	read(5,92) filename
92	format(A20)
	write (6,93)
93	format('+Enter Date for Last Line')
	Read (6,94) lastlinedate
94	format(a8)
	OPEN (UNIT=1,NAME=filename,STATUS='OLD')
100	READ(1,101,END=999) LEN,(LINE(I),I=1,LEN)
	IF(LEN.LE.0) THEN
	  LEN=1
	  LINE(1)=BLANK
	ENDIF
101	FORMAT(Q,80A1)
110	if(LINE(1).EQ.';') GO TO 100
	IF(LINE(1).NE.'.') GO TO 500
	IF(LINE(2).NE.'C'.AND.LINE(2).NE.'c') GO TO 130		!CLEAR SCREEN
112		WRITE (6,111) esc,esc
111		FORMAT('+',$,a1,'[0;0H',a1,'[2J')
115		DO 120 I=3,LEN
120		LINE(I-2)=LINE(I)
		LEN=LEN-2
		IF (LEN.LE.0) GO TO 100
		GO TO 110
130	IF(LINE(2).NE.'A'.AND.LINE(2).NE.'a') GO TO 140		!REPROCESS FILE
		REWIND 1
		GO TO 100
140	IF(LINE(2).NE.'X'.AND.LINE(2).NE.'x') GO TO 150
		CENTER=.FALSE.				!DO NOT CENTER LINES
		GO TO 115
150	IF(LINE(2).NE.'Y'.AND.LINE(2).NE.'y') GO TO 160
		CENTER=.TRUE.				!CENTER
		GO TO 115
160	IF(LINE(2).NE.'P'.AND.LINE(2).NE.'p') GO TO 170
		CENTER=.TRUE.
		GO TO 112				!NOW CLEAR SCREEN
170	IF(LINE(2).NE.'H'.AND.LINE(2).NE.'h') GO TO 180
		LINE_SIZE=3
		GO TO 115
180	IF(LINE(2).NE.'W'.AND.LINE(2).NE.'w') GO TO 190
		LINE_SIZE=6
		GO TO 115
190	IF(LINE(2).NE.'L'.AND.LINE(2).NE.'l') GO TO 200
		LINE_SIZE=5
		GO TO 115
200	IF(LINE(2).NE.'S'.AND.LINE(2).NE.'s') GO TO 210
	WRITE(6,201) ESC	!MOVE CURSOR TO HOME POSITION
201		FORMAT('+',$,a1,'[24;1H')
	if(num_screen.gt.0) WRITE (6,202) esc,num_screen,lastlinedate
202	format('+',$,a1,'#6',I3,14x,'MITRE',9x,a8)
	WRITE(6,203) ESC
203	format('+',$,a1,'[1;1H')
	num_screen=num_screen+1
205		READ(5,101,end=999) I
		GO TO 115
210	IF(LINE(2).NE.'$') GO TO 220
		DO 211 I=2,LEN
211		IF(LINE(I).EQ.'$') LINE(I)=ESC
		WRITE (6,212) (LINE(I),I=2,LEN)
212		FORMAT('+',$,80A1)
		GO TO 100
220	IF(LINE(2).NE.'R'.AND.LINE(2).NE.'r') go to 230
		WRITE (6,221) ESC
221		FORMAT('+',A1,'[7m',$)
		REVERSE=.TRUE.
		go to 115
230	IF(LINE(2).NE.'N'.AND.LINE(2).NE.'n') go to 240
		WRITE(6,231) ESC
231	FORMAT('+',A1,'[0m',$)
		REVERSE=.FALSE.
		go to 115
240	IF(LINE(2).NE.'B'.AND.LINE(2).NE.'b') GO TO 250
		WRITE(6,241) ESC
241		FORMAT('+',A1,'[1m',$)
		go to 115
250	IF(LINE(2).NE.'U'.AND.LINE(2).NE.'u') go to 260
		write (6,251) ESC
251		format('+',a1,'[4m',$)
		go to 115
260	IF(LINE(2).NE.'F'.AND.LINE(2).NE.'f') GO TO 270
		WRITE (6,261) ESC
261		FORMAT('+',A1,'[5m',$)
		go to 115
270	IF(LINE(2).NE.'V'.AND.LINE(2).NE.'v') GO TO 280
	WRITE(6,271) esc,esc,esc
271	format(' ',a1,'[4m',$,a1,'#4',40(' '),a1,'[0m')
	go to 115
280	WRITE(6,281) LINE(2)
281	FORMAT(' COMMAND NOT IMPLEMENTED IN THIS VERSION - ',A1)
		GO TO 205
500	NULL_FINISH=0
	NULL=0
	MAX_LEN=40
	IF(LINE_SIZE.EQ.5) MAX_LEN=80
	IF(CENTER) NULL=(MAX_LEN- Min(MAX_LEN,LEN) )/2
	len = min(len, max(1,max_len-null) )
	IF(REVERSE)null_finish=max_len-null-len
	WRITE(6,501) esc,LINE_SIZE,(BLANK,I=1,NULL),(LINE(I),I=1,LEN),
	1  (BLANK,I=1,null_finish)
501	FORMAT(' ',$,a1,'#',I1,80A1)
	IF(LINE_SIZE.EQ.3) WRITE(6,501) esc,4,(BLANK,I=1,NULL),
	1  (LINE(I),I=1,LEN),(BLANK,I=1,null_finish)
	GO TO 100
999	write(6,9991) esc
9991	format('+',a1,'[2J',$)
	STOP 'END OF SLIDES'
	END
