$! HPFORMS.COM     
$! Define forms for use with the HP-2000 laser printer
$! (C) 1988 Medical College of Wisconsin.   Written 5/1/88 Kent C. Brodie
$!
$! Modules found in the /SETUP qualifiers should be in the device library
$! file:  SYS$LIBRARY:SYSDEVCTL.TLB
$!
$! Laser print queue should be set up with the qualifiers
$! /DEFAULT=(....,FORM=HPDEFAULT) /LENGTH=66
$!
$!============================================================================
$! DEFAULT form for the hp-2000 laser printer.   
$!
$ Define/form/width=80/margin=(bottom=0)/nowrap/notruncate/stock=default -
/setup=(RESET)/description="HP2000 default form" HPDEFAULT 90
$!
$!=============================================================================
$! PRESTIGE ELITE forms
$!
$ Define/form/width=96/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,LPI_6,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_PRESTIGE) -
/description="Simplex Portrait  12-pitch 10-point Prestige Elite" PRESTIGE1 1
$!
$ Define/form/width=126/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_LANDSCAPE,LPI_8,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_PRESTIGE) -
/description="Simplex Landscape 12-pitch 10-point Prestige Elite" PRESTIGE2 2
$!
$ Define/form/width=96/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_PORTRAIT,LPI_6,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_PRESTIGE) -
/description="Duplex  Portrait  12-pitch 10-point Prestige Elite" PRESTIGE3 3
$!
$ Define/form/width=126/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_LANDSCAPE,LPI_8,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_PRESTIGE) -
/description="Duplex  Landscape 12-pitch 10-point Prestige Elite" PRESTIGE4 4
$!
$!=============================================================================
$! COURIER forms
$ Define/form/width=96/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,LPI_6,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Simplex Portrait  12-pitch 10-point Courier" COURIER1 11
$!
$ Define/form/width=126/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_LANDSCAPE,LPI_8,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_PRESTIGE) -
/description="Simplex Landscape 12-pitch 10-point Courier" COURIER2 12
$!
$ Define/form/width=80/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,LPI_6,PITCH_10,POINT_12,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Simplex Portrait  10-pitch 12-point Courier" COURIER3 13
$!
$ Define/form/width=110/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_LANDSCAPE,LPI_8,PITCH_10,POINT_12,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Simplex Landscape 10-pitch 12-point Courier" COURIER4 14
$!
$ Define/form/width=80/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_PORTRAIT,LPI_6,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Duplex  Portrait  12-pitch 10-point Courier" COURIER5 15
$!
$ Define/form/width=110/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_LANDSCAPE,LPI_8,PITCH_12,POINT_10,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Duplex  Landscape 12-pitch 10-point Courier" COURIER6 16
$!
$ Define/form/width=80/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_PORTRAIT,LPI_6,PITCH_10,POINT_12,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Duplex  Portrait  10-pitch 12-point Courier" COURIER7 17
$!
$ Define/form/width=110/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_LANDSCAPE,LPI_8,PITCH_10,POINT_12,STY_UPRIGHT,STROKE_MED,TYP_COURIER) -
/description="Duplex  Landscape 10-pitch 12-point Courier" COURIER8 18
$!
$!===================================================================
$! IMAGE forms.  (those that are similar to what IMAGE PRINTING produces)
$! [these forms are overlayed with a "greenbar" effect with nice borders]
$!
$ Define/form/width=150/margin=(bottom=0,left=12,top=1)/length=60 -
 /stock=3HOLE/notruncate/nowrap/setup= -
 (RESET,SEPARATE,PAP_SIMPLEX,OFFSET_LEFT,ORI_LANDSCAPE,LPI_8,PITCH_15, - 
 POINT_8,STY_UPRIGHT,STROKE_MED,TYP_LINEPRINT, - 
 IMAGE1,IMAGE2,IMAGE3,IMAGE4) -
/description="Simplex Landscape Greenbar Lineprint" IMAGE1 71
$!
$ Define/form/width=150/margin=(bottom=0,left=12,top=1)/length=60 -
 /stock=3HOLE/notruncate/nowrap/setup= -
 (RESET,SEPARATE,PAP_DUPLEX,OFFSET_LEFT,ORI_LANDSCAPE,LPI_8,PITCH_15, - 
 POINT_8,STY_UPRIGHT,STROKE_MED,TYP_LINEPRINT, - 
 IMAGE1,IMAGE2,IMAGE3,IMAGE4,PAGE_SKIP) -
/description="Duplex  Landscape Greenbar Lineprint" IMAGE2 72
$!
$!===================================================================
$! Lineprinter type forms.  (like above but with no "greenbars")
$!
$ Define/form/width=150/margin=(bottom=0,left=12,top=1)/length=60 -
 /notruncate/nowrap/stock=default/setup= -
 (RESET,SEPARATE,PAP_SIMPLEX,OFFSET_LEFT,ORI_LANDSCAPE,LPI_8,PITCH_15, - 
 POINT_8,STY_UPRIGHT,STROKE_MED,TYP_LINEPRINT) -
 /description="Simplex Landscape Lineprint" LINEPRINT1 61
$!
$ Define/form/width=150/margin=(bottom=0,left=12,top=1)/length=60 -
 /notruncate/nowrap/stock=default/setup= -
 (RESET,SEPARATE,PAP_DUPLEX,OFFSET_LEFT,ORI_LANDSCAPE,LPI_8,PITCH_15, - 
 POINT_8,STY_UPRIGHT,STROKE_MED,TYP_LINEPRINT) -
/description="Duplex  Landscape Lineprint" LINEPRINT2 62
$!
$!===================================================================
$! HELVETICA BOLD forms
$!
$ Define/form/width=96/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,LPI_6,SPACE_PROP,POINT_14,STY_UPRIGHT, -
STROKE_BOLD,TYP_HELV) -
/description="Simplex Portrait  14-point Helvitica Bold" HELV1 21
$!
$ Define/form/width=96/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_PORTRAIT,LPI_6,SPACE_PROP,POINT_14,STY_UPRIGHT, -
STROKE_BOLD,TYP_HELV) -
/description="Duplex  Portrait  14-point Helvitica Bold" HELV2 22
$!
$ Define/form/width=126/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_LANDSCAPE,LPI_6,SPACE_PROP,POINT_14,STY_UPRIGHT, -
STROKE_BOLD,TYP_HELV) -
/description="Simplex Landscape 14-point Helvitica Bold" HELV3 23
$!
$ Define/form/width=126/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_DUPLEX,ORI_LANDSCAPE,LPI_6,SPACE_PROP,POINT_14,STY_UPRIGHT, -
STROKE_BOLD,TYP_HELV) -
/description="Duplex  Landscape 14-point Helvitica Bold" HELV4 24
$!
$!===================================================================
$! Letter GOTHIC forms
$!
$ Define/form/width=80/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,LPI_6,PITCH_10,POINT_14,STY_UPRIGHT, -
STROKE_MED,TYP_GOTHIC) -
/description="Simplex Portrait  10-pitch 14-point Gothic" GOTHIC1 41
$!
$ Define/form/width=128/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,LPI_8,PITCH_16,POINT_9,STY_UPRIGHT, -
STROKE_MED,TYP_GOTHIC) -
/description="Simplex Portrait  16-pitch  9-point Gothic" GOTHIC2 42
$!===================================================================
$! OCR-A forms
$!
$ Define/form/width=80/margin=(bottom=0)/stock=default/setup= -
(RESET,PAP_SIMPLEX,ORI_PORTRAIT,SYM_OCR_A,LPI_6,PITCH_10,POINT_12, -
STY_UPRIGHT,STROKE_MED,TYP_LINEPRINT) -
/description="Simplex Portrait  10-Pitch 12-point OCR A" OCR1 43
$!
