$! Map the terminal server port in LATCP so that it is available
$! to the system.   Note:  "PLUTO" is a DECserver node name.
$!
$SET NOON
$RUN SYS$SYSTEM:LATCP
CREATE PORT LTA700:
SET PORT LTA700: /NODE=PLUTO  /PORT=PORT_1
EXIT
$!
$! Now set up the print queues on each of the two systems, and then
$! create the generic queue SYS$LASER.
$!
$! Compute the name of the executing node
$!
$ NODE = F$GETSYI("NODENAME")
$!
$SET NOON
$ NODEa_START = "/NOSTART"
$ NODEb_START = "/NOSTART"
$!
$! Redefine one of the previous symbols.
$!
$ 'NODE'_START = "/START"
$!
$! Set up local characteristics for the applications devices.
$!
$! This procedure assumes that the remote devices have been mapped to the
$! same LTAx: device on each node that accesses them.
$!
$ SET TERMINAL/SPEED=19200/PERM/DEVICE=LN03/WIDTH=511
  /NOBROADCAST/LOWER/NOWRAP  LTA700:
$! (width=511 is used for PC applications.  We need the maximum allowed
$!  to accomodate massive escape sequences for graphics, etc.)
$!
$! Set the protection on the devices so that only the symbiont can access
$! them.
$ SET PROTECTION=(S:RWLP,O,G,W) /DEVICE LTA700:
$!
$! Set the device spooled.
$!
$ SET DEVICE LTA700: /SPOOLED=('NODE'$LASER1,SYS$SYSDEVICE)
$!
$!   Define forms for use with the HP laser printer
$!
$ @SYS$MANAGER:HPFORMS.COM
$!
$!               Set up the queue on node A
$!
$ INITIALIZE/QUEUE /PROCESSOR=LATSYM/SCHEDULE=NOSIZE -
  /DEFAULT=(FLAG,NOFEED,FORM=HPDEFAULT) /RECORD_BLOCKING /LIBRARY=SYSDEVCTL -
  /ON=NODEA::LTA700:/NOENABLE_GENERIC -
  'NODEa_START' NODEA$LASER1
$!
$!               Set up the queue on node B
$!
$ INITIALIZE/QUEUE /PROCESSOR=LATSYM/SCHEDULE=NOSIZE -
  /DEFAULT=(FLAG,NOFEED,FORM=HPDEFAULT) /RECORD_BLOCKING /LIBRARY=SYSDEVCTL -
  /ON=NODEB::LTA700:/NOENABLE_GENERIC -
  'NODEb_START' NODEB$LASER1
$!
$!
$!               Set up the generic Laser Printer Queue
$!
$ INITIALIZE/QUEUE /START /GENERIC=(NODEA$LASER1,NODEB$LASER1) -
  /SCHEDULE=NOSIZE SYS$LASER
$ EXIT
