/* Modification History
   --------------------
   Sep.  8, 1987 JEM - Conversion from BETA to Release
   Sep. 25, 1987 JEM - modify all FID declarations to be unsigned
   Oct.  3, 1988 JEM - fixed call to get_header, original fid wasn't being sent
*/
#include descrip
#include climsgdef

#include "fh2def.h"
#include "fi2def.h"
#include "fm2def.h"
#include "FileInfo.h"

#include "displaydef.h"
#include "cld.h"

char *cvt_time();
char *format_uic();
char *get_header();
unsigned int change();

init_display(disp)
  struct display_info *disp;
{
  disp->di_l_dsplybits0 = 0;
  disp->di_l_dsplybits1 = 0;
  if (cli_present("DISPLAY.ALL") & 1) {
    disp->di_l_dsplybits0 = -1;
    disp->di_l_dsplybits1 = -1;
  };

  disp->di_v_fullname = 1;

  disp->di_v_credat = change(disp->di_v_credat, t_display, t_credate);
  disp->di_v_revdat = change(disp->di_v_revdat, t_display, t_revdate);
  disp->di_v_expdat = change(disp->di_v_expdat, t_display, t_expdate);
  disp->di_v_bakdat = change(disp->di_v_bakdat, t_display, t_bakdate);
  disp->di_v_revision =  change(disp->di_v_revision, t_display, t_revisions);
  disp->di_v_extents = change(disp->di_v_extents, t_display, t_extents);
  disp->di_v_headers = change(disp->di_v_headers, t_display, t_header);
  disp->di_v_lbn = change(disp->di_v_lbn , t_display, t_lbn);
  disp->di_v_owner = change(disp->di_v_owner, t_display, t_owner);
  disp->di_v_char = change(disp->di_v_char, t_display, t_char);
  disp->di_v_journal = change(disp->di_v_journal, t_display, t_journal);
  disp->di_v_prot = change(disp->di_v_prot, t_display, t_prot);
  disp->di_v_fid = change(disp->di_v_fid, t_display, t_fid);
  disp->di_v_backlink = change(disp->di_v_backlink, t_display, t_backlink);
  disp->di_v_access = change(disp->di_v_access, t_display, t_access);
  disp->di_v_highwater = change(disp->di_v_highwater, t_display, t_highwater);
  disp->di_v_ru_active = change(disp->di_v_ru_active, t_display, t_ru_active);
  disp->di_v_rectype = change(disp->di_v_rectype, t_display, t_rtype);
  disp->di_v_fileorg = change(disp->di_v_fileorg, t_display, t_fileorg);
  disp->di_v_attrib = change(disp->di_v_attrib, t_display, t_attr);
  disp->di_v_rsize = change(disp->di_v_rsize, t_display, t_rsize);
  disp->di_v_alloc = change(disp->di_v_alloc, t_display, t_hiblk);
  disp->di_v_used = change(disp->di_v_used, t_display, t_efblk);
  disp->di_v_wasted = change(disp->di_v_wasted, t_display, t_wasted);
  disp->di_v_bktsize = change(disp->di_v_bktsize, t_display, t_bktsize);
  disp->di_v_vfcsize = change(disp->di_v_vfcsize, t_display, t_vfcsize);
  disp->di_v_maxrec = change(disp->di_v_maxrec, t_display, t_maxrec);
  disp->di_v_defext = change(disp->di_v_defext, t_display, t_defext);
  disp->di_v_gbc = change(disp->di_v_gbc, t_display, t_gbc);
  disp->di_v_version_limit = change(disp->di_v_version_limit,
                                    t_display, t_versions);
  disp->di_v_filename = change(disp->di_v_filename, t_display, t_filename);
  disp->di_v_fullname = change(disp->di_v_fullname, t_display, t_fullname);
  disp->di_v_acl = change(disp->di_v_acl, t_display, "ACL");
  return;
}

display_header(disp,fid,fh2,context,cached,chan)
  struct display_info *disp;
  unsigned short int fid,chan;
  struct fh2def *fh2;
  struct FileInfo *context;
  int cached;
{
  struct fh2def *exthdr;
  struct fi2def *fi2;
  struct fm2def *fm2,*fm2adr;
  long int fm2offset=0,lbn=0,count=0,totextents=0,tothdrs=0;
  static struct dsc$descriptor filename={0, DSC$K_DTYPE_T, DSC$K_CLASS_D, 0};
  $DESCRIPTOR(newline,"\n");
  unsigned short int nxtfid[3], orig_fid[3];
  long int used,alloc,wasted,blocknum,addr;
  long status;
  long int i,j;
  static char *blockaddr=0;
  static char *No = "No";

  static char ace_buff[512];
  static struct dsc$descriptor ace_txt =
    {0,DSC$K_DTYPE_T,DSC$K_CLASS_S,ace_buff};
  static struct dsc$descriptor ace_bin =
    {0,DSC$K_DTYPE_T,DSC$K_CLASS_S,0};
  struct binary_acl {
    unsigned char length;
    unsigned char type;
    unsigned short int flags;
  } *acaddr;

  /* if this is a completely unused header, don't bother displaying it */
  if ((fh2->fh2$w_fid[0] == 0)
      && (fh2->fh2$w_fid[1] == 0)
      && (fh2->fh2$b_idoffset == 0)
      && (fh2->fh2$b_mpoffset == 0)
      && (fh2->fh2$b_acoffset == 0)
      && (fh2->fh2$b_rsoffset == 0))
    return;

  /* compute where in the file header the file ident info is */
  fi2 = (long int)fh2 + fh2->fh2$b_idoffset * 2;

  printf("\n"); /* separate the buggers with a blank line */

  if (disp->di_v_fullname) {
    status = fid_to_name(&chan,(*fh2).fh2$w_fid,&filename);
    if ((status & 1) && fh2->fh2$w_fid[0])
      printf("%.*s\n",filename.dsc$w_length,filename.dsc$a_pointer);
    else {
      status = fid_to_name(&chan,(*fh2).fh2$w_backlink,&filename);
      for (i=0;(i < FI2$S_FILENAME) &&
                    ((*fi2).fi2$t_filename[i] != ' ');i++);
      j = 0;
      if ((fh2->fh2$b_mpoffset - fh2->fh2$b_idoffset) >= 60)
        for (j=0;(j < FI2$S_FILENAMEXT) &&
                      ((*fi2).fi2$t_filenamext[j] != ' ');j++);
      printf("[?]%.*s%.*s\n",i,(*fi2).fi2$t_filename,
                             j,(*fi2).fi2$t_filenamext);
      if (status & 1)
        printf("(in %.*s%)\n",filename.dsc$w_length,filename.dsc$a_pointer);
    };
  };

  if (disp->di_v_filename) {
    for (i=0;(i < FI2$S_FILENAME)
         && ((*fi2).fi2$t_filename[i] != ' ');i++);
    j = 0;
    if ((fh2->fh2$b_mpoffset - fh2->fh2$b_idoffset) >= 60)
      for (j=0;(j < FI2$S_FILENAMEXT)
           && ((*fi2).fi2$t_filenamext[j] != ' ');j++);

    printf("Filename = %.*s%.*s\n",
           i,(*fi2).fi2$t_filename, j,(*fi2).fi2$t_filenamext);
  };

  if (disp->di_v_prot)
    printf("protection = (S%s%s,O%s%s,G%s%s,W%s%s)\n",
      (fh2->fh2$v_fileprot_system != 15)?":":"",
      t_fileprot[fh2->fh2$v_fileprot_system],
      (fh2->fh2$v_fileprot_owner != 15)?":":"",
      t_fileprot[fh2->fh2$v_fileprot_owner],
      (fh2->fh2$v_fileprot_group != 15)?":":"",
      t_fileprot[fh2->fh2$v_fileprot_group],
      (fh2->fh2$v_fileprot_world != 15)?":":"",
      t_fileprot[fh2->fh2$v_fileprot_world]);

  if (disp->di_v_fid)
    printf("File ID = (%s%d,%d,%d)\n",
           (fh2->fh2$w_fid[0] == 0)?"*":"",
           (fh2->fh2$w_fid[0] == 0)?fid:fh2->fh2$w_fid[0],
           fh2->fh2$w_fid[1],
           fh2->fh2$w_fid[2]);

  if (disp->di_v_backlink)
    printf("Backlink File ID = (%d,%d,%d)\n",
           fh2->fh2$w_backlink[0],
           fh2->fh2$w_backlink[1],
           fh2->fh2$w_backlink[2]);

  if (disp->di_v_owner)
    printf("%s = [%o,%o] = [%s]\n",t_owner,
           fh2->fh2$w_uicgroup,fh2->fh2$w_uicmember,
           format_uic(fh2->fh2$l_fileowner));

  if (disp->di_v_credat)
    printf("%s = %s\n",t_credate,cvt_time(&(*fi2).fi2$q_credate));
  if (disp->di_v_revdat)
    printf("%s = %s\n",t_revdate,cvt_time(&(*fi2).fi2$q_revdate));
  if (disp->di_v_expdat)
    printf("%s = %s\n",t_expdate,cvt_time(&(*fi2).fi2$q_expdate));
  if (disp->di_v_bakdat)
    printf("%s = %s\n",t_bakdate,cvt_time(&(*fi2).fi2$q_bakdate));
  if (disp->di_v_revision)
    printf("%s = %d\n",t_revisions,(*fi2).fi2$w_revision);

  if (disp->di_v_fileorg)
    printf("%s = %s\n",t_fileorg,ta_fileorg[fh2->fat.fat$v_fileorg]);
  if (disp->di_v_rectype)
    printf("%s = %s\n",t_rtype,ta_rtype[fh2->fat.fat$v_rtype]);
  if (disp->di_v_attrib)
    printf("%s = (%s%s,%s%s,%s%s,%s%s)\n",
      t_attr,
      fh2->fat.fat$v_fortrancc?"":No,t_fortrancc,
      fh2->fat.fat$v_impliedcc?"":No,t_impliedcc,
      fh2->fat.fat$v_printcc?"":No,t_printcc,
      fh2->fat.fat$v_nospan?No:"",t_nospan);

  if (disp->di_v_char) {
    printf("%s = (%s%s,%s%s,%s%s,%s%s,\n",
      t_char,
      fh2->fh2$v_badacl?"":No,t_badacl,
      fh2->fh2$v_nobackup?No:"",t_nobackup,
      fh2->fh2$v_contigb?"":No,t_contigb,
      fh2->fh2$v_nocharge?No:"",t_nocharge);
    printf("    %s%s,%s%s,%s%s,%s%s,%s%s,\n",
      fh2->fh2$v_contig?"":No,t_contig,
      fh2->fh2$v_directory?"":No,t_directory,
      fh2->fh2$v_erase?"":No,t_erase,
      fh2->fh2$v_badblock?"":No,t_badblock,
      fh2->fh2$v_locked?"":No,t_locked);
    printf("    %s%s,%s%s,%s%s,%s%s,%s%s)\n",
      fh2->fh2$v_markdel?"":No,t_markdel,
      fh2->fh2$v_spool?"":No,t_spool,
      fh2->fh2$v_readcheck?"":No,t_readcheck,
      fh2->fh2$v_writeback?"":No,t_writeback,
      fh2->fh2$v_writcheck?"":No,t_writcheck);
  };

  if (disp->di_v_journal)
    printf("%s = (%s%s,%s%s,%s%s,%s%s,%s%s,%s%s,%s%s)\n",
      t_journal,
      fh2->fh2$v_journal_file?"":No,t_journal_file,
      fh2->fh2$v_aijnl?"":No,t_aijnl,
      fh2->fh2$v_atjnl?"":No,t_atjnl,
      fh2->fh2$v_bijnl?"":No,t_bijnl,
      fh2->fh2$v_rujnl?"":No,t_rujnl,
      fh2->fh2$v_never_ru?"":No,t_never_ru,
      fh2->fh2$v_only_ru?"":No,t_only_ru);

  if (disp->di_v_ru_active)
    printf("%s = %d\n",t_ru_active,fh2->fh2$b_ru_active);

  if (disp->di_v_rsize)
    printf("%s = %d\n",t_rsize,fh2->fat.fat$w_rsize);
  if (disp->di_v_vfcsize)
    printf("%s = %d\n",t_vfcsize,fh2->fat.fat$b_vfcsize);
  if (disp->di_v_maxrec)
    printf("%s = %d\n",t_maxrec,fh2->fat.fat$w_maxrec);

  used = (fh2->fat.fat$w_efblkh<<16)|fh2->fat.fat$w_efblkl;
  if (fh2->fat.fat$w_ffbyte == 0)
    --used;
  if (disp->di_v_used)
    printf("%s = %d (+%d)\n",t_efblk,used,fh2->fat.fat$w_ffbyte);

  alloc = (fh2->fat.fat$w_hiblkh<<16)|fh2->fat.fat$w_hiblkl;
  if (disp->di_v_alloc)
    printf("%s = %d\n",t_hiblk,alloc);

  if (disp->di_v_wasted) {
    wasted = alloc-used;
    printf("%s = %d\n",t_wasted,wasted);
  };

  if (disp->di_v_defext)
    printf("%s = %d\n",t_defext,fh2->fat.fat$w_defext);
  if (disp->di_v_bktsize)
    printf("%s = %d\n",t_bktsize,fh2->fat.fat$b_bktsize);
  if (disp->di_v_gbc)
    printf("%s = %d\n",t_gbc,fh2->fat.fat$w_gbc);
  if (disp->di_v_version_limit)
    printf("%s = %d\n",t_versions,fh2->fat.fat$w_versions);

  if (disp->di_v_highwater) {
    i = fh2->fh2$l_highwater;
    printf("%s = %d\n",t_highwater,i==0?0:i-1);
  };

  if (disp->di_v_access)
    printf("%s = %s\n",t_access,ta_access[fh2->fh2$b_acc_mode]);

  /* if display headers or extents, then counts the suckers up */
  /* note that to ease the code, we'll display the lbns here as well */
  if (disp->di_v_headers || disp->di_v_extents || disp->di_v_lbn) {
    /* okay, loop through all the header blocks, starting with this one */
    exthdr = fh2;
    for (i = 0; i < 3; i++)
      orig_fid[i] = fh2->fh2$w_fid[i];
    while (exthdr && (exthdr->fh2$b_mpoffset!=255)) {
      fm2offset = 0;
      fm2adr = (char *)exthdr + exthdr->fh2$b_mpoffset * 2;
      i = exthdr->fh2$b_map_inuse * 2;
      while (fm2offset < i) {
        fm2 = (char *)fm2adr + fm2offset;
        j=0;
        switch (fm2->fm2$v_format) {
          case FM2$C_PLACEMENT:
            lbn = 0;
            count = 0;
            if (disp->di_v_lbn)
              printf("Placement control: (%04x) %s%s%s%s\n",
                     fm2->fm2$w_word0,
                     fm2->fm2$v_exact?"  Exact":"",
                     fm2->fm2$v_oncyl?"  On cylinder placement desired":"",
                     fm2->fm2$v_rvn?"  Relative volume number":"",
                     fm2->fm2$v_lbn?"  Specific LBN":"");
            fm2offset += FM2$C_LENGTH0;
            break;
          case FM2$C_FORMAT1:
            ++j;
            ++totextents;
            lbn = (fm2->fm2$v_highlbn <<16) + fm2->fm2$w_lowlbn;
            count = fm2->fm2$b_count1;
            fm2offset += FM2$C_LENGTH1;
            break;
          case FM2$C_FORMAT2:
            ++j;
            ++totextents;
            lbn = fm2->fm2$l_lbn2;
            count = fm2->fm2$v_count2;
            fm2offset += FM2$C_LENGTH2;
            break;
          case FM2$C_FORMAT3:
            ++j;
            ++totextents;
            lbn = fm2->fm2$l_lbn3;
            count = (fm2->fm2$v_count2 << 16) + fm2->fm2$w_lowcount;
            fm2offset += FM2$C_LENGTH3;
            break;
        };
        if (disp->di_v_lbn && j)
          printf("%s = %10d - %10d (%10d blocks)\n",
                 t_lbn,lbn,lbn+count,count+1);
      };

      if (exthdr->fh2$w_ext_fid[0]) {
        printf("Extension header #%d (%d,%d,%d)\n",
          exthdr->fh2$w_seg_num+1,
          exthdr->fh2$w_ext_fid[0],
          exthdr->fh2$w_ext_fid[1],
          exthdr->fh2$w_ext_fid[2]);
        exthdr = get_header(exthdr->fh2$w_ext_fid,orig_fid,
                            context,cached,chan);
        if (exthdr == 0)
          printf("--unable to get extension header\n");
        ++tothdrs;
      }
      else
       exthdr = 0;
    };
    if (disp->di_v_headers)
      printf("%s = %d\n",t_header,tothdrs);
    if (disp->di_v_extents)
      printf("%s = %d\n",t_extents,totextents);
  };

  if (disp->di_v_acl) {
    /* okay, loop through all the header blocks, starting with this one */
    if (fh2->fh2$b_acoffset < fh2->fh2$b_rsoffset)
      printf("Access control list\n");

    exthdr = fh2;
    for (i = 0; i < 3; i++)
      orig_fid[i] = fh2->fh2$w_fid[i];
    while (exthdr && (exthdr->fh2$b_acoffset < exthdr->fh2$b_rsoffset)) {
      acaddr = (char *)exthdr + exthdr->fh2$b_acoffset * 2;
      ace_bin.dsc$w_length = acaddr->length;
      while ((acaddr < ((char *)exthdr + (exthdr->fh2$b_rsoffset*2)))
             && (ace_bin.dsc$w_length != 0)) {
        /* format the ace */
        ace_bin.dsc$a_pointer = acaddr;
        ace_txt.dsc$w_length = 512;
        i = 3; /* number of chars to indent */
        j = 77; /* width of acl */
        status = sys$format_acl(&ace_bin,&ace_txt.dsc$w_length,
                                &ace_txt,&j,&newline,&i,0);
        if (status & 1)
          printf("%.*s\n",ace_txt.dsc$w_length,ace_txt.dsc$a_pointer);
        else
          printf("Error %d in formal_acl call\n",status);

        /* move on to next ace */
        acaddr = (char *)acaddr + ace_bin.dsc$w_length;
        ace_bin.dsc$w_length = acaddr->length;
      };
      exthdr = get_header(exthdr->fh2$w_ext_fid,orig_fid,
                          context,cached,chan);
    };
  };

  return;
}

char *cvt_time(date)
  long int date[2];
{
  static char str[27];
  static struct dsc$descriptor date_str={26,DSC$K_DTYPE_T,DSC$K_CLASS_S,str};

  if ((date[0]==0) && (date[1]==0))
    return("none");

  str[0]='\0';
  if (sys$asctim(0,&date_str,date,0) & 1)
    str[26]='\0';

  return(str);
}

char *format_uic(uic)
  long int uic;
{
  static char id[66];
  static struct dsc$descriptor id_str={65,DSC$K_DTYPE_T,DSC$K_CLASS_S,id};
  unsigned short int idlen;
  long int status;

  id[0] = '\0';
  status = sys$idtoasc(uic,&idlen,&id_str,0,0,0);
  if (status & 1)
    id[idlen] = '\0';
  return(id);
}
