/* Modification History
   --------------------
   Sep.  8, 1987 JEM - Conversion from BETA to Release
   Sep. 24, 1987 JEM - modify all FID declarations to unsigned
*/
#include descrip
#include iodef
#include "fibdef.h"
#include "atrdef.h"
#include "fh2def.h"
#include "fileinfo.h"

char *get_header(fid,ofid,context,cached,chan)
  unsigned short int fid[3],ofid[3];
  struct FileInfo *context;
  int cached;
  short int chan;
{
  struct fh2def *fh2;
  static char *blockaddr=0;
  static long int block=512;
  long int blocknum,addr,i,j,status;

  static struct fibdef fib; /* short fib */
  static struct dsc$descriptor fibdesc =
    {FIB$K_ACCDATA,DSC$K_DTYPE_Z,DSC$K_CLASS_S,&fib};
  static struct ATRDEF atr[] = {
    ATR$S_HEADER,ATR$C_HEADER,0,
    0,0,0
    };
  short int iosb[4];

  if (fid[0] == 0) return(0);

  /* if cached and the fid is valid, just grab the header */
  /* this condition should mean they are doing a FULLNAME search */
  /* or asking for an extension header for FULLNAME or FILE_ID search */
  if ((cached && (fid[0] != 0) && (fid[1] != 0)) || fid[2] != 0) {
    if (blockaddr == 0) {
      status = lib$get_vm(&block,&blockaddr);
      if (!(status & 1)) return(0);
    };
    atr[0].atr$l_addr = blockaddr;
    for (i=0;i<3;i++)
      fib.fib$w_fid[i] = fid[i];
    /* Use the IO$_ACCESS function to return info about the file */
    status = sys$qiow(0,chan,IO$_ACCESS,
                      &iosb,0,0,&fibdesc,0,0,0,&atr,0);
    if ((status & 1) && (iosb[0] & 1))
      fh2 = blockaddr;
    else {
      fh2 = 0; /* assume this last ditch effort won't work */
      /* well, it didn't work for some reason.. Let's see if we can jog it's
         memory concerning this file by opening the darned thing. This seems
         to be a bug, but, heck, this seems to be a work around */
      /* Here we need to open the file pointed to by ofid.. Let's set the
         fib to NORECORD so we don't set dates.. */
      for (i=0;i<3;i++)
        fib.fib$w_fid[i] = ofid[i];
      fib.fib$l_acctl = FIB$M_NOLOCK | FIB$M_NORECORD;
      status = sys$qiow(0,chan,IO$_ACCESS|IO$M_ACCESS,
                        &iosb,0,0,&fibdesc,0,0,0,0,0);
      if ((status & 1) && (iosb[0] & 1)) {
        for (i=0;i<3;i++)
          fib.fib$w_fid[i] = fid[i];
/*        status = sys$qiow(0,context->fi_r_fab.fab$l_stv,IO$_ACCESS,
                          &iosb,0,0,&fibdesc,0,0,0,&atr,0); */
        status = sys$qiow(0,chan,IO$_ACCESS,&iosb,0,0,&fibdesc,0,0,0,&atr,0);
        if ((status & 1) && (iosb[0] & 1))
          fh2 = blockaddr;
      };
      for (i=0;i<3;i++)
        fib.fib$w_fid[i] = ofid[i];
      fib.fib$l_acctl = FIB$M_NORECORD;
      status = sys$qiow(0,chan,IO$_DEACCESS,&iosb,0,0,&fibdesc,0,0,0,0,0);
    };
    return(fh2);
  };

  /* get the header */
  if (fid[0]) {
    /* see if it is already mapped in */
    blocknum = fid[0] + context->fi_l_recoff;
    if ((blocknum > context->fi_l_offset)
       &(blocknum < context->fi_l_offset+context->fi_l_pagcnt+1)) {
      /* the header is already mapped into memory */
      addr = blocknum - context->fi_l_offset;
      addr = addr*512 + context->fi_l_begadr;
      j=1;
      for (i=0;i<3;i++)
        if ((fid[i] != (struct fh2 *)addr->fh2$w_fid[i]) && (fid[i] != 0))
          j=0;
      if (j)
        fh2 = addr;
      else
        fh2 = 0;
    }
    else {
      fh2 = 0;
      /* need to read the right block into memory */
      status = read_section_block(&context,&blocknum,&blockaddr);
      if (status & 1)
        fh2 = blockaddr;
    };
  }
  else
    fh2 = 0;

  /* if cached and we found a header, and the header fid isn't set to */
  /* zero, then get the real (possibly cached) header */
  /* these conditions should be met if they specified  a FILE_ID search */
  if (cached && fh2 && fh2->fh2$w_fid[0]) {
    if (blockaddr == 0) {
      status = lib$get_vm(&block,&blockaddr);
      if (!(status & 1)) return(0);
    };
    atr[0].atr$l_addr = blockaddr;
    for (i=0;i<3;i++)
      fib.fib$w_fid[i]=fh2->fh2$w_fid[i];
    /* Use the IO$_ACCESS function to return info about the file */
    status = sys$qiow(0,chan,IO$_ACCESS,&iosb,0,0,&fibdesc,0,0,0,&atr,0);
    if ((status & 1) && (iosb[0] & 1))
      fh2 = blockaddr;
    else
      fh2 = 0;
  };

  return(fh2);
}
