/* This header file was created by Joe Meadows, and is not copyrighted
   in any way. No guarantee is made as to the accuracy of the contents
   of this header file. This header file was last modified on Sep. 8th,
   1987. */
#include descrip

#define DATE { unsigned : 32; unsigned : 32; }

#define SI_K_LBN_LIST_SIZE 40
#define SI_K_OWNER_LIST_SIZE 40
#define SI_K_BACKLINK_LIST_SIZE 40
#define SI_K_ACL_ID_LIST_SIZE 40

struct search_info {
  variant_union {
    variant_struct {
      long int si_l_srchbits0;
      long int si_l_srchbits1;
    } si_dummy_srchbits_struct;
    variant_struct {
      unsigned si_v_credat : 1;
      unsigned si_v_revdat : 1;
      unsigned si_v_expdat : 1;
      unsigned si_v_bakdat : 1;
      unsigned si_v_revision : 1;
      unsigned si_v_extents : 1;
      unsigned si_v_headers : 1;
      unsigned si_v_lbn : 1;
      unsigned si_v_owner : 1;
      unsigned si_v_char : 1;
      unsigned si_v_journal : 1;
      unsigned si_v_prot : 1;
      unsigned si_v_backlink : 1;
      unsigned si_v_access : 1;
      unsigned si_v_highwater : 1;
      unsigned si_v_ru_active : 1;
      unsigned si_v_rectype : 1;
      unsigned si_v_fileorg : 1;
      unsigned si_v_attrib : 1;
      unsigned si_v_rsize : 1;
      unsigned si_v_alloc : 1;
      unsigned si_v_used : 1;
      unsigned si_v_wasted : 1;
      unsigned si_v_bktsize : 1;
      unsigned si_v_vfcsize : 1;
      unsigned si_v_maxrec : 1;
      unsigned si_v_defext : 1;
      unsigned si_v_gbc : 1;
      unsigned si_v_ffbyte : 1;
      unsigned si_v_version_limit : 1;
      unsigned si_v_filename : 1;
      unsigned si_v_placement : 1;
      unsigned si_v_aclexists : 1;
      unsigned si_v_aclcontains : 1;
    } si_dummy_srchbits;
  } si_dummy_srch_union;
  unsigned si_v_and_match : 1;
  struct DATE si_q_credat_min;
  struct DATE si_q_credat_max;
  struct DATE si_q_revdat_min;
  struct DATE si_q_revdat_max;
  struct DATE si_q_expdat_min;
  struct DATE si_q_expdat_max;
  struct DATE si_q_bakdat_min;
  struct DATE si_q_bakdat_max;
  unsigned long int si_l_revision_min;
  unsigned long int si_l_revision_max;
  unsigned long int si_l_extents_min;
  unsigned long int si_l_extents_max;
  unsigned long int si_l_headers_min;
  unsigned long int si_l_headers_max;
  unsigned long int si_l_alloc_min;
  unsigned long int si_l_alloc_max;
  unsigned long int si_l_used_min;
  unsigned long int si_l_used_max;
  unsigned long int si_l_wasted_min;
  unsigned long int si_l_wasted_max;
  unsigned long si_l_highwater_min;
  unsigned long si_l_highwater_max;
  unsigned short int si_w_rsize_min;
  unsigned short int si_w_rsize_max;
  unsigned char si_b_bktsize_min;
  unsigned char si_b_bktsize_max;
  unsigned char si_b_vfcsize_min;
  unsigned char si_b_vfcsize_max;
  unsigned char si_b_ru_active_min;
  unsigned char si_b_ru_active_max;
  unsigned short int si_w_maxrec_min;
  unsigned short int si_w_maxrec_max;
  unsigned short int si_w_defext_min;
  unsigned short int si_w_defext_max;
  unsigned short int si_w_gbc_min;
  unsigned short int si_w_gbc_max;
  unsigned short int si_w_ffbyte_min;
  unsigned short int si_w_ffbyte_max;
  unsigned short int si_w_version_limit_min;
  unsigned short int si_w_version_limit_max;

  variant_union {
    unsigned char si_b_fileorgset;
    struct si_fileorgdef {
      unsigned v_sequential : 1;
      unsigned v_relative : 1;
      unsigned v_indexed : 1;
      unsigned v_direct : 1;
    } si_fileorgset;
  } si_dummy_fileorgset_union;
  variant_union {
    unsigned char si_b_fileorgclr;
    struct si_fileorgdef si_fileorgclr;
  } si_dummy_fileorgclr_union;

  variant_union {
    unsigned char si_b_rectypeset;
    struct si_rectypedef {
      unsigned v_undefined : 1;
      unsigned v_fixed : 1;
      unsigned v_variable : 1;
      unsigned v_vfc : 1;
      unsigned v_stream : 1;
      unsigned v_streamlf : 1;
      unsigned v_streamcr : 1;
    } si_rectypeset;
  } si_dummy_rectypeset_union;
  variant_union {
    unsigned char si_b_rectypeclr;
    struct si_rectypedef si_rectypeclr;
  } si_dummy_rectypeclr_union;

  variant_union {
    unsigned long int si_l_charset;
    struct si_chardef {
      unsigned : 1;
      unsigned v_nobackup : 1;
      unsigned v_writeback : 1;
      unsigned v_readcheck : 1;
      unsigned v_writcheck : 1;
      unsigned v_contigb : 1;
      unsigned v_locked : 1;
      unsigned v_contig : 1;
      unsigned : 3;
      unsigned v_badacl : 1;
      unsigned v_spool : 1;
      unsigned v_directory : 1;
      unsigned v_badblock : 1;
      unsigned v_markdel : 1;
      unsigned v_nocharge : 1;
      unsigned v_erase : 1;
    } si_charset;
  } si_dummy_charset_union;
  variant_union {
    unsigned long int si_l_charclr;
    struct si_chardef si_charclr;
  } si_dummy_charclr_union;

  variant_union {
    unsigned char si_b_attrib_set;
    struct  si_attribdef {
      unsigned v_fortrancc : 1;
      unsigned v_impliedcc : 1;
      unsigned v_printcc : 1;
      unsigned v_nospan : 1;
    } si_attribset;
  } si_dummy_attribset_union;
  variant_union {
    unsigned char si_b_attrib_clr;
    struct  si_attribdef si_attribclr;
  } si_dummy_attribclr_union;

  variant_union {
    unsigned short int si_w_place_set;
    struct  si_placementdef {
      unsigned v_exact : 1;
      unsigned v_oncyl : 1;
      unsigned : 10;
      unsigned v_lbn : 1;
      unsigned v_rvn : 1;
    } si_placeset;
  } si_dummy_placeset_union;
  variant_union {
    unsigned short int si_w_place_clr;
    struct  si_placementdef si_placeclr;
  } si_dummy_placeclr_union;

  variant_union {
    unsigned char si_b_journalset;
    struct si_journaldef {
      unsigned v_only_ru : 1;
      unsigned v_rujnl : 1;
      unsigned v_bijnl : 1;
      unsigned v_aijnl : 1;
      unsigned v_atjnl : 1;
      unsigned v_never_ru : 1;
      unsigned v_journal_file:1;
    } si_journalset;
  } si_dummy_journalset_union;

  variant_union {
    unsigned char si_b_journalclr;
    struct si_journaldef si_journalclr;
  } si_dummy_journalset_union;

  variant_union {
    unsigned char si_b_access_set;
    struct si_accessdef {
      unsigned v_user : 1;
      unsigned v_supervisor : 1;
      unsigned v_executive : 1;
      unsigned v_kernel : 1;
    } si_access_set;
  } si_dummy_access_set_union;

  variant_union {
    unsigned char si_b_access_clr;
    struct si_accessdef si_access_clr;
  } si_dummy_access_clr_union;

  variant_union {
    short int si_w_protection;
    struct {
      unsigned read : 1;
      unsigned write : 1;
      unsigned execute : 1;
      unsigned delete : 1;
    } si_v_protection;
  } si_dummy_protection_union;

  unsigned short int si_w_protset;
  unsigned short int si_w_protclr;

  long int si_l_lbn_list[SI_K_LBN_LIST_SIZE+1];
  long int si_l_owner_list[SI_K_OWNER_LIST_SIZE+1];
  unsigned short int si_w_backlink[SI_K_BACKLINK_LIST_SIZE+1];
  long int si_l_acl_id_list[SI_K_ACL_ID_LIST_SIZE+1];
  struct dsc$descriptor si_t_filename;
};
