/*
 * this file was made by hand, and has NOT been tested yet.
 *
 * Pointed to by CTL$GL_CCBBASE (high end address, table is accessed using
 * negative byte displacements)
 *
 * The number of CCBs is stored in CTL$GW_NMIOCH and is controlled
 * by the sysgen parameter CHANNELCNT
 *
 * CCB$B_AMOD contains 0 if it is unassigned, 1 if kernel, 2 if exec, etc.
 * XQP reserves a channel for itself by storing -1, thus preventing it from
 * being deassigned.
 *
 * I would assume you want to lock the I/O database to do anything with these.
 */

/**** MODULE $CCBDEF ***
 * +
 *  CCB - CHANNEL CONTROL BLOCK
 *  
 *  THERE IS ONE CHANNEL CONTROL BLOCK FOR EACH SOFTWARE CHANNEL THAT A
 *  PROCESS MAY INITIATE I/O REQUESTS ON. THE NUMBER OF SUCH I/O CHANNELS
 *  IS DETERMINED BY THE FIXED NUMBER ASSIGNED TO A PROCESS PLUS ANY
 *  ADDITIONAL CHANNELS REQUIRED BY THE IMAGE CURRENTLY BEING EXECUTED
 *  BY THE PROCESS.
 * 
 *  **** WARNING ****
 *         THE CHANNEL CONTROL BLOCK IS ASSUMED TO BE FOUR LONG WORDS
 *  THROUGHOUT THE EXEC.  ITS SIZE MAY BE CHANGED BUT ONLY BY POWERS OF 2.
 * -
 */
#define CCB$M_AMB  1
#define CCB$M_IMGTMP  2
#define CCB$M_RDCHKDON  4
#define CCB$M_WRTCHKDON  8
#define CCB$M_LOGCHKDON  16
#define CCB$M_PHYCHKDON  32
#define CCB$K_LENGTH  16	/* LENGTH OF CCB */
#define CCB$C_LENGTH  16	/* LENGTH OF CCB */
#define CCB$S_CCBDEF  16
struct ccbdef {
  long int ccb$l_ucb;	/* ADDRESS OF ASSIGNED DEVICE UCB */
  long int ccb$l_wind;	/* ADDRESS OF WINDOW BLOCK */
  union {
    unsigned char ccb$b_sts;  /* CHANNEL STATUS */
    struct {
      unsigned ccb$v_amb:1;	/* MAILBOX ASSOCIATED WITH CHANNEL */
      unsigned ccb$v_imgtmp:1;	/* IMAGE TEMPORARY */
      unsigned ccb$v_rdchkdon:1;	/* READ PROTECTION CHECK COMPLETED */
      unsigned ccb$v_wrtchkdon:1;	/* WRITE PROTECTION CHECK COMPLETED */
      unsigned ccb$v_logchkdon:1;	/* LOGICAL I/O ACCESS CHECK DONE */
      unsigned ccb$v_phychkdon:1;	/* PHYSICAL I/O ACCESS CHECK DONE */
    } ccb$sts_bits;
  } ccb$sts_overlay;
  unsigned char ccb$b_amod;	/* ACCESS MODE THAT ASSIGNED CHANNEL */
  short int ccb$w_ioc;	/* NUMBER OF OUTSTANDING I/O REQUESTS ON CHANNEL */
  long int ccb$l_dirp;	/* DEACCESS I/O REQUEST PACKET ADDRESS */
};
