/*
 * this file was made by hand, and has NOT been tested yet.
 *
 * Linked into the volume control block listhead (VCB$L_FCBFL)
 * (which in turn is pointed to by the UCB (UCB$L_VCB), for instance)
 */

/**** MODULE $FCBDEF ***
 * +
 *  FCB - FILE CONTROL BLOCK
 * 
 *  THERE IS ONE FILE CONTROL BLOCK FOR EACH UNIQUELY ACCESSED FILE ON A
 *  VOLUME. THE FILE CONTROL BLOCK PROVIDES THE VEHICLE WHEREBY SHARED
 *  ACCESS TO A FILE MAY BE CONTROLLED.
 * -
 */
#define FCB$K_LENGTH 180	/*  LENGTH OF STANDARD FCB */
#define FCB$C_LENGTH 180	/*  LENGTH OF STANDARD FCB */
#define FCB$S_FCBDEF 180
struct fcbdef {
  long int fcb$l_fcbfl;	/*  FCB LIST FORWARD LINK */
  long int fcb$l_fcbbl;	/*  FCB LIST BACKWARD LINK */
  short int fcb$w_size;	/*  SIZE OF FCB IN BYTES */
  unsigned char fcb$b_type;	/*  STRUCTURE TYPE OF FCB */
  unsigned char fcb$b_acclkmode;	/*  Access lock mode.*/
  long int fcb$l_exfcb;	/*  ADDRESS OF EXTENSION FCB */
  long int fcb$l_wlfl;	/*  WINDOW LISTHEAD FORWARD LINK */
  long int fcb$l_wlbl;	/*  WINDOW LISTHEAD BACKWARD LINK */
  short int fcb$w_refcnt;	/*  Total references to this FCB.*/
  short int fcb$w_acnt;	/*  FILE ACCESS COUNT */
  short int fcb$w_wcnt;	/*  FILE WRITER COUNT */
  short int fcb$w_lcnt;	/*  FILE LOCK COUNT */
  short int fcb$w_tcnt;	/*  COUNT OF TRUNCATE LOCKS */
  union {
    short int fcb$w_status;	/*  FILE STATUS */
    struct {
      unsigned fcb$v_dir;	/*  FCB IS A DIRECTORY LRU ENTRY */
      unsigned fcb$v_markdel;	/*  FILE IS MARKED FOR DELETE */
      unsigned fcb$v_badblk;	/*  BAD BLOCK ENCOUNTERED IN FILE */
      unsigned fcb$v_excl;	/*  FILE IS EXCLUSIVELY ACCESSED */
      unsigned fcb$v_spool;	/*  FILE IS AN INTERMEDIATE SPOOL FILE */
      unsigned fcb$v_rmslock;	/*  FILE IS OPEN WITH RMS RECORD LOCKING */
      unsigned fcb$v_erase;	/*  ERASE DATA WHEN BLOCKS REMOVED FROM FILE*/
      unsigned fcb$v_badacl;	/*  ACL IS CORRUPT*/
      unsigned fcb$v_stale;	/*  Reconstruct FCB from header.*/
      unsigned fcb$v_delaytrnc;	/*  Delay truncation.*/
    } fcb$status_bits;
  } fcb$status_overlay;
  union {
    short int fcb$w_fid[3];	/*  FILE IDENTIFICATION */
    struct {
      short int fcb$w_fid_num;	/*  FILE NUMBER */
      short int fcb$w_fid_seq;	/*  FILE SEQUENCE NUMBER */
      union {
        short int fcb$w_fid_rvn;	/*  RELATIVE VOLUME NUMBER */
        struct {
          unsigned char fcb$b_fid_rvn;	/*  SHORT FORM RVN */
          unsigned char fcb$b_fid_nmx;	/*  EXTENDED FILE NUMBER */
        } fcb$fidrvn_fields;
      } fcb$fidrvn_overlay;
    } fcb$fid_fields;
  } fcb$fid_overlay;
  short int fcb$w_segn;	/*  FILE SEGMENT NUMBER */
  long int fcb$l_stvbn;	/*  STARTING VIRTUAL BLOCK NUMBER */
  long int fcb$l_stlbn;	/*  STARTING LOGICAL BLOCK NUMBER */
  long int fcb$l_hdlbn;	/*  LBN OF FILE HEADER */
  long int fcb$l_filesize;	/*  FILE SIZE IN BLOCKS */
  long int fcb$l_efblk;	/*  END OF FILE VBN */
  short int fcb$w_versions;	/*  MAXIMUM NUMBER OF VERSIONS IN DIRECTORY */
  short int fcb$w_dirseq;	/*  DIRECTORY USE SEQUENCE NUMBER */
  long int fcb$l_highwater;	/*  HIGH WATER MARK IN FILE*/
  long int fcb$l_acclkid;	/*  Access lock ID.*/
  long int fcb$l_lockbasis;	/*  Lock basis for this FCB.*/
  long int fcb$l_truncvbn;	/*  VBN for delayed truncation.*/
  long int fcb$l_cachelkid;	/*  Cache interlock lock ID*/
  struct {
    union {
      long int fcb$l_fileowner;	/*  FILE OWNER UIC */
      struct {
        short int fcb$w_uicmember;	/*  MEMBER NUMBER */
        short int fcb$w_uicgroup;	/*  GROUP NUMBER */
      } fcb$uic_fields;
    } fcb$uic_overlay;
    unsigned char fcb$r_fill[12];
    long int fcb$q_acmode[2];	/* Access mode protection vector*/
    union {
      long int fcb$l_sys_prot;	/*  Protection word/vector*/
      short int fcb$w_fileprot;	/*  FILE PROTECTION MASK */
    } fcb$prot_overlay;
    long int fcb$l_own_prot;	/*  Owner protection*/
    long int fcb$l_grp_prot;	/*  Group protection*/
    long int fcb$l_wor_prot;	/*  World protection*/
    long int fcb$l_aclfl;	/*  ACCESS CONTROL LIST FORWARD LINK */
    long int fcb$l_aclbl;	/*  ACCESS CONTROL LIST BACKWARD LINK */
    long int fcb$r_min_class_prot[5];	/*  Minimum security classification mask*/
    long int fcb$r_max_class_prot[5];	/*  Maximum security classification mask*/
  } fcb$r_orb;	/*  Object's Rights Block */
  long int fcb$l_dirindx;	/*  Directory index pointer*/
};
