#include ssdef
#include string
#include stdio
#include descrip

#include "menu_def.h"

static FILE *menus,*items,*astrings,*keydefs;
static int item_num=1, astring_num=1, keydef_num=1;

menu_compile(outfile,head)
  char *outfile;
  struct Menu *head;
{
  char filename[255];
  FILE *compiled, *comfile;

  sprintf(filename,"%s_main.c",outfile);
  compiled = fopen(filename,"w","rfm=var","rat=cr");
  fprintf(compiled,"#include \"menu$directory:menu_def.h\"\n");
  fprintf(compiled,"extern int loop();\n");
  fprintf(compiled,"globalref mnu__menus;\n");
  fprintf(compiled,"globalref mnu__items;\n");
  fprintf(compiled,"globalref mnu__astrings;\n");
  fprintf(compiled,"globalref mnu__keydefs;\n");
  fprintf(compiled,"ENTRY$ROUTINE(menufile,dfltfile,node)\n");
  fprintf(compiled,"  char *menufile, *dfltfile;\n");
  fprintf(compiled,"  struct MenuList *node;\n");
  fprintf(compiled,"{\n");
  fprintf(compiled,"  node->entrypnt = &loop;\n");
  fprintf(compiled,"  node->menu = &mnu__menus;\n");
  fprintf(compiled,"  node->array_menus = &mnu__menus;\n");
  fprintf(compiled,"  node->array_items = &mnu__items;\n");
  fprintf(compiled,"  node->array_astrings = &mnu__astrings;\n");
  fprintf(compiled,"  node->array_keydefs = &mnu__keydefs;\n");
  fprintf(compiled,"}\n");
  fclose(compiled);

  sprintf(filename,"%s_menus.mar",outfile);
  menus = fopen(filename,"w","rfm=var","rat=cr");
  fprintf(menus,".macro	MENU,next,prev,name,ditm,hitm,arrow,prompt,wait,");
  fprintf(menus,"keydef,file,topic,sep,itmwidth,align,numeric,width,deflt,");
  fprintf(menus,"length,?s1,?s2,?s3,?s4,?s5\n");
  fprintf(menus,"	.save_psect\n");
  fprintf(menus,"	.psect	strings_psect	rd,nowrt,shr\n");
  fprintf(menus,".if not_blank <name>\n");
  fprintf(menus,"s1:	.asciz	name\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <wait>\n");
  fprintf(menus,"s2:	.asciz	wait\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <file>\n");
  fprintf(menus,"s3:	.asciz	file\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <topic>\n");
  fprintf(menus,"s4:	.asciz	topic\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <deflt>\n");
  fprintf(menus,"s5:	.asciz	deflt\n");
  fprintf(menus,".endc\n");
  fprintf(menus,"	.restore_psect\n");
  fprintf(menus,"	.long	next,prev\n");
  fprintf(menus,".if blank <name>\n");
  fprintf(menus,"	.long	0\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <name>\n");
  fprintf(menus,"  	.address s1\n");
  fprintf(menus,".endc\n");
  fprintf(menus,"	.long	ditm,hitm,arrow,prompt\n");
  fprintf(menus,".if blank <wait>\n");
  fprintf(menus,"	.long	0\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <wait>\n");
  fprintf(menus,"  	.address s2\n");
  fprintf(menus,".endc\n");
  fprintf(menus,"	.long	keydef\n");
  fprintf(menus,".if blank <file>\n");
  fprintf(menus,"	.long	0\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <file>\n");
  fprintf(menus,"  	.address s3\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if blank <topic>\n");
  fprintf(menus,"	.long	0\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <topic>\n");
  fprintf(menus,"	.address s4\n");
  fprintf(menus,".endc\n");
  fprintf(menus,"	.byte	sep\n");
  fprintf(menus,"	.long	itmwidth,align,numeric,width\n");
  fprintf(menus,".if blank <deflt>\n");
  fprintf(menus,"	.long	0\n");
  fprintf(menus,".endc\n");
  fprintf(menus,".if not_blank <deflt>\n");
  fprintf(menus,"  	.address s5\n");
  fprintf(menus,".endc\n");
  fprintf(menus,"	.long	length\n");
  fprintf(menus,".endm\n");
  fprintf(menus,"\n");
  fprintf(menus,"qt = ^a/\"/\n");
  fprintf(menus,"lt = 60\n");
  fprintf(menus,"gt = 62\n");
  fprintf(menus,"\n");
  fprintf(menus,"   	.psect	Menus_Psect	rd,nowrt,shr\n");
  fprintf(menus,"\n");
  fprintf(menus,"mnu__menus::\n");

  sprintf(filename,"%s_items.mar",outfile);
  items = fopen(filename,"w","rfm=var","rat=cr");
  fprintf(items,".macro	ITEM, next,prev,name,itm,desc,prompt,wait,command,force,file,topic,deflt,type,cnt,?s1,?s2,?s3,?s4,?s5,?s6,?s7\n");
  fprintf(items,"	.save_psect\n");
  fprintf(items,"	.psect	strings_psect	rd,nowrt,shr\n");
  fprintf(items,".if not_blank <name>\n");
  fprintf(items,"s1:	.asciz	name\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <wait>\n");
  fprintf(items,"s2:	.asciz	wait\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <command>\n");
  fprintf(items,"s3:	.asciz	command\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <force>\n");
  fprintf(items,"s4:	.asciz	force\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <file>\n");
  fprintf(items,"s5:	.asciz	file\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <topic>\n");
  fprintf(items,"s6:	.asciz	topic\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <deflt>\n");
  fprintf(items,"s7:	.asciz	deflt\n");
  fprintf(items,".endc\n");
  fprintf(items,"	.restore_psect\n");
  fprintf(items,"	.long	next,prev\n");
  fprintf(items,".if blank <name>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <name>\n");
  fprintf(items,"  	.address s1\n");
  fprintf(items,".endc\n");
  fprintf(items,"	.long	itm,desc,prompt\n");
  fprintf(items,".if blank <wait>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <wait>\n");
  fprintf(items,"  	.address s2\n");
  fprintf(items,".endc\n");
  fprintf(items,".if blank <command>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <command>\n");
  fprintf(items,"  	.address s3\n");
  fprintf(items,".endc\n");
  fprintf(items,".if blank <force>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <force>\n");
  fprintf(items,"  	.address s4\n");
  fprintf(items,".endc\n");
  fprintf(items,".if blank <file>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <file>\n");
  fprintf(items,"  	.address s5\n");
  fprintf(items,".endc\n");
  fprintf(items,".if blank <topic>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <topic>\n");
  fprintf(items,"	.address s6\n");
  fprintf(items,".endc\n");
  fprintf(items,".if blank <deflt>\n");
  fprintf(items,"	.long	0\n");
  fprintf(items,".endc\n");
  fprintf(items,".if not_blank <deflt>\n");
  fprintf(items,"  	.address s7\n");
  fprintf(items,".endc\n");
  fprintf(items,"	.long	type,cnt\n");
  fprintf(items,".endm\n");
  fprintf(items,"\n");
  fprintf(items,"qt = ^a/\"/\n");
  fprintf(items,"lt = 60\n");
  fprintf(items,"gt = 62\n");
  fprintf(items,"\n");
  fprintf(items,"   	.psect	Items_Psect	rd,nowrt,shr\n");
  fprintf(items,"\n");
  fprintf(items,"mnu__items::\n");
  fprintf(items,"ITEM 0,0,,0,0,0,,,,,,,0,0\n");

  sprintf(filename,"%s_astrings.mar",outfile);
  astrings = fopen(filename,"w","rfm=var","rat=cr");
  fprintf(astrings,"    	.macro	ASTRING, l,s,m,n,?str\n");
  fprintf(astrings,"	.long	l\n");
  fprintf(astrings,".if blank <s>\n");
  fprintf(astrings,"	.long	0\n");
  fprintf(astrings,".endc\n");
  fprintf(astrings,".if not_blank <s>\n");
  fprintf(astrings,"	.save_psect\n");
  fprintf(astrings,"	.psect	strings_psect	rd,nowrt,shr\n");
  fprintf(astrings,"str:	.asciz	s\n");
  fprintf(astrings,"	.restore_psect\n");
  fprintf(astrings,"	.address str\n");
  fprintf(astrings,".endc\n");
  fprintf(astrings,"	.long	m\n");
  fprintf(astrings,"	.long	n\n");
  fprintf(astrings,"	.endm\n");
  fprintf(astrings,"\n");
  fprintf(astrings,"qt = ^a/\"/\n");
  fprintf(astrings,"lt = 60\n");
  fprintf(astrings,"gt = 62\n");
  fprintf(astrings,"\n");
  fprintf(astrings,"   	.psect	Astrings_Psect	rd,nowrt,shr\n");
  fprintf(astrings,"\n");
  fprintf(astrings,"mnu__astrings::\n");
  fprintf(astrings,"ASTRING 0,,0,0\n");

  sprintf(filename,"%s_keydefs.mar",outfile);
  keydefs = fopen(filename,"w","rfm=var","rat=cr");
  fprintf(keydefs,"    	.macro	KEYDEF, n,s,?str\n");
  fprintf(keydefs,"	.long	n\n");
  fprintf(keydefs,".if blank <s>\n");
  fprintf(keydefs,"	.long	0\n");
  fprintf(keydefs,".endc\n");
  fprintf(keydefs,".if not_blank <s>\n");
  fprintf(keydefs,"	.save_psect\n");
  fprintf(keydefs,"	.psect	strings_psect	rd,nowrt,shr\n");
  fprintf(keydefs,"str:	.asciz	s\n");
  fprintf(keydefs,"	.restore_psect\n");
  fprintf(keydefs,"	.address str\n");
  fprintf(keydefs,".endc\n");
  fprintf(keydefs,"	.endm\n");
  fprintf(keydefs,"\n");
  fprintf(keydefs,"qt = ^a/\"/\n");
  fprintf(keydefs,"lt = 60\n");
  fprintf(keydefs,"gt = 62\n");
  fprintf(keydefs,"\n");
  fprintf(keydefs,"   	.psect	Keydefs_Psect	rd,nowrt,shr\n");
  fprintf(keydefs,"\n");
  fprintf(keydefs,"mnu__keydefs::\n");
  fprintf(keydefs,"KEYDEF 0,\n");

  print_menus(head);

  /* print dummy trailing elements, just to be safe */
  fprintf(menus,"MENU 0,0,,0,0,0,0,,0,,,0,0,0,0,0,,0\n");
  fprintf(menus,".end\n");
  fclose(menus);
  fprintf(items,"ITEM 0,0,,0,0,0,,,,,,,0,0\n");
  fprintf(items,".end\n");
  fclose(items);
  fprintf(astrings,"ASTRING 0,,0,0\n");
  fprintf(astrings,".end\n");
  fclose(astrings);
  fprintf(keydefs,"KEYDEF 0,\n");
  fprintf(keydefs,".end\n");
  fclose(keydefs);

  sprintf(filename,"%s_compile.com",outfile);
  comfile = fopen(filename,"w","rfm=var","rat=cr");
  fprintf(comfile,"$ macro %s_astrings,%s_items,%s_keydefs,%s_menus\n",
		outfile,outfile,outfile,outfile);
  fprintf(comfile,"$ cc %s_main\n",outfile);
  fprintf(comfile,"$ link/share/notrace/exe=%s-\n",outfile);
  fprintf(comfile,"	%s_main,%s_astrings,%s_items,%s_keydefs,%s_menus,-\n",
		outfile,outfile,outfile,outfile,outfile);
  fprintf(comfile,"	menu$directory:module/opt\n");
  fclose(comfile);

  sprintf(filename,"@%s_compile.com",outfile);
  lib_do_command(filename);
}

string(s)
  char *s;
{
  static char *nothing = " ";
  static char dummy[1024];
  int len;

  if (s)
  {
    strcpy(dummy,"<\"");

    while (strlen(s))
    {
      len = strcspn(s,"\"<>");
      strncat(dummy,s,len);
      s += len;
      if (*s == '\"')
      {
        strcat(dummy,"\"<qt>\"");
        ++s;
      }
      if (*s == '<')
      {
        strcat(dummy,"\"<lt>\"");
        ++s;
      }
      if (*s == '>')
      {
        strcat(dummy,"\"<gt>\"");
        ++s;
      }
    }
    strcat(dummy,"\">");

    return(dummy);
  }
  else
    return(nothing);
}

character (s)
  char s;
{
  static char dummy[4];

  sprintf(dummy,"%d",s);
  return(dummy);
}

print_menus(menu)
  struct Menu *menu;
{
  if (menu == 0)
    return;

  while (menu)
  {
    fprintf(menus,"MENU %d,%d,%s,",
		menu->link.next?-1:0,
		menu->link.prev?-1:0,
		string(menu->link.name));
    fprintf(menus,"%d,",print_items(menu->display_itm));
    fprintf(menus,"%d,",print_items(menu->hidden_itm));
    fprintf(menus,"%d,",traverse_astring(menu->arrow));
    fprintf(menus,"%d,-\n",traverse_astring(menu->prompt));
    fprintf(menus," %s,",string(menu->wait));
    fprintf(menus,"%d,",traverse_keydefs(menu->keydefs));
    fprintf(menus,"%s,",string(menu->helpfile));
    fprintf(menus,"%s,",string(menu->helptopic));
    fprintf(menus,"%s,%d,%d,%d,%d,",
		character(menu->separator),
		menu->itemwidth,
		menu->align,
		menu->numeric,
		menu->width);
    fprintf(menus,"%s,",string(menu->default_item));
    fprintf(menus,"%d\n",menu->length);
    menu = menu->link.next;
  }
}


print_items(item)
  struct Item *item;
{
  int thisitem;

  if (item==0)
    return(0);

  thisitem = item_num;
  while (item)
  {
    ++item_num;
    fprintf(items,"ITEM %d,%d,%s,",
		item->link.next?-1:0,
		item->link.prev?-1:0,
		string(item->link.name));
    fprintf(items,"%d,",traverse_astring(item->item));
    fprintf(items,"%d,",traverse_astring(item->descr));
    fprintf(items,"%d,",traverse_astring(item->prompt));
    fprintf(items,"%s,-\n",string(item->wait));
    fprintf(items," %s,",string(item->command));
    fprintf(items,"%s,",string(item->forcecmd));
    fprintf(items,"%s,",string(item->helpfile));
    fprintf(items,"%s,",string(item->helptopic));
    fprintf(items,"%s,%d,%d\n",
		string(item->dflt),
		item->cmdtyp,
		item->paramcnt);
    item = item->link.next;
  }
  return(thisitem);
}

traverse_astring(astring)
  struct AString *astring;
{
  int thisitm;

  if (astring == 0)
    return(0);

  thisitm = astring_num;
  ++astring_num;

  fprintf(astrings,"ASTRING %d,%s,%d,%d\n",
	astring->length,
	string(astring->string),
	astring->mode,
	astring->next?-1:0);

  while (astring->next)
  {
    astring = astring->next;
    ++astring_num;
    fprintf(astrings,"ASTRING %d,,%d,%d\n",
	astring->length,
	astring->mode,
	astring->next?-1:0);
  }
  return(thisitm);
}

traverse_keydefs(keydef)
  struct KeyDef *keydef;
{
  int thiskey;

  if (keydef == 0)
    return(0);

  thiskey = keydef_num;
  /* name, value, next */
  while (keydef)
  {
    ++keydef_num;
    fprintf(keydefs,"KEYDEF %d,%s\n",
		keydef->next?-1:0,
		string(keydef->string));
    keydef = keydef->next;
  }
  return(thiskey);
}

lib_do_command(s)
  char *s;
{
  struct dsc$descriptor sdesc = {strlen(s),0,0,s};

  lib$do_command(&sdesc);
}
