#include ctype

#include "keywords.h"

lookup_keyword(str,sep)
  char *str;
  char sep;
{
  static char *keys[MAXKEYS] = {"ALIGN", "ARROW", "CENTER", "DEFAULT", "FORCE",
		"HELP", "HIDE", "INCLUDE", "KEY", "LEFT", "NOALIGN",
		"NONUMBERS", "NUMBERS", "PARAMS", "PROMPT", "RIGHT",
		"SEPARATOR", "TITLE", "WAIT", "WIDTH"};
  static int keyindx[MAXKEYS] = {KEY_ALIGN, KEY_ARROW, KEY_CENTER, KEY_DEFAULT,
	KEY_FORCE, KEY_HELP, KEY_HIDE, KEY_INCLUDE, KEY_KEY, KEY_LEFT,
	KEY_NOALIGN, KEY_NONUMBERS, KEY_NUMBERS, KEY_PARAMS, KEY_PROMPT,
	KEY_RIGHT, KEY_SEPARATOR, KEY_TITLE, KEY_WAIT, KEY_WIDTH};


  int i,len = 0;

  while(isspace(str[len]))
    ++str;
  while((str[len] != sep) && isalpha(str[len]) && (len < strlen(str)))
  {
    str[len] = toupper(str[len]);
    ++len;
  }

  /* see if the string is one of these keywords.. */
  for (i = 0; i < MAXKEYS; ++i)
  {
    if (strncmp(keys[i],str,len) == 0)
    {
      /* either ambiguous, or it's been found! */
      if (i < MAXKEYS + 1)
      {
        if (strncmp(keys[i + 1],str,len) == 0)
        {
          return(-2); /* too bad, it was ambiguous */
        }
      }
      return(keyindx[i]); /* a match was found! return it! */
    }
  }
  return(-1); /* it wasn't one of these keywords! */
}
