#include descrip

#define SMG$_EOF 1213442
#define SMG$_NO_MORMSG 0x00128041
#include "menu_def.h"

static struct {
  unsigned init : 1;
  unsigned msg : 1;
  int pb, kb, kt;
  int rows, cols;
  int input;
} screen;

static struct Window {
  int vd;
  int rows, cols;
} menu_window;

call(status)
  int status;
{
  if (!(status & 1)) lib$signal(status);
};

broadcast_message(astarg, r0, r1, pc, psl)
  int *astarg, *r0, *r1, *pc, *psl;
{
  screen.msg = 1;

  smg$cancel_input(&screen.kb);
  return(1);
}

message_waiting()
{
  return(screen.msg);
}

repaint_screen(astarg, r0, r1, pc, psl)
  int *astarg, *r0, *r1, *pc, *psl;
{
  smg$cancel_input(&screen.kb);
  smg$repaint_screen(&screen.pb);
}

create_window(window, length, width, row, col)
  struct Window *window;
  int length, width, row, col;
{
  int N0 = 0, N1 = 1, N3 = 3, N22 = 22, N24 = 24, N80 = 80;
  int mask, nlen;

  if (window == 0)    
  {
    window = calloc(1,sizeof(struct Window));
  };

  if (window->vd)
  {
    call(smg$delete_virtual_display(&(window->vd)));
  };

  call(smg$create_virtual_display(&length, &width, &(window->vd)));

  if (!(screen.init))
  {
    call(smg$create_pasteboard(&screen.pb, 0, &screen.rows, &screen.cols));
    call(smg$create_virtual_keyboard(&screen.kb));
    call(smg$set_keypad_mode(&screen.kb, &N0));
    call(smg$set_broadcast_trapping(&screen.pb, &broadcast_message));
    mask = (1 << ('R' - '@')) | (1 << ('W' - '@'));
    call(smg$set_out_of_band_asts(&screen.pb,&mask,&repaint_screen,&screen.pb));
    call(smg$create_virtual_display(&N3, &N80, &screen.input));
    call(smg$paste_virtual_display(&screen.input, &screen.pb, &N22, &N1));
    screen.init = 1;
  }
  call(smg$change_pbd_characteristics(&screen.pb,&width,&screen.cols,
					&screen.rows,&screen.rows));
  call(smg$paste_virtual_display(&(window->vd), &screen.pb, &row, &col));
  call(smg$repaste_virtual_display(&screen.input,&screen.pb,&N22,&N1));
}

init_key_table()
{
  static struct dsc$descriptor keyname = {0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
  static struct dsc$descriptor ifname  = {0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
  int context = 0, status = 1;

  if (screen.kt == 0)
    call(smg$create_key_table(&screen.kt));

  while (status & 1)
  {
    status = smg$list_key_defs(&screen.kt,&context,&keyname,&ifname);
    if (status & 1)
    {
      smg$delete_key_def(&screen.kt,&keyname,&ifname);
    }
  }
  define_key("UP \"\x07fUP\"/terminate/noecho");
  define_key("DOWN \"\x07fDOWN\"/terminate/noecho");
  define_key("PF2 \"\x07fHELP\"/terminate/noecho");
  define_key("PF3 \"\x07fPREV_SCREEN\"/terminate/noecho");
  define_key("PF4 \"\x07fNEXT_SCREEN\"/terminate/noecho");
  define_key("E5 \"\x07fPREV_SCREEN\"/terminate/noecho");
  define_key("E6 \"\x07fNEXT_SCREEN\"/terminate/noecho");
  define_key("F10 \"\x07fEXIT\"/terminate/noecho");
  define_key("HELP \"\x07fHELP\"/terminate/noecho");
}

define_key(s)
  char *s;
{
  static struct dsc$descriptor dynamic = {0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
  struct dsc$descriptor s_desc = {strlen(s),DSC$K_DTYPE_T,DSC$K_CLASS_S,s};
  $DESCRIPTOR(define,"define/key ");
  $DESCRIPTOR(err,"Error defining key - ");
  struct AString err_str;
  char errnum[12];
  struct dsc$descriptor num_desc = {11,DSC$K_DTYPE_T,DSC$K_CLASS_S,errnum};
  int status;

  str$copy_dx(&dynamic,&define);
  str$append(&dynamic, &s_desc);

  status = smg$define_key(&screen.kt, &dynamic);
  if (!(status & 1))
  {
    str$copy_dx(&dynamic,&err);
    sprintf(errnum,"(%08X) ",status);
    str$append(&dynamic, &num_desc);
    str$append(&dynamic, &s_desc);
    err_str.length = dynamic.dsc$w_length;
    err_str.string = dynamic.dsc$a_pointer;
    err_str.mode = 0;
    err_str.next = 0;
    error(&err_str);
  }
}

draw_arrow(line,arrow,flag)
  int line;
  struct AString *arrow;
  int flag;
{
  int N1 = 1;
  int pb, p, row, col, newline;

  hide_display();
  set_cursor(menu_window.vd,line,1);
  write_astring(menu_window.vd, arrow, flag);

  /* make sure that line is on the screen */
  smg$get_pasting_info(&menu_window.vd, &screen.pb, &p, &row, &col);
  if ((row + line) < 2)
  {
    newline = 2 - line;
    smg$move_virtual_display(&menu_window.vd, &screen.pb, &newline, &N1);
  }
  else
  {
    if ((row + line) > screen.rows - 2)
    {
    newline = (screen.rows - 2) - line;
    smg$move_virtual_display(&menu_window.vd, &screen.pb, &newline, &N1);
    }
  }
  show_display();
}

erase_arrow(line, arrow)
  int line;
  struct AString *arrow;
{
  int N1 = 1, length;

  if (arrow && arrow->string)
  {
    length = strlen(arrow->string);
    hide_display();
    smg$erase_display(&menu_window.vd, &line, &N1, &line, &length);
    show_display();
  }
}

error(s)
  struct AString *s;
{
  $DESCRIPTOR(pressret,"Press return to continue");
  struct dsc$descriptor dummy = {0,0,0,0};
  int N1 = 1, N3 = 3, N22 = 22, N80 = 80;
  int status, term;

  if (screen.input == 0)
  {
    create_window(&screen.input, N3, N80, N22, N1);
  }

  call(smg$ring_bell(&screen.input));
  write_astring(screen.input, s, 0);
  new_line(screen.input);

  smg$read_string(&screen.kb,&dummy,&pressret,0,0,0,0,0,&term,&screen.input);
}

set_cursor(vd,line,col)
  int vd, line, col;
{
  call(smg$set_cursor_abs(&vd,&line,&col));
}

hide_display()
{
  call(smg$begin_pasteboard_update(&screen.pb));
}

show_display()
{
  call(smg$end_pasteboard_update(&screen.pb));
}

sopen(length, width)
  int length, width;
{
  create_window(&menu_window,length + 1,width,1,1);
}

sclose()
{
  int N0 = 0;

  if (screen.init)
  {
    if(menu_window.vd)
      call(smg$delete_virtual_display(&menu_window.vd));
    menu_window.vd = 0;
    call(smg$delete_virtual_display(&screen.input));
    screen.input = 0;
    call(smg$set_out_of_band_asts(&screen.pb,&N0,0));
    call(smg$disable_broadcast_trapping(&screen.pb));
    call(smg$delete_virtual_keyboard(&screen.kb));
    screen.kb = 0;
    call(smg$delete_pasteboard(&screen.pb));
    screen.pb = 0;
    screen.init = 0;
  }
}

snew_line()
{
  new_line(menu_window.vd);
}

new_line(vd)
  int vd;
{
  int N1 = 1;

  call(smg$set_cursor_abs(&vd,0,&N1));
  if (!(smg$set_cursor_rel(&vd,&N1,0) & 1))
  { /* assume error is invalid row, and scroll display up */
    call(smg$scroll_display_area(&vd));
    /* smg$set_cursor_rel(&vd,&N1,0); */
  }
}

swrite_spaces(n)
{
  write_spaces(menu_window.vd,n);
}

write_spaces(vd,n)
  int vd, n;
{
  call(smg$set_cursor_rel(&vd,0,&n));
}

swrite_astring(astring,flag)
  struct AString *astring;
  int flag;
{
  write_astring(menu_window.vd,astring,flag);
}

write_astring(vd,astring,flag)
  int vd;
  struct AString *astring;
  int flag;
{
  struct {int len; char *ptr;} str;
  int N1 = 1;
  int rend;

  str.len = astring->length;
  str.ptr = astring->string;
  while(astring)
  {
    /* print this portion of string, with specified attributes */
    rend = astring->mode;
    if ((flag == 1) && ((int)astring->string == 0))
    { /* fix up address of current chunk (if array version, and not set) */
      str.ptr += str.len;
      str.len = astring->length;
      call(smg$put_chars(&vd, &str, 0,0,0, &rend));
    }
    else
      call(smg$put_chars(&vd, astring, 0,0,0, &rend));

    if ((int)(astring->next) == -1)
      ++astring;
    else
      astring = astring->next;
  }
}

prompt(node,menu,str,len,term)
  struct MenuList *node;
  struct Menu *menu;
  char **str;
  unsigned short int *len, *term;
{
  static struct dsc$descriptor retstr = {0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
  static struct dsc$descriptor nullstr = {1,DSC$K_DTYPE_T,DSC$K_CLASS_S,"\0"};
  struct AString *astrings, *promptstr;
  int status, dummy = 0, N1 = 1;

  if (node->flag == 1)
  {
    astrings = node->array_astrings;
    promptstr = ((int)(menu->prompt) >= 0)?&astrings[(int)(menu->prompt)]:0;
  }
  else
  {
    promptstr = menu->prompt;
  }

  smg$erase_line(&screen.input, &N1, &N1);
  set_cursor(screen.input, 1, 1);
  status = smg$read_composed_line(&screen.kb, &screen.kt, &retstr, promptstr,
				0, &screen.input, &N1, 0,0,0,0, term);
  while (((status & 1) == 0) && (status != SMG$_EOF))
  {
    get_broadcast_messages();
    smg$erase_line(&screen.input, &N1, &N1);
    set_cursor(screen.input, 1, 1);
    status = smg$read_composed_line(&screen.kb, &screen.kt, &retstr, promptstr,
					0, &screen.input, &N1, 0,0,0,0, term);
  }
  get_broadcast_messages();

  *len = retstr.dsc$w_length;
  str$append(&retstr,&nullstr); /* null terminate the string.. */
  *str = retstr.dsc$a_pointer;

  return(status);
}

get_broadcast_messages()
{
  static struct dsc$descriptor brdmsg = {0,DSC$K_DTYPE_T,DSC$K_CLASS_D,0};
  int status;

  while (screen.msg)
  {
    status = smg$get_broadcast_message(&screen.pb, &brdmsg);
    if ((status & 1) && !(status == SMG$_NO_MORMSG))
    {
      smg$ring_bell(&screen.input);
      call(smg$put_with_scroll(&screen.input, &brdmsg));
    }
    else
    {
      screen.msg = 0;
    }
  }
}
