/* This header file was created by converting the $NFBDEF macro
  * and adding the comments taken from NETUSR.SDL
 * (VMS 4.6 microfiche page 334)
 */

#define NFB$C_ENDOFLIST	0	/* used to terminate the field i.d. */
#define NFB$C_WILDCARD	1	/* field to use for "match all" database searches */
#define NFB$C_CTX_SIZE	64	/* length of context area in P2 buffer */

/* The following codes are passed in the second IOSB longword to qualify
 * an SS$_ILLCNTRFUNC error.
 *
 * The high order word of these error codes must be zero
 * so that they won't be confused with field i.d.s
 */
#define NFB$_ERR_FCT	1	/* unrecognized NFB$B_FCT value */
#define NFB$_ERR_DB	2	/* unrecognized NFB$B_DATABASE value */
#define NFB$_ERR_P1	3	/* The P1 buffer is invalid */
#define NFB$_ERR_P2	4	/* The P2 buffer is invalid */
#define NFB$_ERR_P3	5	/* The P3 buffer is invalid */
#define NFB$_ERR_P4	6	/* The P4 buffer is invalid */
#define NFB$_ERR_P5	7	/* The P5 buffer should not have been specified */
#define NFB$_ERR_P6	8	/* The P6 buffer should not have been specified */
#define NFB$_ERR_CELL	9	/* unrecognized NFB$B_CELL value */
#define NFB$_ERR_OPER	10	/* unrecognized NFB$B_OPER value */
#define NFB$_ERR_SRCH	11	/* unrecognized NFB$L_SRCH_KEY field i.d. */
#define NFB$_ERR_SRCH2	12	/* unrecognized NFB$L_SRCH2_KEY field i.d. */
#define NFB$_ERR_OPER2	13	/* unrecognized NFB$B_OPER2 value */
#define NFB$_ERR_FLAGS	14	/* undefined bits in NFB$B_FLAGS were not zero */

#define NFB$B_FCT	0	/* function codes */
#define NFB$C_DECLNAME	21	/* declare name */
#define NFB$C_DECLOBJ	22	/* declare object */
#define NFB$C_DECLSERV	23	/* declare server process available */
#define NFB$C_LOGEVENT	28	/* log a network event */
#define NFB$C_READEVENT	29	/* read current raw event queue (used by EVL only) */
#define NFB$C_FC_DELETE	33	/* remove an entry from the database */
#define NFB$C_FC_SHOW	34	/* return specified field values */
#define NFB$C_FC_SET	35	/* set/modify the field values */
#define NFB$C_FC_CLEAR	36	/* clear specified field values */
#define NFB$C_FC_ZERCOU	37	/* zero (and optionally read) counters */
#define NFB$C_FC_LOOP	38	/* loop (used only to PSI to loop an x.25 line) */
#define NFB$C_FC_MAX	38	/* maximum FCT value

#define NFB$B_FLAGS	1	/* miscellaneous control flags */
#define NFB$V_ERRUPD	0
#define NFB$V_MULT	1
#define NFB$V_NOCTX	2
#define NFB$M_ERRUPD	1	/* update position context, even on error */
#define NFB$M_MULT	2	/* process as many entries as can be fit into P4 */
#define NFB$M_NOCTX	4	/* Don't update position context, even if successful
                                 * (used to stay on an entry for a while) This flag
                                 * overrides the ERRUPD flag.
                                 */

#define NFB$B_DATABASE	2	/* code identifying the database */
#define NFB$C_DB_LNI	1	/* local node */
#define NFB$C_DB_NDI	2	/* common nodes */
#define NFB$C_DB_OBI	3	/* network objects */
#define NFB$C_DB_CRI	4	/* circuits */
#define NFB$C_DB_PLI	5	/* lines */
#define NFB$C_DB_EFI	6	/* event logging filters */
#define NFB$C_DB_ESI	7	/* event logging sinks */
#define NFB$C_DB_LLI	8	/* logical-links */
#define NFB$C_DB_XNI	9	/* X.25 networks */
#define NFB$C_DB_XGI	10	/* X.25 groups */
#define NFB$C_DB_XDI	11	/* X.25 DTEs */
#define NFB$C_DB_XS5	12	/* X.25 server */
#define NFB$C_DB_XD5	13	/* X.25 destinations */
#define NFB$C_DB_XS9	14	/* X.29 server */
#define NFB$C_DB_XD9	15	/* X.29 destinations */
#define NFB$C_DB_XTI	16	/* X.25 trace facility */
#define NFB$C_DB_XTT	17	/* X.25 tracepoints */
#define NFB$C_DB_SPI	18	/* server process */
#define NFB$C_DB_AJI	19	/* adjaceny information */
#define NFB$C_DB_ARI	20	/* area information */
#define NFB$C_DB_XDTE	21	/* PSI reserved database */
#define NFB$C_DB_PSI2	22	/* PSI reserved database */
#define NFB$C_DB_PSI3	23	/* PSI reserved database */
#define NFB$C_DB_PSI4	24	/* PSI reserved database */
#define NFB$C_DB_PSI5	25	/* PSI reserved database */
#define NFB$C_DB_SDI	26	/* service DLE information */
#define NFB$C_DB_XAI	27	/* X.25 access database */
#define NFB$C_DB_XXX	28	/* last database definition for NFB$C_DB_MAX calc. */
#define NFB$C_DB_MAX	27	/* Maximum database value */

#define NFB$B_OPER	3	/* specifies the sense of the database search operation */
#define NFB$C_OP_EQL	0	/* match if SRCH_KEY EQL database entry field */
#define NFB$C_OP_GTRU	1	/* match if SRCH_KEY GTRU database field entry */
#define NFB$C_OP_LSSU	2	/* match if SRCH_KEY LSSU database field entry */
#define NFB$C_OP_NEQ	3	/* match if SRCH_KEY NEQ database field entry */
/* the following may only be used internally by NETACP */
#define NFB$C_OP_FNDMIN	4	/* find entry with minimum key value */
#define NFB$C_OP_FNDMAX	5	/* find entry with maximum key value */
#define NFB$C_OP_FNDPOS	6	/* find entry position in database */
#define NFB$C_OP_MAXFCT	3	/* maximum operator function */
#define NFB$C_OP_MAXINT	6	/* maximum internal function */

#define NFB$L_SRCH_KEY	4
/* Search key field identifier specifying the key used
 * to locate the entry in the database. This search is controlloed
 * by the sense of the NFB$B_OPER field.
 *
 * If this field has the value NFB$C_WILDCARD then the very next
 * entry in the list is assumed to be the target of the search.
 *
 * If this field is not specified (zero), then it
 * is assumed to be NFB$C_WILDCARD (no search key)
 */

#define NFB$L_SRCH2_KEY	8
/* secondary search key field identifier specifying the key used
 * to locate the entry in the database. This search is controlled by
 * the sense of the NFB$B_OPER2 field.
 *
 * If both SRCH_KEY and SRCH2_KEY are specified, then only those
 * database entries matching both search keys will be processed.
 *
 * If this field is not specified (zero) then it is assumed to be
 * NFB$C_WILDCARD (no search key)
 */

#define NFB$B_OPER2	12	/* specifies the sense of the
				 * database search operation
				 * when comparing against the SRCH2_KEY
				 */

#define NFB$B_MBZ1	13	/* must be zero */

#define NFB$W_CELL_SIZE	14
/* some of the field values found in the P4 buffer are
 * counted strings. If the "cell" size is non-zero, it
 * indicates the number of bytes which each string in
 * the P4 buffer occupies. If it is zero then string
 * fields are stores as variable length fields.
 */

#define NFB$L_FLDID	16
/* cell containing the first field i.d. -- the list
 * of field i.d.s begins here and continues to the
 * end of the structure.
 *
 * The list may be terminated before the end of the
 * structure by placing the value NFB$C_ENDOFLIST
 * in the longword following the last field i.d.
 */

#define NFB$K_LENGTH	16
#define NFB$C_LENGTH	16

/* define the field i.d. format */
#define NFB$L_PARAM_ID	0
#define NFB$M_INX	65535	/* Index into semantic table */
#define NFB$S_INX	16
#define NFB$V_INX	0
#define NFB$M_TYP	196608	/* Field type (string, bit, etc. */
#define NFB$C_TYP_BIT	0	/* field type for bits */
#define NFB$C_TYP_V	0	/* field type for bits */
#define NFB$C_TYP_LNG	1	/* field type for longs */
#define NFB$C_TYP_L	1	/* field type for longs */
#define NFB$C_TYP_STR	2	/* field type for strings */
#define NFB$C_TYP_S	2	/* field type for strings */
#define NFB$S_TYP	2
#define NFB$V_TYP	16
#define NFB$M_SPARE	16515072	/* reserved, must be zero */
#define NFB$S_SPARE	6
#define NFB$V_SPARE	18
#define NFB$M_DB	-16777216	/* database i.d. */
#define NFB$S_DB	8
#define NFB$V_DB	24

#define NFB$L_LNG_VALUE	0	/* longword value */
#define NFB$L_BIT_VALUE	0	/* longword value - bit 0 */
#define NFB$W_STR_COUNT	0	/* string - count */
#define NFB$B_STR_TEXT	2	/* string - text */

/* database parameter i.d.s */

/* define the NDI database */
/* boolean params */
#define NFB$C_NDI_LCK	33554433	/* set if conditionally writable fields are not writeable */
#define NFB$C_NDI_LOO	33554434	/* set if CNF is for a "loopback" node */
#define NFB$C_NDI_REA	33554435	/* set if node is reachable */
/* longword parameters */
#define NFB$C_NDI_TAD	33619984	/* "transformed address" - uses local node address
					 * for the local NDI (instead of zero as does ADD)
					 */
#define NFB$C_NDI_CTA	33619985	/* absolute due time for logging counters */
#define NFB$C_NDI_ADD	33619986	/* address */
#define NFB$C_NDI_CTI	33619987	/* counter timer */
#define NFB$C_NDI_ACL	33619988	/* active links */
#define NFB$C_NDI_DEL	33619989	/* delay */
#define NFB$C_NDI_DTY	33619990	/* destination type */
#define NFB$C_NDI_DCO	33619991	/* destination cost */
#define NFB$C_NDI_DHO	33619992	/* destination hops */
#define NFB$C_NDI_SDV	33619993	/* service device */
#define NFB$C_NDI_CPU	33619994	/* CPU type */
#define NFB$C_NDI_STY	33619995	/* software type */
#define NFB$C_NDI_DAD	33619996	/* dump address */
#define NFB$C_NDI_DCT	33619997	/* dump count */
#define NFB$C_NDI_OHO	33619998	/* host */
#define NFB$C_NDI_IHO	33619999	/* host */
#define NFB$C_NDI_ACC	33620000	/* access switch (inbound, outbound, etc.) */
#define NFB$C_NDI_PRX	33620001	/* ** obsolete ** (node proxy parameter) */
#define NFB$C_NDI_NND	33620002	/* next node address */
#define NFB$C_NDI_SNV	33620003	/* service node version */
#define NFB$C_NDI_INB	33620004	/* async line - inbound node type */
/* string parameters */
#define NFB$C_NDI_COL  	33685568	/* collating sequnce */
#define NFB$C_NDI_HAC	33685569	/* node address/loop linename combination */
#define NFB$C_NDI_CNT	33685570	/* counters */
#define NFB$C_NDI_NNA	33685571	/* name */
#define NFB$C_NDI_SLI	33685572	/* service line */
#define NFB$C_NDI_SPA	33685573	/* service password */
#define NFB$C_NDI_LOA	33685574	/* load file */
#define NFB$C_NDI_SLO	33685575	/* secondary loader */
#define NFB$C_NDI_TLO	33685576	/* tertiary loader */
#define NFB$C_NDI_SID	33685577	/* software i.d. */
#define NFB$C_NDI_DUM	33685578	/* dump file */
#define NFB$C_NDI_SDU	33685579	/* secondary dumper */
#define NFB$C_NDI_NLI	33685580	/* loopback line */
#define NFB$C_NDI_DLI	33685581	/* destination line */
#define NFB$C_NDI_PUS	33685582	/* privileged user id */
#define NFB$C_NDI_PAC	33685583	/* privileged account */
#define NFB$C_NDI_PPW	33685584	/* privileged password */
#define NFB$C_NDI_NUS	33685585	/* non-priv user id */
#define NFB$C_NDI_NAC	33685586	/* non-priv user account */
#define NFB$C_NDI_NPW	33685587	/* non-priv user password */
#define NFB$C_NDI_RPA	33685588	/* recieve password */
#define NFB$C_NDI_TPA	33685589	/* trasnsmit password */
#define NFB$C_NDI_DFL	33685590	/* diagnostic load file */
#define NFB$C_NDI_HWA	33685591	/* hardware NI address (ROM address) */
#define NFB$C_NDI_LPA	33685592	/* loop assistant NI address */
#define NFB$C_NDI_NNN	33685593	/* next node name to destination (goes with nnd) */
#define NFB$C_NDI_LAA	33685594	/* node assist agent */
#define NFB$C_NDI_LAP	33685595	/* load assist parameter */

/* define field parameters for each parameter in the LNI database */
#define NFB$C_LNI_LCK	16777217
#define NFB$C_LNI_ALI	16777218
#define NFB$C_LNI_ADD	16842768
#define NFB$C_LNI_ACL	16842769
#define NFB$C_LNI_ITI	16842770
#define NFB$C_LNI_OTI	16842771
#define NFB$C_LNI_STA	16842772
#define NFB$C_LNI_MLK	16842773
#define NFB$C_LNI_DFA	16842774
#define NFB$C_LNI_DWE	16842775
#define NFB$C_LNI_IAT	16842776
#define NFB$C_LNI_RFA	16842777
#define NFB$C_LNI_ETY	16842778
#define NFB$C_LNI_RTI	16842779
#define NFB$C_LNI_RSI	16842780
#define NFB$C_LNI_SAD	16842781
#define NFB$C_LNI_MAD	16842782
#define NFB$C_LNI_MLN	16842783
#define NFB$C_LNI_MCO	16842784
#define NFB$C_LNI_MHO	16842785
#define NFB$C_LNI_MVI	16842786
#define NFB$C_LNI_MBU	16842787
#define NFB$C_LNI_BUS	16842788
#define NFB$C_LNI_LPC	16842789
#define NFB$C_LNI_LPL	16842790
#define NFB$C_LNI_LPD	16842791
#define NFB$C_LNI_DAC	16842792
#define NFB$C_LNI_DPX	16842793
#define NFB$C_LNI_PIQ	16842794
#define NFB$C_LNI_LPH	16842795
#define NFB$C_LNI_BRT	16842796
#define NFB$C_LNI_MAR	16842797
#define NFB$C_LNI_MBE	16842798
#define NFB$C_LNI_MBR	16842799
#define NFB$C_LNI_AMC	16842800
#define NFB$C_LNI_AMH	16842801
#define NFB$C_LNI_SBS	16842802
#define NFB$C_LNI_ALA	16842803
#define NFB$C_LNI_ALM	16842804
#define NFB$C_LNI_COL	16908352
#define NFB$C_LNI_NAM	16908353
#define NFB$C_LNI_CNT	16908354
#define NFB$C_LNI_IDE	16908355
#define NFB$C_LNI_MVE	16908356
#define NFB$C_LNI_NVE	16908357
#define NFB$C_LNI_RVE	16908358
#define NFB$C_LNI_PHA	16908359
#define NFB$C_OBI_LCK	50331649
#define NFB$C_OBI_SET	50331650
#define NFB$C_OBI_ALO	50331651
#define NFB$C_OBI_ALI	50331652
#define NFB$C_OBI_LPR	50397200
#define NFB$C_OBI_HPR	50397201
#define NFB$C_OBI_UCB	50397202
#define NFB$C_OBI_CHN	50397203
#define NFB$C_OBI_NUM	50397204
#define NFB$C_OBI_PID	50397205
#define NFB$C_OBI_PRX	50397206
#define NFB$C_OBI_COL	50462784
#define NFB$C_OBI_ZNA	50462785
#define NFB$C_OBI_SFI	50462786
#define NFB$C_OBI_IAC	50462787
#define NFB$C_OBI_NAM	50462788
#define NFB$C_OBI_FID	50462789
#define NFB$C_OBI_USR	50462790
#define NFB$C_OBI_ACC	50462791
#define NFB$C_OBI_PSW	50462792
#define NFB$C_CRI_LCK	67108865
#define NFB$C_CRI_SER	67108866
#define NFB$C_CRI_BLK	67108867
#define NFB$C_CRI_VER_FILL	67108868
#define NFB$C_CRI_DLM	67108869
#define NFB$C_CRI_OWPID	67174416
#define NFB$C_CRI_CTA	67174417
#define NFB$C_CRI_SRV	67174418
#define NFB$C_CRI_STA	67174419
#define NFB$C_CRI_SUB	67174420
#define NFB$C_CRI_LCT	67174421
#define NFB$C_CRI_PNA	67174422
#define NFB$C_CRI_BLO	67174423
#define NFB$C_CRI_COS	67174424
#define NFB$C_CRI_HET	67174425
#define NFB$C_CRI_LIT	67174426
#define NFB$C_CRI_MRC	67174427
#define NFB$C_CRI_RCT	67174428
#define NFB$C_CRI_POL	67174429
#define NFB$C_CRI_PLS	67174430
#define NFB$C_CRI_USE	67174431
#define NFB$C_CRI_TYP	67174432
#define NFB$C_CRI_CHN	67174433
#define NFB$C_CRI_MBL	67174434
#define NFB$C_CRI_MWI	67174435
#define NFB$C_CRI_TRI	67174436
#define NFB$C_CRI_BBT	67174437
#define NFB$C_CRI_TRT	67174438
#define NFB$C_CRI_MRB	67174439
#define NFB$C_CRI_MTR	67174440
#define NFB$C_CRI_ACB	67174441
#define NFB$C_CRI_ACI	67174442
#define NFB$C_CRI_IAB	67174443
#define NFB$C_CRI_IAI	67174444
#define NFB$C_CRI_IAT	67174445
#define NFB$C_CRI_DYB	67174446
#define NFB$C_CRI_DYI	67174447
#define NFB$C_CRI_DYT	67174448
#define NFB$C_CRI_DTH	67174449
#define NFB$C_CRI_MST	67174450
#define NFB$C_CRI_XPT	67174451
#define NFB$C_CRI_MRT	67174452
#define NFB$C_CRI_RPR	67174453
#define NFB$C_CRI_DRT	67174454
#define NFB$C_CRI_VER	67174455
#define NFB$C_CRI_COL	67240000
#define NFB$C_CRI_NAM	67240001
#define NFB$C_CRI_VMSNAM	67240002
#define NFB$C_CRI_CHR	67240003
#define NFB$C_CRI_CNT	67240004
#define NFB$C_CRI_P2P	67240005
#define NFB$C_CRI_LOO	67240006
#define NFB$C_CRI_PNN	67240007
#define NFB$C_CRI_NUM	67240008
#define NFB$C_CRI_DTE	67240009
#define NFB$C_CRI_DEVNAM	67240010
#define NFB$C_CRI_NET	67240011
#define NFB$C_PLI_LCK	83886081
#define NFB$C_PLI_SER	83886082
#define NFB$C_PLI_DUP	83886083
#define NFB$C_PLI_CON	83886084
#define NFB$C_PLI_CLO	83886085
#define NFB$C_PLI_SWI	83886086
#define NFB$C_PLI_HNG	83886087
#define NFB$C_PLI_CTA	83951632
#define NFB$C_PLI_STA	83951633
#define NFB$C_PLI_SUB	83951634
#define NFB$C_PLI_LCT	83951635
#define NFB$C_PLI_PRO	83951636
#define NFB$C_PLI_STI	83951637
#define NFB$C_PLI_HTI	83951638
#define NFB$C_PLI_MBL	83951639
#define NFB$C_PLI_MRT	83951640
#define NFB$C_PLI_MWI	83951641
#define NFB$C_PLI_SLT	83951642
#define NFB$C_PLI_DDT	83951643
#define NFB$C_PLI_DLT	83951644
#define NFB$C_PLI_SRT	83951645
#define NFB$C_PLI_BFN	83951646
#define NFB$C_PLI_BUS	83951647
#define NFB$C_PLI_PLVEC	83951648
#define NFB$C_PLI_RTT	83951649
#define NFB$C_PLI_MOD	83951650
#define NFB$C_PLI_LPC	83951651
#define NFB$C_PLI_LPL	83951652
#define NFB$C_PLI_LPD	83951653
#define NFB$C_PLI_EPT	83951654
#define NFB$C_PLI_LNS	83951655
#define NFB$C_PLI_BFS	83951656
#define NFB$C_PLI_TPI	83951657
#define NFB$C_PLI_COL	84017216
#define NFB$C_PLI_NAM	84017217
#define NFB$C_PLI_VMSNAM	84017218
#define NFB$C_PLI_CHR	84017219
#define NFB$C_PLI_CNT	84017220
#define NFB$C_PLI_MCD	84017221
#define NFB$C_PLI_HWA	84017222
#define NFB$C_PLI_DEVNAM	84017223
#define NFB$C_PLI_NET	84017224
#define NFB$C_EFI_LCK	100663297
#define NFB$C_EFI_SIN	100728848
#define NFB$C_EFI_SP1	100728849
#define NFB$C_EFI_B1	100728850
#define NFB$C_EFI_B2	100728851
#define NFB$C_EFI_COL	100794432
#define NFB$C_EFI_EVE	100794433
#define NFB$C_EFI_SB1	100794434
#define NFB$C_EFI_SB2	100794435
#define NFB$C_EFI_SB3	100794436
#define NFB$C_ESI_LCK	117440513
#define NFB$C_ESI_SNK	117506064
#define NFB$C_ESI_STA	117506065
#define NFB$C_ESI_SP1	117506066
#define NFB$C_ESI_B1	117506067
#define NFB$C_ESI_B2	117506068
#define NFB$C_ESI_COL	117571648
#define NFB$C_ESI_LNA	117571649
#define NFB$C_ESI_SB1	117571650
#define NFB$C_ESI_SB2	117571651
#define NFB$C_ESI_SB3	117571652
#define NFB$C_LLI_LCK	134217729
#define NFB$C_LLI_DLY	134283280
#define NFB$C_LLI_STA	134283281
#define NFB$C_LLI_LLN	134283282
#define NFB$C_LLI_RLN	134283283
#define NFB$C_LLI_PNA	134283284
#define NFB$C_LLI_PID	134283285
#define NFB$C_LLI_IPID	134283286
#define NFB$C_LLI_XWB	134283287
#define NFB$C_LLI_CNT	134283288
#define NFB$C_LLI_COL	134348864
#define NFB$C_LLI_USR	134348865
#define NFB$C_LLI_PRC	134348866
#define NFB$C_LLI_PNN	134348867
#define NFB$C_LLI_RID	134348868
#define NFB$C_XNI_LCK	150994945
#define NFB$C_XNI_MNS_FILL	150994946
#define NFB$C_XNI_CAT	151060496
#define NFB$C_XNI_CLT	151060497
#define NFB$C_XNI_DBL	151060498
#define NFB$C_XNI_DWI	151060499
#define NFB$C_XNI_MBL	151060500
#define NFB$C_XNI_MCL	151060501
#define NFB$C_XNI_MRS	151060502
#define NFB$C_XNI_MST	151060503
#define NFB$C_XNI_MWI	151060504
#define NFB$C_XNI_RST	151060505
#define NFB$C_XNI_STT	151060506
#define NFB$C_XNI_COL	151126080
#define NFB$C_XNI_NETENT	151126081
#define NFB$C_XNI_PROF	151126082
#define NFB$C_XDI_LCK	184549377
#define NFB$C_XDI_ACH	184614928
#define NFB$C_XDI_ASW	184614929
#define NFB$C_XDI_CTM	184614930
#define NFB$C_XDI_MCH	184614931
#define NFB$C_XDI_STA	184614932
#define NFB$C_XDI_SUB	184614933
#define NFB$C_XDI_MCI	184614934
#define NFB$C_XDI_CAT	184614935
#define NFB$C_XDI_CLT	184614936
#define NFB$C_XDI_DBL	184614937
#define NFB$C_XDI_DWI	184614938
#define NFB$C_XDI_MBL	184614939
#define NFB$C_XDI_MCL	184614940
#define NFB$C_XDI_MRS	184614941
#define NFB$C_XDI_MST	184614942
#define NFB$C_XDI_MWI	184614943
#define NFB$C_XDI_RST	184614944
#define NFB$C_XDI_STT	184614945
#define NFB$C_XDI_MODE	184614946
#define NFB$C_XDI_ITT	184614947
#define NFB$C_XDI_COL	184680512
#define NFB$C_XDI_DTE	184680513
#define NFB$C_XDI_CHN	184680514
#define NFB$C_XDI_LIN	184680515
#define NFB$C_XDI_DNT	184680516
#define NFB$C_XDI_CNT	184680517
#define NFB$C_XGI_LCK	167772161
#define NFB$C_XGI_GNM	167837712
#define NFB$C_XGI_GTY	167837713
#define NFB$C_XGI_COL	167903296
#define NFB$C_XGI_GRP	167903297
#define NFB$C_XGI_GDT	167903298
#define NFB$C_XGI_GNT	167903299
#define NFB$C_XS5_LCK	201326593
#define NFB$C_XS5_MCI	201392144
#define NFB$C_XS5_STA	201392145
#define NFB$C_XS5_ACI	201392146
#define NFB$C_XS5_CTM	201392147
#define NFB$C_XS5_COL	201457728
#define NFB$C_XS5_CNT	201457729
#define NFB$C_XD5_LCK	218103809
#define NFB$C_XD5_PRI	218169360
#define NFB$C_XD5_SAD	218169361
#define NFB$C_XD5_NOD	218169362
#define NFB$C_XD5_RED	218169363
#define NFB$C_XD5_COL	218234944
#define NFB$C_XD5_DST	218234945
#define NFB$C_XD5_CMK	218234946
#define NFB$C_XD5_CVL	218234947
#define NFB$C_XD5_GRP	218234948
#define NFB$C_XD5_SDTE	218234949
#define NFB$C_XD5_OBJ	218234950
#define NFB$C_XD5_FIL	218234951
#define NFB$C_XD5_USR	218234952
#define NFB$C_XD5_PSW	218234953
#define NFB$C_XD5_ACC	218234954
#define NFB$C_XD5_CDTE	218234955
#define NFB$C_XD5_RDTE	218234956
#define NFB$C_XD5_NET	218234957
#define NFB$C_XD5_EMK	218234958
#define NFB$C_XD5_EVL	218234959
#define NFB$C_XD5_ACL	218234960
#define NFB$C_XD5_IDTE	218234961
#define NFB$C_XS9_LCK	234881025
#define NFB$C_XS9_MCI	234946576
#define NFB$C_XS9_STA	234946577
#define NFB$C_XS9_ACI	234946578
#define NFB$C_XS9_CTM	234946579
#define NFB$C_XS9_COL	235012160
#define NFB$C_XS9_CNT	235012161
#define NFB$C_XD9_LCK	251658241
#define NFB$C_XD9_PRI	251723792
#define NFB$C_XD9_SAD	251723793
#define NFB$C_XD9_NOD	251723794
#define NFB$C_XD9_RED	251723795
#define NFB$C_XD9_COL	251789376
#define NFB$C_XD9_DST	251789377
#define NFB$C_XD9_CMK	251789378
#define NFB$C_XD9_CVL	251789379
#define NFB$C_XD9_GRP	251789380
#define NFB$C_XD9_SDTE	251789381
#define NFB$C_XD9_OBJ	251789382
#define NFB$C_XD9_FIL	251789383
#define NFB$C_XD9_USR	251789384
#define NFB$C_XD9_PSW	251789385
#define NFB$C_XD9_ACC	251789386
#define NFB$C_XD9_CDTE	251789387
#define NFB$C_XD9_RDTE	251789388
#define NFB$C_XD9_NET	251789389
#define NFB$C_XD9_EMK	251789390
#define NFB$C_XD9_EVL	251789391
#define NFB$C_XD9_ACL	251789392
#define NFB$C_XD9_IDTE	251789393
#define NFB$C_XTI_LCK	268435457
#define NFB$C_XTI_STA	268501008
#define NFB$C_XTI_BFZ	268501009
#define NFB$C_XTI_CPL	268501010
#define NFB$C_XTI_MBK	268501011
#define NFB$C_XTI_MBF	268501012
#define NFB$C_XTI_MVR	268501013
#define NFB$C_XTI_COL	268566592
#define NFB$C_XTI_FNM	268566593
#define NFB$C_XTT_LCK	285212673
#define NFB$C_XTT_TST	285278224
#define NFB$C_XTT_CPS	285278225
#define NFB$C_XTT_COL	285343808
#define NFB$C_XTT_TPT	285343809
#define NFB$C_XAI_LCK	452984833
#define NFB$C_XAI_NDA	453050384
#define NFB$C_XAI_COL	453115968
#define NFB$C_XAI_NET	453115969
#define NFB$C_XAI_USR	453115970
#define NFB$C_XAI_PSW	453115971
#define NFB$C_XAI_ACC	453115972
#define NFB$C_XAI_NOD	453115973
#define NFB$C_XDTE_LCK	352321537
#define NFB$C_XDTE_COL	352452672
#define NFB$C_XDTE_NET	352452673
#define NFB$C_XDTE_DTE	352452674
#define NFB$C_XDTE_ID	352452675
#define NFB$C_XDTE_ACL	352452676
#define NFB$C_SPI_LCK	301989889
#define NFB$C_SPI_PRL	301989890
#define NFB$C_SPI_PID	302055440
#define NFB$C_SPI_IRP	302055441
#define NFB$C_SPI_CHN	302055442
#define NFB$C_SPI_RNA	302055443
#define NFB$C_SPI_COL	302121024
#define NFB$C_SPI_ACS	302121025
#define NFB$C_SPI_RID	302121026
#define NFB$C_SPI_SFI	302121027
#define NFB$C_SPI_NCB	302121028
#define NFB$C_SPI_PNM	302121029
#define NFB$C_AJI_LCK	318767105
#define NFB$C_AJI_REA	318767106
#define NFB$C_AJI_RRA	318767107
#define NFB$C_AJI_ADD	318832656
#define NFB$C_AJI_TYP	318832657
#define NFB$C_AJI_LIT	318832658
#define NFB$C_AJI_BLO	318832659
#define NFB$C_AJI_RPR	318832660
#define NFB$C_AJI_COL	318898240
#define NFB$C_AJI_NNA	318898241
#define NFB$C_AJI_CIR	318898242
#define NFB$C_SDI_LCK	436207617
#define NFB$C_SDI_SUB	436273168
#define NFB$C_SDI_PID	436273169
#define NFB$C_SDI_COL	436338752
#define NFB$C_SDI_CIR	436338753
#define NFB$C_SDI_PHA	436338754
#define NFB$C_SDI_PRC	436338755
#define NFB$C_ARI_LCK	335544321
#define NFB$C_ARI_REA	335544322
#define NFB$C_ARI_ADD	335609872
#define NFB$C_ARI_DCO	335609873
#define NFB$C_ARI_DHO	335609874
#define NFB$C_ARI_NND	335609875
#define NFB$C_ARI_COL	335675456
#define NFB$C_ARI_DLI	335675457
