c-----------------------------------------------------------------------------
	integer Function Get_DECnet_Node(link,node,site)

c  Get the remote DECnet node name given a link found in the UCB
c  for the remote terminal.  Taken from Craig Leres (lbl) Ratfor routine.
c  His comments follow.

c	### rmtinfo - get remote terminal info
c	#
c	# synopsis
c	#
c	#    integer status, link, node
c	#    character site(7)
c	#    status = rmtinfo ( link, node, site )
c	#
c	#	link - rtt link number
c	#	node - returned DECnet node number
c	#	site - character string to receive site name
c	#	status - VMS return status
c	#
c	# Given the link number (as found in the ucb$w_rtt_link offset in the
c	# unit control block of a remote terminal), this routine consults NETACP
c	# to get the node number and site name of the DECnet host the remote
c	# terminal is attached to. The privilege NETMBX is required for use.
c	#
c	# Warning: This routine is chalked full of undocumented MAGIC.
c	#
	Parameter NFB$C_FC_SHOW = '00000022'X
	Parameter NFB$M_NOUPD	= '00000004'X
	Parameter NFB$C_DB_LLI	= '00000008'X
	Parameter NFB$C_OP_EQL	= '00000000'X
	Parameter NFB$C_LLI_LLN	= '08010012'X
	Parameter NFB$C_WILDCARD= '00000001'X
	Parameter NFB$C_LLI_PNA	= '08010014'X
	Parameter NFB$C_LLI_PNN	= '08020043'X
	Parameter NFB$C_ENDOFLIST= '00000000'X

	Parameter NFB_SIZE	= 28	!	# one gronk + 3 long
	Parameter BUF_SIZE	= 13	!	# long + word + 7 byte string
	Integer*2		link
	Integer		node,enode
	character*7	site,esite

	Integer i, status, chan, sys$assign, sys$qiow
	integer net_dsc(2), nfb_dsc(2), key_dsc(2), key(2), buf_dsc(2)
	Character Net_str*4 /'NET:'/
	integer k1, k2, f1, f2, f3
	integer*2 c1, c2, iosb(4), elen
	logical init/.false./
	byte nfb(NFB_SIZE), buf(BUF_SIZE)
	equivalence (nfb(5), k1), (nfb(9), k2), (nfb(13), c1), (nfb(15), c2)
	equivalence (nfb(17), f1), (nfb(21), f2), (nfb(25), f3)
	equivalence (buf(1), enode), (buf(5), elen), (buf(7), esite)
	external ss$_normal, io$_acpcontrol

	site = ' '

	Net_dsc(1) = len(Net_Str)
	Net_dsc(2) = %loc(Net_Str)
	status = sys$assign ( Net_dsc, chan, , )
	if ( status .ne. %loc(ss$_normal) ) then
	    Call Lib$Signal(%Val(status))
	    Return
	End if

	nfb(1) = NFB$C_FC_SHOW
	nfb(2) = NFB$M_NOUPD	!	# don't update the database
	nfb(3) = NFB$C_DB_LLI	!	# logical link information database
	nfb(4) = NFB$C_OP_EQL	!	# match the key exactly
	k1 = NFB$C_LLI_LLN	!	# the key is a logical link number
	k2 = NFB$C_WILDCARD	!	# search the whole database
	c1 = 0			!	# must be zero
	c2 = 0			!	# let counted strings vary in length
	f1 = NFB$C_LLI_PNA	!	# partner's node address
	f2 = NFB$C_LLI_PNN	!	# partner's node name
	f3 = NFB$C_ENDOFLIST

	nfb_dsc(1) = NFB_SIZE
	nfb_dsc(2) = %loc(nfb)

	key_dsc(1) = 8
	key_dsc(2) = %loc(key)
	key(1) = 0
	key(2) = link

	buf_dsc(1) = BUF_SIZE
	buf_dsc(2) = %loc(buf)

	status = sys$qiow (,%val(chan),%val(%loc(io$_acpcontrol)),iosb,,,
	1    nfb_dsc,key_dsc,,buf_dsc,,)
	if ( status .ne. %loc(ss$_normal) ) then
	    Call Lib$Signal(%Val(status))
	    Call sys$dassgn (%Val(chan))
	    Return
	End if
	if ( iosb(1) .ne. %loc(ss$_normal) ) then
	    Call Lib$Signal(%Val(iosb(1)))
	    Call sys$dassgn (%Val(chan))
	    Return
	End if

	Call sys$dassgn (%Val(chan))

	site = esite(:elen)
	node = enode

	return

	end
