/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:44:43 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFAE.S */
#ifndef $ACRDEF_H
#define $ACRDEF_H
 
/*** MODULE $ACRDEF ***/
/*+                                                                           */
/* ACRDEF - ACCOUNTING RECORD DEFINITIONS                                     */
/*                                                                            */
/***********************************************************************      */
/* NOTE:  IF ANY FIELDS CHANGE, A NEW VERSION NUMBER MUST BE ADDED AND *      */
/*         "ACR$K_CURVER" EQUATED TO IT.                                      *       */
/***********************************************************************      */
/*                                                                            */
/*-                                                                           */
/* RECORD/PACKET VERSIONS (ACR$V_VERSION)                                     */
#define ACR$K_VERSION2 0        /* VMS VERSION 2 ACCOUNTING FORMAT            */
#define ACR$K_VERSION3T 1       /* VMS VERSION 3 FIELD TEST                   */
#define ACR$K_VERSION3 2        /* VMS VERSION 3 ACCOUNTING FORMAT            */
#define ACR$K_CURVER 2  /* CURRENT FORMAT VERSION NUMBER                      */
#define ACR$M_PACKET 0x00000001
#define ACR$M_TYPE 0x000000FE
#define ACR$M_SUBTYPE 0x00000F00
#define ACR$M_VERSION 0x00007000
#define ACR$M_CUSTOMER 0x00008000
#define ACR$K_PRCDEL 1  /* PROCESS DELETE                                     */
#define ACR$K_PRCPUR 2  /* PROCESS PURGE                                      */
#define ACR$K_IMGDEL 3  /* IMAGE DELETE                                       */
#define ACR$K_IMGPUR 4  /* IMAGE PURGE                                        */
#define ACR$K_SYSINIT 5 /* SYSTEM INITIALIZATION                              */
#define ACR$K_SETTIME 6 /* SET SYSTEM TIME                                    */
#define ACR$K_LOGFAIL 7 /* LOGIN VALIDATION FAILURE                           */
#define ACR$K_PRINT 8   /* PRINT JOB                                          */
#define ACR$K_USER 9    /* USER SUPPLIED DATA                                 */
#define ACR$K_ENABLE 10 /* ACC. MANG. FUNCTION ENABLE                         */
#define ACR$K_DISABLE 11        /* ACC. MANG. FUNCTION DISABLE                */
#define ACR$K_ALTACM 12 /* DECLARE ALTERNATE ACC. MANG.                       */
#define ACR$K_FILE_FL 13        /* ACCOUNTING FILE - FORWARD LINK             */
#define ACR$K_FILE_BL 14        /* ACCOUNTING FILE - BACKWARD LINK            */
/* RECORD SUBTYPE (ACR$V_SUBTYPE) CONSTANTS                                   */
#define ACR$K_INTERACTIVE 1     /* INTERACTIVE PROCESS                        */
#define ACR$K_SUBPROCESS 2      /* SUBPROCESS                                 */
#define ACR$K_DETACHED 3        /* DETACHED PROCESS                           */
#define ACR$K_BATCH 4   /* BATCH PROCESS                                      */
#define ACR$K_NETWORK 5 /* NETWORK PROCESS                                    */
/* PACKET TYPE (ACR$V_TYPE) CONSTANTS                                         */
#define ACR$K_ID 1      /* IDENTIFICATION PACKET                              */
#define ACR$K_RESOURCE 2        /* RESOURCE USAGE PACKET                      */
#define ACR$K_IMAGENAME 3       /* IMAGENAME PACKET                           */
#define ACR$K_FILENAME 4        /* FILENAME PACKET                            */
#define ACR$K_USER_DATA 5       /* USER DATA PACKET                           */
struct acrdef {
    union {
        unsigned short int acr$w_type;  /* RECORD/PACKET TYPE                 */
        struct {
            unsigned acr$v_packet : 1;  /* RECORD(0)/PACKET(1)                */
            unsigned acr$v_type : 7;    /* RECORD/PACKET TYPE                 */
            unsigned acr$v_subtype : 4; /* RECORD/PACKET SUBTYPE              */
            unsigned acr$v_version : 3; /* RECORD/PACKET VERSION NUMBER       */
            unsigned acr$v_customer : 1;        /* DIGITAL(0)/CUSTOMER(1)     */
            } acr$r_type_bits;
/* RECORD TYPE (ACR$V_TYPE) CONSTANTS                                         */
        } acr$r_type_overlay;
    unsigned short int acr$w_length;    /* RECORD OR PACKET LENGTH            */
/*                                                                            */
/* RECORD HEADER                                                              */
/*                                                                            */
} ;
#define ACR$K_HDRLEN 12 /* RECORD HEADER LENGTH                               */
#define ACR$C_HDRLEN 12 /* RECORD HEADER LENGTH                               */
/*                                                                            */
struct acrdef1 {
    char acrdef$$_fill_2 [4];
    unsigned int acr$q_systime [2];     /* EVENT SYSTEM TIME                  */
/* IDENTIFICATION PACKET                                                      */
/*                                                                            */
} ;
#define ACR$K_IDVAR 46  /* BEGINNING OF VARIABLE STORAGE AREA                 */
#define ACR$C_IDVAR 46  /* BEGINNING OF VARIABLE STORAGE AREA                 */
/*                                                                            */
struct acrdef2 {
    char acrdef$$_fill_3 [4];
    unsigned long int acr$l_pid;        /* PROCESS ID                         */
    unsigned long int acr$l_owner;      /* OWNER PROCES ID                    */
    union {
        unsigned long int acr$l_uic;    /* PROCESS UIC                        */
        struct {
            unsigned short int acr$w_mem;       /* MEMBER UIC                 */
            unsigned short int acr$w_grp;       /* GROUP UIC                  */
            } acr$r_uic_fields;
        } acr$r_uic_overlay;
    unsigned int acr$q_priv [2];        /* PROCESS PRIV                       */
    unsigned char acr$b_pri;    /* PROCESS PRIORITY                           */
    char acrdef$$_fill_1;       /* SPARE                                      */
    unsigned short int acr$w_username;  /* USERNAME OFFSET                    */
    unsigned short int acr$w_account;   /* ACCOUNT NAME OFFSET                */
    unsigned short int acr$w_nodename;  /* NODE NAME OFFSET                   */
    unsigned short int acr$w_terminal;  /* TERMINAL NAME OFFSET               */
    unsigned short int acr$w_jobname;   /* JOB NAME OFFSET                    */
    unsigned long int acr$l_jobid;      /* JOB ID                             */
    unsigned short int acr$w_queue;     /* QUEUE NAME OFFSET                  */
    unsigned short int acr$w_nodeaddr;  /* REMOTE NODE ADDRESS                */
    unsigned short int acr$w_remoteid;  /* REMOTE ID OFFSET                   */
/* RESOURCE PACKET                                                            */
/*                                                                            */
} ;
struct acrdef3 {
    char acrdef$$_fill_4 [4];
    unsigned int acr$q_login [2];       /* PROCESS/IMAGE START TIME           */
    unsigned long int acr$l_status;     /* PROCESS/IMAGE FINAL STATUS         */
    unsigned long int acr$l_imgcnt;     /* IMAGE EXECUTION COUNT/SEQUENCE NUMBER      */
    unsigned long int acr$l_cputime;    /* PROCESS/IMAGE CPU TIME             */
    unsigned long int acr$l_faults;     /* PROCESS/IMAGE PAGE FAULT COUNT     */
    unsigned long int acr$l_faultio;    /* PROCESS/IMAGE PAGE FAULT I/O COUNT */
    unsigned long int acr$l_wspeak;     /* PROCESS/IMAGE WORKING SET PEAK     */
    unsigned long int acr$l_pagefl;     /* PROCESS/IMAGE PEAK PAGE FILE USAGE */
    unsigned long int acr$l_diocnt;     /* PROCESS/IMAGE DIRECT I/O COUNT     */
    unsigned long int acr$l_biocnt;     /* PROCESS/IMAGE BUFFERED I/O COUNT   */
    unsigned long int acr$l_volumes;    /* PROCESS/IMAGE VOLUME MOUNT COUNT   */
/*                                                                            */
/* IMAGENAME PACKET                                                           */
/*                                                                            */
} ;
struct acrdef4 {
    char acrdef$$_fill_5 [4];
    char acr$t_imagename [256]; /* IMAGENAME                                  */
/*                                                                            */
/* PRINT RESOURCE PACKET                                                      */
/*                                                                            */
} ;
struct acrdef5 {
    char acrdef$$_fill_6 [4];
    unsigned long int acr$l_printsts;   /* JOB STATUS                         */
    unsigned int acr$q_quetime [2];     /* TIME JOB WAS QUEUED                */
    unsigned int acr$q_begtime [2];     /* TIME JOB WAS BEGUN                 */
    unsigned long int acr$l_symcputim;  /* SYMBIONT CPU TIME                  */
    unsigned long int acr$l_pagecnt;    /* TOTAL PAGES PRINTED                */
    unsigned long int acr$l_qiocnt;     /* TOTAL QIOS ISSUED                  */
    unsigned long int acr$l_getcnt;     /* TOTAL GETS ISSUED                  */
/*                                                                            */
/* FILENAME PACKET                                                            */
/*                                                                            */
} ;
struct acrdef6 {
    char acrdef$$_fill_7 [4];
    char acr$t_filename [256];  /* FILENAME                                   */
/*                                                                            */
/* USER DATA PACKET                                                           */
/*                                                                            */
} ;
struct acrdef7 {
    char acrdef$$_fill_8 [4];
    char acr$t_user_data [256]; /* USER DATA                                  */
} ;
#endif
