/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:46:33 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFMP.S */
#ifndef $PR8SSDEF_H
#define $PR8SSDEF_H
 
/*** MODULE $PR8SSDEF ***/
#define PR8SS$_IPIR 22  /* Interprocessor Interrupt Reg.                      */
#define PR8SS$_NICR 25  /* Interval Clock Next Interval Register              */
#define PR8SS$_ICR 26   /* Interval Clock Interval Count Register             */
#define PR8SS$_TODR 27  /* Time Of Day Register                               */
#define PR8SS$_TBDR 36  /* Translation Buffer Disable Register                */
#define PR8SS$_CADR 37  /* Cache Disable Register                             */
#define PR8SS$_MCESR 38 /* Machine Check Error Summary Register               */
#define PR8SS$_ACCS 40  /* Floating Point Accellerator Register               */
#define PR8SS$_WCSA 44  /* WCS Address Register                               */
#define PR8SS$_WCSD 45  /* WCS Data Register                                  */
#define PR8SS$_WCSC 46  /* WCS Cam Register                                   */
#define PR8SS$_PME 61   /* Performance Monitor Enable                         */
#define PR8SS$_RXCS1 80 /* Serial Line 1 Receive CSR                          */
#define PR8SS$_RXDB1 81 /* Serial Line 1 Receive Data Buffer                  */
#define PR8SS$_TXCS1 82 /* Serial Line 1 Transmit CSR                         */
#define PR8SS$_TXDB1 83 /* Serial Line 1 Transmit Data Buffer                 */
#define PR8SS$_RXCS2 84 /* Serial Line 2 Receive CSR                          */
#define PR8SS$_RXDB2 85 /* Serial Line 2 Receive Data Buffer                  */
#define PR8SS$_TXCS2 86 /* Serial Line 2 Transmit CSR                         */
#define PR8SS$_TXDB2 87 /* Serial Line 2 Transmit Data Buffer                 */
#define PR8SS$_RXCS3 88 /* Serial Line 3 Receive CSR                          */
#define PR8SS$_RXDB3 89 /* Serial Line 3 Receive Data Buffer                  */
#define PR8SS$_TXCS3 90 /* Serial Line 3 Transmit CSR                         */
#define PR8SS$_TXDB3 91 /* Serial Line 3 Transmit Data Buffer                 */
#define PR8SS$_RXCD 92  /* Receive Console Data Register                      */
#define PR8SS$_CACHEX 93        /* Cache Invalidate Register                  */
#define PR8SS$_BINID 94 /* BI Node ID Register                                */
#define PR8SS$_BIINIT 95        /* BI Init Nodes Register                     */
#define PR8SS$M_SID_SECP 0x00000100
#define PR8SS$M_RXCS_IE 0x00000040
#define PR8SS$M_RXCS_DONE 0x00000080
#define PR8SS$M_RXDB_ERR 0x00008000
#define PR8SS$M_TXCS_IE 0x00000040
#define PR8SS$M_TXCS_RDY 0x00000080
#define PR8SS$M_TXCS_BRE 0x00000100
#define PR8SS$_BAUD300 0        /* Baud Rate of 300                           */
#define PR8SS$_BAUD600 1        /* Baud Rate of 600                           */
#define PR8SS$_BAUD1200 2       /* Baud Rate of 1200                          */
#define PR8SS$_BAUD2400 3       /* Baud Rate of 2400                          */
#define PR8SS$_BAUD4800 4       /* Baud Rate of 4800                          */
#define PR8SS$_BAUD9600 5       /* Baud Rate of 9600                          */
#define PR8SS$_BAUD19200 6      /* Baud Rate of 19200                         */
#define PR8SS$_BAUD38400 7      /* Baud Rate of 38400                         */
#define PR8SS$_BOOTCPU 2        /* Boot CPU Command                           */
#define PR8SS$_CLRWARM 3        /* Clear Warm-start Flag                      */
#define PR8SS$_CLRCOLD 4        /* Clear Cold-start Flag                      */
#define PR8SS$M_CADR_D 0x00000001
#define PR8SS$M_CADR_H 0x00000002
#define PR8SS$M_RXCD_BSY 0x00008000
union pr8ssdef {
    struct {    /* Read only SID register                                     */
        unsigned pr8ss$v_sid_ucrev : 8; /* Ucode Revision Level               */
        unsigned pr8ss$v_sid_secp : 1;  /* Secondary Patch Bit                */
        unsigned pr8ss$v_sid_patrev : 10;       /* Patch Rev Level            */
        unsigned pr8ss$v_sid_cpurev : 5;        /* CPU Rev level              */
        unsigned pr8ss$v_sid_type : 8;  /* CPU Type Code                      */
        } pr8ss$r_pr8sssid_bits;
    struct {    /* Console RCV CSR                                            */
        unsigned pr8ss$$_fill_1 : 6;    /*                                    */
        unsigned pr8ss$v_rxcs_ie : 1;   /* Interrupt Enable                   */
        unsigned pr8ss$v_rxcs_done : 1; /* 1=> Char. received                 */
        } pr8ss$r_pr8ssrxcs_bits;
    struct {    /* Console RCV Data Register                                  */
        unsigned pr8ss$v_rxdb_data : 8; /* Received Data                      */
        unsigned pr8ss$$_fill_2 : 7;    /*                                    */
        unsigned pr8ss$v_rxdb_err : 1;  /* Error                              */
        } pr8ss$r_pr8ssrxdb_bits;
    struct {    /* Console Transmit CSR                                       */
        unsigned pr8ss$$_fill_3 : 6;    /*                                    */
        unsigned pr8ss$v_txcs_ie : 1;   /* Interrupt Enable                   */
        unsigned pr8ss$v_txcs_rdy : 1;  /* Ready                              */
        unsigned pr8ss$v_txcs_bre : 1;  /* (WO) Baud Rate Enable              */
        unsigned pr8ss$$_fill_4 : 1;    /*                                    */
        unsigned pr8ss$v_txcs_baud : 3; /* Baud Rate                          */
/* Values to set baud rates                                                   */
        unsigned pr8ss$v_fill_25 : 3;
        } pr8ss$r_pr8sstxcs_bits;
    struct {    /* Console Transmit Data Register                             */
        unsigned pr8ss$v_txdb_data : 8; /* Data to Transmit                   */
        unsigned pr8ss$v_txdb_id : 4;   /* ID - Destination of                */
/*  transmitted data -                                                        */
/*  0=>UART0, F=>Console                                                      */
/*  command                                                                   */
/* Possible Console Commands                                                  */
        unsigned pr8ss$v_fill_26 : 4;
        } pr8ss$r_pr8sstxdb_bits;
    struct {    /* Cache Disable Register                                     */
        unsigned pr8ss$v_cadr_d : 1;    /* Disable Cache                      */
        unsigned pr8ss$v_cadr_h : 1;    /* Force 100% Cache Hits              */
        unsigned pr8ss$v_fill_27 : 6;
        } pr8ss$r_pr8sscadr_bits;
    struct {    /* WCS (Patch) Address Reg                                    */
        unsigned pr8ss$v_wcsa_data : 8; /* High Order Data Bits               */
        unsigned pr8ss$$_fill_4 : 8;    /*                                    */
        unsigned pr8ss$v_wcsa_ramadr : 16;      /* Ram Address                */
        } pr8ss$r_pr8sswcsa_bits;
    struct {    /* WCS (Patch) CAM Reg                                        */
        unsigned pr8ss$$_fill_5 : 8;    /*                                    */
        unsigned pr8ss$v_wcsc_camadr : 8;       /* Cam Address                */
        unsigned pr8ss$v_wcsc_romadr : 16;      /* Rom Address                */
        } pr8ss$r_pr8sswcsc_bits;
    struct {    /* Receive Console Data Register                              */
        unsigned pr8ss$v_rxcd_data : 8; /* Received Data                      */
        unsigned pr8ss$v_rxcd_nodeid : 4;       /* Sender's Node ID           */
        unsigned pr8ss$$_fill_6 : 3;    /*                                    */
        unsigned pr8ss$v_rxcd_bsy : 1;  /* Set=>Data has been received        */
        } pr8ss$r_pr8ssrxcd_bits;
    struct {    /* Cache Invalidate Register                                  */
        unsigned pr8ss$$_fill_7 : 9;    /*                                    */
        unsigned pr8ss$v_cachex_pfn : 21;       /* Physical Page Number       */
        unsigned pr8ss$v_fill_28 : 2;
        } pr8ss$r_pr8sscachex_bits;
    struct {    /* BI Node ID Register                                        */
        unsigned pr8ss$v_binid_nid : 4; /* BI Node ID this node               */
        unsigned pr8ss$v_fill_29 : 4;
        } pr8ss$r_pr8ssbinid_bits;
} ;
#endif
