/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:37:41 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]OBJFMT.SDI; */
#ifndef OBJFMT_H
#define OBJFMT_H
 
/*** MODULE $OBJRECDEF ***/
#define OBJ$C_HDR 0     /*Module header record                                */
#define OBJ$C_HDR_MHD 0 /* Main header record                                 */
#define OBJ$C_HDR_LNM 1 /* Language processor record                          */
#define OBJ$C_HDR_SRC 2 /* Source files description                           */
#define OBJ$C_HDR_TTL 3 /* Title text                                         */
#define OBJ$C_HDR_CPR 4 /* Copyright text                                     */
#define OBJ$C_HDR_MTC 5 /* Maintenance text                                   */
#define OBJ$C_HDR_GTX 6 /* General text                                       */
#define OBJ$C_GSD 1     /*Global symbol definition record                     */
#define OBJ$C_GSD_PSC 0 /* P-sect definition                                  */
#define OBJ$C_GSD_SYM 1 /* Symbol (simple) definition                         */
#define OBJ$C_GSD_EPM 2 /* Entry point definition                             */
#define OBJ$C_GSD_PRO 3 /* Procedure definition                               */
#define OBJ$C_GSD_SYMW 4        /* Symbol definition with word psect          */
#define OBJ$C_GSD_EPMW 5        /* Entry point definition with word psect     */
#define OBJ$C_GSD_PROW 6        /* Procedure definition with word psect       */
#define OBJ$C_GSD_IDC 7 /* Random entity check                                */
#define OBJ$C_GSD_ENV 8 /* Environment definition                             */
#define OBJ$C_GSD_LSY 9 /* Local symbol definition/reference                  */
#define OBJ$C_GSD_LEPM 10       /* Local symbol entry point def.              */
#define OBJ$C_GSD_LPRO 11       /* Local symbol procedure def.                */
#define OBJ$C_GSD_SPSC 12       /* Shareable image psect definition           */
#define OBJ$C_TIR 2     /*Text information record                             */
#define OBJ$C_EOM 3     /*End of module record                                */
#define OBJ$C_DBG 4     /*Debugger information record                         */
#define OBJ$C_TBT 5     /*Traceback information record                        */
#define OBJ$C_LNK 6     /*Linker options record                               */
#define OBJ$C_EOMW 7    /*End of module record with word psect                */
#define OBJ$C_MAXRECTYP 7       /*Last assigned record type                   */
#define OBJ$K_SUBTYP 1
#define OBJ$C_SUBTYP 1
#define OBJ$C_MAXRECSIZ 2048    /*Maximum legal record size                   */
#define OBJ$C_STRLVL 0  /*Structure level                                     */
#define OBJ$C_SYMSIZ 31 /*Maximum symbol length                               */
#define OBJ$C_STOREPLIM -1      /*Maximum repeat count on store commands      */
#define OBJ$C_PSCALILIM 9       /*Maximum p-sect alignment                    */
struct objrecdef {
    unsigned char obj$b_rectyp; /*First byte always record type               */
/*Permissable record types                                                    */
    unsigned char obj$b_subtyp; /*Record sub-type byte                        */
    unsigned char obj$b_mhd_strlv;      /*Structure level                     */
    union {
        unsigned short int obj$w_mhd_recsz;     /*Maximum record size         */
        struct {
            char objrecdef$$_fill_1 [2];
            char obj$t_mhd_name [];     /*Module name field                   */
/*Misc. constants                                                             */
            } obj$r_mhd_recsz_fields;
        } obj$r_mhd_recsz_overlay;
} ;
 
/*** MODULE $MHDEF ***/
/*                                                                            */
/* Module header record (MHD)                                                 */
/*                                                                            */
#define MHD$C_MHD 0     /*Main header record                                  */
#define MHD$C_LNM 1     /*Language name and version                           */
#define MHD$C_SRC 2     /*Source file specification                           */
#define MHD$C_TTL 3     /*Title text of module                                */
#define MHD$C_CPR 4     /*Copyright notice                                    */
#define MHD$C_MTC 5     /*Maintenence status                                  */
#define MHD$C_GTX 6     /*General text                                        */
#define MHD$C_MAXHDRTYP 6       /*Maximum allowable type                      */
struct mhdef {
    unsigned char mhd$b_rectyp; /*Record type (OBJ$C_MHD)                     */
    unsigned char mhd$b_hdrtyp; /*Type field for MHD                          */
/*Types of header records                                                     */
    unsigned char mhd$b_strlvl; /*Structure level                             */
    unsigned short int mhd$w_recsiz;    /*Maximum record size                 */
    unsigned char mhd$b_namlng; /*Module name length                          */
    char mhd$t_name [31];       /*Module name                                 */
/*                                        /*Module version (ASCIC)            */
/*                                        /*Creation date/time (17 bytes)     */
/*                                        /*Time of last patch (17 bytes)     */
} ;
 
/*** MODULE $EOMDEF ***/
/*                                                                            */
/* End of module record (EOM)                                                 */
/*                                                                            */
#define EOM$C_SUCCESS 0 /*Successful (no errors)                              */
#define EOM$C_WARNING 1 /*Warnings issued                                     */
#define EOM$C_ERROR 2   /*Errors detected                                     */
#define EOM$C_ABORT 3   /*Abort the link                                      */
#define EOM$K_EOMMIN 2  /*Min length of EOM record                            */
#define EOM$C_EOMMIN 2  /*Min length of EOM record                            */
#define EOM$K_EOMMX1 7  /*Length of EOM record w/o transfer flags             */
#define EOM$C_EOMMX1 7  /*Length of EOM record w/o transfer flags             */
#define EOM$K_EOMMAX 8  /*Maximum length of EOM record                        */
#define EOM$C_EOMMAX 8  /*Maximum length of EOM record                        */
#define EOM$M_WKTFR 0x00000001
struct eomdef {
    unsigned char eom$b_rectyp; /*Record type (OBJ$C_EOM)                     */
    unsigned char eom$b_comcod; /*Compiler completion code                    */
/*Values                                                                      */
    unsigned char eom$b_psindx; /*P-sect of transfer address                  */
    unsigned long int eom$l_tfradr;     /*Transfer address                    */
    union {
        unsigned char eom$b_tfrflg;     /*Transfer address flags              */
        struct {
            unsigned eom$v_wktfr : 1;   /*Transfer address is weak            */
            unsigned eom$v_fill_0 : 7;
            } eom$r_tfrflg_bits;
        } eom$r_tfrflg_overlay;
} ;
 
/*** MODULE $EOMWDEF ***/
/*                                                                            */
/* End of module record with word of psect (EOMW)                             */
/*                                                                            */
#define EOMW$K_EOMMIN 2 /*Min length of EOM record                            */
#define EOMW$C_EOMMIN 2 /*Min length of EOM record                            */
#define EOMW$K_EOMMX1 8 /*Length of EOMW record w/o transfer flags            */
#define EOMW$C_EOMMX1 8 /*Length of EOMW record w/o transfer flags            */
#define EOMW$K_EOMMAX 9 /*Maximum length of EOMW record                       */
#define EOMW$C_EOMMAX 9 /*Maximum length of EOMW record                       */
#define EOMW$M_WKTFR 0x00000001
struct eomwdef {
    unsigned char eomw$b_rectyp;        /*Record type (OBJ$C_EOM)             */
    unsigned char eomw$b_comcod;        /*Compiler completion code            */
    unsigned short int eomw$w_psindx;   /*P-sect of transfer address          */
    unsigned long int eomw$l_tfradr;    /*Transfer address                    */
    union {
        unsigned char eomw$b_tfrflg;    /*Transfer address flags              */
        struct {
            unsigned eomw$v_wktfr : 1;  /*Transfer address is weak            */
            unsigned eomw$v_fill_1 : 7;
            } eomw$r_tfrflg_bits;
        } eomw$r_tfrflg_overlay;
} ;
 
/*** MODULE $LNKDEF ***/
/*                                                                            */
/* Linker Options Record (LNK)                                                */
/*                                                                            */
#define LNK$C_OLB 0     /* object library spec                                */
#define LNK$C_SHR 1     /* shareable image library spec                       */
#define LNK$C_OLI 2     /* object library with inclusion list                 */
#define LNK$C_OBJ 3     /* object file or symbol table file                   */
#define LNK$C_SHA 4     /* individually specified shr img                     */
#define LNK$C_MAXRECTYP 4       /* highest current record type                */
#define LNK$M_SELSER 0x00000001
#define LNK$M_LIBSRCH 0x00000002
struct lnkdef {
    unsigned char lnk$b_rectyp; /* record type LNK                            */
    unsigned char lnk$b_lnktyp; /* sub record type                            */
    union {
        unsigned short int lnk$w_flags;
        struct {
            unsigned lnk$v_selser : 1;  /* selectively searched (LNK$C_OBJ)   */
            unsigned lnk$v_libsrch : 1;
            unsigned lnk$v_fill_2 : 6;
            } lnk$r_flags_bits;
        } lnk$r_flags_overlay;
    union {
        unsigned short int lnk$w_namlng;        /* length of filespec name    */
        struct {
            char lnkdef$$_fill_1 [2];
            char lnk$t_name []; /* actual name                                */
            } lnk$r_namlng_fields;
        } lnk$r_namlng_overlay;
} ;
 
/*** MODULE $GSDEF ***/
/*                                                                            */
/* Global symbol definition record (GSD)                                      */
/*                                                                            */
#define GSD$K_ENTRIES 1 /*Offset to first entry in record                     */
#define GSD$C_ENTRIES 1 /*Offset to first entry in record                     */
#define GSD$C_PSC 0     /*Psect definition                                    */
#define GSD$C_SYM 1     /*Symbol specification                                */
#define GSD$C_EPM 2     /*Entry point and mask definition                     */
#define GSD$C_PRO 3     /*Procedure with formal arguments                     */
#define GSD$C_SYMW 4    /*Symbol specification with word psect                */
#define GSD$C_EPMW 5    /*Entry point mask with word psect                    */
#define GSD$C_PROW 6    /*Procedure with word psect                           */
#define GSD$C_IDC 7     /*Random entity check                                 */
#define GSD$C_ENV 8     /*Define environment                                  */
#define GSD$C_LSY 9     /*Local symbol                                        */
#define GSD$C_LEPM 10   /*Local symbol entry point definition                 */
#define GSD$C_LPRO 11   /*Local symbol procedure definition                   */
#define GSD$C_SPSC 12   /*Shareable image psect definition                    */
#define GSD$C_SYMV 13   /*Vectored (dual-valued) versions of SYM,             */
#define GSD$C_EPMV 14   /*      EPM,                                          */
#define GSD$C_PROV 15   /*      PRO                                           */
#define GSD$C_MAXRECTYP 15      /*Maximum entry type defined                  */
struct gsdef {
    unsigned char gsd$b_rectyp; /*Record type (OBJ$C_GSD)                     */
    unsigned char gsd$b_gsdtyp; /*Type of entry (first byte of entry)         */
} ;
 
/*** MODULE $GPSDEF ***/
/*                                                                            */
/* GSD entry - P-section definition                                           */
/*                                                                            */
#define GPS$M_PIC 0x00000001
#define GPS$M_LIB 0x00000002
#define GPS$M_OVR 0x00000004
#define GPS$M_REL 0x00000008
#define GPS$M_GBL 0x00000010
#define GPS$M_SHR 0x00000020
#define GPS$M_EXE 0x00000040
#define GPS$M_RD 0x00000080
#define GPS$M_WRT 0x00000100
#define GPS$M_VEC 0x00000200
#define GPS$K_NAME 9
#define GPS$C_NAME 9
struct gpsdef {
    union {
        unsigned char gps$b_gsdtyp;     /*Typ field                           */
        struct {
            char gps$t_start [];
            char gpsdef$$_fill_1;
            } gps$r_gsdtyp_fields;
        } gps$r_gsdtyp_overlay;
    unsigned char gps$b_align;  /*P-sect alignment                            */
    union {
        unsigned short int gps$w_flags; /*P-sect flags                        */
        struct {
            unsigned gps$v_pic : 1;     /*Position independent                */
            unsigned gps$v_lib : 1;     /*From a shareable image              */
            unsigned gps$v_ovr : 1;     /*Overlaid memory allocation          */
            unsigned gps$v_rel : 1;     /*Relocatable                         */
            unsigned gps$v_gbl : 1;     /*Global scope                        */
            unsigned gps$v_shr : 1;     /*Shareable                           */
            unsigned gps$v_exe : 1;     /*Executable                          */
            unsigned gps$v_rd : 1;      /*Readable                            */
            unsigned gps$v_wrt : 1;     /*Writeable                           */
            unsigned gps$v_vec : 1;     /*Vector psect                        */
            unsigned gps$v_fill_3 : 6;
            } gps$r_flags_bits;
        } gps$r_flags_overlay;
    unsigned long int gps$l_alloc;      /*Length of this contribution         */
    unsigned char gps$b_namlng; /*Length of p-sect name                       */
    char gps$t_name [31];       /*Name field                                  */
} ;
 
/*** MODULE $SGPSDEF ***/
/*                                                                            */
/* GSD entry - P-section definition in shareable image                        */
/*                                                                            */
#define SGPS$M_PIC 0x00000001
#define SGPS$M_LIB 0x00000002
#define SGPS$M_OVR 0x00000004
#define SGPS$M_REL 0x00000008
#define SGPS$M_GBL 0x00000010
#define SGPS$M_SHR 0x00000020
#define SGPS$M_EXE 0x00000040
#define SGPS$M_RD 0x00000080
#define SGPS$M_WRT 0x00000100
#define SGPS$M_VEC 0x00000200
#define SGPS$K_NAME 13
#define SGPS$C_NAME 13
struct sgpsdef {
    union {
        unsigned char sgps$b_gsdtyp;    /*Typ field                           */
        struct {
            char sgps$t_start [];
            char sgpsdef$$_fill_1;
            } sgps$r_gsdtyp_fields;
        } sgps$r_gsdtyp_overlay;
    unsigned char sgps$b_align; /*P-sect alignment                            */
    union {
        unsigned short int sgps$w_flags;        /*P-sect flags                */
        struct {
            unsigned sgps$v_pic : 1;    /*Position independent                */
            unsigned sgps$v_lib : 1;    /*From a shareable image              */
            unsigned sgps$v_ovr : 1;    /*Overlaid memory allocation          */
            unsigned sgps$v_rel : 1;    /*Relocatable                         */
            unsigned sgps$v_gbl : 1;    /*Global scope                        */
            unsigned sgps$v_shr : 1;    /*Shareable                           */
            unsigned sgps$v_exe : 1;    /*Executable                          */
            unsigned sgps$v_rd : 1;     /*Readable                            */
            unsigned sgps$v_wrt : 1;    /*Writeable                           */
            unsigned sgps$v_vec : 1;    /*Vector psect                        */
            unsigned sgps$v_fill_4 : 6;
            } sgps$r_flags_bits;
        } sgps$r_flags_overlay;
    unsigned long int sgps$l_alloc;     /*Length of this psect in shr image   */
    unsigned long int sgps$l_base;      /*Base of this psect in shr image     */
    unsigned char sgps$b_namlng;        /*Length of p-sect name               */
    char sgps$t_name [31];      /*Name field                                  */
} ;
 
/*** MODULE $GSYDEF ***/
/*                                                                            */
/* GSD entry - Symbol definition                                              */
/*                                                                            */
/* common to definitions, references, and entry                               */
/* point definitions.                                                         */
/*                                                                            */
#define GSY$M_WEAK 0x00000001
#define GSY$M_DEF 0x00000002
#define GSY$M_UNI 0x00000004
#define GSY$M_REL 0x00000008
struct gsydef {
    union {
        unsigned char gsy$b_gsdtyp;     /*Type field                          */
        struct {
            char gsy$t_start [];
            char gsydef$$_fill_1;
            } gsy$r_gsdtyp_fields;
        } gsy$r_gsdtyp_overlay;
    unsigned char gsy$b_datyp;  /*Symbol data type                            */
    union {
        unsigned short int gsy$w_flags; /*Symbol flags                        */
        struct {
            unsigned gsy$v_weak : 1;    /*Weak symbol                         */
            unsigned gsy$v_def : 1;     /*Definition                          */
            unsigned gsy$v_uni : 1;     /*Universal                           */
            unsigned gsy$v_rel : 1;     /*Relocatable                         */
            unsigned gsy$v_fill_5 : 4;
            } gsy$r_flags_bits;
        } gsy$r_flags_overlay;
} ;
 
/*** MODULE $SRFDEF ***/
/*                                                                            */
/* Symbol reference (SYM$M_DEF in GSY$W_FLAGS is 0)                           */
/*                                                                            */
#define SRF$K_NAME 5
#define SRF$C_NAME 5
struct srfdef {
    union {
        unsigned char srf$b_gsdtyp;     /*Maps over GSY$B_GSDTYP              */
        struct {
            char srf$t_start [];
            char srfdef$$_fill_1;
            } srf$r_gsdtyp_fields;
        } srf$r_gsdtyp_overlay;
    unsigned char srf$b_datyp;  /*Maps over GSY$B_DATYP                       */
    unsigned short int srf$w_flags;     /*Maps over GSY$W_FLAGS               */
    unsigned char srf$b_namlng; /*Length of symbol name                       */
    char srf$t_name [31];       /*Symbol name                                 */
} ;
 
/*** MODULE $SDFDEF ***/
/*                                                                            */
/* Symbol definition                                                          */
/*                                                                            */
#define SDF$K_NAME 10
#define SDF$C_NAME 10
struct sdfdef {
    union {
        unsigned char sdf$b_gsdtyp;     /*Maps over GSY$B_GSDTYP              */
        struct {
            char sdf$t_start [];
            char sdfdef$$_fill_1;
            } sdf$r_gsdtyp_fields;
        } sdf$r_gsdtyp_overlay;
    unsigned char sdf$b_datyp;  /*Maps over GSY$B_DATYP                       */
    unsigned short int sdf$w_flags;     /*Maps over GSY$W_FLAGS               */
    unsigned char sdf$b_psindx; /*Owning psect number                         */
    unsigned long int sdf$l_value;      /*Value of symbol                     */
    unsigned char sdf$b_namlng; /*Length of name                              */
    char sdf$t_name [31];       /*Symbol name                                 */
} ;
 
/*** MODULE $SDFVDEF ***/
/*                                                                            */
/* Symbol definition for vectored symbols                                     */
/*                                                                            */
#define SDFV$K_NAME 14
#define SDFV$C_NAME 14
struct sdfvdef {
    union {
        unsigned char sdfv$b_gsdtyp;    /*Maps over GSY$B_GSDTYP              */
        struct {
            char sdfv$t_start [];
            char sdfvdef$$_fill_1;
            } sdfv$r_gsdtyp_fields;
        } sdfv$r_gsdtyp_overlay;
    unsigned char sdfv$b_datyp; /*Maps over GSY$B_DATYP                       */
    unsigned short int sdfv$w_flags;    /*Maps over GSY$W_FLAGS               */
    unsigned char sdfv$b_psindx;        /*Owning psect number                 */
    unsigned long int sdfv$l_value;     /*Value of symbol                     */
    unsigned long int sdfv$l_vector;    /*Vectored value of symbol            */
    unsigned char sdfv$b_namlng;        /*Length of name                      */
    char sdfv$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $EPMDEF ***/
/*                                                                            */
/* GSD entry - Entry point definition                                         */
/*                                                                            */
#define EPM$K_NAME 12
#define EPM$C_NAME 12
struct epmdef {
    union {
        unsigned char epm$b_gsdtyp;     /*Maps over GSY$B_GSDTYP              */
        struct {
            char epm$t_start [];
            char epmdef$$_fill_1;
            } epm$r_gsdtyp_fields;
        } epm$r_gsdtyp_overlay;
    unsigned char epm$b_datyp;  /*Maps over GSY$B_DATYP                       */
    unsigned short int epm$w_flags;     /*Maps over GSY$W_FLAGS               */
    unsigned char epm$b_psindx; /*Maps over SDF$B_PSINDX                      */
    unsigned long int epm$l_addrs;      /*Entry point address, maps over SDF$L_VALUE  */
    unsigned short int epm$w_mask;      /*Entry point mask                    */
    unsigned char epm$b_namlng; /*Length of name                              */
    char epm$t_name [31];       /*Symbol name                                 */
} ;
 
/*** MODULE $EPMVDEF ***/
/*                                                                            */
/* GSD entry - Entry point definition                                         */
/*                                                                            */
#define EPMV$K_NAME 16
#define EPMV$C_NAME 16
struct epmvdef {
    union {
        unsigned char epmv$b_gsdtyp;    /*Maps over GSY$B_GSDTYP              */
        struct {
            char epmv$t_start [];
            char epmvdef$$_fill_1;
            } epmv$r_gsdtyp_fields;
        } epmv$r_gsdtyp_overlay;
    unsigned char epmv$b_datyp; /*Maps over GSY$B_DATYP                       */
    unsigned short int epmv$w_flags;    /*Maps over GSY$W_FLAGS               */
    unsigned char epmv$b_psindx;        /*Maps over SDF$B_PSINDX              */
    unsigned long int epmv$l_addrs;     /*Entry point address, maps over SDF$L_VALUE  */
    unsigned long int epmv$l_vector;    /*Vectored entry point address        */
    unsigned short int epmv$w_mask;     /*Entry point mask                    */
    unsigned char epmv$b_namlng;        /*Length of name                      */
    char epmv$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $PRODEF ***/
/*                                                                            */
/* GSD entry - Procedure definition                                           */
/*                                                                            */
#define PRO$K_NAME 12
#define PRO$C_NAME 12
struct prodef {
    union {
        unsigned char pro$b_gsdtyp;     /*Maps over GSY$B_GSDTYP              */
        struct {
            char pro$t_start [];
            char prodef$$_fill_1;
            } pro$r_gsdtyp_fields;
        } pro$r_gsdtyp_overlay;
    unsigned char pro$b_datyp;  /*Maps over GSY$B_DATYP                       */
    unsigned short int pro$w_flags;     /*Maps over GSY$W_FLAGS               */
    unsigned char pro$b_psindx; /*Maps over SDF$B_PSINDX                      */
    unsigned long int pro$l_addrs;      /*Entry point address, maps over SDF$L_VALUE  */
    unsigned short int pro$w_mask;      /*Entry point mask                    */
    unsigned char pro$b_namlng; /*Length of name                              */
    char pro$t_name [31];       /*Symbol name                                 */
} ;
 
/*** MODULE $PROVDEF ***/
/*                                                                            */
/* GSD entry - Procedure definition                                           */
/*                                                                            */
#define PROV$K_NAME 16
#define PROV$C_NAME 16
struct provdef {
    union {
        unsigned char prov$b_gsdtyp;    /*Maps over GSY$B_GSDTYP              */
        struct {
            char prov$t_start [];
            char provdef$$_fill_1;
            } prov$r_gsdtyp_fields;
        } prov$r_gsdtyp_overlay;
    unsigned char prov$b_datyp; /*Maps over GSY$B_DATYP                       */
    unsigned short int prov$w_flags;    /*Maps over GSY$W_FLAGS               */
    unsigned char prov$b_psindx;        /*Maps over SDF$B_PSINDX              */
    unsigned long int prov$l_addrs;     /*Entry point address, maps over SDF$L_VALUE  */
    unsigned long int prov$l_vector;    /*Vectored entry point address        */
    unsigned short int prov$w_mask;     /*Entry point mask                    */
    unsigned char prov$b_namlng;        /*Length of name                      */
    char prov$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $FMLDEF ***/
/*                                                                            */
/* Appended to a procedure definition are the formal arguments:               */
/*        FML$ - The fixed part of the formal arguments description           */
/*                                                                            */
#define FML$K_SIZE 2
#define FML$C_SIZE 2
struct fmldef {
    unsigned char fml$b_minargs;        /*Minimum number of arguments         */
    unsigned char fml$b_maxargs;        /*Maximum which include function if procedure is one  */
} ;
 
/*** MODULE $ARGDEF ***/
/*                                                                            */
/*        ARG$ - The argument descriptors                                     */
/*                                                                            */
#define ARG$C_UNKNOWN 0 /* Unspecified or unknown                             */
#define ARG$C_VALUE 1   /* Passed by value                                    */
#define ARG$C_REF 2     /* Passed by reference                                */
#define ARG$C_DESC 3    /* Passed by descriptor                               */
#define ARG$K_SIZE 2
#define ARG$C_SIZE 2
struct argdef {
    union {
        unsigned char arg$b_valctl;     /*Validation control byte             */
        struct {
            unsigned arg$v_passmech : 2;        /*Passing mechanism           */
            unsigned arg$v_fill_6 : 6;
            } arg$r_valctl_bits;
/* Passing mechanisms                                                         */
        } arg$r_valctl_overlay;
    unsigned char arg$b_bytecnt;        /*Remaining byte count                */
} ;
 
/*** MODULE $SDFWDEF ***/
/*                                                                            */
/* Symbol definition with word of psect value                                 */
/*                                                                            */
#define SDFW$K_NAME 11
#define SDFW$C_NAME 11
struct sdfwdef {
    union {
        unsigned char sdfw$b_gsdtyp;    /*Maps over GSY$B_GSDTYP              */
        struct {
            char sdfw$t_start [];
            char sdfwdef$$_fill_1;
            } sdfw$r_gsdtyp_fields;
        } sdfw$r_gsdtyp_overlay;
    unsigned char sdfw$b_datyp; /*Maps over GSY$B_DATYP                       */
    unsigned short int sdfw$w_flags;    /*Maps over GSY$W_FLAGS               */
    unsigned short int sdfw$w_psindx;   /*Owning psect number                 */
    unsigned long int sdfw$l_value;     /*Value of symbol                     */
    unsigned char sdfw$b_namlng;        /*Length of name                      */
    char sdfw$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $EPMWDEF ***/
/*                                                                            */
/* GSD entry - Entry point definition with word of psect value                */
/*                                                                            */
#define EPMW$K_NAME 13
#define EPMW$C_NAME 13
struct epmwdef {
    union {
        unsigned char epmw$b_gsdtyp;    /*Maps over GSY$B_GSDTYP              */
        struct {
            char epmw$t_start [];
            char epmwdef$$_fill_1;
            } epmw$r_gsdtyp_fields;
        } epmw$r_gsdtyp_overlay;
    unsigned char epmw$b_datyp; /*Maps over GSY$B_DATYP                       */
    unsigned short int epmw$w_flags;    /*Maps over GSY$W_FLAGS               */
    unsigned short int epmw$w_psindx;   /*Maps over SDFW$W_PSINDX             */
    unsigned long int epmw$l_addrs;     /*Entry point address, maps over SDFW$L_VALUE */
    unsigned short int epmw$w_mask;     /*Entry point mask                    */
    unsigned char epmw$b_namlng;        /*Length of name                      */
    char epmw$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $PROWDEF ***/
/*                                                                            */
/* GSD entry - Procedure definition with word of psect value                  */
/*                                                                            */
#define PROW$K_NAME 13
#define PROW$C_NAME 13
struct prowdef {
    union {
        unsigned char prow$b_gsdtyp;    /*Maps over GSY$B_GSDTYP              */
        struct {
            char prow$t_start [];
            char prowdef$$_fill_1;
            } prow$r_gsdtyp_fields;
        } prow$r_gsdtyp_overlay;
    unsigned char prow$b_datyp; /*Maps over GSY$B_DATYP                       */
    unsigned short int prow$w_flags;    /*Maps over GSY$W_FLAGS               */
    unsigned short int prow$w_psindx;   /*Maps over SDFW$W_PSINDX             */
    unsigned long int prow$l_addrs;     /*Entry point address, maps over SDFW$L_VALUE */
    unsigned short int prow$w_mask;     /*Entry point mask                    */
    unsigned char prow$b_namlng;        /*Length of name                      */
    char prow$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $IDCDEF ***/
/*                                                                            */
/* IDC - Random entity ident consistency check                                */
/*                                                                            */
#define IDC$C_LEQ 0
#define IDC$C_EQUAL 1
struct idcdef {
    unsigned char idc$b_gsdtyp; /*Type field                                  */
    union {
        unsigned short int idc$w_flags; /*Flags                               */
        struct {
            unsigned idc$v_binident : 1;        /*Ident is binary longword rather than ASCIC  */
            unsigned idc$v_idmatch : 2; /*Field for ident match control if binary ident       */
            unsigned idc$v_errsev : 3;  /*Error severity (default is warning-0)       */
            unsigned idc$v_fill_7 : 2;
            } idc$r_flags_bits;
/*Match control values                                                        */
        } idc$r_flags_overlay;
    union {
        unsigned char idc$b_namlng;     /*Length of entity name               */
        struct {
            char idcdef$$_fill_1;
            char idc$t_name []; /*                                            */
/* Followed by entity name                                                    */
/* Followed by                                                                */
/*        byte of ident length                                                */
/*                ident string (length = string length)                       */
/*                        or                                                  */
/*                ident binary value (length = 4)                             */
/* Followed by byte of length of name of object                               */
/* Followed by the object name                                                */
            } idc$r_namlng_fields;
        } idc$r_namlng_overlay;
} ;
 
/*** MODULE $ENVDEF ***/
/*                                                                            */
/* ENV - Define/reference an environment                                      */
/*                                                                            */
#define ENV$M_DEF 0x00000001
#define ENV$M_NESTED 0x00000002
struct envdef {
    unsigned char env$b_gsdtyp; /*Type field                                  */
    union {
        unsigned short int env$w_flags; /*Environment flags                   */
        struct {
            unsigned env$v_def : 1;     /*Definition of environment           */
            unsigned env$v_nested : 1;  /*Nested environment if set           */
            unsigned env$v_fill_8 : 6;
            } env$r_flags_bits;
        } env$r_flags_overlay;
    unsigned short int env$w_envindx;   /*Index of parent environment         */
    unsigned char env$b_namlng; /*Length of environment name                  */
    char env$t_name [31];       /*Environment name                            */
} ;
 
/*** MODULE $LSYDEF ***/
/*                                                                            */
/* LSY - Module-Local symbol definition                                       */
/*                                                                            */
/* Common to definitions, references, entry points, and procedure definitions */
/*                                                                            */
#define LSY$M_WEAK 0x00000001
#define LSY$M_DEF 0x00000002
#define LSY$M_UNI 0x00000004
#define LSY$M_REL 0x00000008
struct lsydef {
    union {
        unsigned char lsy$b_gsdtyp;     /*Type field                          */
        struct {
            char lsy$t_start [];
            char lsydef$$_fill_1;
            } lsy$r_gsdtyp_fields;
        } lsy$r_gsdtyp_overlay;
    unsigned char lsy$b_datyp;  /*Symbol type                                 */
    union {
        unsigned short int lsy$w_flags; /*Symbol flags                        */
        struct {
            unsigned lsy$v_weak : 1;    /*Weak symbol (not used)              */
            unsigned lsy$v_def : 1;     /*Defined symbol                      */
            unsigned lsy$v_uni : 1;     /*Universal (not used)                */
            unsigned lsy$v_rel : 1;     /*Relocatable                         */
            unsigned lsy$v_fill_9 : 4;
            } lsy$r_flags_bits;
        } lsy$r_flags_overlay;
    unsigned short int lsy$w_envindx;   /*Environment index                   */
} ;
 
/*** MODULE $LSRFDEF ***/
/*                                                                            */
/* Module-local Symbol reference (LSY$M_DEF in LSY$W_FLAGS is 0)              */
/*                                                                            */
#define LSRF$K_NAME 7
#define LSRF$C_NAME 7
struct lsrfdef {
    union {
        unsigned char lsrf$b_gsdtyp;    /*Maps over LSY$B_GSDTYP              */
        struct {
            char lsrf$t_start [];
            char lsrfdef$$_fill_1;
            } lsrf$r_gsdtyp_fields;
        } lsrf$r_gsdtyp_overlay;
    unsigned char lsrf$b_datyp; /*Maps over LSY$B_DATYP                       */
    unsigned short int lsrf$w_flags;    /*Maps over LSY$W_FLAGS               */
    unsigned short int lsrf$w_envindx;  /*Maps over LSY$W_ENVINDX             */
    unsigned char lsrf$b_namlng;        /*Length of symbol name               */
    char lsrf$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $LSDFDEF ***/
/*                                                                            */
/* Module-local Symbol definition                                             */
/*                                                                            */
#define LSDF$K_NAME 13
#define LSDF$C_NAME 13
struct lsdfdef {
    union {
        unsigned char lsdf$b_gsdtyp;    /*Maps over LSY$B_GSDTYP              */
        struct {
            char lsdf$t_start [];
            char lsdfdef$$_fill_1;
            } lsdf$r_gsdtyp_fields;
        } lsdf$r_gsdtyp_overlay;
    unsigned char lsdf$b_datyp; /*Maps over LSY$B_DATYP                       */
    unsigned short int lsdf$w_flags;    /*Maps over LSY$W_FLAGS               */
    unsigned short int lsdf$w_envindx;  /*Environment index symbol defined in */
    unsigned short int lsdf$w_psindx;   /*Owning psect number                 */
    unsigned long int lsdf$l_value;     /*Value of symbol                     */
    unsigned char lsdf$b_namlng;        /*Length of name                      */
    char lsdf$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $LEPMDEF ***/
/*                                                                            */
/* GSD entry - Module local entry point definition                            */
/*                                                                            */
#define LEPM$K_NAME 15
#define LEPM$C_NAME 15
struct lepmdef {
    union {
        unsigned char lepm$b_gsdtyp;    /*Maps over LSY$B_GSDTYP              */
        struct {
            char lepm$t_start [];
            char lepmdef$$_fill_1;
            } lepm$r_gsdtyp_fields;
        } lepm$r_gsdtyp_overlay;
    unsigned char lepm$b_datyp; /*Maps over LSY$B_DATYP                       */
    unsigned short int lepm$w_flags;    /*Maps over LSY$W_FLAGS               */
    unsigned short int lepm$w_envindx;  /*Environment index symbol defined in */
    unsigned short int lepm$w_psindx;   /*Maps over LSDF$W_PSINDX             */
    unsigned long int lepm$l_addrs;     /*Entry point address, maps           */
/* over LSDF$L_VALUE                                                          */
    unsigned short int lepm$w_mask;     /*Entry point mask                    */
    unsigned char lepm$b_namlng;        /*Length of name                      */
    char lepm$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $LPRODEF ***/
/*                                                                            */
/* GSD entry - Module Local Procedure definition                              */
/*                                                                            */
#define LPRO$K_NAME 15
#define LPRO$C_NAME 15
struct lprodef {
    union {
        unsigned char lpro$b_gsdtyp;    /*Maps over LSY$B_GSDTYP              */
        struct {
            char lpro$t_start [];
            char lprodef$$_fill_1;
            } lpro$r_gsdtyp_fields;
        } lpro$r_gsdtyp_overlay;
    unsigned char lpro$b_datyp; /*Maps over LSY$B_DATYP                       */
    unsigned short int lpro$w_flags;    /*Maps over LSY$W_FLAGS               */
    unsigned short int lpro$w_envindx;  /*Environment index symbol defined in */
    unsigned short int lpro$w_psindx;   /*Maps over LSDF$W_PSINDX             */
    unsigned long int lpro$l_addrs;     /*Entry point address, maps           */
/* over LSDF$L_VALUE                                                          */
    unsigned short int lpro$w_mask;     /*Entry point mask                    */
    unsigned char lpro$b_namlng;        /*Length of name                      */
    char lpro$t_name [31];      /*Symbol name                                 */
} ;
 
/*** MODULE $TIRDEF ***/
/*                                                                            */
/* Text, information and relocation record (TIR)                              */
/*                                                                            */
#define TIR$C_STA_GBL 0 /*Stack global symbol value                           */
#define TIR$C_STA_SB 1  /*Stack signed byte                                   */
#define TIR$C_STA_SW 2  /*Stack signed word                                   */
#define TIR$C_STA_LW 3  /*Stack longword                                      */
#define TIR$C_STA_PB 4  /*Stack psect base plus byte offset                   */
#define TIR$C_STA_PW 5  /*Stack psect base plus word offset                   */
#define TIR$C_STA_PL 6  /*Stack psect base plus longword offset               */
#define TIR$C_STA_UB 7  /*Stack unsigned byte                                 */
#define TIR$C_STA_UW 8  /*Stack unsigned word                                 */
#define TIR$C_STA_BFI 9 /*Stack byte from image                               */
#define TIR$C_STA_WFI 10        /*Stack word from image                       */
#define TIR$C_STA_LFI 11        /*Stack longword from image                   */
#define TIR$C_STA_EPM 12        /*Stack entry point mask                      */
#define TIR$C_STA_CKARG 13      /*Stack result of argument checking (true or false)   */
#define TIR$C_STA_WPB 14        /*Stack psect base plus byte offset -- word psect number      */
#define TIR$C_STA_WPW 15        /*Stack psect base plus word offset -- word psect number      */
#define TIR$C_STA_WPL 16        /*Stack psect base plus longword offset -- word of psect number       */
#define TIR$C_STA_LSY 17        /*Stack local symbol value                    */
#define TIR$C_STA_LIT 18        /*Stack literal                               */
#define TIR$C_STA_LEPM 19       /*Stack local symbol entry point mask         */
#define TIR$C_MAXSTACOD 19      /*Last assigned code of stack group           */
#define TIR$C_MINSTOCOD 20      /*First assigned store command code           */
#define TIR$C_STO_SB 20 /*Store signed byte                                   */
#define TIR$C_STO_SW 21 /*Store signed word                                   */
#define TIR$C_STO_L 22  /*Store longword                                      */
#define TIR$C_STO_BD 23 /*Store byte displaced                                */
#define TIR$C_STO_WD 24 /*Store word displaced                                */
#define TIR$C_STO_LD 25 /*Store longword displaced                            */
#define TIR$C_STO_LI 26 /*Store short literal                                 */
#define TIR$C_STO_PIDR 27       /*Store pos. indep. data reference            */
#define TIR$C_STO_PICR 28       /*Store pos. indep. code reference            */
#define TIR$C_STO_RSB 29        /*Store repeated signed byte                  */
#define TIR$C_STO_RSW 30        /*Store repeated signed word                  */
#define TIR$C_STO_RL 31 /*Store repeated longword                             */
#define TIR$C_STO_VPS 32        /*Store arbitrary field                       */
#define TIR$C_STO_USB 33        /*Store unsigned byte                         */
#define TIR$C_STO_USW 34        /*Store unsigned word                         */
#define TIR$C_STO_RUB 35        /*Store repeated unsigned byte                */
#define TIR$C_STO_RUW 36        /*Store repeated unsigned word                */
#define TIR$C_STO_B 37  /*Store byte                                          */
#define TIR$C_STO_W 38  /*Store word                                          */
#define TIR$C_STO_RB 39 /*Store repeated byte                                 */
#define TIR$C_STO_RW 40 /*Store repeated word                                 */
#define TIR$C_STO_RIVB 41       /*Store repeated immediate variable bytes     */
#define TIR$C_STO_PIRR 42       /*Store pos. indep. relative reference        */
#define TIR$C_MAXSTOCOD 42      /*Last assigned store command code            */
#define TIR$C_MINOPRCOD 50      /*First assigned operator command code        */
#define TIR$C_OPR_NOP 50        /*No-op                                       */
#define TIR$C_OPR_ADD 51        /*Add                                         */
#define TIR$C_OPR_SUB 52        /*Subtract                                    */
#define TIR$C_OPR_MUL 53        /*Multiply                                    */
#define TIR$C_OPR_DIV 54        /*Divide                                      */
#define TIR$C_OPR_AND 55        /*Logical AND                                 */
#define TIR$C_OPR_IOR 56        /*Logical inclusive OR                        */
#define TIR$C_OPR_EOR 57        /*Logical exclusive OR                        */
#define TIR$C_OPR_NEG 58        /*Negate                                      */
#define TIR$C_OPR_COM 59        /*Complement                                  */
#define TIR$C_OPR_INSV 60       /*Insert bit field                            */
#define TIR$C_OPR_ASH 61        /*Arithmetic shift                            */
#define TIR$C_OPR_USH 62        /*Unsigned shift                              */
#define TIR$C_OPR_ROT 63        /*Rotate                                      */
#define TIR$C_OPR_SEL 64        /*Select one of three longwords on top of stack       */
#define TIR$C_OPR_REDEF 65      /*Redefine this symbol after pass 2           */
#define TIR$C_OPR_DFLIT 66      /*Define a literal                            */
#define TIR$C_MAXOPRCOD 66      /*Last assigned operator command code         */
#define TIR$C_MINCTLCOD 80      /*First assigned control command code         */
#define TIR$C_CTL_SETRB 80      /*Set relocation base                         */
#define TIR$C_CTL_AUGRB 81      /*Augment relocation base                     */
#define TIR$C_CTL_DFLOC 82      /*Define debug location                       */
#define TIR$C_CTL_STLOC 83      /*Set debug location                          */
#define TIR$C_CTL_STKDL 84      /*Stack debug location                        */
#define TIR$C_MAXCTLCOD 84      /*Last assigned control command code          */
union tirdef {
    unsigned char tir$b_rectyp; /*Record type (OBJ$C_TIR)                     */
/* Define relocation commands                                                 */
} ;
#endif
