/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:33:04 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFAE.S */
#ifndef $ACEDEF_H
#define $ACEDEF_H
 
/*** MODULE $ACEDEF ***/
/*+                                                                           */
/*                                                                            */
/* Access Control list Entry structure definitions                            */
/*                                                                            */
/*-                                                                           */
#define ACE$C_KEYID 1   /* Key identifier entry                               */
#define ACE$C_RMSJNL_BI 2       /* RMS BI journal                             */
#define ACE$C_RMSJNL_AI 3       /* RMS AI journal                             */
#define ACE$C_RMSJNL_AT 4       /* RMS AT journal                             */
#define ACE$C_AUDIT 5   /* Security audit journal entry                       */
#define ACE$C_ALARM 6   /* Security alarm entry                               */
#define ACE$C_INFO 7    /* General purpose information                        */
#define ACE$C_RMSJNL_RU_DEFAULT 8       /* RU journal default volume          */
#define ACE$C_DIRDEF 9  /* Directory default protection                       */
#define ACE$C_RMSJNL_RU 10      /* RU journal (many per file)                 */
#define ACE$C_SUBSYSTEM_IDS 11  /* Protected subsystem ids                    */
#define ACE$C_RESERVED 255      /* Reserved ACE type                          */
#define ACE$C_APPLICATION 7     /* Alternate application ACE code             */
#define ACE$C_CUST 1    /* Customer defined                                   */
#define ACE$C_CSS 2     /* CSS defined                                        */
#define ACE$C_VMS 3     /* VMS defined                                        */
#define ACE$M_SUCCESS 0x00000001
#define ACE$M_FAILURE 0x00000002
#define ACE$M_DEFAULT 0x00000100
#define ACE$M_PROTECTED 0x00000200
#define ACE$M_HIDDEN 0x00000400
#define ACE$M_NOPROPAGATE 0x00000800
#define ACE$M_READ 0x00000001
#define ACE$M_WRITE 0x00000002
#define ACE$M_EXECUTE 0x00000004
#define ACE$M_DELETE 0x00000008
#define ACE$M_CONTROL 0x00000010
#define ACE$K_LENGTH 8  /* Length of the overhead area                        */
#define ACE$C_LENGTH 8  /* Length of the overhead area                        */
#define ACE$C_RMS_ATTRIBUTES 0  /* variant of ACE for file attributes         */
#define ACE$K_RMS_ATTRIBUTES 0  /* variant of ACE for file attributes         */
#define ACE$K_RMSATR_MINOR_V50 2        /* minor ID for VMS 5.0               */
#define ACE$K_RMSATR_MINOR_VDW 2        /* minor ID for DECwindows V1.0       */
#define ACE$C_RMSATR_MINOR_ID 2 /* current minor ID (obsolete symbol)         */
#define ACE$K_RMSATR_MINOR_ID 2
#define ACE$C_RMSATR_MAJOR_ID 1 /* current major ID                           */
#define ACE$K_RMSATR_MAJOR_ID 1
#define ACE$M_STATISTICS 0x00000001
#define ACE$M_XLATE_DEC 0x00000002
#define ACE$S_RMSATR 20 /* size of RMS file attributes ACE (fixed fields)     */
#define ACE$S_RMSATR_V50 20     /* size of RMS file attributes ACE (fixed fields)     */
#define ACE$S_RMSATR_VDW 20     /* size of RMS file attributes ACE (fixed fields)     */
/* Beyond the fixed fields, variable length information will by stored        */
#define ACE$_RMSATR_ORGANIZATION 1      /* organizational extension object ID */
#define ACE$_RMSATR_SEMANTICS 2 /* file semantics object ID                   */
#define ACE$K_RMSATR_ORG_MAX_LEN 64
#define ACE$K_RMSATR_SEM_MAX_LEN 64
#define ACE$S_RMSJNL_RU_DEFAULT 17      /* length of RMSJNL RU default ACE    */
#define ACE$M_JOURNAL_DISABLED 0x00000001
#define ACE$M_BACKUP_DONE 0x00000002
#define ACE$S_RMSJNL_RU 38      /* length of RMSJNL RU ACE                    */
#define ACE$S_RMSJNL 50 /* length of RMSJNL AI/BI/AT ACE                      */
struct acedef {
    unsigned char ace$b_size;   /* Size of the entry                          */
    unsigned char ace$b_type;   /* Type of entry                              */
    union {
        unsigned short int ace$w_flags; /* Type dependent & independent flags */
        struct {        /* Flags for INFO type ACE                            */
            unsigned ace$v_info_type : 4;       /* INFO ACE subtype           */
            unsigned ace$v_fill_0 : 4;
            } ace$r_flags_info;
        struct {        /* Flags for KEYID type                               */
            unsigned ace$v_reserved : 4;        /* Count of reserved longwords*/
            unsigned ace$v_fill_1 : 4;
            } ace$r_flags_keyid;
        struct {
            unsigned ace$v_success : 1; /* Audit or alarm upon success        */
            unsigned ace$v_failure : 1; /* Audit ot alarm upon failure        */
            unsigned ace$v_fill_2 : 6;
            } ace$r_flags_bits0;
        struct {        /* Type independent flags                             */
            unsigned ace$v_fill_1 : 8;
            unsigned ace$v_default : 1; /* Directory default entry            */
            unsigned ace$v_protected : 1;       /* Protected ACE              */
            unsigned ace$v_hidden : 1;  /* Hidden ACE                         */
            unsigned ace$v_nopropagate : 1;     /* No propagation between versions    */
            unsigned ace$v_fill_3 : 4;
            } ace$r_flags_bits;
        } ace$r_flags_overlay;
    union {     /* Start of ACE overlayed area                                */
        struct {        /* KEY-ID and security audit types                    */
            union {
                unsigned long int ace$l_access; /* Access rights bitmask      */
                struct {
                    unsigned ace$v_read : 1;    /* Allowed to read            */
                    unsigned ace$v_write : 1;   /* Allowed to write           */
                    unsigned ace$v_execute : 1; /* Allowed to execute         */
                    unsigned ace$v_delete : 1;  /* Allowed to delete          */
                    unsigned ace$v_control : 1; /* All privileges of the owner        */
                    unsigned ace$v_fill_6 : 3;
                    } ace$r_fill_5;
                } ace$r_fill_4;
            union {
                unsigned long int ace$l_key;    /* Start of the key fields    */
                char ace$t_auditname [16];      /* Start of the security journal name */
                } ace$r_key_overlay;
            } ace$r_key_aud_type;
        struct {
            union {
                unsigned long int ace$l_info_flags;     /* INFO type application flags*/
                struct {
                    unsigned short int ace$w_application_flags; /* VMS application flags word */
                    unsigned short int ace$w_application_facility;      /* VMS application facility code      */
                    } ace$r_fill_8;
                } ace$r_fill_7;
            union {
                char ace$t_info_start;  /* Start of the information           */
                struct {
                    unsigned short int ace$w_rmsatr_variant;    /* Which variant of the RMS attributes ACE    */
                    unsigned char ace$b_rmsatr_fixlen;  /* length of fixed format fields      */
/* (introduced at minor ID 3. Older                                           */
/*  ACE's are assumed to be all fixed form)                                   */
                    char ace$b_rmsatr_spare1;   /* currectly unused           */
                    unsigned short int ace$w_rmsatr_minor_id;   /* RMS file attributes ACE minor ID   */
                    unsigned short int ace$w_rmsatr_major_id;   /* RMS file attributes ACE major ID   */
                    union {
                        unsigned long int ace$l_rms_attribute_flags;    /* RMS file attributes flags definitions      */
                        struct {
                            unsigned ace$v_statistics : 1;      /* Statistics monitoring enabled on this file */
                            unsigned ace$v_xlate_dec : 1;       /* File semantics are DEC-local       */
                            unsigned ace$v_fill_11 : 6;
                            } ace$r_fill_10;
                        } ace$r_fill_9;
/* using a {field-type, length, value} scheme.  This allows extensibility     */
/* and compact representation.                                                */
/*                                                                            */
/* field types are:                                                           */
                    } ace$r_rmsatr_type;
                } ace$r_info_data;
            } ace$r_info_type;
        struct {        /* Used for all 5 RMSJNL_xxx ACEs                     */
            char ace$t_volnam [12];     /* Volume name of journal file        */
            unsigned char ace$b_volnam_len;     /* Length of volume name of journal file      */
            unsigned char ace$b_rjrver; /* RMS journal file structure level   */
            union {     /* File-id of journal file                            */
                unsigned short int ace$w_fid [3];       /* file id            */
                struct {
                    unsigned short int ace$w_fid_num;   /* file number        */
                    unsigned short int ace$w_fid_seq;   /* sequence number    */
                    union {
                        unsigned short int ace$w_fid_rvn;       /* relative volume number     */
                        struct {
                            unsigned char ace$b_fid_rvn;        /* alternate format RVN       */
                            unsigned char ace$b_fid_nmx;        /* alternate format file number extension     */
                            } ace$r_fid_rvn_fields;
                        } ace$r_fid_rvn_overlay;
                    } ace$r_fid_fields;
                } ace$r_fid_overlay;
            union {
                unsigned short int ace$w_rmsjnl_flags;
                struct {
                    unsigned ace$v_journal_disabled : 1;        /* journaling disabled*/
/* (AI, BI, AT only; set by BACKUP)                                           */
                    unsigned ace$v_backup_done : 1;     /* BACKUP done on this file;  */
/* RMS needs to write a backup marker                                         */
/* (AI, BI, AT only; set by BACKUP)                                           */
                    unsigned ace$v_fill_12 : 6;
                    } ace$r_rmsjnl_flags_bits;
                } ace$r_rmsjnl_flags_overlay;
            unsigned long int ace$l_jnlidx;     /* journal stream index number*/
            unsigned int ace$q_cdate [2];       /* creation date/time of journal      */
            unsigned long int ace$l_backup_seqno;       /* BACKUP sequence number (to */
/* find where to start in journal).                                           */
            unsigned int ace$q_modification_time [2];   /* timestamp of last backup or last   */
/* journal entry recovered.                                                   */
            } ace$r_rmsjnl_type;
        struct {
            unsigned long int ace$l_spare1;     /* For alignment              */
            unsigned long int ace$l_sys_prot;   /* Default system protection  */
            unsigned long int ace$l_own_prot;   /* Default owner protection   */
            unsigned long int ace$l_grp_prot;   /* Default group protection   */
            unsigned long int ace$l_wor_prot;   /* Default world protection   */
            } ace$r_dirdef_type;
        struct {        /* Protected subsystem ACE type                       */
            unsigned long int ace$l_spare2;     /* For alignment              */
            unsigned int ace$q_image_ids [2];   /* Start of the image ids (a  */
/* quadword for each identifier)                                              */
            } ace$r_image_id_type;
        } ace$r_ace_fields;
} ;
#endif
