/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:33:04 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFAE.S */
#ifndef $DMPDEF_H
#define $DMPDEF_H
 
/*** MODULE $DMPDEF ***/
/*                                                                            */
/* LAYOUT OF THE HEADER BLOCK OF THE SYSTEM DUMP FILE                         */
/* (WHICH IS THE FIRST DISK BLOCK OF SYS$SYSTEM:SYSDUMP.DMP)                  */
/*                                                                            */
#define DMP$M_OLDDUMP 0x00000001
#define DMP$M_EMPTY 0x00000002
#define DMP$M_HDRBLK 0x00000004
#define DMP$M_ERRLOG 0x00000008
#define DMP$M_MEMORY 0x00000010
#define DMP$M_SPT 0x00000020
#define DMP$M_WRITECOMP 0x00000040
#define DMP$M_ERRLOGCOMP 0x00000080
#define DMP$M_DUMP_STYLE 0x00000F00
#define DMP$K_FULL_DUMP 0       /* FULL PHYSICAL MEMORY DUMP (OLD WAY)        */
#define DMP$K_SUBSET_DUMP 1     /* SUBSETTED DUMP FILE (NOT ALL INFO SAVED)   */
#define DMP$C_DUMP_LUMP 127     /* NUMBER OF SPTES REQUIRED FOR SUBSET DUMPS  */
#define DMP$C_MEMDSCSIZ 8       /* SIZE OF ONE MEMORY DESCRIPTOR              */
#define DMP$C_NMEMDSC 8 /* NUMBER OF MEMORY DESCRIPTORS                       */
#define DMP$K_DUMPVER 1280      /* DUMP FILE VERSION NUMBER                   */
#define DMP$K_LENGTH 132        /* LENGTH OF FILE HEADER                      */
#define DMP$C_LENGTH 132        /* LENGTH OF FILE HEADER                      */
struct dmpdef {
    unsigned long int dmp$l_errseq;     /* LAST ERROR LOG SEQ. NUMBER         */
    union {
        unsigned long int dmp$l_flags;  /* DUMP FILE FLAGS                    */
        struct {
            unsigned dmp$v_olddump : 1; /* SET IF DUMP ALREADY ANALYZED       */
            unsigned dmp$v_empty : 1;   /* SET IF DUMP HAS NO DATA BLOCKS     */
            unsigned dmp$v_hdrblk : 1;  /* SET IF ERROR WRITING FIRST BLOCK OF DUMP HEADER    */
            unsigned dmp$v_errlog : 1;  /* SET IF ERROR WRITING BLOCKS 2-3 OF DUMP HEADER     */
            unsigned dmp$v_memory : 1;  /* SET IF ERROR WRITING MEMORY CONTENTS TO DUMP FILE  */
            unsigned dmp$v_spt : 1;     /* SET IF ERROR WRITING SYSTEM PAGE TABLE BLOCKS TO DUMP FILE */
            unsigned dmp$v_writecomp : 1;       /* SET IF DUMP WRITE WAS COMPLETED    */
            unsigned dmp$v_errlogcomp : 1;      /* SET IF HEADER/ERROR LOGS WRITE WAS COMPLETED       */
            unsigned dmp$v_dump_style : 4;      /* SET TO DIFFERENTIATE BETWEEN DIFFERENT STYLE DUMPS */
            unsigned dmp$v_fill_28 : 4;
            } dmp$r_flags_bits;
/* DUMP_STYLE BITFIELD SETTINGS                                               */
        } dmp$r_flags_overlay;
    unsigned long int dmp$l_sbr;        /* SYSTEM BASE REGISTER               */
    unsigned long int dmp$l_slr;        /* SYSTEM LENGTH REGISTER             */
    unsigned long int dmp$l_ksp;        /* KERNEL STACK POINTER               */
    unsigned long int dmp$l_esp;        /* EXECUTIVE STACK POINTER            */
    unsigned long int dmp$l_ssp;        /* SUPERVISOR STACK POINTER           */
    unsigned long int dmp$l_usp;        /* USER STACK POINTER                 */
    unsigned long int dmp$l_isp;        /* INTERRUPT STACK POINTER            */
    union {
        unsigned long int dmp$l_memory_desc_space [16]; /* RESERVE SPACE FOR 8 MEMORY DESCRIPTORS (2 LONGWORDS EACH)  */
        union {
            unsigned long int dmp$l_memdsc;     /* 8 MEMORY DESCRIPTORS       */
            struct {
                unsigned dmp$v_pagcnt : 24;     /* NUMBER OF PAGES IN MEMORY  */
                unsigned dmp$v_tr : 8;  /* TR NUMBER FOR MEMORY               */
                unsigned dmp$v_basepfn : 32;    /* BASE PFN FOR MEMORY        */
                } dmp$r_memdsc_bits;
            } dmp$r_memdsc_overlay;
        } dmp$r_memory_desc;
    unsigned long int dmp$l_sysver;     /* SYSTEM VERSION NUMBER              */
    unsigned long int dmp$l_check;      /* ONES COMPLEMENT OF SYSVER          */
    unsigned short int dmp$w_dumpver;   /* DUMP FILE VERSION NUMBER           */
    unsigned short int dmp$w_erlbufcnt; /* NUMBER OF ERROR LOG BUFFERS        */
    unsigned short int dmp$w_erlbufhead;        /* RING BUFFER HEAD INDEX     */
    unsigned short int dmp$w_erlbuftail;        /* RING BUFFER TAIL INDEX     */
    unsigned long int dmp$l_errstatus;  /* LAST ERROR STATUS FROM DUMP WRITE  */
    unsigned long int dmp$l_dumperrs;   /* COUNT OF ERRORS DURING DUMP WRITE  */
    unsigned long int dmp$l_mempagcnt;  /* COUNT OF MEMORY PAGES DUMPED       */
    unsigned long int dmp$l_saveprccnt; /* COUNT OF SAVED PROCESSES (SUBSET DUMP)     */
    unsigned long int dmp$l_crasherl;   /* SYSTEM CRASH ERR LOG ENTRY         */
} ;
#endif
