/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:36:21 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFMP.S */
#ifndef $MNTDEF_H
#define $MNTDEF_H
 
/*** MODULE $MNTDEF ***/
/*+                                                                           */
/*                                                                            */
/* FLAG BITS FOR THE $MOUNT SYSTEM SERVICE.                                   */
/*                                                                            */
/*-                                                                           */
#define MNT$M_FOREIGN 0x00000001
#define MNT$M_GROUP 0x00000002
#define MNT$M_NOASSIST 0x00000004
#define MNT$M_NODISKQ 0x00000008
#define MNT$M_NOHDR3 0x00000010
#define MNT$M_NOLABEL 0x00000020
#define MNT$M_NOWRITE 0x00000040
#define MNT$M_OVR_ACCESS 0x00000080
#define MNT$M_OVR_EXP 0x00000100
#define MNT$M_OVR_IDENT 0x00000200
#define MNT$M_OVR_SETID 0x00000400
#define MNT$M_READCHECK 0x00000800
#define MNT$M_SHARE 0x00001000
#define MNT$M_MESSAGE 0x00002000
#define MNT$M_SYSTEM 0x00004000
#define MNT$M_WRITECHECK 0x00008000
#define MNT$M_WRITETHRU 0x00010000
#define MNT$M_NOCACHE 0x00020000
#define MNT$M_OVR_LOCK 0x00040000
#define MNT$M_NOMNTVER 0x00080000
#define MNT$M_NOUNLOAD 0x00100000
#define MNT$M_TAPE_DATA_WRITE 0x00200000
#define MNT$M_NOCOPY 0x00400000
#define MNT$M_NOAUTO 0x00800000
#define MNT$M_INIT_ALL 0x01000000
#define MNT$M_INIT_CONT 0x02000000
#define MNT$M_OVR_VOLO 0x04000000
#define MNT$M_INTERCHG 0x08000000
#define MNT$M_CLUSTER 0x10000000
#define MNT$M_NOREBUILD 0x20000000
#define MNT$M_OVR_SHAMEM 0x40000000
#define MNT$M_MULTI_VOL 0x80000000
#define MNT$_DEVNAM 1   /* DEVICE NAME                                        */
#define MNT$_VOLNAM 2   /* VOLUME NAME                                        */
#define MNT$_LOGNAM 3   /* LOGICAL NAME                                       */
#define MNT$_FLAGS 4    /* MOUNT FLAGS                                        */
#define MNT$_ACCESSED 5 /* ACCESSED VALUE                                     */
#define MNT$_PROCESSOR 6        /* PROCESSOR NAME                             */
#define MNT$_VOLSET 7   /* VOLUME SET NAME                                    */
#define MNT$_BLOCKSIZE 8        /* BLOCKSIZE VALUE                            */
#define MNT$_DENSITY 9  /* TAPE DENSITY VALUE                                 */
#define MNT$_EXTENT 10  /* NUMBER OF EXTENT CACHE ENTRIES                     */
#define MNT$_FILEID 11  /* FILE ID CACHE SIZE                                 */
#define MNT$_LIMIT 12   /* EXTENT CACHE LIMIT                                 */
#define MNT$_OWNER 13   /* VOLUME OWNER UIC                                   */
#define MNT$_VPROT 14   /* VOLUME PROTECTION                                  */
#define MNT$_QUOTA 15   /* QUOTA CACHE SIZE                                   */
#define MNT$_RECORDSIZ 16       /* RECORD SIZE VALUE                          */
#define MNT$_WINDOW 17  /* NUMBER OF WINDOWS                                  */
#define MNT$_EXTENSION 18       /* DEFAULT FILE EXTENSION                     */
#define MNT$_VISUAL_ID 19       /* VISUAL IDENTIFICATION                      */
#define MNT$_COMMENT 20 /* USER COMMENT                                       */
#define MNT$_UNUSED1 21 /* SPARE (was used for now obsolete journaling-related items) */
#define MNT$_UNUSED2 22 /* SPARE (was used for now obsolete journaling-related items) */
#define MNT$_UNUSED3 23 /* SPARE (was used for now obsolete journaling-related items) */
#define MNT$_SHACOPY_BUF 24     /* SHADOW COPY BUFFER                         */
#define MNT$_SHANAM 25  /* SHADOW SET VIRTUAL UNIT NAME                       */
#define MNT$_SHAMEM 26  /* SHADOW SET MEMBER UNIT NAME                        */
#define MNT$_SHAMEM_MGCOPY 27   /* SHADOW SET MEMBER UNIT NAME (MERGE COPY)   */
#define MNT$_SHAMEM_COPY 28     /* SHADOW SET MEMBER UNIT NAME (FULL COPY)    */
#define MNT$_PRFD_PATH 29       /* PREFERRED DSA PATH                         */
union mntdef {
    struct {
        unsigned mnt$v_foreign : 1;     /* FOREIGN OPTION SELECTED            */
        unsigned mnt$v_group : 1;       /* GROUP OPTION SELECTED              */
        unsigned mnt$v_noassist : 1;    /* NOASSIST OPTION SELECTED           */
        unsigned mnt$v_nodiskq : 1;     /* NODISKQ OPTION SELECTED            */
        unsigned mnt$v_nohdr3 : 1;      /* NOHDR3 OPTION SELECTED             */
        unsigned mnt$v_nolabel : 1;     /* NOLABEL OPTION SELECTED            */
        unsigned mnt$v_nowrite : 1;     /* NOWRITE OPTION SELECTED            */
        unsigned mnt$v_ovr_access : 1;  /* OVERRIDE ACCESSIBLITY OPTION SELECTED      */
        unsigned mnt$v_ovr_exp : 1;     /* OVERRIDE EXPIRATON OPTION SELECTED */
        unsigned mnt$v_ovr_ident : 1;   /* OVERRIDE VOLUME LABEL              */
        unsigned mnt$v_ovr_setid : 1;   /* OVERRIDE VOLUME SET IDENT OPTION SELECTIED */
        unsigned mnt$v_readcheck : 1;   /* READCHECK OPTION SELECTED          */
        unsigned mnt$v_share : 1;       /* SHARE OPTION SELECTED              */
        unsigned mnt$v_message : 1;     /* ALLOW $MOUNT TO PRINT MESSAGES     */
        unsigned mnt$v_system : 1;      /* SYSTEM OPTION SELECTED             */
        unsigned mnt$v_writecheck : 1;  /* WRITECHECK OPTION SELECTED         */
        unsigned mnt$v_writethru : 1;   /* WRITETHRU OPTION SELECTED          */
        unsigned mnt$v_nocache : 1;     /* TURN OFF ALL CACHING               */
        unsigned mnt$v_ovr_lock : 1;    /* OVERRIDE AUTOMATIC WRITE-LOCK      */
        unsigned mnt$v_nomntver : 1;    /* DISABLE MOUNT VERIFICATION         */
        unsigned mnt$v_nounload : 1;    /* DO NOT UNLOAD VOLUME AT DISMOUNT   */
        unsigned mnt$v_tape_data_write : 1;     /* ENABLE WRITE-BACK CACHE ON TAPE    */
        unsigned mnt$v_nocopy : 1;      /* DO NOT ALLOW SHADOW COPY OPERATION */
        unsigned mnt$v_noauto : 1;      /* DO NOT SET THE MTAACP INTO AVR AND AVL MODE*/
        unsigned mnt$v_init_all : 1;    /* INITIALIZE ALL VOLUMES IN SET BEFORE WRITING       */
        unsigned mnt$v_init_cont : 1;   /* INITIALIZE CONTINUATION VOLUMES BEFORE WRITING     */
        unsigned mnt$v_ovr_volo : 1;    /* OVERRIDE VOL1 VOLUME IDENTIFIER FIELD      */
        unsigned mnt$v_interchg : 1;    /* VOL FOR INTERCHG NO VMS SPECIFIC INFO WRITTEN TO TAPE      */
        unsigned mnt$v_cluster : 1;     /* CLUSTER-WIDE MOUNT OPTION SELECTED */
        unsigned mnt$v_norebuild : 1;   /* DO NOT REBUILD VOLUME              */
        unsigned mnt$v_ovr_shamem : 1;  /* OVERRIDE SHADOW MEMBERSHIP RESTRICTION     */
        unsigned mnt$v_multi_vol : 1;   /* MULTI_VOLUME TAPE SET              */
        } mnt$r_mntdef_bits;
/*                                                                            */
/* Item codes for mount parameters.                                           */
/*                                                                            */
/* DEFINE CODES AS CONSTANTS                                                  */
} ;
#endif
