/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:09:49 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]DTK$ROUTINE */
#ifndef DTK$ROUTINES_H
#define DTK$ROUTINES_H
 
/*** MODULE DTK$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    DTK$ANSWER_PHONE                                                        */
/*                                                                            */
/*    Wait for Phone to Ring and Answer                                       */
/*                                                                            */
/*    The Wait for Phone to Ring and Answer routine                           */
/*    waits for the phone connected to the DECtalk device to ring             */
/*    and then answers it.                                                    */
/*                                                                            */
/*+~dtk$answer_phone~+*/
unsigned long int dtk$answer_phone(
    const unsigned long int  *voice_id,
    ...
    /* const long int  *number_of_rings, */
    /* const struct dsc$descriptor *text, */
    /* const long int  *timeout */
    ) ;
/*~-dtk$answer_phone-~*/
/*    DTK$CHECK_HDWR_STATUS                                                   */
/*                                                                            */
/*    Check Hardware Status                                                   */
/*                                                                            */
/*    The Check Hardware Status routine checks the DECtalk hardware for hardware      */
/*    malfunctions.                                                           */
/*                                                                            */
/*+~dtk$check_hdwr_status~+*/
unsigned long int dtk$check_hdwr_status(
    const unsigned long int  *voice_id,
    unsigned long int  *hdwr_status
    ) ;
/*~-dtk$check_hdwr_status-~*/
/*    DTK$DIAL_PHONE                                                          */
/*                                                                            */
/*    Dial the Telephone                                                      */
/*                                                                            */
/*    The Dial the Telephone routine dials the specified number on the telephone.     */
/*                                                                            */
/*+~dtk$dial_phone~+*/
unsigned long int dtk$dial_phone(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *phone_number,
    ...
    /* const unsigned long int  *dial_mode, */
    /* const struct dsc$descriptor *text, */
    /* const long int  *timeout */
    ) ;
/*~-dtk$dial_phone-~*/
/*    DTK$HANGUP_PHONE                                                        */
/*                                                                            */
/*    Hang Up the Phone                                                       */
/*                                                                            */
/*    The Hang Up the Phone routine speaks an optional message and            */
/*    then hangs up the phone.                                                */
/*                                                                            */
/*+~dtk$hangup_phone~+*/
unsigned long int dtk$hangup_phone(
    const unsigned long int  *voice_id,
    ...
    /* const struct dsc$descriptor *text */
    ) ;
/*~-dtk$hangup_phone-~*/
/*    DTK$INITIALIZE                                                          */
/*                                                                            */
/*    Initialize DECtalk                                                      */
/*                                                                            */
/*    The Initialize DECtalk routine initializes a DECtalk device and returns the device's assigned   */
/*    voice identifier.                                                       */
/*                                                                            */
/*+~dtk$initialize~+*/
unsigned long int dtk$initialize(
    unsigned long int  *voice_id,
    const struct dsc$descriptor *output_device,
    ...
    /* long int  *device_type */
    ) ;
/*~-dtk$initialize-~*/
/*    DTK$LOAD_DICTIONARY                                                     */
/*                                                                            */
/*    Load a Word into the DECtalk Dictionary                                 */
/*                                                                            */
/*    The Load a Word into the DECtalk Dictionary routine                     */
/*    loads a phonemic definition of a word into the DECtalk                  */
/*    dictionary.                                                             */
/*                                                                            */
/*+~dtk$load_dictionary~+*/
unsigned long int dtk$load_dictionary(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    const struct dsc$descriptor *substitution
    ) ;
/*~-dtk$load_dictionary-~*/
/*    DTK$READ_KEYSTROKE                                                      */
/*                                                                            */
/*    Read a Key Entered on the Keypad                                        */
/*                                                                            */
/*    The Read a Key Entered on the Keypad routine                            */
/*    reads a key entered on the phone keypad.                                */
/*                                                                            */
/*+~dtk$read_keystroke~+*/
unsigned long int dtk$read_keystroke(
    const unsigned long int  *voice_id,
    long int  *key_code,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *timeout */
    ) ;
/*~-dtk$read_keystroke-~*/
/*    DTK$READ_STRING                                                         */
/*                                                                            */
/*    Read a Series of Keys Entered on the Keypad                             */
/*                                                                            */
/*    The Read a Series of Keys Entered on the Keypad routine reads a         */
/*    series of keys entered on the phone keypad.                             */
/*                                                                            */
/*+~dtk$read_string~+*/
unsigned long int dtk$read_string(
    const unsigned long int  *voice_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *timeout, */
    /* long int  *longword_integer_termin_code */
    ) ;
/*~-dtk$read_string-~*/
/*    DTK$RETURN_LAST_INDEX                                                   */
/*                                                                            */
/*    Return Last Index Spoken                                                */
/*                                                                            */
/*    The Return Last Index Spoken routine returns the last index spoken.     */
/*                                                                            */
/*+~dtk$return_last_index~+*/
unsigned long int dtk$return_last_index(
    const unsigned long int  *voice_id,
    long int  *p_index
    ) ;
/*~-dtk$return_last_index-~*/
/*    DTK$SPELL_TEXT                                                          */
/*                                                                            */
/*    Spell Text                                                              */
/*                                                                            */
/*    The Spell Text routine causes DECtalk to pronounce each letter of       */
/*    the specified text.                                                     */
/*                                                                            */
/*+~dtk$spell_text~+*/
unsigned long int dtk$spell_text(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$spell_text-~*/
/*    DTK$SPEAK_FILE                                                          */
/*                                                                            */
/*    Speak the Text in a Specified File                                      */
/*                                                                            */
/*    The Speak the Text in a Specified File routine                          */
/*    speaks the text contained in the specified file.                        */
/*                                                                            */
/*+~dtk$speak_file~+*/
unsigned long int dtk$speak_file(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *filespec,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$speak_file-~*/
/*    DTK$SPEAK_PHONEMIC_TEXT                                                 */
/*                                                                            */
/*    Speak the Specified Phonemic Text                                       */
/*                                                                            */
/*    The Speak the Specified Phonemic Text routine                           */
/*    sends the specified phonemic text to the DECtalk device                 */
/*    to be spoken.                                                           */
/*                                                                            */
/*+~dtk$speak_phonemic_text~+*/
unsigned long int dtk$speak_phonemic_text(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$speak_phonemic_text-~*/
/*    DTK$SPEAK_TEXT                                                          */
/*                                                                            */
/*    Speak the Specified Text                                                */
/*                                                                            */
/*    The Speak the Specified Text routine                                    */
/*    sends the specified text to the DECtalk device                          */
/*    to be spoken.                                                           */
/*                                                                            */
/*+~dtk$speak_text~+*/
unsigned long int dtk$speak_text(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$speak_text-~*/
/*    DTK$SET_INDEX                                                           */
/*                                                                            */
/*    Insert an Index at the Current Position                                 */
/*                                                                            */
/*    The Insert an Index at the Current Position routine                     */
/*    inserts an index into the current output stream.                        */
/*                                                                            */
/*+~dtk$set_index~+*/
unsigned long int dtk$set_index(
    const unsigned long int  *voice_id,
    const long int  *p_index
    ) ;
/*~-dtk$set_index-~*/
/*    DTK$SET_KEYPAD_MODE                                                     */
/*                                                                            */
/*    Turn the Phone Keypad On and Off                                        */
/*                                                                            */
/*    The Turn the Phone Keypad On and Off routine turns recognition          */
/*    of the telephone keypad on or off.                                      */
/*                                                                            */
/*+~dtk$set_keypad_mode~+*/
unsigned long int dtk$set_keypad_mode(
    const unsigned long int  *voice_id,
    const unsigned long int  *keypad_mode
    ) ;
/*~-dtk$set_keypad_mode-~*/
/*    DTK$SET_LOGGING_MODE                                                    */
/*                                                                            */
/*    Set the Logging Mode for the Video Terminal Connected to the DECtalk Device     */
/*                                                                            */
/*    The Set the Logging Mode for the Video Terminal                         */
/*    Connected to the DECtalk Device routine                                 */
/*    controls the information that is displayed on the video                 */
/*    terminal while the DECtalk device is functioning.                       */
/*                                                                            */
/*+~dtk$set_logging_mode~+*/
unsigned long int dtk$set_logging_mode(
    const unsigned long int  *voice_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_logging_mode-~*/
/*    DTK$SET_MODE                                                            */
/*                                                                            */
/*    Set the Mode for the DECtalk Terminal                                   */
/*                                                                            */
/*    The Set the Mode for the DECtalk Terminal routine                       */
/*    sets or resets the mode settings of the DECtalk terminal.               */
/*                                                                            */
/*+~dtk$set_mode~+*/
unsigned long int dtk$set_mode(
    const unsigned long int  *voice_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_mode-~*/
/*    DTK$SET_SPEECH_MODE                                                     */
/*                                                                            */
/*    Turn Speech Mode On and Off                                             */
/*                                                                            */
/*    The Turn Speech Mode On and Off routine                                 */
/*    either starts or stops the DECtalk device's speech.                     */
/*                                                                            */
/*+~dtk$set_speech_mode~+*/
unsigned long int dtk$set_speech_mode(
    const unsigned long int  *voice_id,
    const unsigned long int  *new_mode,
    ...
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_speech_mode-~*/
/*    DTK$SET_TERMINAL_MODE                                                   */
/*                                                                            */
/*    Set the Mode for the Video Terminal Connected to the DECtalk Device     */
/*                                                                            */
/*    The Set the Mode for the Video Terminal                                 */
/*    Connected to the DECtalk Device routine                                 */
/*    controls the attributes of the video terminal connected                 */
/*    to the DECtalk device.                                                  */
/*                                                                            */
/*+~dtk$set_terminal_mode~+*/
unsigned long int dtk$set_terminal_mode(
    const unsigned long int  *voice_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_terminal_mode-~*/
/*    DTK$SET_VOICE                                                           */
/*                                                                            */
/*    Set Voice Characteristics                                               */
/*                                                                            */
/*    The Set Voice Characteristics routine                                   */
/*    changes the DECtalk voice characteristics to match those                */
/*    specified.                                                              */
/*                                                                            */
/*+~dtk$set_voice~+*/
unsigned long int dtk$set_voice(
    const unsigned long int  *voice_id,
    ...
    /* const long int  *new_voice, */
    /* const long int  *speech_rate, */
    /* const unsigned long int  *comma_pause, */
    /* const unsigned long int  *period_pause */
    ) ;
/*~-dtk$set_voice-~*/
/*    DTK$TERMINATE                                                           */
/*                                                                            */
/*    Terminate DECtalk                                                       */
/*                                                                            */
/*    The Terminate DECtalk routine terminates the use of an initialized DECtalk      */
/*    device.                                                                 */
/*                                                                            */
/*+~dtk$terminate~+*/
unsigned long int dtk$terminate(
    const unsigned long int  *voice_id
    ) ;
/*~-dtk$terminate-~*/
#endif
