/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:18:45 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]NCS$ROUTINE */
#ifndef NCS$ROUTINES_H
#define NCS$ROUTINES_H
 
/*** MODULE NCS$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    NCS$COMPARE                                                             */
/*                                                                            */
/*    Compare Strings                                                         */
/*                                                                            */
/*    Compares two strings using specified collating sequence as comparison   */
/*    basis.                                                                  */
/*                                                                            */
/*+~ncs$compare~+*/
long int ncs$compare(
    const unsigned long int  *cs_id,
    const struct dsc$descriptor *string_1,
    const struct dsc$descriptor *string_2
    ) ;
/*~-ncs$compare-~*/
/*    NCS$CONVERT                                                             */
/*                                                                            */
/*    Convert String                                                          */
/*                                                                            */
/*    Convert a string using the specified conversion function.               */
/*                                                                            */
/*+~ncs$convert~+*/
unsigned long int ncs$convert(
    const unsigned long int  *cf_id,
    const struct dsc$descriptor *source,
    struct dsc$descriptor *dest,
    unsigned short int  *ret_length
    ) ;
/*~-ncs$convert-~*/
/*    NCS$END_CF                                                              */
/*                                                                            */
/*    End Conversion Function                                                 */
/*                                                                            */
/*    Terminates the use of a conversion function by the calling program.     */
/*                                                                            */
/*+~ncs$end_cf~+*/
unsigned long int ncs$end_cf(
    unsigned long int  *cf_id
    ) ;
/*~-ncs$end_cf-~*/
/*    NCS$END_CS                                                              */
/*                                                                            */
/*    End Collating Sequence                                                  */
/*                                                                            */
/*    Terminates the use of a collating sequence by the calling program.      */
/*                                                                            */
/*+~ncs$end_cs~+*/
unsigned long int ncs$end_cs(
    unsigned long int  *cs_id
    ) ;
/*~-ncs$end_cs-~*/
/*    NCS$GET_CF                                                              */
/*                                                                            */
/*    Get Conversion Function                                                 */
/*                                                                            */
/*    Retrieves the definition of the named conversion function from the NCS  */
/*    library.                                                                */
/*                                                                            */
/*+~ncs$get_cf~+*/
unsigned long int ncs$get_cf(
    unsigned long int  *cf_id,
    ...
    /* const struct dsc$descriptor *cfname, */
    /* const struct dsc$descriptor *librar */
    ) ;
/*~-ncs$get_cf-~*/
/*    NCS$GET_CS                                                              */
/*                                                                            */
/*    Get Collating Sequence                                                  */
/*                                                                            */
/*    Retrieves the definition of the named collating sequence from the NCS   */
/*    library.                                                                */
/*                                                                            */
/*+~ncs$get_cs~+*/
unsigned long int ncs$get_cs(
    unsigned long int  *cs_id,
    ...
    /* const struct dsc$descriptor *csname, */
    /* const struct dsc$descriptor *librar */
    ) ;
/*~-ncs$get_cs-~*/
/*    NCS$RESTORE_CF                                                          */
/*                                                                            */
/*    Restore Conversion Function                                             */
/*                                                                            */
/*    Permits the calling program to restore the definition of a "saved"      */
/*    conversion function from a data base or an RMS file.                    */
/*                                                                            */
/*+~ncs$restore_cf~+*/
unsigned long int ncs$restore_cf(
    unsigned long int  *cf_id,
    ...
    /* const unsigned long int  *length, */
    /* const unsigned long int  *address */
    ) ;
/*~-ncs$restore_cf-~*/
/*    NCS$RESTORE_CS                                                          */
/*                                                                            */
/*    Restore Collating Sequence                                              */
/*                                                                            */
/*    Permits the calling program to restore the definition of a "saved" collating    */
/*    sequence from a data base or an RMS file.                               */
/*                                                                            */
/*+~ncs$restore_cs~+*/
unsigned long int ncs$restore_cs(
    unsigned long int  *cs_id,
    ...
    /* const unsigned long int  *length, */
    /* const unsigned long int  *address */
    ) ;
/*~-ncs$restore_cs-~*/
/*    NCS$SAVE_CF                                                             */
/*                                                                            */
/*    Save Conversion Function                                                */
/*                                                                            */
/*    Provides the calling program with information that permits the application      */
/*    to store the definition of a conversion function in a local data base or an     */
/*    RMS file rather than the NCS$LIBRARY.                                   */
/*                                                                            */
/*+~ncs$save_cf~+*/
unsigned long int ncs$save_cf(
    const unsigned long int  *cf_id,
    ...
    /* unsigned long int  *length, */
    /* unsigned long int  *address */
    ) ;
/*~-ncs$save_cf-~*/
/*    NCS$SAVE_CS                                                             */
/*                                                                            */
/*    Save Collating Sequence                                                 */
/*                                                                            */
/*    Provides the calling program with information that permits the application      */
/*    to store the definition of a collating sequence in a local data base or an      */
/*    RMS file rather than the NCS$LIBRARY.                                   */
/*                                                                            */
/*+~ncs$save_cs~+*/
unsigned long int ncs$save_cs(
    const unsigned long int  *cs_id,
    ...
    /* unsigned long int  *length, */
    /* unsigned long int  *address */
    ) ;
/*~-ncs$save_cs-~*/
#endif
