/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:22:28 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]OTS$ROUTINE */
#ifndef OTS$ROUTINES_H
#define OTS$ROUTINES_H
 
/*** MODULE OTS$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    OTS$CVT_T_D                                                             */
/*                                                                            */
/*    Convert Numeric Text to D- or F-Floating Value                          */
/*                                                                            */
/*    The Convert Numeric Text to D- or F-Floating routines                   */
/*    convert an ASCII text string representation of a                        */
/*    numeric value to a D_floating or F_floating value.                      */
/*                                                                            */
/*+~ots$cvt_t_d~+*/
unsigned long int ots$cvt_t_d(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    double float  *floating_point_value,
    ...
    /* const unsigned long int digits_in_fraction, */
    /* const long int scale_factor, */
    /* const unsigned long int flags_value, */
    /* char  *extension_bits */
    ) ;
/*~-ots$cvt_t_d-~*/
/*    OTS$CVT_T_F                                                             */
/*                                                                            */
/*    Convert Numeric Text to D- or F-Floating Value                          */
/*                                                                            */
/*    The Convert Numeric Text to D- or F-Floating routines                   */
/*    convert an ASCII text string representation of a                        */
/*    numeric value to a D_floating or F_floating value.                      */
/*                                                                            */
/*+~ots$cvt_t_f~+*/
unsigned long int ots$cvt_t_f(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    float  *floating_point_value,
    ...
    /* const unsigned long int digits_in_fraction, */
    /* const long int scale_factor, */
    /* const unsigned long int flags_value, */
    /* char  *extension_bits */
    ) ;
/*~-ots$cvt_t_f-~*/
/*    OTS$CVT_T_G                                                             */
/*                                                                            */
/*    Convert Numeric Text to G- or H-Floating Value                          */
/*                                                                            */
/*    The Convert Numeric Text to G- or H-Floating routines                   */
/*    convert an ASCII text string representation of a                        */
/*    numeric value to a G_floating or H_floating value.                      */
/*                                                                            */
/*+~ots$cvt_t_g~+*/
unsigned long int ots$cvt_t_g(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    double float  *floating_point_value,
    ...
    /* const unsigned long int digits_in_fraction, */
    /* const long int scale_factor, */
    /* const unsigned long int flags_value, */
    /* short int  *extension_bits */
    ) ;
/*~-ots$cvt_t_g-~*/
/*    OTS$CVT_T_H                                                             */
/*                                                                            */
/*    Convert Numeric Text to G- or H-Floating Value                          */
/*                                                                            */
/*    The Convert Numeric Text to G- or H-Floating routines                   */
/*    convert an ASCII text string representation of a                        */
/*    numeric value to a G_floating or H_floating value.                      */
/*                                                                            */
/*+~ots$cvt_t_h~+*/
unsigned long int ots$cvt_t_h(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    struct {int floating$$ret_0_ [4];}  *floating_point_value,
    ...
    /* const unsigned long int digits_in_fraction, */
    /* const long int scale_factor, */
    /* const unsigned long int flags_value, */
    /* short int  *extension_bits */
    ) ;
/*~-ots$cvt_t_h-~*/
/*    OTS$DIVC                                                                */
/*                                                                            */
/*    Complex Division                                                        */
/*                                                                            */
/*    The Complex Division routines                                           */
/*    return a complex result of a division on complex                        */
/*    numbers.                                                                */
/*                                                                            */
/*ENTRY ots$divc ALIAS $ots_divc PARAMETER (                                  */
/*    F_FLOATING COMPLEX NAMED complex_dividend IN                            */
/*        TYPENAME f_floating_complex VALUE,                                  */
/*    F_FLOATING COMPLEX NAMED complex_divisor IN                             */
/*        TYPENAME f_floating_complex VALUE )                                 */
/*  RETURNS F_FLOATING COMPLEX NAMED RESULT TYPENAME f_floating_complex;      */
/*    OTS$DIVCD_R3                                                            */
/*                                                                            */
/*    Complex Division                                                        */
/*                                                                            */
/*    The Complex Division routines                                           */
/*    return a complex result of a division on complex                        */
/*    numbers.                                                                */
/*                                                                            */
/*ENTRY ots$divcd_r3 ALIAS $ots_divcd_r3 PARAMETER (                          */
/*    D_FLOATING COMPLEX NAMED complex_dividend IN                            */
/*        TYPENAME d_floating_complex VALUE,                                  */
/*    D_FLOATING COMPLEX NAMED complex_divisor IN                             */
/*        TYPENAME d_floating_complex VALUE )                                 */
/*  RETURNS D_FLOATING COMPLEX NAMED RESULT TYPENAME d_floating_complex;      */
/*    OTS$DIVCG_R3                                                            */
/*                                                                            */
/*    Complex Division                                                        */
/*                                                                            */
/*    The Complex Division routines                                           */
/*    return a complex result of a division on complex                        */
/*    numbers.                                                                */
/*                                                                            */
/*ENTRY ots$divcg_r3 ALIAS $ots_divcg_r3 PARAMETER (                          */
/*    G_FLOATING COMPLEX NAMED complex_dividend IN                            */
/*        TYPENAME g_floating_complex VALUE,                                  */
/*    G_FLOATING COMPLEX NAMED complex_divisor IN                             */
/*        TYPENAME g_floatin_complex VALUE )                                  */
/*  RETURNS G_FLOATING COMPLEX NAMED RESULT TYPENAME g_floating_complex;      */
/*    OTS$DIV_PK_LONG                                                         */
/*                                                                            */
/*    Packed Decimal Division with Long Divisor                               */
/*                                                                            */
/*    The Packed Decimal Division with Long Divisor routine                   */
/*    divides fixed-point decimal data, which is stored in packed             */
/*    decimal form, when precision and scale requirements for the quotient call       */
/*    for multiple precision division. The divisor must have a precision of   */
/*    thirty or thirty-one digits.                                            */
/*                                                                            */
/*+~ots$div_pk_long~+*/
int ots$div_pk_long(
    const int  *packed_decimal_dividend,
    const int  *packed_decimal_divisor,
    const short int divisor_precision,
    int  *packed_decimal_quotient,
    const short int quotient_precision,
    const short int precision_data,
    const short int scale_data
    ) ;
/*~-ots$div_pk_long-~*/
/*    OTS$DIV_PK_SHORT                                                        */
/*                                                                            */
/*    Packed Decimal Division with Short Divisor                              */
/*                                                                            */
/*    The Packed Decimal Division with Short Divisor routine                  */
/*    divides fixed-point decimal data                                        */
/*    when precision and scale requirements for the quotient call for         */
/*    multiple-precision division.                                            */
/*                                                                            */
/*+~ots$div_pk_short~+*/
int ots$div_pk_short(
    const int  *packed_decimal_dividend,
    const int  *packed_decimal_divisor,
    const short int divisor_precision,
    int  *packed_decimal_quotient,
    const short int quotient_precision,
    const short int precision_data
    ) ;
/*~-ots$div_pk_short-~*/
/*    OTS$MOVE3                                                               */
/*                                                                            */
/*    Move Data Without Fill                                                  */
/*                                                                            */
/*    The Move Data Without Fill routine                                      */
/*    moves up to 231-1 bytes, (2,147,483,647 bytes) from a                   */
/*    specified source address to a specified destination address.            */
/*                                                                            */
/*+~ots$move3~+*/
int ots$move3(
    const long int length_value,
    const unsigned char  *source_array [1],
    unsigned char  *destination_array [1]
    ) ;
/*~-ots$move3-~*/
/*    OTS$MOVE5                                                               */
/*                                                                            */
/*    Move Data with Fill                                                     */
/*                                                                            */
/*    The Move Data with Fill routine                                         */
/*    moves up to 231-1 bytes, (2,147,483,647 bytes) from a                   */
/*    specified source address to a specified destination address,            */
/*    with separate source and destination lengths,                           */
/*    and with fill.  Overlap of the source and destination arrays            */
/*    does not affect the result.                                             */
/*                                                                            */
/*+~ots$move5~+*/
int ots$move5(
    const long int longword_int_source_length,
    const unsigned char  *source_array [1],
    const unsigned char fill_value,
    const long int longword_int_dest_length,
    unsigned char  *destination_array [1]
    ) ;
/*~-ots$move5-~*/
/*    OTS$MULCD_R3                                                            */
/*                                                                            */
/*    Complex Multiplication                                                  */
/*                                                                            */
/*    The Complex Multiplication routines                                     */
/*    calculate the complex product of two complex                            */
/*    values.                                                                 */
/*                                                                            */
/*ENTRY ots$mulcd_r3 ALIAS $ots_mulcd_r3 PARAMETER (                          */
/*    D_FLOATING COMPLEX NAMED complex_multiplier IN                          */
/*        TYPENAME d_floating_complex VALUE,                                  */
/*    D_FLOATING COMPLEX NAMED complex_multiplicand IN                        */
/*        TYPENAME d_floating_complex VALUE )                                 */
/*  RETURNS D_FLOATING COMPLEX NAMED RESULT TYPENAME d_floating_complex;      */
/*    OTS$MULCG_R3                                                            */
/*                                                                            */
/*    Complex Multiplication                                                  */
/*                                                                            */
/*    The Complex Multiplication routines                                     */
/*    calculate the complex product of two complex                            */
/*    values.                                                                 */
/*                                                                            */
/*ENTRY ots$mulcg_r3 ALIAS $ots_mulcg_r3 PARAMETER (                          */
/*    G_FLOATING COMPLEX NAMED complex_multiplier IN                          */
/*        TYPENAME g_floating_complex VALUE,                                  */
/*    G_FLOATING COMPLEX NAMED complex_multiplicand IN                        */
/*        TYPENAME g_floating_complex VALUE )                                 */
/*  RETURNS G_FLOATING COMPLEX NAMED RESULT TYPENAME g_floating_complex;      */
/*    OTS$CNVOUT                                                              */
/*                                                                            */
/*    Convert D_floating, G_floating or H_floating Number to Character String */
/*                                                                            */
/*    The Convert Floating to Character String routines convert               */
/*    a D_floating, G_floating or H_floating number                           */
/*    to a character string in                                                */
/*    the FORTRAN E format.                                                   */
/*                                                                            */
/*+~ots$cnvout~+*/
unsigned long int ots$cnvout(
    const double float  *d_g_or_h_float_pt_input_val,
    struct dsc$descriptor *fixed_length_resultant_string,
    const unsigned long int digits_in_fraction
    ) ;
/*~-ots$cnvout-~*/
/*    OTS$CNVOUT_G                                                            */
/*                                                                            */
/*    Convert D_floating, G_floating or H_floating Number to Character String */
/*                                                                            */
/*    The Convert Floating to Character String routines convert               */
/*    a D_floating, G_floating or H_floating number                           */
/*    to a character string in                                                */
/*    the FORTRAN E format.                                                   */
/*                                                                            */
/*+~ots$cnvout_g~+*/
unsigned long int ots$cnvout_g(
    const double float  *d_g_or_h_float_pt_input_val,
    struct dsc$descriptor *fixed_length_resultant_string,
    const unsigned long int digits_in_fraction
    ) ;
/*~-ots$cnvout_g-~*/
/*    OTS$CNVOUT_H                                                            */
/*                                                                            */
/*    Convert D_floating, G_floating or H_floating Number to Character String */
/*                                                                            */
/*    The Convert Floating to Character String routines convert               */
/*    a D_floating, G_floating or H_floating number                           */
/*    to a character string in                                                */
/*    the FORTRAN E format.                                                   */
/*                                                                            */
/*+~ots$cnvout_h~+*/
unsigned long int ots$cnvout_h(
    const struct {int d_g_or_h$$ret_0_ [4];}  *d_g_or_h_float_pt_input_val,
    struct dsc$descriptor *fixed_length_resultant_string,
    const unsigned long int digits_in_fraction
    ) ;
/*~-ots$cnvout_h-~*/
/*    OTS$POWCC                                                               */
/*                                                                            */
/*    Raise a Complex Base to a Complex Floating-Point Exponent               */
/*                                                                            */
/*    The Raise a Complex Base to a Complex Floating-Point Exponent routines  */
/*    return the result of raising                                            */
/*    a complex base to a complex exponent.                                   */
/*                                                                            */
/*ENTRY ots$powcc ALIAS $ots_powcc PARAMETER (                                */
/*    F_FLOATING COMPLEX NAMED complex_base IN                                */
/*        TYPENAME f_floating_complex VALUE,                                  */
/*    F_FLOATING COMPLEX NAMED complex_exponent_value IN                      */
/*        TYPENAME f_floating_complex VALUE )                                 */
/*  RETURNS F_FLOATING COMPLEX NAMED RESULT TYPENAME f_floating_complex;      */
/*    OTS$POWCDCD_R3                                                          */
/*                                                                            */
/*    Raise a Complex Base to a Complex Floating-Point Exponent               */
/*                                                                            */
/*    The Raise a Complex Base to a Complex Floating-Point Exponent routines  */
/*    raise                                                                   */
/*    a complex base to a complex exponent.                                   */
/*                                                                            */
/*ENTRY ots$powcdcd_r3 ALIAS $ots_powcdcd_r3 PARAMETER (                      */
/*    D_FLOATING COMPLEX NAMED complex_base IN                                */
/*        TYPENAME d_floating_complex VALUE,                                  */
/*    D_FLOATING COMPLEX NAMED complex_exponent_value IN                      */
/*        TYPENAME d_floating_complex VALUE )                                 */
/*  RETURNS D_FLOATING COMPLEX NAMED RESULT TYPENAME d_floating_complex;      */
/*    OTS$POWCGCG_R3                                                          */
/*                                                                            */
/*    Raise a Complex Base to a Complex Floating-Point Exponent               */
/*                                                                            */
/*    The Raise a Complex Base to a Complex Floating-Point Exponent routines  */
/*    raise                                                                   */
/*    a complex base to a complex exponent.                                   */
/*                                                                            */
/*ENTRY ots$powcgcg_r3 ALIAS $ots_powcgcg_r3 PARAMETER (                      */
/*    G_FLOATING COMPLEX NAMED complex_base IN                                */
/*        TYPENAME g_floating_complex VALUE,                                  */
/*    G_FLOATING COMPLEX NAMED complex_exponent_value IN                      */
/*        TYPENAME g_floating_complex VALUE )                                 */
/*  RETURNS G_FLOATING COMPLEX NAMED RESULT TYPENAME g_floating_complex;      */
/*    OTS$POWCJ                                                               */
/*                                                                            */
/*    Raise a Complex Base to a Signed Longword Integer Exponent              */
/*                                                                            */
/*    The Raise a Complex Base to a Signed Longword Integer Exponent          */
/*    routines return the complex result of raising a complex base to an      */
/*    integer exponent.                                                       */
/*                                                                            */
/*ENTRY ots$powcj ALIAS $ots_powcj PARAMETER (                                */
/*    F_FLOATING COMPLEX NAMED complex_base IN                                */
/*        TYPENAME f_floating_complex VALUE,                                  */
/*    LONGWORD NAMED longword_integer_exponent IN                             */
/*        TYPENAME longword_signed VALUE )                                    */
/*  RETURNS F_FLOATING COMPLEX NAMED RESULT TYPENAME f_floating_complex;      */
/*    OTS$POWCDJ_R3                                                           */
/*                                                                            */
/*    Raise a Complex Base to a Signed Longword Integer Exponent              */
/*                                                                            */
/*    The Raise a Complex Base to a Signed Longword Integer Exponent          */
/*    routines return the complex result of raising a complex base to an      */
/*    integer exponent.                                                       */
/*                                                                            */
/*ENTRY ots$powcdj_r3 ALIAS $ots_powcdj_r3 PARAMETER (                        */
/*    D_FLOATING COMPLEX NAMED complex_base IN                                */
/*        TYPENAME D_floating_complex VALUE,                                  */
/*    LONGWORD NAMED longword_integer_exponent IN                             */
/*        TYPENAME longword_signed VALUE )                                    */
/*  RETURNS D_FLOATING COMPLEX NAMED RESULT TYPENAME d_floating_complex;      */
/*    OTS$POWCGJ_R3                                                           */
/*                                                                            */
/*    Raise a Complex Base to a Signed Longword Integer Exponent              */
/*                                                                            */
/*    The Raise a Complex Base to a Signed Longword Integer Exponent          */
/*    routines return the complex result of raising a complex base to an      */
/*    integer exponent.                                                       */
/*                                                                            */
/*ENTRY ots$powcgj_r3 ALIAS $ots_powcgj_r3 PARAMETER (                        */
/*    G_FLOATING COMPLEX NAMED complex_base IN                                */
/*        TYPENAME g_floating_complex VALUE,                                  */
/*    LONGWORD NAMED longword_integer_exponent IN                             */
/*        TYPENAME longword_signed VALUE )                                    */
/*  RETURNS G_FLOATING COMPLEX NAMED RESULT TYPENAME g_floating_complex;      */
/*    OTS$POWDD                                                               */
/*                                                                            */
/*    Raise a D_floating Base to D_floating Exponent                          */
/*                                                                            */
/*    The Raise a D_floating Base to a D_floating Exponent routine            */
/*    raises a D_floating base to a D_floating                                */
/*    exponent.                                                               */
/*                                                                            */
/*ENTRY ots$powdd ALIAS $ots_powdd PARAMETER (                                */
/*    D_FLOATING NAMED D_floating_point_base IN                               */
/*        TYPENAME d_floating VALUE,                                          */
/*    D_FLOATING NAMED D_floating_point_exponent IN                           */
/*        TYPENAME d_floating VALUE )                                         */
/*  RETURNS D_FLOATING NAMED RESULT TYPENAME d_floating;                      */
/*    OTS$POWDJ                                                               */
/*                                                                            */
/*    Raise a D_floating Base to a Longword Exponent                          */
/*                                                                            */
/*    The Raise a D_floating Base to a Longword Exponent routine              */
/*    raises a D_floating base to a longword exponent.                        */
/*                                                                            */
/*ENTRY ots$powdj ALIAS $ots_powdj PARAMETER (                                */
/*    D_FLOATING NAMED D_floating_point_base IN                               */
/*        TYPENAME d_floating VALUE,                                          */
/*    LONGWORD NAMED longword_integer_exponent IN                             */
/*        TYPENAME longword_signed VALUE )                                    */
/*  RETURNS D_FLOATING NAMED RESULT TYPENAME d_floating;                      */
/*    OTS$POWDR                                                               */
/*                                                                            */
/*    Raise a D_floating Base to an F_floating Exponent                       */
/*                                                                            */
/*    The Raise a D_floating Base to an F_floating Exponent routines          */
/*    raise a D_floating base to an                                           */
/*    F_floating exponent.                                                    */
/*                                                                            */
/*ENTRY ots$powdr ALIAS $ots_powdr PARAMETER (                                */
/*    D_FLOATING NAMED D_floating_point_base IN                               */
/*        TYPENAME d_floating VALUE,                                          */
/*    F_FLOATING NAMED F_floating_point_exponent IN                           */
/*        TYPENAME f_floating VALUE )                                         */
/*  RETURNS D_FLOATING NAMED RESULT TYPENAME d_floating;                      */
/*    OTS$POWGG                                                               */
/*                                                                            */
/*    Raise a G_floating Base to a G_floating Exponent                        */
/*                                                                            */
/*    The Raise a G_floating Base to a G_floating Exponent routine            */
/*    raises a G_floating base to a G_floating exponent.                      */
/*                                                                            */
/*ENTRY ots$powgg ALIAS $ots_powgg PARAMETER (                                */
/*    G_FLOATING NAMED G_floating_point_base IN                               */
/*        TYPENAME g_floating VALUE,                                          */
/*    G_FLOATING NAMED G_floating_point_exponent IN                           */
/*        TYPENAME g_floating VALUE )                                         */
/*  RETURNS G_FLOATING NAMED RESULT TYPENAME g_floating;                      */
/*    OTS$POWGJ                                                               */
/*                                                                            */
/*    Raise a G_floating Base to a Longword Exponent                          */
/*                                                                            */
/*    The Raise a G_floating Base to a Longword Exponent routine              */
/*    raises a G_floating base to a longword exponent.                        */
/*                                                                            */
/*ENTRY ots$powgj ALIAS $ots_powgj PARAMETER (                                */
/*    G_FLOATING NAMED G_floating_point_base IN                               */
/*        TYPENAME g_floating VALUE,                                          */
/*    LONGWORD NAMED longword_integer_exponent IN                             */
/*        TYPENAME longword_signed VALUE )                                    */
/*  RETURNS G_FLOATING NAMED RESULT TYPENAME g_floating;                      */
/*    OTS$POWHH_R3                                                            */
/*                                                                            */
/*    Raise an H_floating Base to an H_floating Exponent                      */
/*                                                                            */
/*    The Raise an H_floating Base to an H_floating Exponent                  */
/*    routine raises an H_floating base to an H_floating exponent.            */
/*                                                                            */
/*ENTRY ots$powhh_r3 ALIAS $ots_powhh_r3 PARAMETER (                          */
/*    H_FLOATING NAMED H_floating_point_base IN                               */
/*        TYPENAME h_floating VALUE,                                          */
/*    H_FLOATING NAMED H_floating_point_exponent IN                           */
/*        TYPENAME h_floating VALUE )                                         */
/*  RETURNS H_FLOATING NAMED RESULT TYPENAME h_floating;                      */
/*    OTS$POWHJ_R3                                                            */
/*                                                                            */
/*    Raise an H_floating Base to an Longword Exponent                        */
/*                                                                            */
/*    The Raise an H_floating Base to a Longword Exponent                     */
/*    routine raises an H_floating base to a longword exponent.               */
/*                                                                            */
/*ENTRY ots$powhj_r3 ALIAS $ots_powhj_r3 PARAMETER (                          */
/*    H_FLOATING NAMED H_floating_point_base IN                               */
/*        TYPENAME h_floating VALUE,                                          */
/*    LONGWORD NAMED longword_integer_exponent IN                             */
/*        TYPENAME longword_signed VALUE )                                    */
/*  RETURNS H_FLOATING NAMED RESULT TYPENAME h_floating;                      */
/*    OTS$POWII                                                               */
/*                                                                            */
/*    Raise a Word Base to a Word Exponent                                    */
/*                                                                            */
/*    The Raise a Word Base to a Word Exponent routine                        */
/*    raises a word base to a word exponent.                                  */
/*                                                                            */
/*+~ots$powii~+*/
short int ots$powii(
    const short int word_integer_base,
    const short int word_integer_exponent
    ) ;
/*~-ots$powii-~*/
/*    OTS$POWJJ                                                               */
/*                                                                            */
/*    Raise a Longword Base to a Longword Exponent                            */
/*                                                                            */
/*    The Raise a Longword Base to a Longword Exponent routine                */
/*    raises a signed longword base to a signed longword exponent.            */
/*                                                                            */
/*+~ots$powjj~+*/
long int ots$powjj(
    const long int longword_integer_base,
    const long int longword_integer_exponent
    ) ;
/*~-ots$powjj-~*/
/*    OTS$POWLULU                                                             */
/*                                                                            */
/*    Raise an Unsigned Longword Base to an Unsigned Longword Exponent        */
/*                                                                            */
/*    The Raise an Unsigned Longword Base to an Unsigned Longword             */
/*    Exponent routine                                                        */
/*    raises an unsigned longword integer base to                             */
/*    an unsigned longword integer exponent.                                  */
/*                                                                            */
/*+~ots$powlulu~+*/
unsigned long int ots$powlulu(
    const unsigned long int unsigned_lword_int_base,
    const unsigned long int unsigned_lword_int_exponent
    ) ;
/*~-ots$powlulu-~*/
/*    OTS$POWRD                                                               */
/*                                                                            */
/*    Raise an F_floating Base to D_floating Exponent                         */
/*                                                                            */
/*    The Raise an F_floating Base to a D_floating Exponent                   */
/*    routine raises an F_floating base to a D_floating                       */
/*    exponent.                                                               */
/*                                                                            */
/*ENTRY ots$powrd ALIAS $ots_powrd PARAMETER (                                */
/*    F_FLOATING NAMED F_floating_point_base IN                               */
/*        TYPENAME f_floating VALUE,                                          */
/*    D_FLOATING NAMED D_floating_point_exponent IN                           */
/*        TYPENAME d_floating VALUE )                                         */
/*  RETURNS D_FLOATING NAMED RESULT TYPENAME d_floating;                      */
/*    OTS$POWRJ                                                               */
/*                                                                            */
/*    Raise an F_floating Base to a Longword Exponent                         */
/*                                                                            */
/*    The Raise an F_floating Base to a Longword Exponent                     */
/*    routine raises an F_floating base to a longword exponent.               */
/*                                                                            */
/*+~ots$powrj~+*/
float ots$powrj(
    const float f_floating_point_base,
    const long int longword_integer_exponent
    ) ;
/*~-ots$powrj-~*/
/*    OTS$POWRR                                                               */
/*                                                                            */
/*    Raise an F_floating Base to F_floating Exponent                         */
/*                                                                            */
/*    The Raise an F_floating Base to an F_floating Exponent                  */
/*    routine raises an F_floating base to an F_floating                      */
/*    exponent.                                                               */
/*                                                                            */
/*+~ots$powrr~+*/
float ots$powrr(
    const float f_floating_point_base,
    const float f_floating_point_exponent
    ) ;
/*~-ots$powrr-~*/
/*    OTS$POWRLU                                                              */
/*                                                                            */
/*    Raise a Floating-Point Base to an Unsigned Longword Integer Exponent    */
/*                                                                            */
/*    The Raise a Floating-Point Base to an Unsigned Longword Integer         */
/*    Exponent routines raises                                                */
/*    a floating-point base to an unsigned longword integer exponent.         */
/*                                                                            */
/*+~ots$powrlu~+*/
float ots$powrlu(
    const float floating_point_base,
    const unsigned long int unsigned_lword_int_exponent
    ) ;
/*~-ots$powrlu-~*/
/*    OTS$POWDLU                                                              */
/*                                                                            */
/*    Raise a Floating-Point Base to an Unsigned Longword Integer Exponent    */
/*                                                                            */
/*    The Raise a Floating-Point Base to an Unsigned Longword Integer         */
/*    Exponent routines raises                                                */
/*    a floating-point base to an unsigned longword integer exponent.         */
/*                                                                            */
/*ENTRY ots$powdlu ALIAS $ots_powdlu PARAMETER (                              */
/*    D_FLOATING NAMED floating_point_base IN                                 */
/*        TYPENAME d_floating VALUE,                                          */
/*    LONGWORD UNSIGNED NAMED unsigned_lword_int_exponent IN                  */
/*        TYPENAME longword_unsigned VALUE )                                  */
/*  RETURNS D_FLOATING NAMED RESULT TYPENAME d_floating;                      */
/*    OTS$POWGLU                                                              */
/*                                                                            */
/*    Raise a Floating-Point Base to an Unsigned Longword Integer Exponent    */
/*                                                                            */
/*    The Raise a Floating-Point Base to an Unsigned Longword Integer         */
/*    Exponent routines raises                                                */
/*    a floating-point base to an unsigned longword integer exponent.         */
/*                                                                            */
/*ENTRY ots$powglu ALIAS $ots_powglu PARAMETER (                              */
/*    G_FLOATING NAMED floating_point_base IN                                 */
/*        TYPENAME g_floating VALUE,                                          */
/*    LONGWORD UNSIGNED NAMED unsigned_lword_int_exponent IN                  */
/*        TYPENAME longword_unsigned VALUE )                                  */
/*  RETURNS G_FLOATING NAMED RESULT TYPENAME g_floating;                      */
/*    OTS$POWHLU_R3                                                           */
/*                                                                            */
/*    Raise a Floating-Point Base to an Unsigned Longword Integer Exponent    */
/*                                                                            */
/*    The Raise a Floating-Point Base to an Unsigned Longword Integer         */
/*    Exponent routines raises                                                */
/*    a floating-point base to an unsigned longword integer exponent.         */
/*                                                                            */
/*ENTRY ots$powhlu_r3 ALIAS $ots_powhlu_r3 PARAMETER (                        */
/*    H_FLOATING NAMED floating_point_base IN                                 */
/*        TYPENAME h_floating VALUE,                                          */
/*    LONGWORD UNSIGNED NAMED unsigned_lword_int_exponent IN                  */
/*        TYPENAME longword_unsigned VALUE )                                  */
/*  RETURNS H_FLOATING NAMED RESULT TYPENAME h_floating;                      */
/*    OTS$SCOPY_DXDX                                                          */
/*                                                                            */
/*    Copy a Source String Passed by Descriptor to a Destination String       */
/*                                                                            */
/*    The Copy a Source String Passed by Descriptor to a Destination String   */
/*    routine                                                                 */
/*    copies a source string to a destination string. Both strings are        */
/*    passed by descriptor.                                                   */
/*                                                                            */
/*+~ots$scopy_dxdx~+*/
unsigned short int ots$scopy_dxdx(
    const struct dsc$descriptor *source_string,
    struct dsc$descriptor *destination_string
    ) ;
/*~-ots$scopy_dxdx-~*/
/*    OTS$SCOPY_R_DX                                                          */
/*                                                                            */
/*    Copy a Source String Passed by Reference to a Destination String        */
/*                                                                            */
/*    The Copy a Source String Passed by Reference to a Destination String    */
/*    routine copies a source string passed by reference to a destination     */
/*    string.                                                                 */
/*                                                                            */
/*+~ots$scopy_r_dx~+*/
unsigned short int ots$scopy_r_dx(
    const unsigned short int word_int_source_length_val,
    const char  *source_string_address,
    struct dsc$descriptor *destination_string
    ) ;
/*~-ots$scopy_r_dx-~*/
/*    OTS$SFREE1_DD                                                           */
/*                                                                            */
/*    Strings, Free One Dynamic                                               */
/*                                                                            */
/*    The Free One Dynamic String routine                                     */
/*    returns one dynamic string area to free storage.                        */
/*                                                                            */
/*+~ots$sfree1_dd~+*/
int ots$sfree1_dd(
    unsigned int  *dynamic_descriptor [2]
    ) ;
/*~-ots$sfree1_dd-~*/
/*    OTS$SFREEN_DD                                                           */
/*                                                                            */
/*    Strings, Free n Dynamic                                                 */
/*                                                                            */
/*    The Free n Dynamic Strings routine                                      */
/*    takes as input a vector of one or more dynamic string areas and         */
/*    returns them to free storage.                                           */
/*                                                                            */
/*+~ots$sfreen_dd~+*/
int ots$sfreen_dd(
    const unsigned long int descriptor_count_value,
    unsigned int  *first_descriptor [2]
    ) ;
/*~-ots$sfreen_dd-~*/
/*    OTS$SGET1_DD                                                            */
/*                                                                            */
/*    Strings, Get One Dynamic                                                */
/*                                                                            */
/*    The Get One Dynamic String routine                                      */
/*    allocates a specified number of bytes of dynamic virtual                */
/*    memory to a specified string descriptor.                                */
/*                                                                            */
/*+~ots$sget1_dd~+*/
int ots$sget1_dd(
    const unsigned short int word_integer_length_value,
    unsigned int  *dynamic_descriptor [2]
    ) ;
/*~-ots$sget1_dd-~*/
/*    OTS$CVT_L_TB                                                            */
/*                                                                            */
/*    Convert an Unsigned Integer to Binary Text                              */
/*                                                                            */
/*    The Convert an Unsigned Integer to Binary Text routine                  */
/*    converts an unsigned integer value of arbitrary length to               */
/*    binary representation in an ASCII text string. By default, a longword is*/
/*    converted.                                                              */
/*                                                                            */
/*+~ots$cvt_l_tb~+*/
unsigned long int ots$cvt_l_tb(
    const int  *varying_input_value,
    struct dsc$descriptor *fixed_length_resultant_string,
    ...
    /* const long int number_of_digits, */
    /* const long int input_value_size */
    ) ;
/*~-ots$cvt_l_tb-~*/
/*    OTS$CVT_L_TI                                                            */
/*                                                                            */
/*    Convert Signed Integer to Decimal Text                                  */
/*                                                                            */
/*    The Convert Signed Integer to Decimal Text routine                      */
/*    converts a signed integer to a decimal ASCII text string. This          */
/*    routine supports FORTRAN Iw and Iw.m output and BASIC output conversion.        */
/*                                                                            */
/*+~ots$cvt_l_ti~+*/
unsigned long int ots$cvt_l_ti(
    const int  *varying_input_value,
    struct dsc$descriptor *fixed_length_resultant_string,
    ...
    /* const long int number_of_digits, */
    /* const long int input_value_size, */
    /* const unsigned long int flags_value */
    ) ;
/*~-ots$cvt_l_ti-~*/
/*    OTS$CVT_L_TL                                                            */
/*                                                                            */
/*    Convert Integer to Logical Text                                         */
/*                                                                            */
/*    The Convert Integer to Logical Text routine                             */
/*    converts an integer to an ASCII text string representation              */
/*    using FORTRAN L (logical) format.                                       */
/*                                                                            */
/*+~ots$cvt_l_tl~+*/
unsigned long int ots$cvt_l_tl(
    const long int  *longword_integer_value,
    struct dsc$descriptor *fixed_length_resultant_string
    ) ;
/*~-ots$cvt_l_tl-~*/
/*    OTS$CVT_L_TO                                                            */
/*                                                                            */
/*    Convert Unsigned Integer to Octal Text                                  */
/*                                                                            */
/*    The Convert Unsigned Integer to Octal Text routine                      */
/*    converts an unsigned integer to an octal ASCII text string.             */
/*    OTS$CVT_L_TO supports FORTRAN Ow and Ow.m output conversion formats.    */
/*                                                                            */
/*+~ots$cvt_l_to~+*/
unsigned long int ots$cvt_l_to(
    const int  *varying_input_value,
    struct dsc$descriptor *fixed_length_resultant_string,
    ...
    /* const long int number_of_digits, */
    /* const long int input_value_size */
    ) ;
/*~-ots$cvt_l_to-~*/
/*    OTS$CVT_L_TU                                                            */
/*                                                                            */
/*    Convert Unsigned Integer to Decimal Text                                */
/*                                                                            */
/*    The Convert Unsigned Integer to Decimal Text routine                    */
/*    converts a byte, word or longword value to unsigned decimal             */
/*    representation in an ASCII text string. By default, a longword is       */
/*    converted.                                                              */
/*                                                                            */
/*+~ots$cvt_l_tu~+*/
unsigned long int ots$cvt_l_tu(
    const int  *varying_input_value,
    struct dsc$descriptor *fixed_length_resultant_string,
    ...
    /* const long int number_of_digits, */
    /* const long int input_value_size */
    ) ;
/*~-ots$cvt_l_tu-~*/
/*    OTS$CVT_L_TZ                                                            */
/*                                                                            */
/*    Convert Integer to Hexadecimal Text                                     */
/*                                                                            */
/*    The Convert Integer to Hexadecimal Text routine                         */
/*    converts an unsigned integer to a hexadecimal ASCII text                */
/*    string. OTS$CVT_L_TZ supports FORTRAN Zw and Zw.m output conversion     */
/*    formats.                                                                */
/*                                                                            */
/*+~ots$cvt_l_tz~+*/
unsigned long int ots$cvt_l_tz(
    const int  *varying_input_value,
    struct dsc$descriptor *fixed_length_resultant_string,
    ...
    /* const long int number_of_digits, */
    /* const long int input_value_size */
    ) ;
/*~-ots$cvt_l_tz-~*/
/*    OTS$CVT_TB_L                                                            */
/*                                                                            */
/*    Convert Binary Text to Unsigned Integer                                 */
/*                                                                            */
/*    The Convert Binary Text to Unsigned Integer routine                     */
/*    converts an ASCII text string representation of an unsigned             */
/*    binary value to an unsigned integer value of arbitrary length. By default,      */
/*    the result is a longword. Valid input characters are the blank and the  */
/*    digits 0 and 1. No sign is permitted.                                   */
/*                                                                            */
/*+~ots$cvt_tb_l~+*/
unsigned long int ots$cvt_tb_l(
    const struct dsc$descriptor *input_string,
    int  *varying_output_value,
    ...
    /* const long int output_value_size, */
    /* const unsigned long int flags_value */
    ) ;
/*~-ots$cvt_tb_l-~*/
/*    OTS$CVT_TI_L                                                            */
/*                                                                            */
/*    Convert Signed Integer Text to Integer                                  */
/*                                                                            */
/*    The Convert Signed Integer Text to Integer routine                      */
/*    converts an ASCII text string representation of a decimal               */
/*    number to a signed byte, word, or longword integer value.               */
/*    The result is a longword by                                             */
/*    default, but the calling program can specify a byte or a word value     */
/*    instead.                                                                */
/*                                                                            */
/*+~ots$cvt_ti_l~+*/
unsigned long int ots$cvt_ti_l(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    int  *varying_output_value,
    ...
    /* const long int output_value_size, */
    /* const unsigned long int flags_value */
    ) ;
/*~-ots$cvt_ti_l-~*/
/*    OTS$CVT_TL_L                                                            */
/*                                                                            */
/*    Convert Logical Text to Integer                                         */
/*                                                                            */
/*    The Convert Logical Text to Integer routine                             */
/*    converts an ASCII text string representation of a FORTRAN-77 L          */
/*    format to a byte, word, or longword integer value. The result is a longword by  */
/*    default, but the calling program can specify a byte or a word value     */
/*    instead.                                                                */
/*                                                                            */
/*+~ots$cvt_tl_l~+*/
unsigned long int ots$cvt_tl_l(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    int  *varying_output_value,
    ...
    /* const long int output_value_size */
    ) ;
/*~-ots$cvt_tl_l-~*/
/*    OTS$CVT_TO_L                                                            */
/*                                                                            */
/*    Convert Octal Text to Signed Integer                                    */
/*                                                                            */
/*    The Convert Octal Text to Signed Integer routine                        */
/*    converts an ASCII text string representation of an                      */
/*    octal value to an signed integer of an arbitrary length. The result is a*/
/*    longword by default, but the calling program can specify a byte, word,  */
/*    or longword.                                                            */
/*                                                                            */
/*+~ots$cvt_to_l~+*/
unsigned long int ots$cvt_to_l(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    int  *varying_output_value,
    ...
    /* const long int output_value_size, */
    /* const unsigned long int flags_value */
    ) ;
/*~-ots$cvt_to_l-~*/
/*    OTS$CVT_TU_L                                                            */
/*                                                                            */
/*    Convert Unsigned Decimal Text to Integer                                */
/*                                                                            */
/*    The Convert Unsigned Decimal Text to Integer routine                    */
/*    converts an ASCII text string representation of an unsigned             */
/*    decimal value to an unsigned byte, word, or longword value. By default, the     */
/*    result is a longword. Valid input characters are the space and the digits 0     */
/*    through 9. No sign is permitted.                                        */
/*                                                                            */
/*+~ots$cvt_tu_l~+*/
unsigned long int ots$cvt_tu_l(
    const struct dsc$descriptor *fixed_length_input_string,
    int  *varying_output_value,
    ...
    /* const long int output_value_size, */
    /* const unsigned long int flags_value */
    ) ;
/*~-ots$cvt_tu_l-~*/
/*    OTS$CVT_TZ_L                                                            */
/*                                                                            */
/*    Convert Hexadecimal Text to Unsigned Integer                            */
/*                                                                            */
/*    The Convert Hexadecimal Text to Unsigned Integer routine                */
/*    converts an ASCII text string representation of an unsigned             */
/*    hexadecimal value to an unsigned integer of an arbitrary length.        */
/*    The result is a longword by default, but the calling program can specify*/
/*    a byte, word, or longword                                               */
/*    value.                                                                  */
/*                                                                            */
/*+~ots$cvt_tz_l~+*/
unsigned long int ots$cvt_tz_l(
    const struct dsc$descriptor *fixed_or_dynamic_input_string,
    int  *varying_input_value,
    ...
    /* const long int input_value_size, */
    /* const unsigned long int flags_value */
    ) ;
/*~-ots$cvt_tz_l-~*/
#endif
