/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:28:38 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]SMG$ROUTINE */
#ifndef SMG$ROUTINES_H
#define SMG$ROUTINES_H
 
/*** MODULE SMG$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    SMG$ADD_KEY_DEF                                                         */
/*                                                                            */
/*    Add Key Definition                                                      */
/*                                                                            */
/*    The Add Key Definition routine adds a keypad key definition to a table  */
/*    of key definitions.                                                     */
/*                                                                            */
/*+~smg$add_key_def~+*/
unsigned long int smg$add_key_def(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *key_name,
    ...
    /* const struct dsc$descriptor *if_state, */
    /* const unsigned long int  *attributes, */
    /* const struct dsc$descriptor *equivalence_string, */
    /* const struct dsc$descriptor *state_string */
    ) ;
/*~-smg$add_key_def-~*/
/*    SMG$ALLOW_ESCAPE                                                        */
/*                                                                            */
/*    Allow Escape Sequences                                                  */
/*                                                                            */
/*    SMG$ALLOW_ESCAPE enables or disables SMG parsing of escape sequences which are  */
/*    output to a virtual display.                                            */
/*                                                                            */
/*+~smg$allow_escape~+*/
unsigned long int smg$allow_escape(
    const unsigned long int  *display_id,
    const unsigned long int  *flags
    ) ;
/*~-smg$allow_escape-~*/
/*    SMG$BEGIN_DISPLAY_UPDATE                                                */
/*                                                                            */
/*    Begin Batching of Display Updates                                       */
/*                                                                            */
/*    The Begin Batching of Display Updates routine saves, or batches, all    */
/*    output to a virtual display until a matching call to                    */
/*    SMG$END_DISPLAY_UPDATE is encountered.                                  */
/*                                                                            */
/*+~smg$begin_display_update~+*/
unsigned long int smg$begin_display_update(
    const unsigned long int  *display_id
    ) ;
/*~-smg$begin_display_update-~*/
/*    SMG$BEGIN_PASTEBOARD_UPDATE                                             */
/*                                                                            */
/*    Begin Batching of Pasteboard Updates                                    */
/*                                                                            */
/*    The Begin Batching of Pasteboard Updates routine saves, or batches,     */
/*    all output to a pasteboard until a matching call to                     */
/*    SMG$END_PASTEBOARD_UPDATE is encountered.                               */
/*                                                                            */
/*+~smg$begin_pasteboard_update~+*/
unsigned long int smg$begin_pasteboard_update(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$begin_pasteboard_update-~*/
/*    SMG$CANCEL_INPUT                                                        */
/*                                                                            */
/*    Cancel Input Request                                                    */
/*                                                                            */
/*    The Cancel Input Request routine immediately cancels any                */
/*    read-in-progress that was issued by SMG$READ_COMPOSED_LINE,             */
/*    SMG$READ_KEYSTROKE, SMG$READ_STRING or SMG$READ_VERIFY.                 */
/*                                                                            */
/*+~smg$cancel_input~+*/
unsigned long int smg$cancel_input(
    const unsigned long int  *keyboard_id
    ) ;
/*~-smg$cancel_input-~*/
/*    SMG$CURSOR_COLUMN                                                       */
/*                                                                            */
/*    Return Cursor Column Position                                           */
/*                                                                            */
/*    The Return Cursor Column Position routine returns the virtual cursor's  */
/*    current column position in a specified virtual display.                 */
/*                                                                            */
/*+~smg$cursor_column~+*/
unsigned long int smg$cursor_column(
    const unsigned long int  *display_id
    ) ;
/*~-smg$cursor_column-~*/
/*    SMG$CHECK_FOR_OCCLUSION                                                 */
/*                                                                            */
/*    Check For Occlusion                                                     */
/*                                                                            */
/*    The Check for Occlusion routine checks to see whether a virtual         */
/*    display is covered (occluded) by another virtual display.               */
/*                                                                            */
/*+~smg$check_for_occlusion~+*/
unsigned long int smg$check_for_occlusion(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    long int  *occlusion_state
    ) ;
/*~-smg$check_for_occlusion-~*/
/*    SMG$CHANGE_VIEWPORT                                                     */
/*                                                                            */
/*    Change the Viewport                                                     */
/*                                                                            */
/*    The Change the Viewport Associated with a Virtual Display routine       */
/*    changes the size of an existing viewport in a virtual display. The      */
/*    text that is currently in the viewport is remapped to fit the new       */
/*    dimensions.                                                             */
/*                                                                            */
/*+~smg$change_viewport~+*/
unsigned long int smg$change_viewport(
    const unsigned long int  *display_id,
    ...
    /* const long int  *viewport_row_start, */
    /* const long int  *viewport_column_start, */
    /* const long int  *viewport_number_rows, */
    /* const long int  *viewport_number_columns */
    ) ;
/*~-smg$change_viewport-~*/
/*    SMG$CREATE_KEY_TABLE                                                    */
/*                                                                            */
/*    Create Key Table                                                        */
/*                                                                            */
/*    The Create Key Table routine creates a table for key definitions.       */
/*                                                                            */
/*+~smg$create_key_table~+*/
unsigned long int smg$create_key_table(
    unsigned long int  *key_table_id
    ) ;
/*~-smg$create_key_table-~*/
/*    SMG$CREATE_MENU                                                         */
/*                                                                            */
/*    Fill the Virtual Display With a Menu                                    */
/*                                                                            */
/*    The Fill the Virtual Display with a Menu routine displays menu choices  */
/*    in the virtual display indicated, starting at the specified row.        */
/*                                                                            */
/*+~smg$create_menu~+*/
unsigned long int smg$create_menu(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *choices,
    ...
    /* const unsigned long int  *menu_type, */
    /* const unsigned long int  *flags, */
    /* const long int  *row, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$create_menu-~*/
/*    SMG$CONTROL_MODE                                                        */
/*                                                                            */
/*    Control Mode                                                            */
/*                                                                            */
/*    The Control Mode routine controls the mode of the pasteboard. This      */
/*    includes buffering, minimal updating, whether the screen is cleared     */
/*    when the pasteboard is deleted, and whether tab characters are used     */
/*    for screen formatting.                                                  */
/*                                                                            */
/*+~smg$control_mode~+*/
unsigned long int smg$control_mode(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode, */
    /* const unsigned short int  *buffer_size */
    ) ;
/*~-smg$control_mode-~*/
/*    SMG$COPY_VIRTUAL_DISPLAY                                                */
/*                                                                            */
/*    Copy a Virtual Display                                                  */
/*                                                                            */
/*    The Copy a Virtual Display routine creates a copy of an existing        */
/*    virtual display and assigns to it a new virtual display identifier.     */
/*                                                                            */
/*+~smg$copy_virtual_display~+*/
unsigned long int smg$copy_virtual_display(
    const unsigned long int  *current_display_id,
    unsigned long int  *new_display_id
    ) ;
/*~-smg$copy_virtual_display-~*/
/*    SMG$CREATE_PASTEBOARD                                                   */
/*                                                                            */
/*    Create a Pasteboard                                                     */
/*                                                                            */
/*    The Create Pasteboard routine creates a pasteboard and returns its assigned     */
/*    pasteboard identifier.                                                  */
/*                                                                            */
/*+~smg$create_pasteboard~+*/
unsigned long int smg$create_pasteboard(
    unsigned long int  *pasteboard_id,
    ...
    /* const struct dsc$descriptor *output_device, */
    /* long int  *number_of_pasteboard_rows, */
    /* long int  *number_of_pasteboard_columns, */
    /* const unsigned long int  *flags, */
    /* unsigned long int  *type_of_terminal */
    ) ;
/*~-smg$create_pasteboard-~*/
/*    SMG$CHANGE_PBD_CHARACTERISTICS                                          */
/*                                                                            */
/*    Change Pasteboard Characteristics                                       */
/*                                                                            */
/*    The Change Pasteboad Characteristics routine lets you change the characteristics*/
/*    associated with a pasteboard.                                           */
/*                                                                            */
/*+~smg$change_pbd_characteristics~+*/
unsigned long int smg$change_pbd_characteristics(
    const unsigned long int  *pasteboard_id,
    ...
    /* const long int  *desired_width, */
    /* long int  *width, */
    /* const long int  *desired_height, */
    /* long int  *height, */
    /* const unsigned long int  *desired_background_color, */
    /* unsigned long int  *background_color */
    ) ;
/*~-smg$change_pbd_characteristics-~*/
/*    SMG$CHANGE_RENDITION                                                    */
/*                                                                            */
/*    Change Default Rendition                                                */
/*                                                                            */
/*    The Change Default Rendition routine changes the video attributes for all or part of a  */
/*    virtual display.                                                        */
/*                                                                            */
/*+~smg$change_rendition~+*/
unsigned long int smg$change_rendition(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *number_of_rows,
    const long int  *number_of_columns,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$change_rendition-~*/
/*    SMG$CURSOR_ROW                                                          */
/*                                                                            */
/*    Return Cursor Row Position                                              */
/*                                                                            */
/*    The Return Cursor Row Position routine returns the virtual cursor's     */
/*    current row position in a specified virtual display.                    */
/*                                                                            */
/*+~smg$cursor_row~+*/
unsigned long int smg$cursor_row(
    const unsigned long int  *display_id
    ) ;
/*~-smg$cursor_row-~*/
/*    SMG$CREATE_SUBPROCESS                                                   */
/*                                                                            */
/*    Create and Initialize a Subprocess                                      */
/*                                                                            */
/*    The Create and Initialize a Subprocess routine creates a DCL            */
/*    subprocess and associates it with a virtual display.                    */
/*                                                                            */
/*+~smg$create_subprocess~+*/
unsigned long int smg$create_subprocess(
    const unsigned long int  *display_id,
    ...
    /* const int *ast_routine, */
    /* const unsigned long int ast_argument */
    ) ;
/*~-smg$create_subprocess-~*/
/*    SMG$CREATE_VIRTUAL_DISPLAY                                              */
/*                                                                            */
/*    Create a Virtual Display                                                */
/*                                                                            */
/*    The Create Virtual Display routine creates a virtual display and returns its    */
/*    assigned display identifier                                             */
/*                                                                            */
/*+~smg$create_virtual_display~+*/
unsigned long int smg$create_virtual_display(
    const long int  *number_of_rows,
    const long int  *number_of_columns,
    unsigned long int  *display_id,
    ...
    /* const unsigned long int  *display_attributes, */
    /* const unsigned long int  *video_attributes, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$create_virtual_display-~*/
/*    SMG$CHANGE_VIRTUAL_DISPLAY                                              */
/*                                                                            */
/*    Change Virtual Display                                                  */
/*                                                                            */
/*    The Change Virtual Display routine lets you change the dimensions, border, and video    */
/*    attributes of a virtual display.                                        */
/*                                                                            */
/*+~smg$change_virtual_display~+*/
unsigned long int smg$change_virtual_display(
    const unsigned long int  *display_id,
    ...
    /* const long int  *number_of_rows, */
    /* const long int  *number_of_columns, */
    /* const unsigned long int  *display_attributes, */
    /* const unsigned long int  *video_attributes, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$change_virtual_display-~*/
/*    SMG$CREATE_VIRTUAL_KEYBOARD                                             */
/*                                                                            */
/*    Create a Virtual Keyboard                                               */
/*                                                                            */
/*    The Create Virtual Keyboard routine creates a virtual keyboard and returns its assigned */
/*    keyboard identifier.                                                    */
/*                                                                            */
/*+~smg$create_virtual_keyboard~+*/
unsigned long int smg$create_virtual_keyboard(
    unsigned long int  *keyboard_id,
    ...
    /* const struct dsc$descriptor *input_device, */
    /* const struct dsc$descriptor *default_filespec, */
    /* struct dsc$descriptor *resultant_filespec, */
    /* const unsigned char  *recall_size */
    ) ;
/*~-smg$create_virtual_keyboard-~*/
/*    SMG$CREATE_VIEWPORT                                                     */
/*                                                                            */
/*    Create a Virtual Viewport                                               */
/*                                                                            */
/*    The Create a Virtual Viewport routine creates a viewport and            */
/*    associates it with a virtual display. The location and size of the      */
/*    viewport are specified by the caller.                                   */
/*                                                                            */
/*+~smg$create_viewport~+*/
unsigned long int smg$create_viewport(
    const unsigned long int  *display_id,
    const long int  *viewport_row_start,
    const long int  *viewport_column_start,
    const long int  *viewport_number_rows,
    const long int  *viewport_number_columns
    ) ;
/*~-smg$create_viewport-~*/
/*    SMG$DELETE_CHARS                                                        */
/*                                                                            */
/*    Delete Characters                                                       */
/*                                                                            */
/*    The Delete Characters routine deletes characters in a virtual display.  */
/*                                                                            */
/*+~smg$delete_chars~+*/
unsigned long int smg$delete_chars(
    const unsigned long int  *display_id,
    const long int  *number_of_characters,
    const long int  *start_row,
    const long int  *start_column
    ) ;
/*~-smg$delete_chars-~*/
/*    SMG$DEFINE_KEY                                                          */
/*                                                                            */
/*    Perform a DEFINE/KEY Command                                            */
/*                                                                            */
/*    The Perform a DEFINE/KEY Command routine performs the DEFINE/KEY        */
/*    command you provide.                                                    */
/*                                                                            */
/*+~smg$define_key~+*/
unsigned long int smg$define_key(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *command_string
    ) ;
/*~-smg$define_key-~*/
/*    SMG$DISABLE_BROADCAST_TRAPPING                                          */
/*                                                                            */
/*    Disable Broadcast Trapping                                              */
/*                                                                            */
/*    The Disable Broadcast Trapping routine disables trapping of broadcast   */
/*    messages for the specified terminal.                                    */
/*                                                                            */
/*+~smg$disable_broadcast_trapping~+*/
unsigned long int smg$disable_broadcast_trapping(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$disable_broadcast_trapping-~*/
/*    SMG$DISABLE_UNSOLICITED_INPUT                                           */
/*                                                                            */
/*    Disable Unsolicited Input                                               */
/*                                                                            */
/*    The Disable Unsolicited Input routine disables the trapping of          */
/*    unsolicited input.                                                      */
/*                                                                            */
/*+~smg$disable_unsolicited_input~+*/
unsigned long int smg$disable_unsolicited_input(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$disable_unsolicited_input-~*/
/*    SMG$DELETE_KEY_DEF                                                      */
/*                                                                            */
/*    Delete Key Definition                                                   */
/*                                                                            */
/*    The Delete Key Definition routine deletes a key definition from the     */
/*    specified table of key definitions.                                     */
/*                                                                            */
/*+~smg$delete_key_def~+*/
unsigned long int smg$delete_key_def(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *key_name,
    ...
    /* const struct dsc$descriptor *if_state */
    ) ;
/*~-smg$delete_key_def-~*/
/*    SMG$DELETE_LINE                                                         */
/*                                                                            */
/*    Delete Line                                                             */
/*                                                                            */
/*    The Delete Line routine deletes lines from a virtual display.           */
/*                                                                            */
/*+~smg$delete_line~+*/
unsigned long int smg$delete_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    ...
    /* const long int  *number_of_rows */
    ) ;
/*~-smg$delete_line-~*/
/*    SMG$DELETE_MENU                                                         */
/*                                                                            */
/*    End Access to a Menu in the Virtual Display                             */
/*                                                                            */
/*    The End Access to a Menu in the Virtual Display routine ends access to  */
/*    the menu choices in the specified virtual display.                      */
/*                                                                            */
/*+~smg$delete_menu~+*/
unsigned long int smg$delete_menu(
    const unsigned long int  *display_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$delete_menu-~*/
/*    SMG$DELETE_PASTEBOARD                                                   */
/*                                                                            */
/*    Delete Pasteboard                                                       */
/*                                                                            */
/*    The Delete Pasteboard routine deletes a pasteboard.                     */
/*                                                                            */
/*+~smg$delete_pasteboard~+*/
unsigned long int smg$delete_pasteboard(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$delete_pasteboard-~*/
/*    SMG$DRAW_CHAR                                                           */
/*                                                                            */
/*    Draw a Character in a Virtual Display                                   */
/*                                                                            */
/*    The Draw a Character in a Virtual Display routine draws a character at  */
/*    the specified position in a virtual display.                            */
/*                                                                            */
/*+~smg$draw_char~+*/
unsigned long int smg$draw_char(
    const unsigned long int  *display_id,
    const unsigned long int  *flags,
    ...
    /* const long int  *row, */
    /* const long int  *column, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$draw_char-~*/
/*    SMG$DRAW_LINE                                                           */
/*                                                                            */
/*    Draw A Line                                                             */
/*                                                                            */
/*    The Draw a Line routine draws a horizontal or vertical line.            */
/*                                                                            */
/*+~smg$draw_line~+*/
unsigned long int smg$draw_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *end_row,
    const long int  *end_column,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$draw_line-~*/
/*    SMG$DRAW_RECTANGLE                                                      */
/*                                                                            */
/*    Draw a Rectangle                                                        */
/*                                                                            */
/*    The Draw a Rectangle routine draws a rectangle.                         */
/*                                                                            */
/*+~smg$draw_rectangle~+*/
unsigned long int smg$draw_rectangle(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *end_row,
    const long int  *end_column,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$draw_rectangle-~*/
/*    SMG$DELETE_SUBPROCESS                                                   */
/*                                                                            */
/*    Terminate a Subprocess                                                  */
/*                                                                            */
/*    The Terminate a Subprocess routine deletes a subprocess that was        */
/*    created with the SMG$CREATE_SUBPROCESS routine.                         */
/*                                                                            */
/*+~smg$delete_subprocess~+*/
unsigned long int smg$delete_subprocess(
    const unsigned long int  *display_id
    ) ;
/*~-smg$delete_subprocess-~*/
/*    SMG$DEL_TERM_TABLE                                                      */
/*                                                                            */
/*    Delete Terminal Table                                                   */
/*                                                                            */
/*    The Delete Terminal Table routine terminates access to a private TERMTABLE.EXE  */
/*    and frees the associated virtual address space.                         */
/*                                                                            */
/*+~smg$del_term_table~+*/
unsigned long int smg$del_term_table() ;
/*~-smg$del_term_table-~*/
/*    SMG$DELETE_VIRTUAL_DISPLAY                                              */
/*                                                                            */
/*    Delete Virtual Display                                                  */
/*                                                                            */
/*    The Delete Virtual Display routine deletes a virtual display.           */
/*                                                                            */
/*+~smg$delete_virtual_display~+*/
unsigned long int smg$delete_virtual_display(
    const unsigned long int  *display_id
    ) ;
/*~-smg$delete_virtual_display-~*/
/*    SMG$DELETE_VIRTUAL_KEYBOARD                                             */
/*                                                                            */
/*    Delete Virtual Keyboard                                                 */
/*                                                                            */
/*    The Delete Virtual Keyboard routine deletes a virtual keyboard.         */
/*                                                                            */
/*+~smg$delete_virtual_keyboard~+*/
unsigned long int smg$delete_virtual_keyboard(
    const unsigned long int  *keyboard_id
    ) ;
/*~-smg$delete_virtual_keyboard-~*/
/*    SMG$DELETE_VIEWPORT                                                     */
/*                                                                            */
/*    Delete a Viewport                                                       */
/*                                                                            */
/*    The Delete a Viewport routine deletes the specified viewport from any   */
/*    pasteboards to which it is pasted.                                      */
/*                                                                            */
/*+~smg$delete_viewport~+*/
unsigned long int smg$delete_viewport(
    const unsigned long int  *display_id
    ) ;
/*~-smg$delete_viewport-~*/
/*    SMG$ERASE_CHARS                                                         */
/*                                                                            */
/*    Erase Characters                                                        */
/*                                                                            */
/*    The Erase Characters routine erases characters in a virtual display by  */
/*    replacing them with blanks.                                             */
/*                                                                            */
/*+~smg$erase_chars~+*/
unsigned long int smg$erase_chars(
    const unsigned long int  *display_id,
    const long int  *number_of_characters,
    const long int  *start_row,
    const long int  *start_column
    ) ;
/*~-smg$erase_chars-~*/
/*    SMG$END_DISPLAY_UPDATE                                                  */
/*                                                                            */
/*    End Display Update                                                      */
/*                                                                            */
/*    The End Display Update routine ends update batching for a virtual display.      */
/*                                                                            */
/*+~smg$end_display_update~+*/
unsigned long int smg$end_display_update(
    const unsigned long int  *display_id
    ) ;
/*~-smg$end_display_update-~*/
/*    SMG$END_PASTEBOARD_UPDATE                                               */
/*                                                                            */
/*    End Pasteboard Update                                                   */
/*                                                                            */
/*    The End Pasteboard Update routine ends update batching for a pasteboard.*/
/*                                                                            */
/*+~smg$end_pasteboard_update~+*/
unsigned long int smg$end_pasteboard_update(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$end_pasteboard_update-~*/
/*    SMG$ENABLE_UNSOLICITED_INPUT                                            */
/*                                                                            */
/*    Enable Unsolicited Input                                                */
/*                                                                            */
/*    The Enable Unsolicited Input routine detects unsolicited input and      */
/*    calls an AST routine in response.                                       */
/*                                                                            */
/*+~smg$enable_unsolicited_input~+*/
unsigned long int smg$enable_unsolicited_input(
    const unsigned long int  *pasteboard_id,
    const int *ast_routine,
    ...
    /* const unsigned long int ast_argument */
    ) ;
/*~-smg$enable_unsolicited_input-~*/
/*    SMG$ERASE_COLUMN                                                        */
/*                                                                            */
/*    Erase Column from Display                                               */
/*                                                                            */
/*    The Erase Column From Display routine erases the specified portion of   */
/*    the virtual display from the given position to the end of the column.   */
/*                                                                            */
/*+~smg$erase_column~+*/
unsigned long int smg$erase_column(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *column_number, */
    /* const long int  *end_row */
    ) ;
/*~-smg$erase_column-~*/
/*    SMG$ERASE_DISPLAY                                                       */
/*                                                                            */
/*    Erase Virtual Display                                                   */
/*                                                                            */
/*    The Erase Virtual Display routine erases all or part of a virtual       */
/*    display by replacing text characters with blanks.                       */
/*                                                                            */
/*+~smg$erase_display~+*/
unsigned long int smg$erase_display(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const long int  *end_row, */
    /* const long int  *end_column */
    ) ;
/*~-smg$erase_display-~*/
/*    SMG$ERASE_LINE                                                          */
/*                                                                            */
/*    Erase Line                                                              */
/*                                                                            */
/*    The Erase Line routine erases all or part of a line in a virtual display.       */
/*                                                                            */
/*+~smg$erase_line~+*/
unsigned long int smg$erase_line(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column */
    ) ;
/*~-smg$erase_line-~*/
/*    SMG$ERASE_PASTEBOARD                                                    */
/*                                                                            */
/*    Erase  Pasteboard                                                       */
/*                                                                            */
/*    The Erase Pasteboard routine erases the contents of a pasteboard.       */
/*                                                                            */
/*+~smg$erase_pasteboard~+*/
unsigned long int smg$erase_pasteboard(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$erase_pasteboard-~*/
/*    SMG$EXECUTE_COMMAND                                                     */
/*                                                                            */
/*    Execute Command in a Subprocess                                         */
/*                                                                            */
/*    The Execute Command in a Subprocess routine executes the specified      */
/*    command in the subprocess created with the SMG$CREATE_SUBPROCESS        */
/*    routine.                                                                */
/*                                                                            */
/*+~smg$execute_command~+*/
unsigned long int smg$execute_command(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *command_desc,
    ...
    /* const unsigned long int  *flags, */
    /* unsigned long int  *ret_status */
    ) ;
/*~-smg$execute_command-~*/
/*    SMG$FIND_CURSOR_DISPLAY                                                 */
/*                                                                            */
/*    Find Display that Contains the Cursor                                   */
/*                                                                            */
/*    The Find Display that Contains the Cursor routine returns the           */
/*    identifier of the most recently pasted virtual display that contains    */
/*    the physical cursor.                                                    */
/*                                                                            */
/*+~smg$find_cursor_display~+*/
unsigned long int smg$find_cursor_display(
    const unsigned long int  *pasteboard_id,
    unsigned long int  *display_id,
    ...
    /* const long int  *pasteboard_row, */
    /* const long int  *pasteboard_column */
    ) ;
/*~-smg$find_cursor_display-~*/
/*    SMG$FLUSH_BUFFER                                                        */
/*                                                                            */
/*    Flush Buffer                                                            */
/*                                                                            */
/*    The Flush Buffer routine flushes all buffered output to the terminal.   */
/*                                                                            */
/*+~smg$flush_buffer~+*/
unsigned long int smg$flush_buffer(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$flush_buffer-~*/
/*    SMG$GET_BROADCAST_MESSAGE                                               */
/*                                                                            */
/*    Get Broadcast Message                                                   */
/*                                                                            */
/*    The Get Broadcast Message routine determines whether a message has      */
/*    been broadcast to the pasteboard and returns the message.               */
/*                                                                            */
/*+~smg$get_broadcast_message~+*/
unsigned long int smg$get_broadcast_message(
    const unsigned long int  *pasteboard_id,
    ...
    /* struct dsc$descriptor *message, */
    /* unsigned short int  *message_length, */
    /* unsigned short int  *message_type */
    ) ;
/*~-smg$get_broadcast_message-~*/
/*    SMG$GET_CHAR_AT_PHYSICAL_CURSOR                                         */
/*                                                                            */
/*    Return Character At Cursor                                              */
/*                                                                            */
/*    The Return Character At Cursor routine returns the character at the     */
/*    current physical cursor position.                                       */
/*                                                                            */
/*+~smg$get_char_at_physical_cursor~+*/
unsigned long int smg$get_char_at_physical_cursor(
    const unsigned long int  *pasteboard_id,
    unsigned char  *character_code
    ) ;
/*~-smg$get_char_at_physical_cursor-~*/
/*    SMG$GET_DISPLAY_ATTR                                                    */
/*                                                                            */
/*    Get Display Attributes                                                  */
/*                                                                            */
/*    The Get Display Attributes routine returns the attributes associated    */
/*    with a virtual display.                                                 */
/*                                                                            */
/*+~smg$get_display_attr~+*/
unsigned long int smg$get_display_attr(
    const unsigned long int  *display_id,
    ...
    /* long int  *height, */
    /* long int  *width, */
    /* unsigned long int  *display_attributes, */
    /* unsigned long int  *video_attributes, */
    /* const unsigned long int  *character_set, */
    /* unsigned long int  *flags */
    ) ;
/*~-smg$get_display_attr-~*/
/*    SMG$GET_KEYBOARD_ATTRIBUTES                                             */
/*                                                                            */
/*    Get Keyboard Attributes                                                 */
/*                                                                            */
/*    The Get Keyboard Attributes routine gets information about a virtual    */
/*    keyboard and leaves it in a user-supplied area: the keyboard            */
/*    information table (KIT).                                                */
/*                                                                            */
/*+~smg$get_keyboard_attributes~+*/
unsigned long int smg$get_keyboard_attributes(
    const unsigned long int  *keyboard_id,
    int * *p_kit,
    const unsigned long int  *p_kit_size
    ) ;
/*~-smg$get_keyboard_attributes-~*/
/*    SMG$GET_KEY_DEF                                                         */
/*                                                                            */
/*    Get Key Definition                                                      */
/*                                                                            */
/*    The Get Key Definition routine returns the key definition for a specified key.  */
/*                                                                            */
/*+~smg$get_key_def~+*/
unsigned long int smg$get_key_def(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *key_name,
    ...
    /* const struct dsc$descriptor *if_state, */
    /* unsigned long int  *attributes, */
    /* struct dsc$descriptor *equivalence_string, */
    /* struct dsc$descriptor *state_string */
    ) ;
/*~-smg$get_key_def-~*/
/*    SMG$GET_NUMERIC_DATA                                                    */
/*                                                                            */
/*    Get Numeric Terminal Data                                               */
/*                                                                            */
/*    The Get Numeric Terminal Data routine accesses TERMTABLE.EXE and        */
/*    returns the numeric sequence that causes a terminal to perform a        */
/*    specified operation.                                                    */
/*                                                                            */
/*+~smg$get_numeric_data~+*/
unsigned long int smg$get_numeric_data(
    const int * *termtable_address,
    const unsigned long int  *request_code,
    int * *buffer_address
    ) ;
/*~-smg$get_numeric_data-~*/
/*    SMG$GET_PASTING_INFO                                                    */
/*                                                                            */
/*    Return Pasting Information                                              */
/*                                                                            */
/*    Provided that the specified virtual display is currently pasted, the    */
/*    Return Pasting Information routine returns the row and column of the    */
/*    pasting.                                                                */
/*                                                                            */
/*+~smg$get_pasting_info~+*/
unsigned long int smg$get_pasting_info(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    ...
    /* unsigned long int  *flags, */
    /* long int  *pasteboard_row, */
    /* long int  *pasteboard_column */
    ) ;
/*~-smg$get_pasting_info-~*/
/*    SMG$GET_PASTEBOARD_ATTRIBUTES                                           */
/*                                                                            */
/*    Get Pasteboard Attributes                                               */
/*                                                                            */
/*    The Get Pasteboard Attributes routine gets pasteboard attributes and    */
/*    stores them in the pasteboard information table.                        */
/*                                                                            */
/*+~smg$get_pasteboard_attributes~+*/
unsigned long int smg$get_pasteboard_attributes(
    const unsigned long int  *pasteboard_id,
    int  *pasteboard_info_table,
    const unsigned long int  *pasteboard_info_table_size
    ) ;
/*~-smg$get_pasteboard_attributes-~*/
/*    SMG$GET_TERM_DATA                                                       */
/*                                                                            */
/*    Get Terminal Data                                                       */
/*                                                                            */
/*    The Get Terminal Data routine accesses TERMTABLE.EXE and returns the    */
/*    character sequence that causes a terminal to perform a specified        */
/*    operation.                                                              */
/*                                                                            */
/*+~smg$get_term_data~+*/
unsigned long int smg$get_term_data(
    const int * *termtable_address,
    const unsigned long int  *request_code,
    const long int  *maximum_buffer_length,
    long int  *return_length,
    int * *buffer_address,
    ...
    /* const unsigned long int  *input_argument_vector [1] */
    ) ;
/*~-smg$get_term_data-~*/
/*    SMG$GET_VIEWPORT_CHAR                                                   */
/*                                                                            */
/*    Get Characteristics of Display Viewport                                 */
/*                                                                            */
/*    The Get Characteristics of Display Viewport routine returns the         */
/*    characteristics of the specified viewport.                              */
/*                                                                            */
/*+~smg$get_viewport_char~+*/
unsigned long int smg$get_viewport_char(
    const unsigned long int  *display_id,
    ...
    /* long int  *viewport_row_start, */
    /* long int  *viewport_column_start, */
    /* long int  *viewport_number_rows, */
    /* long int  *viewport_number_columns */
    ) ;
/*~-smg$get_viewport_char-~*/
/*    SMG$HOME_CURSOR                                                         */
/*                                                                            */
/*    Home Cursor                                                             */
/*                                                                            */
/*    The Home Cursor routine moves the virtual cursor to the specified       */
/*    corner of a virtual display.                                            */
/*                                                                            */
/*+~smg$home_cursor~+*/
unsigned long int smg$home_cursor(
    const unsigned long int  *display_id,
    ...
    /* const unsigned long int  *position_code */
    ) ;
/*~-smg$home_cursor-~*/
/*    SMG$INIT_TERM_TABLE                                                     */
/*                                                                            */
/*    Initialize Terminal Table                                               */
/*                                                                            */
/*    The Initialize Terminal Table routine initializes the TERMTABLE         */
/*    database for the terminal named, so that subsequent calls to            */
/*    SMG$GET_TERM_DATA can extract information and command strings for that  */
/*    terminal.                                                               */
/*                                                                            */
/*+~smg$init_term_table~+*/
unsigned long int smg$init_term_table(
    const struct dsc$descriptor *terminal_name,
    int * *termtable_address
    ) ;
/*~-smg$init_term_table-~*/
/*    SMG$INSERT_CHARS                                                        */
/*                                                                            */
/*    Insert Characters                                                       */
/*                                                                            */
/*    The Insert Characters routine inserts characters into a virtual display.*/
/*                                                                            */
/*+~smg$insert_chars~+*/
unsigned long int smg$insert_chars(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *character_string,
    const long int  *start_row,
    const long int  *start_column,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$insert_chars-~*/
/*    SMG$INSERT_LINE                                                         */
/*                                                                            */
/*    Insert Line                                                             */
/*                                                                            */
/*    The Insert Line routine inserts a line into a virtual display and       */
/*    scrolls the display.                                                    */
/*                                                                            */
/*+~smg$insert_line~+*/
unsigned long int smg$insert_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    ...
    /* const struct dsc$descriptor *character_string, */
    /* const unsigned long int  *direction, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$insert_line-~*/
/*    SMG$INIT_TERM_TABLE_BY_TYPE                                             */
/*                                                                            */
/*    Initialize TERMTABLE By VMS Terminal Type                               */
/*                                                                            */
/*    The Initialize TERMTABLE by VMS Terminal Type routine initializes the   */
/*    TERMTABLE database for the terminal named, so that subsequent calls to  */
/*    SMG$GET_TERM_DATA can extract information and command strings for that  */
/*    terminal.                                                               */
/*                                                                            */
/*+~smg$init_term_table_by_type~+*/
unsigned long int smg$init_term_table_by_type(
    const char  *terminal_type,
    int * *termtable_address,
    ...
    /* struct dsc$descriptor *terminal_name */
    ) ;
/*~-smg$init_term_table_by_type-~*/
/*    SMG$INVALIDATE_DISPLAY                                                  */
/*                                                                            */
/*    Mark a Display As Invalid                                               */
/*                                                                            */
/*    The Mark a Display as Invalid routine marks a display as invalid and    */
/*    causes the entire display to be redrawn.                                */
/*                                                                            */
/*+~smg$invalidate_display~+*/
unsigned long int smg$invalidate_display(
    const unsigned long int  *display_id
    ) ;
/*~-smg$invalidate_display-~*/
/*    SMG$KEYCODE_TO_NAME                                                     */
/*                                                                            */
/*    Translate a Key Code into a Key Name                                    */
/*                                                                            */
/*    The Translate a Key Code into a Key Name routine translates the key code        */
/*    of a key on the keyboard into its associated key name.                  */
/*                                                                            */
/*+~smg$keycode_to_name~+*/
unsigned long int smg$keycode_to_name(
    const unsigned short int  *key_code,
    struct dsc$descriptor *key_name
    ) ;
/*~-smg$keycode_to_name-~*/
/*    SMG$LABEL_BORDER                                                        */
/*                                                                            */
/*    Label A Virtual Display Border                                          */
/*                                                                            */
/*    The Label a Virtual Display Border routine supplies a label for a       */
/*    virtual display's border.                                               */
/*                                                                            */
/*+~smg$label_border~+*/
unsigned long int smg$label_border(
    const unsigned long int  *display_id,
    ...
    /* const struct dsc$descriptor *text, */
    /* const unsigned long int  *position_code, */
    /* const long int  *units, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$label_border-~*/
/*    SMG$LOAD_KEY_DEFS                                                       */
/*                                                                            */
/*    Load Key Definitions                                                    */
/*                                                                            */
/*    The Load Key Definitions routine loads a file of key definitions        */
/*    (DEFINE/KEY commands) into a specified key table.                       */
/*                                                                            */
/*+~smg$load_key_defs~+*/
unsigned long int smg$load_key_defs(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *filespec,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$load_key_defs-~*/
/*    SMG$LIST_KEY_DEFS                                                       */
/*                                                                            */
/*    List Key Definitions                                                    */
/*                                                                            */
/*    The List Key Definitions routine returns, one at a time, the            */
/*    definition (equivalence string) associated with a specified             */
/*    keys in a specified key table.                                          */
/*                                                                            */
/*+~smg$list_key_defs~+*/
unsigned long int smg$list_key_defs(
    const unsigned long int  *key_table_id,
    unsigned long int  *context,
    ...
    /* struct dsc$descriptor *key_name, */
    /* struct dsc$descriptor *if_state, */
    /* unsigned long int  *attributes, */
    /* struct dsc$descriptor *equivalence_string, */
    /* struct dsc$descriptor *state_string */
    ) ;
/*~-smg$list_key_defs-~*/
/*    SMG$LIST_PASTING_ORDER                                                  */
/*                                                                            */
/*    Return Pasting Information                                              */
/*                                                                            */
/*    The Return Pasting Information routine returns the identifiers of the   */
/*    virtual displays pasted to a specified pasteboard. Optionally, the      */
/*    pasteboard row 1 and column 1 (origins) of the virtual                  */
/*    display are also returned.                                              */
/*                                                                            */
/*+~smg$list_pasting_order~+*/
unsigned long int smg$list_pasting_order(
    const unsigned long int  *pasteboard_id,
    unsigned long int  *context,
    unsigned long int  *display_id,
    ...
    /* long int  *pasteboard_row, */
    /* long int  *pasteboard_column */
    ) ;
/*~-smg$list_pasting_order-~*/
/*    SMG$LOAD_VIRTUAL_DISPLAY                                                */
/*                                                                            */
/*    Load a Virtual Display from a File                                      */
/*                                                                            */
/*    The Load a Virtual Display from a File routine creates a new virtual    */
/*    display and loads it with a virtual display saved with                  */
/*    SMG$SAVE_VIRTUAL_DISPLAY.                                               */
/*                                                                            */
/*+~smg$load_virtual_display~+*/
unsigned long int smg$load_virtual_display(
    unsigned long int  *display_id,
    ...
    /* const struct dsc$descriptor *filespec */
    ) ;
/*~-smg$load_virtual_display-~*/
/*    SMG$MOVE_VIRTUAL_DISPLAY                                                */
/*                                                                            */
/*    Move Virtual Display                                                    */
/*                                                                            */
/*    The Move Virtual Display routine relocates a virtual display on a pasteboard and*/
/*    preserves the pasting order.                                            */
/*                                                                            */
/*+~smg$move_virtual_display~+*/
unsigned long int smg$move_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column,
    ...
    /* const unsigned long int  *top_display_id */
    ) ;
/*~-smg$move_virtual_display-~*/
/*    SMG$MOVE_TEXT                                                           */
/*                                                                            */
/*    Move Text from One Virtual Display to Another                           */
/*                                                                            */
/*    The Move Text from One Virtual Display to                               */
/*    Another routine moves a rectangle of text from one virtual display to   */
/*    another virtual display. Given two points in opposite corners of the    */
/*    rectangle, SMG$MOVE_TEXT determines the desired width and height of     */
/*    the new virtual display.                                                */
/*                                                                            */
/*+~smg$move_text~+*/
unsigned long int smg$move_text(
    const unsigned long int  *display_id,
    const unsigned long int  *top_left_row,
    const unsigned long int  *top_left_column,
    const unsigned long int  *bottom_right_row,
    const unsigned long int  *bottom_right_column,
    const unsigned long int  *display_id2,
    ...
    /* const unsigned long int  *top_left_row2, */
    /* const unsigned long int  *top_left_column2, */
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$move_text-~*/
/*    SMG$NAME_TO_KEYCODE                                                     */
/*                                                                            */
/*    Translate a Key Name into a Key Code                                    */
/*                                                                            */
/*    The Translate a Key Name into a Key Code routine translates the key     */
/*    name of a key on the keyboard into its associated key code.             */
/*                                                                            */
/*+~smg$name_to_keycode~+*/
unsigned long int smg$name_to_keycode(
    const struct dsc$descriptor *key_name,
    unsigned short int  *key_code
    ) ;
/*~-smg$name_to_keycode-~*/
/*    SMG$PASTE_VIRTUAL_DISPLAY                                               */
/*                                                                            */
/*    Paste Virtual Display                                                   */
/*                                                                            */
/*    The Paste Virtual Display routine pastes a virtual display to a pasteboard.     */
/*                                                                            */
/*+~smg$paste_virtual_display~+*/
unsigned long int smg$paste_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column,
    ...
    /* const unsigned long int  *top_display_id */
    ) ;
/*~-smg$paste_virtual_display-~*/
/*    SMG$PUT_CHARS                                                           */
/*                                                                            */
/*    Write Characters to a Virtual Display                                   */
/*                                                                            */
/*    The Write Characters to a Virtual Display routine writes                */
/*    characters in a virtual display with the text you specify.              */
/*                                                                            */
/*+~smg$put_chars~+*/
unsigned long int smg$put_chars(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars-~*/
/*    SMG$PUT_CHARS_HIGHWIDE                                                  */
/*                                                                            */
/*    Write Double-Height Double-Width Characters                             */
/*                                                                            */
/*    The Write Double-Height Double-Width Characters routine writes          */
/*    double-height, double-width characters to a virtual display.            */
/*                                                                            */
/*+~smg$put_chars_highwide~+*/
unsigned long int smg$put_chars_highwide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars_highwide-~*/
/*    SMG$PUT_CHARS_MULTI                                                     */
/*                                                                            */
/*    Put Text with Multiple Renditions to Display                            */
/*                                                                            */
/*    The Put Text with Multiple Renditions to Display routine writes text with       */
/*    multiple renditions to the virtual display.                             */
/*                                                                            */
/*+~smg$put_chars_multi~+*/
unsigned long int smg$put_chars_multi(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_number, */
    /* const long int  *column_number, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *rendition_set, */
    /* const struct dsc$descriptor *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars_multi-~*/
/*    SMG$PUT_CHARS_WIDE                                                      */
/*                                                                            */
/*    Write Double-Width Characters                                           */
/*                                                                            */
/*    The Write Double-Width Characters routine writes double-width characters to a   */
/*    virtual display.                                                        */
/*                                                                            */
/*+~smg$put_chars_wide~+*/
unsigned long int smg$put_chars_wide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars_wide-~*/
/*    SMG$PUT_HELP_TEXT                                                       */
/*                                                                            */
/*    Output HELP Text to the Display                                         */
/*                                                                            */
/*    The Output HELP Text to the Display routine retrieves and outputs the   */
/*    HELP text for the specified topic in the virtual display provided.      */
/*                                                                            */
/*+~smg$put_help_text~+*/
unsigned long int smg$put_help_text(
    const unsigned long int  *display_id,
    ...
    /* const unsigned long int  *keyboard_id, */
    /* const struct dsc$descriptor *help_topic, */
    /* const struct dsc$descriptor *help_library, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$put_help_text-~*/
/*    SMG$PUT_LINE                                                            */
/*                                                                            */
/*    Write Line to Virtual Display                                           */
/*                                                                            */
/*    The Write Line to Virtual Display routine writes a line of text to a    */
/*    virtual display.                                                        */
/*                                                                            */
/*+~smg$put_line~+*/
unsigned long int smg$put_line(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_advance, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set, */
    /* const unsigned long int  *direction */
    ) ;
/*~-smg$put_line-~*/
/*    SMG$PUT_LINE_HIGHWIDE                                                   */
/*                                                                            */
/*    Write Double-Height and Double-Width Line                               */
/*                                                                            */
/*    The Write Double-Height and Double-Width Line routine writes line of    */
/*    text with double-height and double-width characters.                    */
/*                                                                            */
/*+~smg$put_line_highwide~+*/
unsigned long int smg$put_line_highwide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_advance, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_line_highwide-~*/
/*    SMG$PUT_LINE_MULTI                                                      */
/*                                                                            */
/*    Write line with Multiple Renditions to Display                          */
/*                                                                            */
/*    The Write Line with Multiple Renditions to Display routine              */
/*    writes lines with multiple renditions to the virtual display,           */
/*    optionally followed by cursor movement sequences.                       */
/*                                                                            */
/*+~smg$put_line_multi~+*/
unsigned long int smg$put_line_multi(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    const struct dsc$descriptor *rendition_set,
    ...
    /* const struct dsc$descriptor *rendition_complement, */
    /* const long int  *line_advance, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *direction, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_line_multi-~*/
/*    SMG$PUT_LINE_WIDE                                                       */
/*                                                                            */
/*    Write Double-Width Line                                                 */
/*                                                                            */
/*    The Write Double-Width Line routine writes a line of double-width text  */
/*    to a virtual display.                                                   */
/*                                                                            */
/*+~smg$put_line_wide~+*/
unsigned long int smg$put_line_wide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_advance, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_line_wide-~*/
/*    SMG$POP_VIRTUAL_DISPLAY                                                 */
/*                                                                            */
/*    Delete a Series of Virtual Displays                                     */
/*                                                                            */
/*    The Delete a Series of Virtual Displays routine deletes a specified     */
/*    virtual display and all displays that were pasted on the specified      */
/*    pasteboard on top of the specified virtual display.                     */
/*                                                                            */
/*+~smg$pop_virtual_display~+*/
unsigned long int smg$pop_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$pop_virtual_display-~*/
/*    SMG$PUT_PASTEBOARD                                                      */
/*                                                                            */
/*    Output Pasteboard Using Routine                                         */
/*                                                                            */
/*    The Output Pasteboard Using Routine routine accesses the contents of a  */
/*    pasteboard.                                                             */
/*                                                                            */
/*+~smg$put_pasteboard~+*/
unsigned long int smg$put_pasteboard(
    const unsigned long int  *pasteboard_id,
    const int *action_routine,
    const int user_argument,
    const unsigned long int  *flags
    ) ;
/*~-smg$put_pasteboard-~*/
/*    SMG$PRINT_PASTEBOARD                                                    */
/*                                                                            */
/*    Print Pasteboard Using a Print Queue                                    */
/*                                                                            */
/*    The Print Pasteboard Using a Print Queue routine prints the contents    */
/*    of the specified pasteboard on a line printer.                          */
/*                                                                            */
/*+~smg$print_pasteboard~+*/
unsigned long int smg$print_pasteboard(
    const unsigned long int  *pasteboard_id,
    ...
    /* const struct dsc$descriptor *queue_name, */
    /* const long int  *copies, */
    /* const struct dsc$descriptor *form_name */
    ) ;
/*~-smg$print_pasteboard-~*/
/*    SMG$PUT_STATUS_LINE                                                     */
/*                                                                            */
/*    Output Line of Text to Hardware Status Line                             */
/*                                                                            */
/*    The Output Line of Text to Hardware Status Line routine outputs a line  */
/*    of text to the hardware status line.                                    */
/*                                                                            */
/*+~smg$put_status_line~+*/
unsigned long int smg$put_status_line(
    const unsigned long int  *pasteboard_id,
    const struct dsc$descriptor *text
    ) ;
/*~-smg$put_status_line-~*/
/*    SMG$PUT_VIRTUAL_DISPLAY_ENCODED                                         */
/*                                                                            */
/*    Write Encoded String To Display                                         */
/*                                                                            */
/*    SMG$PUT_VIRTUAL_DISPLAY_ENCODED lets you write a string that has multiple video */
/*    renditions to a virtual display.                                        */
/*                                                                            */
/*+~smg$put_virtual_display_encoded~+*/
unsigned long int smg$put_virtual_display_encoded(
    const unsigned long int  *display_id,
    const long int  *encoded_length,
    const int  *encoded_text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *placeholder_argument, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_virtual_display_encoded-~*/
/*    SMG$PUT_WITH_SCROLL                                                     */
/*                                                                            */
/*    Write Text and Scroll                                                   */
/*                                                                            */
/*    SMG$PUT_WITH_SCROLL writes a line of text to a virtual display and scrolls the  */
/*    display if necessary.                                                   */
/*                                                                            */
/*+~smg$put_with_scroll~+*/
unsigned long int smg$put_with_scroll(
    const unsigned long int  *display_id,
    ...
    /* const struct dsc$descriptor *text, */
    /* const unsigned long int  *direction, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_with_scroll-~*/
/*    SMG$RING_BELL                                                           */
/*                                                                            */
/*    Ring the Terminal Bell or Buzzer                                        */
/*                                                                            */
/*    The Ring the Terminal Bell or Buzzer routine sounds the terminal bell or buzzer.*/
/*                                                                            */
/*+~smg$ring_bell~+*/
unsigned long int smg$ring_bell(
    const unsigned long int  *display_id,
    ...
    /* const long int  *number_of_times */
    ) ;
/*~-smg$ring_bell-~*/
/*    SMG$READ_COMPOSED_LINE                                                  */
/*                                                                            */
/*    Read Composed Line                                                      */
/*                                                                            */
/*    The Read Composed Line routine reads a line of input composed of        */
/*    normal keystrokes and equivalence strings.                              */
/*                                                                            */
/*+~smg$read_composed_line~+*/
unsigned long int smg$read_composed_line(
    const unsigned long int  *keyboard_id,
    const unsigned long int  *key_table_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length, */
    /* const unsigned long int  *display_id, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *initial_string, */
    /* const long int  *timeout, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* unsigned short int  *word_terminator_code */
    ) ;
/*~-smg$read_composed_line-~*/
/*    SMG$REMOVE_LINE                                                         */
/*                                                                            */
/*    Remove a Line from a Virtual Display                                    */
/*                                                                            */
/*    The Remove a Line from a Virtual Display routine removes a line from a  */
/*    specified virtual display that was drawn with the SMG$DRAW_LINE or      */
/*    SMG$DRAW_RECTANGLE routines.                                            */
/*                                                                            */
/*+~smg$remove_line~+*/
unsigned long int smg$remove_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *end_row,
    const long int  *end_column
    ) ;
/*~-smg$remove_line-~*/
/*    SMG$REPLACE_INPUT_LINE                                                  */
/*                                                                            */
/*    Replace Input Line                                                      */
/*                                                                            */
/*    The Replace Input Line routine replaces the specified lines in the      */
/*    recall buffer with the specified string.                                */
/*                                                                            */
/*+~smg$replace_input_line~+*/
unsigned long int smg$replace_input_line(
    const unsigned long int  *keyboard_id,
    ...
    /* const struct dsc$descriptor *replace_string, */
    /* const unsigned char  *line_count */
    ) ;
/*~-smg$replace_input_line-~*/
/*    SMG$RETURN_INPUT_LINE                                                   */
/*                                                                            */
/*    Return Input Line                                                       */
/*                                                                            */
/*    The Return Input Line routine returns to the caller the requested line from the recall  */
/*    buffer. This line is retrieved either by matching it with a specified string or */
/*    by specifying the appropriate line number.                              */
/*                                                                            */
/*+~smg$return_input_line~+*/
unsigned long int smg$return_input_line(
    const unsigned long int  *keyboard_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *match_string, */
    /* const unsigned char  *byte_integer_line_number, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-smg$return_input_line-~*/
/*    SMG$READ_FROM_DISPLAY                                                   */
/*                                                                            */
/*    Read Text from Display                                                  */
/*                                                                            */
/*    The Read Text from Display routine reads a line of text from a virtual display. */
/*                                                                            */
/*+~smg$read_from_display~+*/
unsigned long int smg$read_from_display(
    const unsigned long int  *display_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *terminator_string, */
    /* const long int  *start_row */
    ) ;
/*~-smg$read_from_display-~*/
/*    SMG$READ_KEYSTROKE                                                      */
/*                                                                            */
/*    Read a Single Character                                                 */
/*                                                                            */
/*    The Read a Single Character routine reads a keystroke and returns that  */
/*    keystroke's terminator code.                                            */
/*                                                                            */
/*+~smg$read_keystroke~+*/
unsigned long int smg$read_keystroke(
    const unsigned long int  *keyboard_id,
    unsigned short int  *word_terminator_code,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *timeout, */
    /* const unsigned long int  *display_id, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$read_keystroke-~*/
/*    SMG$REPAINT_LINE                                                        */
/*                                                                            */
/*    Repaint One or More Lines on the Current Pasteboard                     */
/*                                                                            */
/*    The Repaint One or More Lines on the Current Pasteboard routine repaints a      */
/*    series of lines on the current pasteboard.                              */
/*                                                                            */
/*+~smg$repaint_line~+*/
unsigned long int smg$repaint_line(
    const unsigned long int  *pasteboard_id,
    const long int  *start_row,
    ...
    /* const long int  *number_of_lines */
    ) ;
/*~-smg$repaint_line-~*/
/*    SMG$REPAINT_SCREEN                                                      */
/*                                                                            */
/*    Repaint Current Pasteboard                                              */
/*                                                                            */
/*    The Repaint Current Pasteboard routine repaints the specified           */
/*    pasteboard after non-SMG I/O has occurred.                              */
/*                                                                            */
/*+~smg$repaint_screen~+*/
unsigned long int smg$repaint_screen(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$repaint_screen-~*/
/*    SMG$REPASTE_VIRTUAL_DISPLAY                                             */
/*                                                                            */
/*    Repaste Virtual Display                                                 */
/*                                                                            */
/*    The Repaste Virtual Display routine moves a virtual display to a new    */
/*    position on the pasteboard. The pasting order is not preserved.         */
/*                                                                            */
/*+~smg$repaste_virtual_display~+*/
unsigned long int smg$repaste_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column,
    ...
    /* const unsigned long int  *top_display_id */
    ) ;
/*~-smg$repaste_virtual_display-~*/
/*    SMG$RESTORE_PHYSICAL_SCREEN                                             */
/*                                                                            */
/*    Restore Physical Pasteboard                                             */
/*                                                                            */
/*    The Restore Physical Pasteboard routine rewrites the pasteboard image as it     */
/*    was at the time the SMG$SAVE_PHYSICAL_SCREEN routine was called.        */
/*                                                                            */
/*+~smg$restore_physical_screen~+*/
unsigned long int smg$restore_physical_screen(
    const unsigned long int  *pasteboard_id,
    const unsigned long int  *display_id
    ) ;
/*~-smg$restore_physical_screen-~*/
/*    SMG$READ_STRING                                                         */
/*                                                                            */
/*    Read String                                                             */
/*                                                                            */
/*    The Read String routine reads a string from a virtual keyboard.         */
/*                                                                            */
/*+~smg$read_string~+*/
unsigned long int smg$read_string(
    const unsigned long int  *keyboard_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *maximum_length, */
    /* const unsigned long int  *modifiers, */
    /* const long int  *timeout, */
    /* const int  *terminator_set, */
    /* unsigned short int  *resultant_length, */
    /* unsigned short int  *word_terminator_code, */
    /* const unsigned long int  *display_id, */
    /* const struct dsc$descriptor *initial_string, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const struct dsc$descriptor *terminator_string */
    ) ;
/*~-smg$read_string-~*/
/*    SMG$RETURN_CURSOR_POS                                                   */
/*                                                                            */
/*    Return Cursor Position                                                  */
/*                                                                            */
/*    The Return Cursor Position routine returns the current virtual cursor   */
/*    position in a specified virtual display.                                */
/*                                                                            */
/*+~smg$return_cursor_pos~+*/
unsigned long int smg$return_cursor_pos(
    const unsigned long int  *display_id,
    long int  *start_row,
    long int  *start_column
    ) ;
/*~-smg$return_cursor_pos-~*/
/*    SMG$READ_VERIFY                                                         */
/*                                                                            */
/*    Read and Verify a String                                                */
/*                                                                            */
/*    The Read and Verify a String routine reads a sequence of characters     */
/*    and verifies the sequence.                                              */
/*                                                                            */
/*+~smg$read_verify~+*/
unsigned long int smg$read_verify(
    const unsigned long int  *keyboard_id,
    struct dsc$descriptor *resultant_string,
    const struct dsc$descriptor *initial_string,
    const struct dsc$descriptor *picture_string,
    const struct dsc$descriptor *fill_character,
    const struct dsc$descriptor *clear_character,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const unsigned long int  *modifiers, */
    /* const long int  *timeout, */
    /* const int  *terminator_set, */
    /* const long int  *initial_offset, */
    /* unsigned short int  *word_terminator_code, */
    /* const unsigned long int  *display_id, */
    /* const struct dsc$descriptor *alternate_echo_string, */
    /* const long int  *alternate_display_id, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$read_verify-~*/
/*    SMG$SET_BROADCAST_TRAPPING                                              */
/*                                                                            */
/*    Enable Broadcast Trapping                                               */
/*                                                                            */
/*    The Enable Broadcast Trapping routine enables the trapping of broadcast */
/*    messages.                                                               */
/*                                                                            */
/*+~smg$set_broadcast_trapping~+*/
unsigned long int smg$set_broadcast_trapping(
    const unsigned long int  *pasteboard_id,
    ...
    /* const int *ast_routine, */
    /* const unsigned long int ast_argument */
    ) ;
/*~-smg$set_broadcast_trapping-~*/
/*    SMG$SCROLL_DISPLAY_AREA                                                 */
/*                                                                            */
/*    Scroll Display Area                                                     */
/*                                                                            */
/*    The Scroll Display Area routine scrolls a rectangular region of a       */
/*    virtual display.                                                        */
/*                                                                            */
/*+~smg$scroll_display_area~+*/
unsigned long int smg$scroll_display_area(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const long int  *height, */
    /* const long int  *width, */
    /* const unsigned long int  *direction, */
    /* const long int  *count */
    ) ;
/*~-smg$scroll_display_area-~*/
/*    SMG$SET_CURSOR_ABS                                                      */
/*                                                                            */
/*    Set Absolute Cursor Position                                            */
/*                                                                            */
/*    The Set Absolute Cursor Position routine moves the virtual cursor to    */
/*    the specified position in a virtual display.                            */
/*                                                                            */
/*+~smg$set_cursor_abs~+*/
unsigned long int smg$set_cursor_abs(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column */
    ) ;
/*~-smg$set_cursor_abs-~*/
/*    SMG$SET_CURSOR_REL                                                      */
/*                                                                            */
/*    Move Cursor\Relative To Current Position                                */
/*                                                                            */
/*    The Move Cursor Relative to Current Position routine moves the virtual  */
/*    cursor the specified number of rows and columns from the current        */
/*    virtual cursor position in a virtual display.                           */
/*                                                                            */
/*+~smg$set_cursor_rel~+*/
unsigned long int smg$set_cursor_rel(
    const unsigned long int  *display_id,
    ...
    /* const long int  *delta_row, */
    /* const long int  *delta_column */
    ) ;
/*~-smg$set_cursor_rel-~*/
/*    SMG$SCROLL_VIEWPORT                                                     */
/*                                                                            */
/*    Scroll a Display Under a Viewport                                       */
/*                                                                            */
/*    The Scroll a Display Under a Viewport routine scrolls a virtual display under its associated    */
/*    viewport.                                                               */
/*                                                                            */
/*+~smg$scroll_viewport~+*/
unsigned long int smg$scroll_viewport(
    const unsigned long int  *display_id,
    ...
    /* const unsigned long int  *direction, */
    /* const long int  *count */
    ) ;
/*~-smg$scroll_viewport-~*/
/*    SMG$SET_DISPLAY_SCROLL_REGION                                           */
/*                                                                            */
/*    Create Display Scrolling Region                                         */
/*                                                                            */
/*    The Create Display Scrolling Region routine creates a scrolling region  */
/*    in a virtual display.                                                   */
/*                                                                            */
/*+~smg$set_display_scroll_region~+*/
unsigned long int smg$set_display_scroll_region(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *end_row */
    ) ;
/*~-smg$set_display_scroll_region-~*/
/*    SMG$SELECT_FROM_MENU                                                    */
/*                                                                            */
/*    Make a Selection From the Menu                                          */
/*                                                                            */
/*    The Make a Selection from the Menu routine lets you move between the    */
/*    menu choices using the arrow keys and lets you make a selection by      */
/*    pressing RETURN.                                                        */
/*                                                                            */
/*+~smg$select_from_menu~+*/
unsigned long int smg$select_from_menu(
    const unsigned long int  *keyboard_id,
    const unsigned long int  *display_id,
    unsigned short int  *selected_choice_number,
    ...
    /* const unsigned short int  *default_choice_number, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *help_library, */
    /* const long int  *timeout, */
    /* unsigned short int  *terminator_code, */
    /* struct dsc$descriptor *selected_choice_string, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$select_from_menu-~*/
/*    SMG$SET_CURSOR_MODE                                                     */
/*                                                                            */
/*    Set the Cursor Mode                                                     */
/*                                                                            */
/*    The Set the Cursor Mode                                                 */
/*    routine turns the physical cursor on or off and selects                 */
/*    jump or smooth scrolling.                                               */
/*                                                                            */
/*+~smg$set_cursor_mode~+*/
unsigned long int smg$set_cursor_mode(
    const unsigned long int  *pasteboard_id,
    const unsigned long int  *flags
    ) ;
/*~-smg$set_cursor_mode-~*/
/*    SMG$SET_KEYPAD_MODE                                                     */
/*                                                                            */
/*    Set Keypad Mode                                                         */
/*                                                                            */
/*    The Set Keypad Mode routine sets the terminal's numeric keypad to either numeric*/
/*    or applications mode.                                                   */
/*                                                                            */
/*+~smg$set_keypad_mode~+*/
unsigned long int smg$set_keypad_mode(
    const unsigned long int  *keyboard_id,
    const unsigned long int  *flags
    ) ;
/*~-smg$set_keypad_mode-~*/
/*    SMG$SNAPSHOT                                                            */
/*                                                                            */
/*    Write Snapshot                                                          */
/*                                                                            */
/*    The Write Snapshot routine writes the current pasteboard buffer to the  */
/*    file or hardcopy terminal specified by the pasteboard identifier.       */
/*                                                                            */
/*+~smg$snapshot~+*/
unsigned long int smg$snapshot(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$snapshot-~*/
/*    SMG$SET_OUT_OF_BAND_ASTS                                                */
/*                                                                            */
/*    Set Out-of-Band ASTs                                                    */
/*                                                                            */
/*    The Set Out-of-Band ASTs routine either enables or disables the         */
/*    trapping of out-of-band control characters.                             */
/*                                                                            */
/*+~smg$set_out_of_band_asts~+*/
unsigned long int smg$set_out_of_band_asts(
    const unsigned long int  *pasteboard_id,
    const unsigned long int  *control_character_mask,
    const int *ast_routine,
    ...
    /* const unsigned long int ast_argument */
    ) ;
/*~-smg$set_out_of_band_asts-~*/
/*    SMG$SET_PHYSICAL_CURSOR                                                 */
/*                                                                            */
/*    Set Cursor on Physical Screen                                           */
/*                                                                            */
/*    The Set Cursor on Physical Screen routine moves the physical cursor to  */
/*    the specified position on the pasteboard.                               */
/*                                                                            */
/*+~smg$set_physical_cursor~+*/
unsigned long int smg$set_physical_cursor(
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column
    ) ;
/*~-smg$set_physical_cursor-~*/
/*    SMG$SET_DEFAULT_STATE                                                   */
/*                                                                            */
/*    Set Default State                                                       */
/*                                                                            */
/*    The Set Default State routine sets and/or returns the current default   */
/*    state for a key table.                                                  */
/*                                                                            */
/*+~smg$set_default_state~+*/
unsigned long int smg$set_default_state(
    const unsigned long int  *key_table_id,
    ...
    /* const struct dsc$descriptor *new_state, */
    /* struct dsc$descriptor *old_state */
    ) ;
/*~-smg$set_default_state-~*/
/*    SMG$SET_TERM_CHARACTERISTICS                                            */
/*                                                                            */
/*    Change Terminal Characterisitics                                        */
/*                                                                            */
/*    The Change Terminal Characteristics routine changes or retrieves the    */
/*    terminal characteristics for a given pasteboard.                        */
/*                                                                            */
/*+~smg$set_term_characteristics~+*/
unsigned long int smg$set_term_characteristics(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *on_characteristics1, */
    /* const unsigned long int  *on_characteristics2, */
    /* const unsigned long int  *off_characteristics1, */
    /* const unsigned long int  *off_characteristics2, */
    /* unsigned long int  *old_characteristics1, */
    /* unsigned long int  *old_characteristics2 */
    ) ;
/*~-smg$set_term_characteristics-~*/
/*    SMG$SAVE_VIRTUAL_DISPLAY                                                */
/*                                                                            */
/*    Save the Virtual Display to a File                                      */
/*                                                                            */
/*    The Save the Virtual Display to a File routine saves the contents of a  */
/*    virtual display and stores it in a file.                                */
/*                                                                            */
/*+~smg$save_virtual_display~+*/
unsigned long int smg$save_virtual_display(
    const unsigned long int  *display_id,
    ...
    /* const struct dsc$descriptor *filespec */
    ) ;
/*~-smg$save_virtual_display-~*/
/*    SMG$SAVE_PHYSICAL_SCREEN                                                */
/*                                                                            */
/*    Save Physical Screen                                                    */
/*                                                                            */
/*    The Save Physical Screen routine saves the contents of the pasteboard so*/
/*    that a later call to SMG$RESTORE_PHYSICAL_SCREEN can restore it.        */
/*                                                                            */
/*+~smg$save_physical_screen~+*/
unsigned long int smg$save_physical_screen(
    const unsigned long int  *pasteboard_id,
    unsigned long int  *display_id,
    ...
    /* const long int  *desired_start_row, */
    /* const long int  *desired_end_row */
    ) ;
/*~-smg$save_physical_screen-~*/
/*    SMG$UNPASTE_VIRTUAL_DISPLAY                                             */
/*                                                                            */
/*    Remove Virtual Display                                                  */
/*                                                                            */
/*    The Remove Virtual Display routine removes a virtual display from a pasteboard. */
/*                                                                            */
/*+~smg$unpaste_virtual_display~+*/
unsigned long int smg$unpaste_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$unpaste_virtual_display-~*/
#endif
