/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:31:22 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]SOR$ROUTINE */
#ifndef SOR$ROUTINES_H
#define SOR$ROUTINES_H
 
/*** MODULE SOR$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*                                                                            */
/*  SOR$BEGIN_MERGE                                                           */
/*                                                                            */
/*  Initialize a Merge Operation                                              */
/*                                                                            */
/*  Initializes the merge operation by opening the input and output files     */
/*  and by providing the number of input files, the key specifications,       */
/*  and the merge options.                                                    */
/*                                                                            */
/*+~sor$begin_merge~+*/
unsigned long int sor$begin_merge(
    /* const int  *key_buffer, */
    /* const unsigned short int  *lrl, */
    /* const unsigned long int  *options, */
    /* const unsigned char  *merge_order, */
    /* const int *user_compare, */
    /* const int *user_equal, */
    /* const int *user_input, */
    /* unsigned long int  *context */
    ) ;
/*~-sor$begin_merge-~*/
/*                                                                            */
/*  SOR$BEGIN_SORT                                                            */
/*                                                                            */
/*  Begin a Sort Operation                                                    */
/*                                                                            */
/*  Initializes a sort operation by opening input and output files and by     */
/*  passing the key information and any sort options.                         */
/*                                                                            */
/*+~sor$begin_sort~+*/
unsigned long int sor$begin_sort(
    /* const int  *key_buffer, */
    /* const unsigned short int  *lrl, */
    /* const unsigned long int  *options, */
    /* const unsigned long int  *file_alloc, */
    /* const int *user_compare, */
    /* const int *user_equal, */
    /* const unsigned char  *sort_process, */
    /* const unsigned char  *work_files, */
    /* unsigned long int  *context */
    ) ;
/*~-sor$begin_sort-~*/
/*                                                                            */
/*  SOR$DO_MERGE                                                              */
/*                                                                            */
/*  Obsolete (from VMS V3)                                                    */
/*                                                                            */
/*+~sor$do_merge~+*/
long int sor$do_merge() ;
/*~-sor$do_merge-~*/
/*                                                                            */
/*  SOR$END_SORT                                                              */
/*                                                                            */
/*  End a Sort Operation                                                      */
/*                                                                            */
/*  Does cleanup functions, such as closing files and releasing memory.       */
/*                                                                            */
/*+~sor$end_sort~+*/
unsigned long int sor$end_sort(
    /* unsigned long int  *context */
    ) ;
/*~-sor$end_sort-~*/
/*                                                                            */
/*  SOR$INIT_MERGE                                                            */
/*                                                                            */
/*  Obsolete (from VMS V3)                                                    */
/*                                                                            */
/*+~sor$init_merge~+*/
long int sor$init_merge(
    /* const unsigned char  *merge_order, */
    /* const int  *key_buffer, */
    /* const unsigned short int  *lrl, */
    /* const unsigned long int  *options, */
    /* const int *user_compare, */
    /* const int *user_equal */
    ) ;
/*~-sor$init_merge-~*/
/*                                                                            */
/*  SOR$INIT_SORT                                                             */
/*                                                                            */
/*  Obsolete (from VMS V3)                                                    */
/*                                                                            */
/*+~sor$init_sort~+*/
long int sor$init_sort(
    /* const int  *key_buffer, */
    /* const unsigned short int  *lrl, */
    /* const unsigned long int  *file_alloc, */
    /* const unsigned char  *work_files, */
    /* const unsigned char  *sort_process, */
    /* const unsigned char  *key_size, */
    /* const int *user_compare, */
    /* const unsigned long int  *options */
    ) ;
/*~-sor$init_sort-~*/
/*                                                                            */
/*  SOR$PASS_FILES                                                            */
/*                                                                            */
/*  Pass File Names                                                           */
/*                                                                            */
/*  Passes the names of input and output files and output file                */
/*  characteristics to SORT or MERGE.                                         */
/*                                                                            */
/*+~sor$pass_files~+*/
unsigned long int sor$pass_files(
    /* const struct dsc$descriptor *inp_desc, */
    /* const struct dsc$descriptor *out_desc, */
    /* const unsigned char  *org, */
    /* const unsigned char  *rfm, */
    /* const unsigned char  *bks, */
    /* const unsigned short int  *bls, */
    /* const unsigned short int  *mrs, */
    /* const unsigned long int  *alq, */
    /* const unsigned long int  *fop, */
    /* const unsigned char  *fsz, */
    /* unsigned long int  *context */
    ) ;
/*~-sor$pass_files-~*/
/*                                                                            */
/*  SOR$RELEASE_REC                                                           */
/*                                                                            */
/*  Pass One Record to Sort                                                   */
/*                                                                            */
/*  Used with the record interface to pass one input record to SORT or        */
/*  MERGE.                                                                    */
/*                                                                            */
/*+~sor$release_rec~+*/
unsigned long int sor$release_rec(
    const struct dsc$descriptor *desc,
    ...
    /* unsigned long int  *context */
    ) ;
/*~-sor$release_rec-~*/
/*                                                                            */
/*  SOR$RETURN_REC                                                            */
/*                                                                            */
/*  Return One Sorted Record                                                  */
/*                                                                            */
/*  Used with the record interface to return one sorted or merged             */
/*  record to a program.                                                      */
/*                                                                            */
/*+~sor$return_rec~+*/
unsigned long int sor$return_rec(
    struct dsc$descriptor *desc,
    ...
    /* unsigned short int  *length, */
    /* unsigned long int  *context */
    ) ;
/*~-sor$return_rec-~*/
/*                                                                            */
/*  SOR$SORT_MERGE                                                            */
/*                                                                            */
/*  Sort                                                                      */
/*                                                                            */
/*  Sorts the input records.                                                  */
/*                                                                            */
/*+~sor$sort_merge~+*/
unsigned long int sor$sort_merge(
    /* unsigned long int  *context */
    ) ;
/*~-sor$sort_merge-~*/
/*                                                                            */
/*  SOR$SPEC_FILE                                                             */
/*                                                                            */
/*  Pass a Specification File Name                                            */
/*                                                                            */
/*  Used to pass a specification file or specification text.                  */
/*                                                                            */
/*+~sor$spec_file~+*/
unsigned long int sor$spec_file(
    /* const struct dsc$descriptor *spec_file, */
    /* const struct dsc$descriptor *spec_buffer, */
    /* unsigned long int  *context */
    ) ;
/*~-sor$spec_file-~*/
/*                                                                            */
/*  SOR$STAT                                                                  */
/*                                                                            */
/*  Obtain Sorting Statistics                                                 */
/*                                                                            */
/*  Returns one statistic about the sort or merge operation to the user       */
/*  program.                                                                  */
/*                                                                            */
/*+~sor$stat~+*/
unsigned long int sor$stat(
    const unsigned short int  *code,
    unsigned long int  *result,
    ...
    /* unsigned long int  *context */
    ) ;
/*~-sor$stat-~*/
#endif
