/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:44:34 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STR$ROUTINE */
#ifndef STR$ROUTINES_H
#define STR$ROUTINES_H
 
/*** MODULE STR$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    STR$ADD                                                                 */
/*                                                                            */
/*    Add Two Decimal Strings                                                 */
/*                                                                            */
/*    The Add Two Decimal Strings routine                                     */
/*    adds two decimal strings of digits.                                     */
/*                                                                            */
/*+~str$add~+*/
unsigned long int str$add(
    const unsigned long int  *asign,
    const long int  *aexp,
    const struct dsc$descriptor *adigits,
    const unsigned long int  *bsign,
    const long int  *bexp,
    const struct dsc$descriptor *bdigits,
    unsigned long int  *csign,
    long int  *cexp,
    struct dsc$descriptor *cdigits
    ) ;
/*~-str$add-~*/
/*    STR$ANALYZE_SDESC                                                       */
/*                                                                            */
/*    Analyze String Descriptor                                               */
/*                                                                            */
/*    The Analyze String Descriptor routine extracts the                      */
/*    length and starting address of the data                                 */
/*    for a variety of string descriptor classes.                             */
/*                                                                            */
/*+~str$analyze_sdesc~+*/
int str$analyze_sdesc(
    const struct dsc$descriptor *input_descriptor,
    unsigned short int  *word_integer_length,
    int * *data_address
    ) ;
/*~-str$analyze_sdesc-~*/
/*    STR$APPEND                                                              */
/*                                                                            */
/*    Append String                                                           */
/*                                                                            */
/*    The Append String routine appends a source string to the end of a destination string.   */
/*    The destination string must be a dynamic or varying-length string.      */
/*                                                                            */
/*+~str$append~+*/
unsigned long int str$append(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-str$append-~*/
/*    STR$CASE_BLIND_COMPARE                                                  */
/*                                                                            */
/*    Compare Strings Without Regard to Case                                  */
/*                                                                            */
/*    The Compare Strings Without Regard to Case routine compares two input   */
/*    strings of any supported class                                          */
/*    and data type without regard to whether the alphabetic characters are uppercase */
/*    or lowercase.                                                           */
/*                                                                            */
/*+~str$case_blind_compare~+*/
long int str$case_blind_compare(
    const struct dsc$descriptor *first_source_string,
    const struct dsc$descriptor *second_source_string
    ) ;
/*~-str$case_blind_compare-~*/
/*    STR$COMPARE                                                             */
/*                                                                            */
/*    Compare Two Strings                                                     */
/*                                                                            */
/*    The Compare Two Strings routine compares the                            */
/*    contents of two strings.                                                */
/*                                                                            */
/*+~str$compare~+*/
long int str$compare(
    const struct dsc$descriptor *first_source_string,
    const struct dsc$descriptor *second_source_string
    ) ;
/*~-str$compare-~*/
/*    STR$CONCAT                                                              */
/*                                                                            */
/*    Concatenate Two or More Strings                                         */
/*                                                                            */
/*    The Concatenate Two or More Strings routine concatenates all specified  */
/*    source strings into a single destination string.                        */
/*                                                                            */
/*+~str$concat~+*/
unsigned long int str$concat(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-str$concat-~*/
/*    STR$COPY_DX                                                             */
/*                                                                            */
/*    Copy a Source String Passed by Descriptor to a Destination String       */
/*                                                                            */
/*    The Copy a Source String Passed by Descriptor to                        */
/*    a Destination String routine copies a source string to                  */
/*    a destination string. Both strings are                                  */
/*    passed by descriptor.                                                   */
/*                                                                            */
/*+~str$copy_dx~+*/
unsigned long int str$copy_dx(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-str$copy_dx-~*/
/*    STR$COPY_R                                                              */
/*                                                                            */
/*    Copy a Source String Passed by Reference to a Destination String        */
/*                                                                            */
/*    The Copy a Source String Passed by Reference to                         */
/*    a Destination String routine copies a source string passed by reference to a destination*/
/*    string.                                                                 */
/*                                                                            */
/*+~str$copy_r~+*/
unsigned long int str$copy_r(
    struct dsc$descriptor *destination_string,
    const unsigned short int  *word_integer_source_length,
    const char  *source_string_address
    ) ;
/*~-str$copy_r-~*/
/*    STR$DIVIDE                                                              */
/*                                                                            */
/*    Divide Two Decimal Strings                                              */
/*                                                                            */
/*    The Divide Two Decimal Strings routine divides two decimal strings.     */
/*                                                                            */
/*+~str$divide~+*/
unsigned long int str$divide(
    const unsigned long int  *asign,
    const long int  *aexp,
    const struct dsc$descriptor *adigits,
    const unsigned long int  *bsign,
    const long int  *bexp,
    const struct dsc$descriptor *bdigits,
    const long int  *total_digits,
    const unsigned long int  *round_truncate_indicator,
    unsigned long int  *csign,
    long int  *cexp,
    struct dsc$descriptor *cdigits
    ) ;
/*~-str$divide-~*/
/*    STR$DUPL_CHAR                                                           */
/*                                                                            */
/*    Duplicate Character  Times                                              */
/*                                                                            */
/*    The Duplicate Character empty Times routine                             */
/*    generates a string containing n duplicates of the input                 */
/*    character. If the destination string is an empty dynamic string descriptor,     */
/*    STR$DUPL_CHAR will allocate and initialize the string.                  */
/*                                                                            */
/*+~str$dupl_char~+*/
unsigned long int str$dupl_char(
    struct dsc$descriptor *destination_string,
    ...
    /* const long int  *repetition_count, */
    /* const char  *ascii_character */
    ) ;
/*~-str$dupl_char-~*/
/*    STR$ELEMENT                                                             */
/*                                                                            */
/*    Extract Delimited Element Substring                                     */
/*                                                                            */
/*    The Extract Delimited Element Substring routine                         */
/*    extracts an element from a string in which the elements are separated   */
/*    by a specified delimiter.                                               */
/*                                                                            */
/*+~str$element~+*/
unsigned long int str$element(
    struct dsc$descriptor *destination_string,
    const long int  *element_number,
    struct dsc$descriptor *delimiter_string,
    struct dsc$descriptor *source_string
    ) ;
/*~-str$element-~*/
/*    STR$COMPARE_EQL                                                         */
/*                                                                            */
/*    Compare Two Strings for Equality                                        */
/*                                                                            */
/*    The Compare Two Strings for Equality routine, compares two              */
/*    strings to see if they have the same length                             */
/*    and contents. Uppercase and lowercase characters are not considered equal.      */
/*                                                                            */
/*+~str$compare_eql~+*/
unsigned long int str$compare_eql(
    const struct dsc$descriptor *first_source_string,
    const struct dsc$descriptor *second_source_string
    ) ;
/*~-str$compare_eql-~*/
/*    STR$FIND_FIRST_IN_SET                                                   */
/*                                                                            */
/*    Find First Character in a Set of Characters                             */
/*                                                                            */
/*    The Find First Character in a Set of                                    */
/*    Characters routine                                                      */
/*    searches a string one character at a time, from                         */
/*    left to right, comparing each character in the string to every character in     */
/*    a specified set of characters for which it is searching.                */
/*                                                                            */
/*+~str$find_first_in_set~+*/
long int str$find_first_in_set(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *set_of_characters
    ) ;
/*~-str$find_first_in_set-~*/
/*    STR$FIND_FIRST_NOT_IN_SET                                               */
/*                                                                            */
/*    Find First Character that Does Not Occur in Set                         */
/*                                                                            */
/*    The Find First Character that Does Not                                  */
/*    Occur in Set routine                                                    */
/*    searches a string, comparing each character to the                      */
/*    characters in a specified set of characters.  The string is searched character  */
/*    by character, from left to right.  STR$FIND_FIRST_NOT_IN_SET returns the*/
/*    position of the first character in the string that does not match any of the    */
/*    characters in the selected set of characters.                           */
/*                                                                            */
/*+~str$find_first_not_in_set~+*/
long int str$find_first_not_in_set(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *set_of_characters
    ) ;
/*~-str$find_first_not_in_set-~*/
/*    STR$FREE1_DX                                                            */
/*                                                                            */
/*    Free One Dynamic String                                                 */
/*                                                                            */
/*    The Free One Dynamic String routine                                     */
/*    deallocates one dynamic string.                                         */
/*                                                                            */
/*+~str$free1_dx~+*/
unsigned long int str$free1_dx(
    struct dsc$descriptor *string_descriptor
    ) ;
/*~-str$free1_dx-~*/
/*    STR$FIND_FIRST_SUBSTRING                                                */
/*                                                                            */
/*    Find First Substring in Input String                                    */
/*                                                                            */
/*    The Find First Substring in Input String routine                        */
/*    finds the first substring (in a provided list of                        */
/*    substrings) occurring in a given string.                                */
/*                                                                            */
/*+~str$find_first_substring~+*/
unsigned long int str$find_first_substring(
    const struct dsc$descriptor *source_string,
    long int  *index,
    long int  *substring_index,
    ...
    /* const struct dsc$descriptor *substring */
    ) ;
/*~-str$find_first_substring-~*/
/*    STR$GET1_DX                                                             */
/*                                                                            */
/*    Allocate One Dynamic String                                             */
/*                                                                            */
/*    The Allocate One Dynamic String routine                                 */
/*    allocates a specified number of bytes of dynamic virtual memory         */
/*    to a specified dynamic string descriptor.                               */
/*                                                                            */
/*+~str$get1_dx~+*/
unsigned long int str$get1_dx(
    const unsigned short int  *word_integer_length,
    struct dsc$descriptor *character_string
    ) ;
/*~-str$get1_dx-~*/
/*    STR$LEFT                                                                */
/*                                                                            */
/*    Extract a Substring of a String                                         */
/*                                                                            */
/*    The Extract a Substring of a String routine copies a substring of a     */
/*    source string into a                                                    */
/*    destination string. The relative starting position in the source        */
/*    string is 1.                                                            */
/*                                                                            */
/*+~str$left~+*/
unsigned long int str$left(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    const long int  *end_position
    ) ;
/*~-str$left-~*/
/*    STR$LEN_EXTR                                                            */
/*                                                                            */
/*    Extract a Substring of a String                                         */
/*                                                                            */
/*    The Extract a Substring of a String routine copies a                    */
/*    substring of a source string into a                                     */
/*    destination string.                                                     */
/*                                                                            */
/*+~str$len_extr~+*/
unsigned long int str$len_extr(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    const long int  *start_position,
    const long int  *longword_integer_length
    ) ;
/*~-str$len_extr-~*/
/*    STR$MATCH_WILD                                                          */
/*                                                                            */
/*    Match Wildcard Specification                                            */
/*                                                                            */
/*    The Match Wildcard Specification routine is used to compare a           */
/*    pattern string that includes wildcard                                   */
/*    characters with a candidate string.  It returns a condition value of STR$_MATCH */
/*    if the strings match and line_break STR$_NOMATCH if they do not match.  */
/*                                                                            */
/*+~str$match_wild~+*/
unsigned long int str$match_wild(
    const struct dsc$descriptor *candidate_string,
    const struct dsc$descriptor *pattern_string
    ) ;
/*~-str$match_wild-~*/
/*    STR$MUL                                                                 */
/*                                                                            */
/*    Multiply Two Decimal Strings                                            */
/*                                                                            */
/*    The Multiply Two Decimal Strings routine multiplies two decimal strings.*/
/*                                                                            */
/*+~str$mul~+*/
unsigned long int str$mul(
    const unsigned long int  *asign,
    const long int  *aexp,
    const struct dsc$descriptor *adigits,
    const unsigned long int  *bsign,
    const long int  *bexp,
    const struct dsc$descriptor *bdigits,
    unsigned long int  *csign,
    long int  *cexp,
    struct dsc$descriptor *cdigits
    ) ;
/*~-str$mul-~*/
/*    STR$COMPARE_MULTI                                                       */
/*                                                                            */
/*    Compare Two Strings for Equality Using Multinational Character Set      */
/*                                                                            */
/*    The Compare Two Strings for Equality Using                              */
/*    Multinational Character Set routine compares two character              */
/*    strings for equality using the                                          */
/*    DEC Multinational character set.                                        */
/*                                                                            */
/*+~str$compare_multi~+*/
long int str$compare_multi(
    const struct dsc$descriptor *first_source_string,
    const struct dsc$descriptor *second_source_string,
    ...
    /* const unsigned long int flags_value, */
    /* const unsigned long int foreign_language */
    ) ;
/*~-str$compare_multi-~*/
/*    STR$POS_EXTR                                                            */
/*                                                                            */
/*    Extract a Substring of a String                                         */
/*                                                                            */
/*    The Extract a Substring of a String routine                             */
/*    copies a substring of a source string into a                            */
/*    destination string.                                                     */
/*                                                                            */
/*+~str$pos_extr~+*/
unsigned long int str$pos_extr(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    const long int  *start_position,
    const long int  *end_position
    ) ;
/*~-str$pos_extr-~*/
/*    STR$POSITION                                                            */
/*                                                                            */
/*    Return Relative Position of Substring                                   */
/*                                                                            */
/*    The Return Relative Position of Substring routine                       */
/*    searches for the first occurrence of a                                  */
/*    single substring within a source string.  If STR$POSITION finds the substring,  */
/*    it returns the relative position of that substring.                     */
/*    If the substring is not found, STR$POSITION returns a zero.             */
/*                                                                            */
/*+~str$position~+*/
unsigned long int str$position(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *substring,
    ...
    /* const long int  *start_position */
    ) ;
/*~-str$position-~*/
/*    STR$PREFIX                                                              */
/*                                                                            */
/*    Prefix a String                                                         */
/*                                                                            */
/*    The Prefix a String routine                                             */
/*    inserts a source string at the beginning of a destination               */
/*    string. The destination string must be dynamic or varying length.       */
/*                                                                            */
/*+~str$prefix~+*/
unsigned long int str$prefix(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-str$prefix-~*/
/*    STR$RECIP                                                               */
/*                                                                            */
/*    Reciprocal of a Decimal String                                          */
/*                                                                            */
/*    The Reciprocal of a Decimal String routine                              */
/*    takes the reciprocal of the first decimal string to the precision       */
/*    limit specified by the second decimal string and returns the result as a*/
/*    decimal string.                                                         */
/*                                                                            */
/*+~str$recip~+*/
unsigned long int str$recip(
    const unsigned long int  *asign,
    const long int  *aexp,
    const struct dsc$descriptor *adigits,
    const unsigned long int  *bsign,
    const long int  *bexp,
    const struct dsc$descriptor *bdigits,
    unsigned long int  *csign,
    long int  *cexp,
    struct dsc$descriptor *cdigits
    ) ;
/*~-str$recip-~*/
/*    STR$REPLACE                                                             */
/*                                                                            */
/*    Replace a Substring                                                     */
/*                                                                            */
/*    The Replace a Substring routine                                         */
/*    copies a source string to a destination string, replacing part          */
/*    of the string with another string.  The substring to be replaced is     */
/*    specified by its starting and ending positions.                         */
/*                                                                            */
/*+~str$replace~+*/
unsigned long int str$replace(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    const long int  *start_position,
    const long int  *end_position,
    const struct dsc$descriptor *replacement_string
    ) ;
/*~-str$replace-~*/
/*    STR$RIGHT                                                               */
/*                                                                            */
/*    Extract a Substring of a String                                         */
/*                                                                            */
/*    The Extract a Substring of a String routine                             */
/*    copies a substring of a source string into a                            */
/*    destination string.                                                     */
/*                                                                            */
/*+~str$right~+*/
unsigned long int str$right(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    const long int  *start_position
    ) ;
/*~-str$right-~*/
/*    STR$ROUND                                                               */
/*                                                                            */
/*    Round or Truncate a Decimal String                                      */
/*                                                                            */
/*    The Round or Truncate a Decimal String routine                          */
/*    rounds or truncates a decimal string to a specified number of           */
/*    significant digits and places the result in another decimal string.     */
/*                                                                            */
/*+~str$round~+*/
unsigned long int str$round(
    const long int  *places,
    const unsigned long int  *flags,
    const unsigned long int  *asign,
    const long int  *aexp,
    const struct dsc$descriptor *adigits,
    unsigned long int  *csign,
    long int  *cexp,
    struct dsc$descriptor *cdigits
    ) ;
/*~-str$round-~*/
/*    STR$TRANSLATE                                                           */
/*                                                                            */
/*    Translate Matched Characters                                            */
/*                                                                            */
/*    The Translate Matched Characters routine successively compares each character in a source string*/
/*    to all characters in a match string.  If a source character has a match,        */
/*    the destination character is taken from the translate string.  Otherwise,       */
/*    STR$TRANSLATE moves the source character to the destination string.     */
/*                                                                            */
/*+~str$translate~+*/
unsigned long int str$translate(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *translation_string,
    const struct dsc$descriptor *match_string
    ) ;
/*~-str$translate-~*/
/*    STR$TRIM                                                                */
/*                                                                            */
/*    Trim Trailing Blanks and Tabs                                           */
/*                                                                            */
/*    The Trim Trailing Blanks and Tabs routine                               */
/*    copies a source string to a destination string and deletes the          */
/*    trailing blank and tab characters.                                      */
/*                                                                            */
/*+~str$trim~+*/
unsigned long int str$trim(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-str$trim-~*/
/*    STR$UPCASE                                                              */
/*                                                                            */
/*    Convert String to All Uppercase Characters                              */
/*                                                                            */
/*    The Convert String to All Uppercase Characters routine                  */
/*    converts a source string to uppercase.                                  */
/*                                                                            */
/*+~str$upcase~+*/
unsigned long int str$upcase(
    struct dsc$descriptor *destination_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-str$upcase-~*/
#endif
