$	ON CONTROL_Y THEN EXIT
$	ON ERROR THEN EXIT
$	IF P1 .NES. "" THEN GOTO 'P1'
$	WRITE SYS$OUTPUT Page,"%CAI-F-NOSUB, No subroutine specified"
$	WAIT 00:00:03
$Purpose:
$	EXIT 1
$!
$Menu:
$	@SYS$INSTRUCTION:Head_Page "The VAX/VMS Directory Command"
$	RUN SYS$INSTRUCTION:DISPLAY

You may choose:

		[1mI[mntro	   -  Introduction to the Directory Command
		[1mQ[mualifiers -  File attribute qualifiers
		[1mO[mutput	   -  Directory output qualifiers
		[1mS[melection  -  File selection qualifiers
		[1mF[minal	   -  Final exam
		[1m*[m	   -  All of the above
		[1mE[mxit	   -  Exit this menu
$	Do_it_all == "I!Q!O!S!F"
$	EXIT 1
$Select:
$	Test:==F
$	Result:==DONE
$	IF P2 .EQS. "E" THEN EXIT 1
$	Result:==OK
$	IF P2 .EQS. "I" THEN GOTO Do_Introduction
$	IF P2 .EQS. "Q" THEN GOTO Do_Qualifiers
$	IF P2 .EQS. "S" THEN GOTO Do_Select
$	IF P2 .EQS. "O" THEN GOTO Do_Output
$	IF P2 .EQS. "F" THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT 1
$!______________
$Final_Exam:
$	@SYS$INSTRUCTION:Head_Page "The Final Exam"
$	TYPE SYS$INPUT



Now let's see if you remember what the qualifiers do.
Will the following directory command
$!______________
$	Test:==T
$	Question==""
$	Question_1=="display files modified after 1-Jan-1982"
$	Example_1=="DIR /SINCE=1-JAN-1982"
$	Answer_1=="N"
$	Reason_1=="To list "+U_line+"modified"+No_Attr+" files must also include /MODIFIED."
$	Question_2=="display all files in a directory"
$	Example_2=="DIR *.*;0"
$	Answer_2=="N"
$	Reason_2=="Only the highest version of each file will be listed."
$	Question_3=="display the work done today on FORTRAN source files"
$	Example_3=="DIR/SINCE *.FOR"
$	Answer_3=="Y"
$	Reason_3=="/SINCE defaults to files created today since midnight."
$	Question_4=="display the total block usage on the system disk"
$	Example_4=="DIR SYS$SYSDEVICE:[000000...]/TOT"
$	Answer_4=="Y"
$	Reason_4=="The command starts with the index directory and works down."
$	Question_5=="display the file owner and the date of last backup"
$	Example_5=="DIR/FULL/EXCLUDE=(*.LIS,*.MAR) FOO.*"
$	Answer_5=="Y"
$	Reason_5=="The /FULL qualifier lists "+U_Line+"all"+No_Attr+" file attributes."
$	Question_6=="display a single column listing of all files"
$	Example_6=="DIR/COLUMNS=2/OWNER/DATE *.*;*"
$	Answer_6=="Y"
$	Reason_6=="The /COL switch only works for simple, /BRIEF format."
$	Question_7=="send a directory to the printer for listing."
$	Example_7=="DIR/OUTPUT=PRINTER.LIS/OWNER/DATE"
$	Answer_7=="N"
$	Reason_7=="Printer.LIS will not get automatically get sent to the printer."
$	Question_8=="display the number of blocks allocated to a file."
$	Example_8=="DIR/SIZE"
$	Answer_8=="N"
$	Reason_8=="The /SIZE displays blocks "+U_Line+"used"+No_Attr+", not blocks allocated."
$	Nmax==8
$	EXIT 1
$Do_Introduction:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J		  [7mIntroduction to the VMS DIRectory Command[m

The VMS DIRectory command  is used to  show which  files are  in a directory and
display certain characteristics about them. The command (normally abbreviated to
DIR) has the following syntax:

	$ DIR/qualif1.../qualifN filespec1,filespec2...,filespecN

where the  file specifiers  can include wild cards (* or %) for directory, name,
type,  or version.   The qualifiers  are used  for producing selective directory
formatting,  or extended  informational display.  One or more qualifiers or file
specifiers may be present but neither is required.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JThe DIRectory command  assumes certain  defaults if  partial file  specifiers or
no file specifiers are present.

	-  If  no file specification is present,  all versions  of all
	   files in your current directory are displayed.  

	-  If you  specify  only a  device name  as part  of the  file
	   specifier, DIR uses your current default directory.  

	-  Whenever the file specification omits a file name and type, 
	   all versions of all files in the directory are displayed.

	-  If a file  specification contains  a file  name and/or file
	   type and no version number, all versions are listed.

	-  If a file specification contains only a file name, all file
	   type and versions are listed.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the effects of certain DIRectory commands.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	SET DEFAULT 'Def_dir'
$	CALL Do_Command -
		"The current directory is displayed if there are no file specifiers." -
		"DIR" Y
$	SET DEFAULT SYS$SCRATCH
$!
$	CALL Do_Command -
		"If you specify a directory only, all files in it are displayed." -
		"DIR SYS$SYSROOT:[SYSUPD]" Y
$!
$	CALL Do_Command -
		"All file types are displayed if file type is omitted." -
		"DIR SYS$SYSROOT:[SYSEXE]SYS" N
$!
$	CALL Do_Command -
		"Use a complete file specifier to select a specific file." -
		"DIR SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$!
$	CALL Do_Command -
		"Use wild cards to display all files of a given type." -
		"DIR SYS$SYSROOT:[SYSEXE]*.COM" N
$!
$	CALL Do_Command -
		"Use wild cards to display all file types with a given name." -
		"DIR SYS$SYSROOT:[SYSEXE]SYS.*" N
$!
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J

Remember the DIRectory  command is simple to use.  Whenever you want to see what
files are present on your current directory just type

		$ DIR

to the DCL prompt ($).  Often you will see that unneeded files are accumulating
(old versions).  Use the PURge or DELete command to remove these files.
!
@[23HPress [7mRETURN[m to continue...
$	Test:==F
$	EXIT 1
$!______________
$Do_Qualifiers:
$	Test:==F
$	@SYS$INSTRUCTION:Head_Page "Directory Qualifiers"
$	RUN SYS$INSTRUCTION:DISPLAY

You may choose:

		[1mI[mntro	    -  Introduction to DIRectory qualifiers
		[1m/D[mate	    -  Date display
		[1m/F[mull	    -  Complete file information
		[1m/O[mwner	    -  File owner information
		[1m/P[mrotection -  File protection information
		[1m/S[mize	    -  File size information
		[1m/T[motal	    -  Print file size totals
		[1mE[mxit	    -  Exit this menu
$Qualif_Select:
$	INQUIRE Z "''Erasel20'Choice"
$	IF Z	.EQS. ""  THEN EXIT 1
$	Z1[0,1]:='Z'
$	Z2[0,2]:='Z'
$	IF Z1	.EQS. "E"  THEN EXIT 1
$	IF Z2	.EQS. "/D" THEN GOTO Qualif_Date
$	IF Z2	.EQS. "/F" THEN GOTO Qualif_Full
$	IF Z2	.EQS. "/O" THEN GOTO Qualif_Owner
$	IF Z2	.EQS. "/P" THEN GOTO Qualif_Protect
$	IF Z2	.EQS. "/S" THEN GOTO Qualif_Size
$	IF Z2	.EQS. "/T" THEN GOTO Qualif_Total
$	IF Z1	.EQS. "I"  THEN GOTO Qualif_Intro
$	WRITE SYS$OUTPUT EraseL22,"%CAI-E-ILLQUAL, ",Choice," is not an allowed qualifier"
$	GOTO QUALIF_SELECT
$!
$Qualif_Intro:
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JThe  DIRectory  command  has  a  wealth  of  qualifiers which  can be  used  for
extracting   specific  information   about  the  files  on  a  given  directory.
By  default,  the DIRectory  command  produces  a  display  with  the  following
qualifiers active:

	/BRIEF          Only file name, type and version listed
	/COLUMNS=4      Display directory in 4 column format.
	/NODATE         Do not display date information.
	/HEADING        Display directory header before listing files.
	/NOOWNER        No display of file ownership
	/NOPROTECTION   No display of file protection
	/NOSIZE         No display of file sizes
	/TRAILING       Display disk space allocation and No of files at end

All the information  that one can  obtain about  a file may be seen by using the
/FULL qualifier.
!
@[23HPress [7mRETURN[m to continue...
$	GOTO Do_Qualifiers
$!
$Qualif_Full:
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J			[7mThe /FULL Qualifier[m

All  the  information  available  about  a file can be obtained  using the /FULL
qualifier.  The information available includes:

	File Name	    Date of creation		Date of last back-up
	File Type	    Date of last modification	Date of expiration
	Version No	    File Owner's UIC		File Protection
	No of Blocks Used   File ID No (FID)		File Organisation
	No Blocks Alloc.    Record Attributes		Record format

Observe the  difference in  display as  we issue both a DIR/BRIEF and a DIR/FULL
command on the same file.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CALL Do_Command -
		"Use the /BRIEF qualifier for a brief display." -
		"DIR/BRIEF SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$!
$	CALL Do_Command -
		"Use the /FULL qualifier for a Full display." -
		"DIR/FULL SYS$SYSROOT:[SYSEXE]SYS.EXE" Y
$!
$	GOTO Do_Qualifiers
$!
$Qualif_Size:	
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JVarious  file  attributes  displayed by  the /FULL qualifier can be individually
displayed.  For example  the /SIZE qualifier  is used  to display  the amount of
disk space files are using.  The format of the /SIZE qualifier is:

			/SIZE[=option]

where the  '=option'  is optional,  and can be any of  ALL, ALLOCATION, or USED.
When a file is created,  so many disk blocks are allocated  for its use.  It may
or may  not use  all of these disk blocks.  If the space a file is using differs
from its allocation, you may be wasting space and should consider truncating the
file (SET FILE/TRUNCATE filespec).
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the DIR/SIZE display with various options.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CALL Do_Command -
		"Use the /SIZE qualifier with no options." -
		"DIR/SIZE SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$	CALL Do_Command -
		"Display Used and Allocated space with the /SIZE=ALL qualifier." -
		"DIR/SIZE=ALL SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$!
$	CALL Do_Command -
		"Display Used space with the /SIZE=USED qualifier." -
		"DIR/SIZE=USED SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$!
$	CALL Do_Command -
		"Display Allocated space with the /SIZE=ALLOCATED qualifier." -
		"DIR/SIZE=ALLOCATION SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$!
$	GOTO Do_qualifiers
$!
$Qualif_Owner:
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JThe file's owner (UIC) can be displayed by using the /OWNER qualifier.
$	CALL Do_Command "For example:" "DIR/OWNER SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$	GOTO Do_qualifiers
$!
$Qualif_Total:
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JThe /TOTAL qualifier inhibits the listing of all individual file information and
prints only:

	Number of files listed
	Total number of blocks used per directory
	Total number of blocks allocated
	Total number of directories and total blocks used
	    and/or allocated in all directories 
	    (if multiple directories are listed).

By default,  the output  format is /BRIEF,  which means  that only the number of
files and blocks used per directory is shown.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JFor example:
$	CALL Do_Command -
		"Display the totals in the VMS HELP directories." -
		"DIR/TOTAL SYS$SYSROOT:[SYSHLP...]" Y
$	GOTO Do_Qualifiers
$!
$Qualif_Protect:
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JFile protection is broken  down into four protection levels  based on the user's
UIC.  The levels  are SYSTEM, OWNER, GROUP,  and WORLD.  The file's OWNER is the
person  whose UIC matches  the UIC of the file.  A  SYSTEM UIC is any UIC with a
group number of 10 or less.  A user's GROUP are all users sharing the same group
code in the UIC. The WORLD represents all others. The following GROUPs exist on
our system:
)0
	Group Name	UIC	Sira group/department
	qqqqqqqqqq	qqq	qqqqqqqqqqqqqqqqqqqqq
	COMM_DIR	260	Commercial Directorate (Marketing)
	D_O		231	Mechanical Design Office
	E_P_D_O		233	Electronics Production Design Office
	EVALUATION	211	Instrument Evaluation (Technology Services)
	GROUP_A		235	Aerospace
	GROUP_B		235	Optics
	GROUP_C		245	Electronics
	TECH_DIR	261	Technical Directorate
	Q_A		250	Quality Assurance
!
@[23HPress [7mRETURN[m to continue...
!
[H[JEach level  can be individually  granted  READ (R),  WRITE (W), EXECUTE (E), and
DELETE (D)  privileges  for  a  file.  The protection mask  for  the file can be
displayed  with  the /PROTECTION qualifier. File protection is coded for display
as [S:RWED,O:RWED,G:RWED,W:RWED] where the letters following  the S:, O:, G: and
W: signify the  access level  to the  file.  If the level is RWED,  all forms of
access are permitted and the file is totally unprotected.
!
@[23HPress [7mRETURN[m to continue...
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT Page,"For an example of the /PROT qualifier:"
$	CALL Do_Command -
		"Display the file and its owner and its protection level." -
		"DIR/OWNER/PROT SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$	GOTO DO_Qualifiers
$!
$Qualif_date:
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JThe /DATE qualifier displays the four dates associated with each file.  The form
of this option is 

	/DATE[=option]

where '=option' is optional and can take values

	  /DATE=ALL		Displays all four dates
 	       =BACKUP		Displays date of last backup
	       =CREATED		Displays creation date
	       =EXPIRED		Displays the expiration date
	       =MODIFIED	Displays the date last modified

If no option is specified /DATE=CREATED is defaulted.
!
@[23HPress [7mRETURN[m to continue...
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT Page,"For an example of the /DATE qualifier:"
$	CALL Do_Command -
		"Display the file creation date (by default)." -
		"DIR/DATE SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$!
$	SET TERMINAL/WRAP
$	CALL Do_Command -
		"Display all dates related to the file." -
		"DIR/DATE=ALL SYS$SYSROOT:[SYSEXE]SYS.EXE" N
$	SET TERMINAL/NOWRAP
$	GOTO Do_Qualifiers
$!
$Do_Output:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JA number of  qualifiers are used  to control the format of the directory display
and to direct the output of the display:

	/BRIEF		   Display file names only, in multi-column format.

	/COLUMNS=n	   Specifies number of columns for /BRIEF (default 4).

	/NOHEADING	   Suppresses default directory heading for listing.

	/NOTRAILING	   Suppresses display of the number of files listed, the
			   number of blocks used, and the totals for directories
		 	   and blocks if multiple directories are specified.

	/OUTPUT[=filespec] Directs  output to  the specified file instead of the
			   current SYS$OUTPUT.

	/PRINTER	   Directs  to  DIRECTORY.LIS  which  is spooled  to the
			   printer and then deleted.
!
@[23HPress [7mRETURN[m to continue...
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	WRITE SYS$OUTPUT Page,"Now for some examples:"
$	CALL Do_Command -
		"Display files without heading and trailing information." -
		"DIR/NOHEADING/NOTRAILING SYS$LIBRARY:*.TLB" N
$!
$	CALL Do_Command -
		"Display using two columns instead of the standard 4 columns." -
		"DIR/COLUMNS=2 SYS$LIBRARY:*.TLB" N
$	EXIT 1
$!
$Do_Select:
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JCertain  qualifiers  are used  to select certain classes  of files  for  display
based on dates or versions of files, or based on excluding certain files.

 /SINCE [=time]		Displays all  files which were  CREATED, MODIFIED,
 /BEFORE[=time]		which  EXPIRED  or  which  were backed up SINCE or
			BEFORE  the specified time.  If no time specified,
			then  the current  date at 00:00 is used.  Also by
			default, if none of /CREATED, /MODIFIED,/BACKUP or
			/EXPIRED is specified, /CREATED is assumed.
 
 /EXCLUDE=(fspec,...)	Excludes  the listed  file specifications from the
			directory listing.
 
 /BACKUP  /CREATED	Used with the /SINCE or /BEFORE qualifier to  give
 /EXPIRED /MODIFIED	the type of date to select on.
 	
 /VERSIONS=n		Lists the latest 'n' versions of each file.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JSome examples of file selection qualifiers follow:
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CALL Do_Command -
		"Exclude *.EXE, *.SYS, *.COM, *.DAT and *.STB files from listing." -
		"DIR/EXCLUDE=(*.EXE,*.SYS,*.COM,*.DAT,*.STB) SYS$SYSROOT:[SYSEXE]" N
$!
$	SET DEFAULT 'Def_dir'
$	CALL Do_Command -
		"Display all files created in your directory today." -
		"DIR/SINCE" Y
$!
$	CALL Do_Command -
		"Display files modified since today at midnight." -
		"DIR/SINCE/MODIFIED" Y
$Reset_Terminal:
$	SET DEFAULT SYS$SCRATCH
$	IF F$SEARCH("SYS$SCRATCH:DIRXXXXX1.TXT").NES."" THEN DELETE SYS$SCRATCH:DIRXXXXX1.TXT;*
$	WRITE SYS$OUTPUT No_Scroll,Smooth
$	EXIT 1
$!
$!
$Do_Command: SUBROUTINE ! text1 command scroll?
$	ON CONTROL_Y THEN EXIT 4
$	Scroll=""
$	IF .NOT.P3 THEN GOTO NOSCROLL
$	Scroll="		     [Use [7mHold Screen[m to suspend/resume output]
$	IF TTYPE.EQS."VT52" THEN -
		Scroll="		       [Press SHIFT/SCROLL if the screen fills]"
$	IF TTYPE.EQS."HP" THEN -
		Scroll="	      [Use [7mctrl/S[m & [7mctrl/Q[0m to suspend/resume output]"
$NOSCROLL:
$	RUN SYS$INSTRUCTION:DISPLAY
[3H[J'P1'

[7m$ 'P2'[m

)9qqqqqqqqqqqqqqqqqqqq'Scroll'[8;24r[9H
$	ON ERROR THEN CONTINUE
$	DEFINE/USER SYS$INPUT SYS$COMMAND
$	'P2'
$	IF Ttype.EQS."HP" .AND. P3 THEN EraseL23="F"	! Home down
$	WRITE SYS$OUTPUT No_Scroll,To_ASCII
$	INQUIRE/NOPUN TMP "''EraseL23'''Erase_rest'Press ''Inverse'RETURN''No_Attr' to continue..."
$	WRITE SYS$OUTPUT EraseL23,Jump
$	IF Ttype.EQS."VT52" .AND. P3 THEN WRITE SYS$OUTPUT Page
$	EXIT 1
$ ENDSUBROUTINE
