$	ON CONTROL_Y THEN EXIT 1
$	DATE=F$EXTRACT(0,11,F$TIME())
$	RETURN = "[7mRETURN[m"
$	PF1=" PF1"
$	UP="^	"
$	IF Ttype.NES."VT52" THEN GOTO Not_VT52
$		PF1="blue"
$		RETURN:=<CR>
$		UP="up arrow"
$Not_VT52:
$	@SYS$INSTRUCTION:Head_Page "System Command Structure"
$	RUN SYS$INSTRUCTION:DISPLAY

VMS, or "Virtual Memory System", is the operating system for our VAX 11/750.  An
operating system  is an interface between the hardware  and the users. 	You tell
the operating system what you want done and it tells the hardware in commands it
understands.

The CLI, or "Command Language Interpreter",  is the part of the operating system
that takes each command you give, checks its validity and that you are permitted
("privileged")  to issue it,  and does it if so.  Our  CLI is DCL,  or  "Digital
Command Language",  which is  very diverse as well as "orthogonal" (meaning that
something learned about one command will often apply to many others).

DCL command format  is also used  within some VMS utilities,  such  as EXCHANGE,
MAIL, and the debugger.  There are even facilities which make it reasonably easy
to  incorporate DCL  command syntax in programs you write yourself,  which saves
people who use them having to learn a new command syntax.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JThe basic DCL command syntax has the following form:

	command[/qualifier_1[/qualifier_2...]] [parameter_1 [parameter_2 ...]]

The square brackets indicate that an item is optional. A command name is always 
required, but not all commands have, or need, qualifiers and/or parameters.

An example (which has one qualifier and two parameters) is:

	SEARCH/NUMBERS FILE.TXT DCL

In plain English, this would read:

	SEARCH, showing line NUMBERS, in file FILE.TXT, for string "DCL"

In which the command,		SEARCH,     may be likened to a verb,
	 the qualifier,		/NUMBERS,   to an adverb,
	 the first parameter,	FILE.TXT,   to the object of the sentence, and
	 the second parameter,	DCL,	    to the subject.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J	!C_1!command!  !Q_1!/qualifier!  !P1_1!parameter_1!  !P2_1!parameter_2!

	!C_2!SEARCH!  !Q_2!/NUMBERS!  !P1_2!FILE.TXT!  !P2_2!DCL!

	!C_3!SEARCH!,  !Q_3!showing line NUMBERS!,  !P1_3!in file FILE.TXT!,  !P2_3!for string "DCL"!
)0qqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqq
[0;0;3|
$	WRITE SYS$OUTPUT Show_C_1,Show_C_2,Show_C_3
$	RUN SYS$INSTRUCTION:DISPLAY
[7H[JThe command name  consists of  one or more  letters or  digits  (starting with a
letter) that uniquely identify a VMS function.  Commands are often documented as
fairly long words,  but you  can abbreviate them  so long as  the result  is not
ambiguous; a maximum of four characters is usually sufficient.

Some simple commands are:-

	CLS	Clear the screen

	PCC	Run the "Portacalc" spreadsheet program

	LOGOUT	Log out of the system (can be abbreviated to LO)
!
@[23HPress [7mRETURN[m to continue...
$	WRITE SYS$OUTPUT NoShow_C_1,NoShow_C_2,NoShow_C_3,-
			 Show_P1_1,Show_P1_2,Show_P1_3
$	RUN SYS$INSTRUCTION:DISPLAY
[7H[JParameters usually specify the object of the command function,  which, as in the
first parameter  of the above example,  is most often a file.  One or more blank
spaces must separate the parameter from the command name, and one parameter from
another.  Parameters  cannot  usually  be abbreviated,  since they name specific
entities  (one exception is a device name,  in which you can sometimes leave off
the terminating colon).

Some more examples of commands with parameters are:

DELETE FRED.DAT;-0	which deletes the oldest version of file FRED.DAT.

COPY FRED.DAT BERT.DAT	which copies file FRED.DAT into BERT.DAT. The order is
			"from"/"to", so the English equivalent of this command
			is: "COPY from FRED.DAT to BERT.DAT".
!
@[23HPress [7mRETURN[m to continue...
$	WRITE SYS$OUTPUT NoShow_P1_1,NoShow_P1_2,NoShow_P1_3,-
			 Show_P2_1,Show_P2_2,Show_P2_3
$	RUN SYS$INSTRUCTION:DISPLAY
[7H[J
To show that they are not always files, the  second parameter  in the example is
the string to be searched for.

Other non-file parameters appear in the following commands:

	SHOW TERMINAL	which lists your current terminal setups

	ERROR 13CB	shows the error message whose number is 13CB (hex)
!
@[23HPress [7mRETURN[m to continue...
$	WRITE SYS$OUTPUT NoShow_P2_1,NoShow_P2_2,NoShow_P2_3
$	RUN SYS$INSTRUCTION:DISPLAY
[7H[JIf you wish to include a space,  lower-case letters, and some special characters
in  a  parameter,  enclose  it  in double-quotes (").  To include  double-quotes
themselves in a double-quoted string, use an adjacent pair ("").

For example:
		The command				finds string
)0		qqqqqqqqqqq				qqqqqqqqqqqq
	SEARCH FILE.TXT "DCL command"			DCL command

	SEARCH FILE.TXT "really!"			really!

	SEARCH FILE.TXT """DCL command"" syntax"	"DCL command" syntax
!
@[23HPress [7mRETURN[m to continue...
!
[7H[JIn many instances,  the parameter is mandatory,  i.e. the command cannot proceed
without it.  Sometimes  you will  get an error message,  and have to reenter the
command from scratch. More often, you will be prompted for the missing item. If,
for example, you simply type:

	SEARCH

then you will be prompted for the required filename and string, as:

[0;0;4|	_File:
[0;0;2|[16;16HFILE.TXT
[0;0;1|	_String:
[0;0;2|[17;18H"DCL command"
[0;0;2|
This is useful when you cannot remember the order on multi-parameter commands.
[0;0;2|
If,  partway through a prompted command,  you decide you do not  wish to execute
it after all, answering ctrl/C to any prompt will cancel the whole command.
!
@[23HPress [7mRETURN[m to continue...
!
[7H[JSome commands require, or allow, lists of files to be supplied. For example, you
can search several files at once by a command like:

	SEARCH FILE.TXT;1[7m,[mFILE.TXT;2[7m,[mANOTHER.TXT;*[7m,[mYET_MORE.DAT "a b c"

Note that individual files forming  the first parameter are separated by commas,
without intervening spaces.
!
@[23HPress [7mRETURN[m to continue...
!
[7H[JSome other utilities also take a list, but separate the files by plus signs (+),
as in:

	FORTRAN MAIN.FOR[7m+[mSUB1.FOR[7m+[mSUB2.FOR

This tells the compiler to treat all three files as if they were one single file
comprising the contents of files MAIN.FOR, SUB1.FOR, and SUB2.FOR, and produce a
single object file,  MAIN.OBJ.  If commas had been used instead of plusses,  the
files would have been compiled separately,  giving three object files: MAIN.OBJ,
SUB1.OBJ, and SUB2.OBJ.
!
@[23HPress [7mRETURN[m to continue...
!
[7H[JThus,  the comma separator means that the command should be applied to each file
individually,  whereas the plus  means they are  to be treated as a single file.
You can even combine the two forms in the same command, so:

	FORTRAN MAIN.FOR+SUB1.FOR+SUB2.FOR[7m,[mPROG.FOR[7m,[mJOB.FOR+JOBSUB.FOR

would be equivalent to three separate commands:

	FORTRAN MAIN.FOR+SUB1.FOR+SUB2.FOR
	FORTRAN PROG.FOR
	FORTRAN JOB.FOR+JOBSUB.FOR
!
@[23HPress [7mRETURN[m to continue...
!
$	WRITE SYS$OUTPUT Show_Q_1,Show_Q_2,Show_Q_3
$	RUN SYS$INSTRUCTION:DISPLAY
[7H[JQualifiers  modify either  a parameter  or the function of the command,  usually
providing more explicit instructions.  A qualifier  consists of  a slash (/) and
an  alphanumeric string,  sometimes followed by  an equals sign  or colon, and a
qualifier value or list of values:

	/qualifier=value

	/qualifier=(value1[7m,[mvalue2[[7m,[m...])

Note  that  lists  must be  enclosed in parentheses,  with  values  separated by
commas, not plusses.  As with parameters, values which contain spaces or special
characters should be enclosed in double-quotes (").

A qualifier  immediately follows  either the  command itself  or a  parameter it
qualifies; often it does not matter which. Intervening spaces are ignored.  Like
commands, qualifiers can be abbreviated to the point of non-ambiguity.
!
@[23HPress [7mRETURN[m to continue...
!
[7H[JNumeric values are taken as decimal by default. To specify octal or hexadecimal,
prefix the number by "%O" or "%X" respectively.

Date and time may be entered in the form  dd-mmm-yyyy:hh:mm:ss.tt,  where any of
the  fields  (but not  leading delimiters)  may be omitted.  Note that  all four
digits  of  the  year  are required -- it's nearly 2000!  Special date  strings,
YESTERDAY, TODAY, and TOMORROW, are also accepted. Thus a value list might read:

	/QUALIFIER=(1234[7m,[m%O1234[7m,[m%X1234[7m,[m"12,34"[7m,[m'DATE'[7m,[mTODAY)

giving numbers 1234, 668, and 4660, string "12,34", and today's date twice.
!
@[23HPress [7mRETURN[m to continue...
!
[7H[JSome more examples are:-

DELETE/CONFIRM ABC.DAT;*	which selectively  deletes all versions of
				ABC.DAT, asking you to confirm that really
				want to do so, as each version is named.

SET TERMINAL/WIDTH=132		sets the page width of the terminal to 132
				(decimal) characters.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JIn some cases, qualifiers can be negated to reverse their effect.  That is, if a
qualifier is  thought  of  as a "switch" turning something on,  then negating it
turns it off. Negation is done by preceding the qualifier name with NO, as:

	/NOqualifier[=value]

Hence, one could suppress line numbering in the above example with:

	SEARCH/[7mNO[mNUMBERS FILE.TXT DCL
!
@[23HPress [7mRETURN[m to continue...
!
[H[JRemember that,  when we talked about "orthognality",  it was said  that what you
learn about one command can be applied to several others. 

Thus,  although each command  has its own particular  allowed set of qualifiers,
some are common to very many of them.

Some of the more common ones will now be shown...
!
@[23HPress [7mRETURN[m to continue...
!
[H[J				[7mInformation Control[m

/ALL or   expands  the output  from some commands.  If you  don't think  you are
/FULL	  getting enough information, try using the /ALL or /FULL qualifier. 

/BRIEF	  reduces the amount of information given.


/LOG	  causes  the facility  to issue  an informational message when  it  has
	  performed the required function.  For example, DELETE/LOG  gives you a
	  list  of deleted files.  For  some commands,  /LOG is the default,  in
	  which case you can use /NOLOG to suppress the message.

/NOTIFY	  used with PRINT, SUBMIT, and SPAWN  commands to ask the system to tell
	  you when  a file  has been printed,  or a batch job or spawned command
	  has completed.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J				[7mFile Selection[m

/BEFORE=date_time selects files  created or modified up to but not including the
		  given date/time.

/SINCE=date_time  selects files created or modified at and after the given date/
		  time. You can often combine /BEFORE and /SINCE to give a range
		  of dates.

/EXCLUDE=value	  excludes the given item, or list of items, from the operation.
		  For example,  this may  be a  list of  files you want excluded
		  from a wildcard operation.

/CONFIRM	  causes  a prompt  to be  issued before  the given operation is
		  carried out.  You can then answer one of: "Yes" to perform the
		  action,  "No" to go on to the next,  "All" to continue without
		  further queries, or "Quit".  This is also useful with wildcard
		  file specifications, where it is not always easy to use one of
		  the above qualifiers to make the full choice automatically.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J				[7mFile Specification[m

/LIBRARY	   used to  tell a  utility that the file to which it is applied
		   is  a library of files,  not  an individual one.  The utility
		   must be specially programmed to handle this.

/OUTPUT[=filespec] names a  file to receive output when you wish to override the
		   default  for  the  command.  For  example,  the  system  SHOW
		   commands normally display the information on your terminal; a
		   /OUTPUT specification  will direct it to a file instead.  You
		   can suppress  unwanted output  from a utility by directing it
		   to  the null device  with /OUTPUT=NL:.  Some facilities, like
		   compilers,  specify  their  output files  with  more specific
		   qualifiers,  such as  /OBJECT and /LIST.  Still others,  like
		   SORT,  have  the output file  as the  second PARAMETER on the
		   command line, instead of using a qualifier to name it.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J			[7mCompiler Control Qualifiers[m

/LIST[=filespec]    specifies that you want a listing,  and the name of the file
		    it should go to.  (By default,  the listing  goes  to a file
		    with the same name as the first source file,  and type LIS.)
		    To get the listing printed automatically, use /LIST=LP:.

/OBJECT[=filespec]  specifies  an alternative name for the object file  (default
		    is  the  first file name,  with filetype OBJ).  Object  file
		    generation  is usually  enabled by default for compilers. If
		    you only want a compilation check, and don't need the object
		    file, you can suppress it with /NOOBject.

/SHOW=item	    specifies what items should (not) go into the list file.

/DEBUG		    specifies that  information for use with the debugger should
		    be included in the object file. (Need to LINK /DEBUG too).

/[NO]OPTIMIZE	    Used  in the  /[NO] form  to turn off compiler optimisation.
		    Usually  used  with /DEBUG  to  avoid  confusion  caused  by
		    optimisation, e.g. use of registers for temporary storage.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JSome qualifiers  must be applied to parameters, rather than commands.  These are
called "local",  or "positional" qualifiers,  rather  than "global" or "command"
qualifiers.  An example from  the above  list is /LIBRARY, which MUST be applied
to a file, since it describes that specific file, e.g.

	MACRO PREFIX+MYLIB/LIBRARY+PROG+SUB1+SUB2

where PREFIX, PROG, SUB1, and SUB2 are MACRO-32 program source files,  but MYLIB
is a macro library.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JIn some cases a qualifier may be EITHER local OR global, with different meanings
according  to  where  it  is  used.  A common example  is the  /OBJECT and /LIST
qualifiers used with compilers.

For example,

	FORTRAN[7m/OBJECT[m=OBJFILE PROG+SUB1+SUB2

specifies that the object file is to be called OBJFILE.OBJ, but

	FORTRAN PREFIX+PROG[7m/OBJECT[m+SUB1+SUB2

specifies  that  the  object file  is to be  named after  the file  to which the
qualifier is attached, making it PROG.OBJ in this case.  (By default it would be
named after the first file in the list, giving PREFIX.OBJ.)
!
@[23HPress [7mRETURN[m to continue...
!
[H[JIf a command will not fit on one line,  end the  incomplete line with a dash (-)
and RETURN.  A "_$" prompt  then appears instead of the normal "$",  and you may
enter a continuation line.  You may repeat this, up to 1024 characters in total.
When the command is complete, end the last line with RETURN alone.

Thus the SEARCH command used above could be entered:

	$ SEARCH -'RETURN'
	_$ FILE.TXT -'RETURN'
	_$ DCL'RETURN'

Note  carefully the spaces before the dashes above.  THESE ARE SIGNIFICANT.  The
whole command  gets concatenated  exactly as you type it, except for the dashes.
Had the spaces been omitted above, the command would have been concatenated to:

	$ SEARCHFILE.TXTDCL

resulting in an error message.  Since excess  spaces are usually ignored, a good
good rule is to always end a continued line at a natural break, and with " -".

Note that in multi-line input, you can only EDIT the current line on the screen.
However, you can CANCEL the whole command with ctrl/C.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JDCL remembers  the  last 20 commands  you issued.  You can see what they were by
typing:

	RECALL/ALL

(or just  pressing the  keypad 'PF1' key).  This gives a numbered list,  the most
recently entered being number 1.  There are several ways to recall commands from
from this list.  When you do so, the recalled command is displayed at the bottom
of the  screen with  the cursor at the end of the line.  You can press [7mRETURN[m to
reexecute it  just as it was before,  use the editing  keys to  modify it before
resubmission, or press ctrl/C to discard it.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J	$ RECALL/ALL
	1 RUN PROG
	2 LINK/DEBUG PROG,SUB1,SUB2
	3 FORTRAN/DEBUG/NOOPTIMIZE SUB2
	4 FORTRAN/DEBUG/NOOPTIMIZE SUB1
	5 FORTRAN/DEBUG/NOOPTIMIZE PROG
	6 EDIT PROG.FOR
	7 FORTRAN/DEBUG/NOOPTIMIZE PROG
	8 RUNOFF PROG_DOC
	$

qqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqq
$	IF Ttype.EQS."HP" THEN WRITE SYS$OUTPUT -
		"&a1r6C







"
$	RUN SYS$INSTRUCTION:DISPLAY
)9[13HIndividual commands can be recalled in various ways:

RECALL number	recalls the command by its number from the RECALL/ALL list. Note
		that every time you issue, or reissue, a command, the numbers in
		the list increment, and the 20th command is lost.
[0;0;4|[10;11HRECALL 6
[0;0;1|	$ EDIT PROG.FOR[7;4H>
!
@[23HPress [7mRETURN[m to continue...
!
[7;4H [10;11H[K
[K[15H[JRECALL string	recalls the  most recent command  beginning with  the characters
		given in the RECALL command parameter. You need give only enough
		characters  to ensure  you get the required command.  E.g. since
		the list above contains a RUN command, with a previously entered
		RUNOFF, then R, RU, or RUN, will select the RUN command,  but at
		least RUNO will be required to get the RUNOFF.
[0;0;4|[10;11HRECALL RUNO
[0;0;1|	$ RUNOFF PROG_DOC[9;4H>
!
@[23HPress [7mRETURN[m to continue...
!
[9;4H [10;11H[K
[K[15H[J)9'UP'    recalls the previous command from the list. You can press it several
or ctrl/B   times to scan  backwards through the list.

V	    steps forward through the list after you have used the up arrow key.

These keys may be the easiest way to fetch a very recent command.
[0;0;4|[10;11H'UP'
[0;0;1|	$ RUN PROG[2;4H>
[0;0;2|[10;11H[K
[K
[0;0;1|[10;11H'UP'
[0;0;1|	$ LINK/DEBUG PROG,SUB1,SUB2[2;4H 
>
[0;0;2|[10;11H[K
[K
[0;0;1|[10;11H'UP'
[0;0;1|	$ FORTRAN/DEBUG/NOOPTIMIZE SUB2[3;4H 
>
[0;0;2|[10;11H[K
[K
[0;0;1|[10;11H'UP'
[0;0;1|	$ FORTRAN/DEBUG/NOOPTIMIZE SUB1[4;4H 
>
[0;0;2|[10;11H[K
[K
[0;0;1|[10;11HV
[0;0;1|	$ FORTRAN/DEBUG/NOOPTIMIZE SUB2[4;4H>
 
[0;0;2|[10;11H[K
[K
[0;0;1|[10;11HV
[0;0;1|	$ LINK/DEBUG PROG,SUB1,SUB2[3;4H>
 
!
@[23HPress [7mRETURN[m to continue...
!
[H[JAnother great  time-saver is the ability  to define some of the auxiliary keypad
keys to  issue part or all of frequently-used commands for you.  For example, if
you  are  developing a program,  compiling,  linking,  and running it,  you will
frequently need commands such as:

	FORTRAN/NOOPTIMIZE/DEBUG PROG,SUB1,SUB2
	LINK/DEBUG PROG,SUB1,SUB2
	RUN PROG

These could be associated with special function keys PF1, PF2, and PF3 using:

	DEFINE/KEY PF1 "FORTRAN/NOOPTIMIZE/DEBUG PROG,SUB1,SUB2"/TERMINATE
	DEFINE/KEY PF2 "LINK/DEBUG PROG,SUB1,SUB2"/TERMINATE
	DEFINE/KEY PF3 "RUN PROG"/TERMINATE

Then pressing  PF1  compiles the three modules,  PF2 links the program,  and PF3
RUNs it, all with only four keystrokes.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JThe  /TERMINATE qualifier  used  above causes  the command string to be executed
immediately you  press the key.  If you  leave it off,  the key just inserts the
string,  and  puts the  cursor after it.  This is  useful in  defining  skeleton
commands to be completed with the line editing function, or entering long items.
For example, you could just:

	DEFINE/KEY PF1 MY_PROGRAM

and then issue the EDIT command by:

	EDIT <PF1>'RETURN'

The system  command  SHOW KEY/ALL  will display  the strings associated with any
keys you have defined.  The Sira system startup file defines several of them for
you, so SHOW KEY/ALL will always show something.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JAll  commands  and  utilities supplied  by  Digital  use the DCL command syntax.
However, there are two other command syntaxes you may meet...
!
@[23HPress [7mRETURN[m to continue...
!
[H[J[4mMCR syntax[m is used by a few utilities transported from RSX-11M systems:

	command output-file[/switches]=input-file[/switches]

Note that the order of input and output files is reversed from the commonest DCL
order  (command input-file output-file),  and that there  is an '=' sign between
the two files.  In some cases,  there may be  lists of  input  or  output files,
separated by commas, and the position of the file in the list may determine what
type it is.  Switches look like DCL qualifiers,  but are  usually limited to two
characters, and values may only be separated from the switch by a colon (:), not
an '=' sign.  Switches are only applied to files, NEVER to the command.

For example:

	$ LIST TT:=SOURCE1/PI:8:10/NOTA/CO:2,SOURCE2

lists files SOURCE1.TXT and SOURCE2.TXT, with page headings at 8cpi and text at
10cpi (the /PI switch), no horizontal tabs (/NOTA), and in two columns (/CO:2).

Utilities using  this older form will be replaced by DCL syntax commands as time
permits.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J[4mUnix Syntax[m is used by utilities  transported from Unix  systems,  including the
Whitesmiths' cross-compilers. The format is:

	command [-flag1 [-flag2...]] [parameter_1[ parameter_2...]]

Flags are single letters, prefixed by a minus or plus sign. Sometimes, they take
values which immediately follow them,  with no separator character. Flags may be
concatenated together without a '-' before each, e.g. -abc instead of -a -b -c.

Parameters, usually files,  are separated from flags, and each other, by spaces.
By  default,  Unix utilities  have  an input and output  file  attached  to  the
terminal. You can redirect them to  files by placing a '>' sign  in front of the
input file,  or a '<' in front of the output. E.g.:

	$ cpp -x -dVMS -i SYS$LIBRARY: >PROG.C <PROG.CP1

calls the C pre-processor  to expand C program PROG.C into output file PROG.CP1.
The -x flag specifies  that PROG.CP1 should  be in a form  suitable for input to
the C pass 1 compiler stage.  -dVMS indicates that symbol VMS should be taken as
defined in any  #ifdef conditionals.  "-i SYS$LIBRARY:" names the system library
directory for the included file in any #include <filename> statements.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JDCL provides you with a way to define your own private ("foreign") commands,  in
terms of system commands,  usually as  abbreviations of special  cases for which
you would otherwise have to enter strings of qualifiers. The syntax is:

	foreign-command :== system-command

When you log in, a number of such definitions are made for you, including:-

	AFT*ER     :== DIRECTORY/DATE/SIZE=ALL/PROT/SINCE=
	BRI*EF     :== DIRECTORY/BRIEF
	D	   :== DIRECTORY/SIZE=ALL/DATE/PROT
	SDE*LETE   :== DELETE/CONFIRM
	TOD*AY     :== DIRECTORY/SINCE/BEFORE=TOMORROW/DATE/SIZE=ALL/PROT
	UNP*ROTECT :== SET FILE/PROTECTION=(S:RWED,O:RWED,G:RWED,W:RWED)
	VT10*0     :== SET TERMINAL/VT100/LINE_EDITING/NOEIGHT_BIT

Whenever  you start a command line with the word on the left of the  ":==",  the
whole phrase  on the right  is  substituted.  The asterisks are not part  of the
symbols;  they just  indicate  the permissible  level of  abbreviation,  so that
"UNP", "UNPR", "UNPRO", etc. are all valid abbreviations for "UNPROTECT".
!
@[23HPress [7mRETURN[m to continue...
!
[H[JAnything you put on the line after the substitution symbol is just appended, so:

	$ AFT*ER :== DIRECTORY/DATE/SIZE=ALL/PROT/SINCE=
	$ AFTER 8-APR-1986 *.RNO

becomes

	$ DIRECTORY/DATE/SIZE=ALL/PROT/SINCE= 8-APR-1986 *.RNO

listing all the Runoff source files created on 8th April.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JA special form of the foreign command definition may be used to RUN programs:

	foreign-command :== $filespec

This  causes the  program in the  named file to be RUN.  Anything you put on the
line after  the command name gets passed to  the program,  which it  can collect
with a system library routine (LIB$GET_FOREIGN). By default, programs started in
this  way  are looked up in the system directory.  To  specify  one  of your own
programs, you must explicitly name your own directory as part of filespec.

For example, if you issue the commands:

	$ CHANGE :== $C:['Prc']MYPROG
	$ CHANGE INPUT_FILE.TXT OUTPUT_FILE.DAT

then you have a private command called "CHANGE", running MYPROG.EXE, which, when
it calls LIB$GET_FOREIGN, gets the string:

	INPUT_FILE.TXT OUTPUT_FILE.DAT
!
@[23HPress [7mRETURN[m to continue...
!
[H[JYou can check the definition of a foreign command with the system command:

	  SHOW SYMBOL foreign-command

E.g.
	$ SHOW SYMBOL AFTER
	  AFT*ER == "DIRECTORY/DATE/SIZE=ALL/PROT/SINCE="


You are  strongly advised  to resist  the temptation  to define  lots of foreign
commands just  to prove  you have  read this section!  Foreign commands  take up
space in the system,  slow down SPAWN operations, and confuse anyone else who is
trying to follow what you are doing at your terminal.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JIf you have a  series of commonly used instructions,  such as  those required to
compile,  link,  and run a program,  you can store them in a "command procedure"
file,  which  enables you to  execute them  all with  one  command,  instead  of
typing them individually,  or defining a lot  of special function keys (if there
are enough).

For example, to compile link, and run a simple FORTRAN program might require:

	$ FORTRAN PROG
	$ LINK PROG
	$ RUN PROG

If you put this (including the $''s at the start of each line) in a file called, 
say, COMPILE.COM (COM is the usual filetype  for a command procedure file), then
the single command:

	$ @COMPILE

does all of the above steps (if no compilation or linkage failures occur).
!
@[23HPress [7mRETURN[m to continue...
!
[H[JYou can pass up to eight parameters (but not qualifiers) to a command procedure.
They go into "local symbols" P1, P2, ... P8, which may  be  substituted when the
file is  executed by  placing the  symbols in  single-quotes.  So if the command
procedure file is rewritten:

	$ FORTRAN ''P1''
	$ LINK ''P1''
	$ RUN ''P1''

Then in:

	$ @COMPILE PROG

all occurences of ''P1'' are replaced by PROG, with the same result as before, but
typing:

	$ @COMPILE OTHER_PROG

would use the same file to compile, link, and run program OTHER_PROG instead.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JCommand  procedures can be a great deal more powerful than this. They can create
symbols and assign values to them, do arithmetic, logical, and string operations
on them,  fetch information about the system,  process, and terminal, and so on.
The COMPILE.COM procedure could,  for example,  be extended  to ask for files if
you do not  supply any  on the  command line  and, if a list is supplied, select
only the first name for use with the LINK and RUN commands:

	$ IF P1.EQS."" THEN INQUIRE "What file(s) do you want to use" P1
	$ FORTRAN ''P1''
	$ NAME = F$ELEMENT(0,",",P1)
	$ LINK ''NAME''
	$ RUN ''NAME''

In  the  above,  F$ELEMENT  is one of  many  "lexical functions",  equivalent to
trigonometrical functions in maths, which perform string manipulations or supply
system information.

Command procedure files  provide a very powerful way of using DCL, to the extent
that quite complex "programs", not necessarily related to system operations) can
be written  using  them.  (This  CAI package  is  largely written as a series of
command procedures.)
!
@[23HPress [7mRETURN[m to continue...
!
[H[JA further use for command procedures is that they can be SUBMITted for execution
by  the BATCH processor.  This  enables you  to run a job  without tying up your
terminal until it finishes,  and is particularly  useful therefore when you want
to run something  which could take several minutes,  or even hours, to complete,
but does  not require  user interaction (like data input) in that period.  Batch
jobs run at  slightly lower  priority than  normal,  "interactive"  ones,  which
reduces the impact  that computationally intensive programs  make on performance
of user-interactive things like editing, where fast response to what you type is
required.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JTo get a command procedure file to run on BATCH, you issue the command:

	SUBMIT[/qualifiers] comfile

where comfile is the name of the command procedure file.

When BATCH starts executing your command procedure file, it is almost as if you
had logged in to another terminal. This means that if you want to read or write
files  in a  directory other  than your  login directory,  you should start the
command procedure file with a directory change command.

Some commands work differently in BATCH to the way they do interactively. (Some,
of course,  like INQUIRE,  cannot work at all).  One difference is that /LIST is
the default for compilations,  so you may need to specify /NOLIST on compilation
lines.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JSome SUBMIT qualifiers are:-

/LOG[=filespec]	   causes a log file to be generated. This contains a listing of
		   all  the commands  and output  you would  have seen  at  your
		   terminal had you typed the command procedure by hand. You can
		   look at this later  to make sure everything worked,  and find
		   any results which would normally be printed at your terminal.
		   A log file is normally produced by default.  You can suppress
		   it with /NOLOG,  in which  case you  must find out some other
		   way  what happened.  If you do not specify filespec,  the log
		   file is named after comfile, with type LOG.

/PRINT		   causes the  log file  to be printed automatically,  and then
		   deleted, when the job finishes. This is the default. You can
		   suppress printing with /NOPRINT.

/PARAMETERS=(list) allows parameters to be specified for passing to the command
		   procedure file. You supply a comma-separated list of strings
		   which may be read by the command procedure as P1 up to P8.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JFor example:

	SUBMIT/NOPRINT/PARAMETERS=PROG COMPILE

would submit the COMPILE.COM file illustrated previously, passing it the name of
the  program to  compile  in  parameter P1.  The /NOPRINT  qualifier  suppresses
printing of the COMPILE.LOG file generated.

Another example might be:

	$ SUBMIT/PARAMETERS=(MTA0,TODAY)/LOG=['Prc'.SCRATCH] BACKUP

which might run a command procedure to back up files created TODAY on tape drive
MTA0.  The  /LOG  qualifier  is  used  here to  force the log file  to be placed
somewhere other than your login directory.
!
@[23HPress [7mRETURN[m to continue...
$	EXIT 1
