$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	ON ERROR THEN GOTO Reset_Terminal
$	IF P1 .NES. "" THEN GOTO 'P1'
$	WRITE SYS$OUTPUT Page,"%CAI-F-NOSUB, No subroutine specified
$	WAIT 00:00:03
$Purpose:
$	EXIT 1
$!
$Menu:
$	@SYS$INSTRUCTION:HEAD_PAGE "The VAX/VMS TYPE Command"
$	RUN SYS$INSTRUCTION:DISPLAY

You may choose:

		[1mI[mntro	-  Introduction to the TYPE Command
		[1mF[minal	-  Final exam
		[1m*[m	-  Both of the above
		[1mE[mxit	-  Exit this menu
$	Do_it_all == "I!F"
$	EXIT 1
$Select:
$	Test:==F
$	Result:==OK
$	ZTmp=P2
$	ZTMP1=P3
$	IF ZTmp   .EQS. "E"  THEN Result:=="DONE"
$	IF ZTmp   .EQS. "E"  THEN EXIT 1
$	IF ZTmp   .EQS. "I"  THEN GOTO Do_Introduction
$	IF Ztmp   .EQS. "F"  THEN GOTO Final_Exam
$	Result:=="BAD"
$	EXIT 1
$!______________
$Final_Exam:
$	@SYS$INSTRUCTION:Head_Page "The Final Exam"
$	TYPE SYS$INPUT


Now let's see if you remember how to use TYPE.

Will the following TYPE command
$!______________
$	Test:==T
$	Question==""
$	Question_1=="display all text files at your terminal"
$	Example_1=="TYPE *.TXT"
$	Answer_1=="Y"
$	Reason_1=="TYPE accepts wild cards as part of file specifiers"
$	Question_2=="display FILE1.TXT and FILE2.TXT at your terminal"
$	Example_2=="T FILE1.TXT FILE2.TXT
$	Answer_2=="N"
$	Reason_2=="Multiple file names must be separated with commas, not spaces."
$	Question_3=="output a text file to the graph plotter TXA1:"
$	Example_3=="TYPE/OUTPUT=TXA1: MYFILE.TXT"
$	Answer_3=="N"
$	Reason_3=="VMS only allows you to output to allocated terminals."
$	Question_4=="type the first file to the terminal, the second to file"
$	Example_4=="TYPE FILE1.TXT,FILE2.TXT/OUTPUT=FILE3.TXT"
$	Answer_4=="N"
$	Reason_4=="The /OUTPUT qualifier is "+U_line+"global"+No_Attr+" so both files go to FILE3.TXT."
$	Question_5=="type all text files in a given directory."
$	Example_5=="TYPE *.*;*"
$	Answer_5=="N"
$	Reason_5=="Wildcard file type will allow non-text files to be displayed."
$	Question_6=="output text from within a command file to another file"
$	Example_6=="TYPE/OUTPUT=FOO.TXT SYS$INPUT
$	Answer_6=="Y"
$	Reason_6=="All text until the next line starting with a "$" goes to FOO.TXT""
$	Nmax==6
$	EXIT 1
$Do_Introduction:
$	SET DEFAULT SYS$INSTRUCTION
$	Test:==F
$	RUN SYS$INSTRUCTION:DISPLAY
[H[J			[7mUsing the VMS TYPE Command[m

The VMS TYPE command is used to display the contents of a file or group of files
to the  current  output device.  The files  should be ASCII text files. Typing a
binary file  (object module,  executable image or  the like)  to  one's terminal
produces  very unsatisfactory results.   The  TYPE command can be abbreviated to
the single letter "T".  It has the following syntax:

	$ TYPE filespec1[,filespec2.....,filespecN]

where the file specifiers can include wild cards  (*) for directory, name, type,
or version.  
!
@[23HPress [7mRETURN[m to continue...
!
[H[JThe output qualifier may be used to  direct the output of the TYPE command to an
output device other than one's current terminal.  This qualifier is:

		/OUTPUT=file-spec

The qualifier may be placed immediately after TYPE  or after any file specifier.
The  /OUTPUT qualifier  directs  the  output  to go  to  the  file  specified by
"file-spec".   This may be  a  terminal or  any other valid  VMS file specifier.
For example,

	$ TYPE /OUTPUT=TXA6: FOO.COM 

displays FOO.COM on terminal TXA6:.  Remember, however, that VMS will not allow
you  to output to  physical devices  which you do not own.  To own a device you
must ALLOCATE it.

If you enter  the command  TYPE with no files,  VMS will prompt you for the file
specifier.  Enter a file specifier, or type Control-Z or Control-Y to cancel the
request.
!
@[23HPress [7mRETURN[m to continue...
!
[H[JNow let us observe the effects of a TYPE command.
$	ON CONTROL_Y THEN GOTO Reset_Terminal
$	CALL Do_Command -
		"VMS produces a warning message if the file can not be found." -
		"TYPE FOO123456.XYZ"
$!
$	RUN SYS$INSTRUCTION:DISPLAY
[H[JThe TYPE  command is a  good way  to demonstrate  the use  of  various  terminal
control keys. If, while output is being typed, you press:-

control-S	temporarily halts output, until you press:
control-Q	when output continues from where it left off.

control-O	then further output is discarded until either TYPE reaches the
		end of the file, or you press control-O again

control-C	discards  the whole of the rest of the  file being typed.  You
		cannot press control-C  again to resume output.  If,  however,
		there is another  file in  the current TYPE command  (i.e. you
		supplied  a list of files) then TYPE will start displaying the
		next file in the list.

On VT100 terminals you can use alternate pressings of the NO SCROLL key instead
of control-S and control-Q.  On VT200 terminals you can use alternate pressings
of the Hold Screen key.

A small file will now be TYPEd to allow you to practice using the above keys.
!
@[23HPress [7mRETURN[m to continue...
!
[H[J
$	CALL Do_Command -
		"Type ^O (control-O) to discard output to terminal. ^O again to restart." -
		"TYPE CTRLO.TXT"
$!
$	CALL Do_Command -
		"Type ^C (control-C) to discard first file and start second." -
		"TYPE CTRLC.TXT,CTRLO"
$!
$	Halt="Ctrl/S"
$	Resume="Ctrl/Q"
$	Stop_start:=CTRLSQ
$	IF Ttype.NES."ANSI" THEN GOTO SQ
$	Halt="Hold screen"
$	Stop_start:=CTRLHOLD
$	IF ANSI_TYPE.EQS."VT200" THEN GOTO SQ0
$	Halt="NO SCROLL"
$	Stop_start:=CTRLSCROLL
$SQ0:	Resume=Halt
$SQ:	CALL Do_Command -
		"Press ''Inverse'''Halt'''No_Attr' to halt output. ''Inverse'''Resume'''No_Attr' again to restart output." -
		"TYPE ''Stop_start'.TXT"
$!
$	SET DEFAULT SYS$SCRATCH
$	COPY SYS$INSTRUCTION:CTRLO.TXT *
$	CALL Do_Command -
		"Capture the output from the text file in another text file." -
		"TYPE /OUTPUT=TYP123456.COM CTRLO.TXT" -
		"DIR TYP123456.COM"
$!
$	CALL Do_Command -
		"Output the data to a device other than your terminal." -
		"TYPE /OUTPUT=NL: CTRLO.TXT"
$	DELETE SYS$SCRATCH:TYP123456.COM;0,CTRLO.TXT;0
$	EXIT 1
$!
$Reset_Terminal:
$	SET DEFAULT SYS$SCRATCH
$	IF F$SEARCH("TYP123456.COM").NES."" THEN DELETE TYP123456.COM;0
$	IF F$SEARCH("CTRLO.TXT").NES."" THEN DELETE CTRLO.TXT;0
$	WRITE SYS$OUTPUT No_Scroll,Smooth
$	EXIT 1
$!______________
$Do_command: SUBROUTINE ! text command1 [[[[command2] command3] command4]
$	ON CONTROL_Y THEN EXIT 4
$	IF Ttype.NES."VT52" THEN GOTO Not_VT52
$	WRITE SYS$OUTPUT Page,"Now let us observe the effects of a TYPE command."
$	Scroll=""
$	WAIT 00:00:02
$Not_VT52:
$	WRITE SYS$OUTPUT EraseL05,P1
$	IF P3.EQS."" THEN WRITE SYS$OUTPUT EraseL10,EraseL09,EraseL08,Erasel07,-
		"Execute the command:  ",Inverse,P2,No_Attr
$	IF P3.NES."" THEN WRITE SYS$OUTPUT Erasel07,"Execute the commands:	",Inverse,P2,No_Attr,-
					   "
			",Inverse,P3,No_Attr
$	IF P4.NES."" THEN WRITE SYS$OUTPUT Erasel09,"			",Inverse,P4,No_Attr
$	IF P5.NES."" THEN WRITE SYS$OUTPUT Erasel10,"			",Inverse,P5,No_Attr
$	WRITE SYS$OUTPUT EraseL11,"===================="
$	WRITE SYS$OUTPUT Scroll,EraseL12,Erase_rest,Smooth
$	N=2
$Next_command:
$	Command=P'N'
$	IF Command.EQS."" THEN GOTO All_Done
$	ON ERROR THEN CONTINUE
$	DEFINE/USER SYS$INPUT SYS$COMMAND
$	WRITE SYS$OUTPUT "$ ",Command
$	'Command'
$	N=N+1
$	IF N.LT.6 THEN GOTO Next_command
$All_Done:
$	WRITE SYS$OUTPUT No_Scroll
$	INQUIRE/NOPUN TMP "''EraseL23'''Erase_rest'Press ''Inverse'RETURN''No_Attr' to continue..."
$	WRITE SYS$OUTPUT EraseL23,Jump
$	EXIT 1
$ ENDSUBROUTINE
