c
c	program to set programmable function keys
c	on a DEC VT220 terminal
c
c	written: 5/1/84 CPH
c	rewritten 2-Jan-85 CJD, to use CLI$ and LIB$ routines
c	modified 21-May-87 CJD, to add /TERMINATE
c				and permit 0-4 key/string pairs
c
	byte esc
	parameter (esc='33'O)
c	parameter (esc='44'O)
	parameter (lline=534)		! 4 keys, filling 256-byte VT200 memory
	parameter (llinem6=528)		! lline-6
	integer*4 cli$present,cli$get_value,i,iptr/7/,k
	character*255 fname/'SYS$OUTPUT'/
	character*2 p(3:8)/'p3','p4','p5','p6','p7','p8'/
	byte line(lline)/esc,'P','1',';','1','|',llinem6*'\'/
c
c	insert header into line;insert clear control;
c	insert lock control;insert func key
c
c
5000	line(3) = line(3) - (cli$present('clear').and.1) !insert clear control
	line(5) = line(5) - (cli$present('lock').and.1)  !insert lock control
c
	if (.not.load('p1','p2',line,iptr)) goto 6000	! no sets
	do i=3,7,2
	  line(iptr) = ';'
	  iptr = iptr + 1
	  if(.not.load(p(i),p(i+1),line,iptr)) goto 5999
	end do
	goto 6000
5999	iptr = iptr - 1			! no definition -- remove ';'
c
c	insert ST;buffer to terminal
c
6000	line(iptr) = esc
c	line(iptr+1) = '\'		! all rest initialised to \
c
	if (cli$present('output')) call cli$get_value('output',fname)
	open(unit=1,carriagecontrol='list',status='new',name=fname)
	write(1,'(<lline>a1)')(line(k),k=1,iptr+1)
	call exit
c
	end
c
c
	function load(p1,p2,line,iptr)
	character*2 p1,p2
	parameter (lline=534)		! 4 keys, filling 256-byte VT200 memory
	byte line(lline)
c
	external msg_invkey,msg_toolong
	integer*4 cli$present,cli$get_value,i,ii,iptr,leng
	character*256 cp
	byte p(256),keys(45),keyn(30),it
c
	data keys/'F','6',' ','F','7',' ','F','8',' ','F','9',' ',
     *            'F','1','0','F','1','1','F','1','2','F','1','3',
     *            'F','1','4','H','E','L','D','O',' ','F','1','7',
     *            'F','1','8','F','1','9','F','2','0'/
	data keyn/'1','7','1','8','1','9','2','0','2','1','2','3',
     *            '2','4','2','5','2','6','2','8','2','9','3','1',
     *            '3','2','3','3','3','4'/
	equivalence (p(1),cp)
c
	load = cli$get_value(p1,cp)
	if(.not.load) return			! end of definitions
	ii = -1
	do 10 i = 1,43,3
	ii = ii + 2
	if(p(1).eq.keys(i) .and. p(2).eq.keys(i+1) .and.
     1		p(3).eq.keys(i+2)) goto 20
10	continue
c
c	error, invalid function key name
c
	call lib$stop(msg_invkey)
c
c	get program
c
20	i = cli$get_value(p2,cp,leng)
c
c	insert function key slash
c
	line(iptr) = keyn(ii)
	line(iptr+1) = keyn(ii+1)
	line(iptr+2) = '/'
	iptr=iptr+3
c
c
c	loop, inserting program into line after converting to hex
c
	i = 1
	do 50 while (i.le.leng)
c
c	if char is a "|xx", where xx is a hex number, copy next 2
c	digits as they come, otherwise, ignore 1st |, so that "||"
c	becomes '|', and "|^" becomes '^'.
c
	if(p(i) .eq. '^') then
	  it = p(i+1).and.'1f'x
	  goto 42
	else if(p(i) .eq. '|') then
	  i = i + 1
c	  decode to see if this is a 2-digit hex number
	  decode(2,40,p(i),err=45) it
40	  format(z2)
42	  i = i + 1
	  goto 46
	else
45	  it = p(i)
46	  encode(2,40,line(iptr)) it
	  if(line(iptr).eq.' ') line(iptr) = '0'
	endif
	iptr = iptr + 2
c
c	don't let the internal buffer overflow
c
	if(iptr .gt. lline-2) call lib$stop(msg_toolong)
50	i = i + 1
c
	if(cli$present('terminate')) then
	  if(iptr .gt. lline-4) call lib$stop(msg_toolong)
	  line(iptr) = '0'
	  line(iptr+1) = 'D'
	  iptr = iptr+2
	endif
	load = 1			! success
	return
c
	end
