C***********************************************************************
C
C	PROGRAM TO CHANGE AND ADD TO INDEXED FILES FOR LABELS AND
C			WORKSHOP LISTS
C
C			BY JEFF BURCH, 23 MAY 1985
C
C***~****1****~****2****~****3****~****4****~****5****~****6****~****7**
	INCLUDE 'CHANGE.INC'
	DATA ISEC /1/, IOPTION /1/

C	**** GET CURRENT MONTH AND YEAR
	CALL IDATE(CUR_MON,CUR_DAY,CUR_YEAR)

C	**** OPEN SCREEN DEFINITION FILE AND INDEXED FILE ****
	CALL OPEN_FILE

C	**** READ THE FIRST RECORD IN THE INDEXED FILE TO GET ICNT
C		IN THE MONTH SLOT, ICNT IS THE LAST USED PRIMARY KEY
	IKEY = 1
	ID = 0
	CALL READ_FILE(IKEY,ID)
	ICNT = MON	!SAVE ICNT AS LAST USED PRIMARY KEY
	ID = -1
	CALL READ_FILE(IKEY,ID)		!GET FIRST USER RECORD AS DEFAULTS


C	**** DISPLAY DATA ON SCREEN, LOOP POINT
50	IF (.NOT.(CHOICE.EQ.'F'.OR.CHOICE.EQ.'f')) THEN
		CHOICE = 'N'
		IOPTION = 1
	ENDIF
	CALL DISPLAY(ISEC)		!USE SECTION 1

C	**** IF USER DESIRES NEXT RECORD OR FIND NEW RECORD, BRANCH ACCORDINGLY

	IF (CHOICE.EQ.'F'.OR.CHOICE.EQ.'f') THEN	!FIND NAME IN THIS CODE
		CALL FIND(IKEY,ID)

	ELSE IF (CHOICE.EQ.'N'.OR.CHOICE.EQ.'n') THEN	!NEXT COMMAND
		ID = -1		!CONTINUATION READ
		CALL READ_FILE(IKEY,ID)

	ELSE IF (CHOICE.EQ.'D'.OR.CHOICE.EQ.'d') THEN	!DELETE COMMAND
		DELETE(1,ERR=150)
		GOTO 160
150		TYPE *,'ERROR DELETING THIS RECORD, HIT RETURN TO CONTINUE'
		READ 155,ANSWER
155		FORMAT(A)
		REPAINT = .TRUE.

160		IF (REC .NE. ICNT) THEN
			ID = -1			!CONTINUATION READ
			CALL READ_FILE(IKEY,ID)	!CONTINUE WITH NEXT RECORD
		ELSE
			TYPE *,'LAST RECORD IN FILE WAS DELETED,',
     &			' HIT RETURN TO CONTINUE'
			READ 155,ANSWER
			REPAINT = .TRUE.
		ENDIF

	ELSE IF (CHOICE.EQ.'E'.OR.CHOICE.EQ.'e') THEN	!END COMMAND
		CALL THE_END
		ID = -1				!USER CHOOSE NOT TO END
		CALL READ_FILE(IKEY,ID)		!CONTINUE WITH NEXT RECORD


	ELSE IF (CHOICE.EQ.'C'.OR.CHOICE.EQ.'c') THEN	!CHANGE COMMAND
		REWRITE (1) IREC,CODE,ZIP,NAME,COMP,ADDRSS,
     &				CITY,STATE, MON,YEAR
		GOTO 200
190		TYPE *,'ERROR WRITING THIS RECORD, HIT RETURN TO CONTINUE'
		READ 155,ANSWER
		REPAINT = .TRUE. 			!REPAINT FULL SCREEN

200		ID = -1				!CONTINUE WITH NEXT RECORD
		CALL READ_FILE(IKEY,ID)

	ELSE IF (CHOICE.EQ.'I'.OR.CHOICE.EQ.'i') THEN	!INSERT COMMAND

		CALL INSERT(IKEY)

	ELSE 
		TYPE *,'UNKNOWN OPTION, HIT RETURN TO CONTINUE'
		READ 155, ANSWER
		REPAINT = .TRUE. 		!REPAINT FULL SCREEN
	ENDIF

	GOTO 50		!DISPLAY CURRENT DATA
	END



	SUBROUTINE FIND(IKEY,ID)
C	**** FIND DESIRED RECORD BASED ON OPTION
	INCLUDE 'CHANGE.INC'
	CHARACTER*30 SEARCH_NAME
	LOGICAL CONTINUE
	DATA ILEN/30/

C	**** SET FLAG CONTINUE IF THIS IS CONTINUATION OF SEQUENCE OF FINDS
	CONTINUE = .FALSE.
	IF (OLD_OPTION .EQ. IOPTION .AND.
     &		OLD_NAME .EQ. NAME .AND.
     &		OLD_REC .EQ. REC .AND.
     &		OLD_CODE .EQ. CODE) CONTINUE = .TRUE.


C	**** SETUP THE SEARCH_NAME IF THIS IS THE FIRST IN A SEQUENCE OF FINDS
	IF (.NOT.(OLD_CHOICE.EQ.'F'.OR. OLD_CHOICE.EQ.'f') .OR.
     &		.NOT.CONTINUE) THEN
		SEARCH_NAME = NAME
C		**** GET LENGTH OF NAME FIELD
		ILEN = 30	!MAX LENGTH FOR COMPARE
		IF (IOPTION .EQ.3.OR.IOPTION.EQ.5) THEN !PARTIAL NAME LENGTH
			DO WHILE (NAME(ILEN:ILEN).EQ.' '.AND. ILEN.GT.1)
				ILEN = ILEN -1
			ENDDO
		ENDIF
	ENDIF

	IF (IOPTION .GT.6 .OR. IOPTION .LT. 1) THEN
		TYPE *,'ILLEGAL FIND OPTION, HIT RETURN'
		READ 10, ANSWER
10		FORMAT(A)
		REPAINT = .TRUE.
		RETURN
	ENDIF

C	**** BRANCH BASED ON DESIRED OPTION
	GOTO (100, 200, 300, 300, 500, 500) IOPTION

C	**** FIND BY RECORD NUMBER OPTION
100	IF (.NOT. CONTINUE) THEN
C		**** CHECK RECORD NUMBER FOR PROPER RANGE
		IF (REC .LT. 1 .OR. REC .GT. ICNT) THEN
			TYPE 110, REC, ICNT
110			FORMAT(' ILLEGAL RECORD # ',I5,' MAXIMUM '
     &				'ALLOWABLE IS: ',I6,
     &				' HIT RETURN TO CONTINUE',$)
			READ 10, ANSWER
			REPAINT = .TRUE.
			RETURN
		ENDIF

C		**** READ THIS RECORD FROM FILE
		ID = 0
		IKEY = REC
	ELSE

C		**** CONTINUATION READ FROM FILE
		ID = -1

	ENDIF
	CALL READ_FILE(IKEY,ID)
	RETURN


C	**** FIND RECORD BASED ON SPECIFIC CODE
200	IF (.NOT. CONTINUE) THEN
		ID = 1
		IKEY = CODE
	ELSE
		ID = -1
	ENDIF
	CALL READ_FILE(IKEY,ID)
	RETURN

C	**** FIND RECORD BASED ON CODE AND PARTIAL NAME
300	IF (.NOT.CONTINUE) THEN
		ID = 1
		IKEY = CODE
		CALL READ_FILE(IKEY,ID)
		IF (REPAINT) RETURN	!READ ERROR

C		**** FIND RECORD IN THIS CODE THAT MATCHES DESIRED NAME
		IF (NAME(1:ILEN).EQ.SEARCH_NAME(1:ILEN)) RETURN
	ENDIF

C	**** CONTINUATION READ WITH SAME CODE
	ID = -1		!CONTINUATION READ
	DO WHILE (CODE.EQ.OLD_CODE)
		CALL READ_FILE(IKEY,ID)
		IF (REPAINT) RETURN	!READ ERROR
		IF (NAME(1:ILEN).EQ.SEARCH_NAME(1:ILEN)) RETURN
	END DO

	TYPE *,'NAME WAS NOT FOUND IN ',
     &		'SPECIFIED CODE, HIT RETURN'
	READ 10,ANSWER
	REPAINT = .TRUE. 	!REPAINT FULL SCREEN
	RETURN

C	**** FIND RECORD BASED ON NAME, SEARCH FULL FILE
500	IF (.NOT.CONTINUE) THEN
		ID = 0
		IKEY = 1	!GET FIRST RECORD FROM FILE
		CALL READ_FILE(IKEY,ID)
		IF (REPAINT) RETURN	!READ ERROR
		ID = -1		!GET NEXT RECORD, THIS IS FIRST DATA RECORD
		CALL READ_FILE(IKEY,ID)

C		**** FIND RECORD IN THIS CODE THAT MATCHES DESIRED NAME
		IF (NAME(1:ILEN).EQ.SEARCH_NAME(1:ILEN)) RETURN
	ENDIF

C	**** CONTINUATION READ, LOOK FOR MATCH WITH SEARCH_NAME
	ID = -1		!CONTINUATION READ
	DO WHILE (.NOT.REPAINT)		!LOOP THRU FULL FILE
		CALL READ_FILE(IKEY,ID)
		IF (REPAINT) RETURN	!READ ERROR
		IF (NAME(1:ILEN).EQ.SEARCH_NAME(1:ILEN)) RETURN
	END DO
	END


	SUBROUTINE READ_FILE(IKEY,ID)
C	**** READ DESIRED RECORD FROM FILE BASED ON KEY AND KEY ID
C	**** IF ID < 0 THEN READ CONTINUATION
	INCLUDE 'CHANGE.INC'

5	IF (ID.EQ.0 .AND. IKEY .EQ. 1 ) THEN
C		**** DO NOTHING IF TRYING TO READ FIRST RECORD

	ELSE IF (ID.EQ.0 .AND. (IKEY .LE. 1 .OR. IKEY .GT. ICNT)) THEN
		TYPE 10, REC, ICNT
10		FORMAT(' ILLEGAL RECORD NUMBER',I4,' MAX RECORD # IS ',I5,
     &			/' INPUT NEW RECORD: ',$)
		READ *, IKEY
		GOTO 5
	ENDIF


	IF (ID .GE. 0) THEN
C		**** READ FROM DESIRED KEY FOR THE FIRST TIME
		READ (1,KEYEQ=IKEY,KEYID=ID,ERR=500)IREC,CODE,ZIP,NAME,
     &			COMP,ADDRSS,CITY,STATE,MON,YEAR

	ELSE
C		**** READ CONTINUATION BY THE SAME KEY INDEX
		READ (1,END=200) IREC,CODE,ZIP,NAME,COMP,ADDRSS,CITY,
     &			STATE,MON,YEAR
	ENDIF
	RETURN

200	TYPE *,'END OF FILE, HIT RETURN TO CONTINUE'
	READ 210, ANSWER
210	FORMAT(A)
	REPAINT = .TRUE.
	RETURN

500	TYPE *,'READ ERROR, HIT RETURN TO CONTINUE'
	READ 210,ANSWER
	REPAINT = .TRUE.
	RETURN
	END



	SUBROUTINE OPEN_FILE
C	**** OPEN THE SCREEN DEFINITION FILE AND THE INDEXED FILE
	INCLUDE 'CHANGE.INC'

	OPEN (UNIT=3,NAME='LBLSCREEN.DAT',STATUS='OLD',ERR=100)

10	TYPE 15
15	FORMAT(1X,'*** LABELS MANAGEMENT PROGRAM ***'//,
     &	 1X,'(1)  LABELS LIST '/,
     &	 1X,'(2)  WORKSHOP LIST '/,
     &	 1X,'(3)  MANUFACTURER LIST '/,
     &	 1X,'CHOOSE: ',$)
	ACCEPT *, ICHOOSE

	IF (ICHOOSE.EQ.1) THEN
		FILE='LABELS.DAT'
	ELSEIF (ICHOOSE.EQ.2) THEN
		FILE='WKSHOP.DAT'
	ELSEIF (ICHOOSE.EQ.3) THEN
		FILE='MANUFACT.DAT'
	ELSE
		GOTO 10
	ENDIF


	OPEN(UNIT=1,NAME=FILE,STATUS='OLD',ACCESS='KEYED',
     &		ORGANIZATION='INDEXED',RECL=32,
     &		KEY=(1:2:INTEGER,3:6:INTEGER),ERR=200)
	RETURN

100	TYPE *,'OPEN FAILURE FOR SCREEN DEFINITION FILE "LBLSCREEN.DAT"'
	CALL EXIT
200	TYPE 210, FILE
210	FORMAT(' OPEN FAILURE FOR INDEXED FILE: ',A)
	CALL EXIT
	END


	SUBROUTINE DISPLAY(ISEC)
C	**** DISPLAY USER DATA ON SCREEN, CALL SCREEN ROUTINES
C	**** IF LOGICAL REPAINT IS TRUE, REPAINT THE SCREEN
	INCLUDE 'CHANGE.INC'
	LOGICAL*1 LOGMODE,FLAG
	INTEGER*4 LOGKEY
	CHARACTER*80 CVAL
	COMMON /FSEC_SCREEN_VALUE/ IVAL(50),RVAL(50),CVAL(50)
	DATA LOGMODE/.TRUE./ LOGKEY /1/, IPERSEC /-999/

C	**** IF FIRST TIME HERE, SAVE ISEC IN IPERSECTION
	IF (IPERSEC.EQ.-999) IPERSEC = ISEC

C	**** SAVE SOME OLD DATA 
	OLD_NAME = NAME
	OLD_CODE = CODE
	OLD_CHOICE = CHOICE
	OLD_OPTION = IOPTION
	OLD_REC = IREC

C	**** TRANSFER USER DATA TO SCREEN ARRAYS
	CVAL(1) = NAME
	CVAL(2) = COMP
	CVAL(3) = ADDRSS
	CVAL(4) = CITY
	CVAL(5) = STATE
	CVAL(6) = CHOICE

	IVAL(1) = ZIP
	IVAL(2) = CODE
	IVAL(3) = IREC
	IVAL(4) = MON
	IVAL(5) = YEAR
	IVAL(6) = IOPTION

C	**** ALLOW USER TO MAKE MODIFICATIONS WITH SCREEN UTILITIES
	IF (REPAINT) ISEC = -1
	CALL SCR_SCRIN(ISEC,3,FLAG,LOGMODE,LOGKEY)
	IF (FLAG) THEN
		TYPE *,'OOPS, FATAL ERROR'
		CALL EXIT
	ENDIF
	ISEC = IPERSEC	!SETUP ISEC FOR NEXT TIME HERE
	REPAINT = .FALSE.	!ASSUME WE WILL NOT HAVE TO REPAINT SCREEN

C	**** TRANSFER DATA FROM SCREEN ARRAYS TO USER VARIABLES
	NAME = CVAL(1)(1:30)
	COMP = CVAL(2)(1:30)
	ADDRSS = CVAL(3)(1:30)
	CITY = CVAL(4)(1:20) 
	STATE = CVAL(5)(1:2) 
	CHOICE = CVAL(6)(1:1) 

	ZIP = IVAL(1) 
	CODE = IVAL(2) 
C****	IREC = IVAL(3) 	!DO NOT ALLOW USER TO CHANGE RECORD NUMBER
	REC = IVAL(3)	!SAVE TEMPORARY RECORD NUMBER HERE
	MON = CUR_MON	!USE CURRENT MONTH AND YEAR
	YEAR = CUR_YEAR
	IOPTION = IVAL(6)
	RETURN
	END


	SUBROUTINE THE_END
C	**** PROMPT TO SEE IF THE USER DESIRES TO END
C	**** UPDATE FIRST RECORD BEFORE ENDING
	INCLUDE 'CHANGE.INC'

C	****	PROMPT FOR END
	TYPE 10
10	FORMAT(1X,'DO YOU WANT TO END (Y/N) ',$)
	READ 20,ANSWER
20 	FORMAT(A)
	IF (ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y') THEN

C		**** UPDATE FIRST RECORD
		IR=1
		READ(1,KEYEQ=IR,KEYID=0)IREC,CODE,ZIP,NAME,
     &			COMP,ADDRSS,CITY,STATE,MON,YEAR
		REWRITE(1) IREC,CODE,ZIP,NAME,COMP,ADDRSS,
     &			CITY,STATE,ICNT,YEAR
		CLOSE (UNIT=1)
		TYPE *,'THE END'
		STOP
	ENDIF

	REPAINT = .TRUE.
	RETURN
	END


	SUBROUTINE INSERT(IKEY)
C	**** INSERT THIS RECORD, FIRST CHECK THE CODE FOR PROPER VALUE
	INCLUDE 'CHANGE.INC'

	IF (CODE.LT.100) THEN
		TYPE *,'INVALID CODE, HIT RETURN'
		READ 10,ANSWER
10		FORMAT(A)
		REPAINT = .TRUE.
	ELSE IF (JMOD(CODE,10).EQ.0) THEN
		TYPE *,'THAT CODE IS MAJOR CATEGORY',
     &			' AND IS INVALID.  HIT RETURN TO CONTINUE'
		READ 10,ANSWER
		REPAINT = .TRUE.
	ELSE
		ICNT = ICNT+1
		WRITE (1) ICNT,CODE,ZIP,NAME,COMP,ADDRSS,
     &				CITY,STATE, MON,YEAR
		ID = -1
		CALL READ_FILE(IKEY,ID)
	ENDIF
	RETURN
	END

