	SUBROUTINE SCR_GETMODE(IMODE)
C********************************************************************
C
C	DETERMINE WHAT MODE USER IS IN
C
C	IMODE = 1 IS INTERACTIVE MODE OR COMMAND FILE WITH DEFINE/USER_MODE
C		2 IS COMMAND FILE WITHOUT DEFINE/USER_MODE
C		3 IS BATCH MODE
C		4 IS UNKNOWN MODE
C
C Modifications Record:
C =====================
C	6-May-87 Chris Doran, Sira
C CJD1	Allow for extra _ in translation of SYS$INPUT and SYS$COMMAND in V4.n
C********************************************************************
	CHARACTER*80 SYS$INPUT,TT,SYS$COMMAND

	ISTAT = LIB$SYS_TRNLOG('TT',ILEN_TT,TT)
		IF(.NOT.ISTAT)CALL LIB$STOP(%VAL(ISTAT))

	ISTAT = LIB$SYS_TRNLOG('SYS$INPUT',ILEN_INP,SYS$INPUT)
		IF(.NOT.ISTAT)CALL LIB$STOP(%VAL(ISTAT))
		SYS$INPUT(1:) = SYS$INPUT(6:)				!CJD1
		ILEN_INP = ILEN_INP - 5					!CJD1

	ISTAT = LIB$SYS_TRNLOG('SYS$COMMAND',ILEN_COM,SYS$COMMAND)
		IF(.NOT.ISTAT)CALL LIB$STOP(%VAL(ISTAT))
		SYS$COMMAND(1:) = SYS$COMMAND(6:)			!CJD1
		ILEN_COM = ILEN_COM - 5					!CJD1

	IF (ILEN_TT .LT. 6 .OR. ILEN_INP .LT. 6 .OR. ILEN_COM .LT. 6) THEN
		IMODE = 4	!UNKNOWN LENGTHS

	ELSE IF	((TT(:6).EQ. SYS$INPUT(:6)) .AND.
     &		(TT(:6).EQ. SYS$COMMAND(:6)) .AND.
     &		(SYS$INPUT(:6) .EQ. SYS$COMMAND(:6))) THEN

C		---- ALL THREE THE SAME, MUST BE INTERACTIVE MODE
		IMODE = 1

	ELSE IF	((TT(:6) .EQ. SYS$COMMAND(:6)) .AND.
     &		(SYS$INPUT(:ILEN_INP) .EQ. 'COMMAND')) THEN

C		---- MUST BE IN COMMAND FILE WITH DEFINE/USER_MODE
		IMODE = 1

	ELSE IF ((TT(:6) .EQ. SYS$COMMAND(:6)) .AND.
     &		(SYS$INPUT(:6) .NE. SYS$COMMAND(:6))) THEN

C		---- MUST BE IN COMMAND FILE WITHOUT DEFINE/USER_MODE
		IMODE = 2

	ELSE IF ((TT(:6) .NE. SYS$COMMAND(:6))) THEN


C		---- MUST BE IN BATCH MODE
		IMODE = 3

	ELSE

C		---- UNKNOWN MODE
		IMODE = 4
	ENDIF
	RETURN
	END
