C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&BLAST_Q\&
C .nf
C .x BLAST_Q>Defined
C Source:BLAST_Q.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C 	      Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:15-JUL-1987
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C  
C .X ATTACH_Q>Referenced
C    ATTACH_Q                   ATTACH TO GLOBAL COMMUNICATIONS QUEUE             
C                                (found in library:QUEUE.OLB)
C  
C .X SHUTDOWN_Q>Referenced
C    SHUTDOWN_Q                 SHUT DOWN THE CURRENT INSTALLED QUEUE             
C                                (found in library:QUEUE.OLB)
C  
C .X DISPLAY_REGION>Referenced
C    DISPLAY_REGION             GET OUR OWN ATTACHMENT TO THE QUEUE INFORMATION   
C                                (found in library:QUEUE.OLB)
C  
C .X FIND_Q_PROCESSES>Referenced
C    FIND_Q_PROCESSES           FIND WHAT PROCESSES ARE CURRENTLY ATTACHED TO THE 
C                               QUEUE                                             
C                                (found in library:QUEUE.OLB)
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This progam is used to blast the current installed queue
C out of the water and also any processes that are attached to the
C queue.  This is done in the following manner:
C .list
C .le;Attach to the queue
C .le;Find out about our attachement (so we won't blow ourselves out)
C .le;Request that the queue be shutdown
C .le;Find out all processes that are attached to the queue
C .le;Do a delete process for all those processes but ourselves.
C .le;Delete the global section
C .le;Exit
C .els
C end.doc ****************************** end.doc  
C
C REVISION HISTORY:
C
C 1.1  15-JUL-1987  E. LAKIA
C	Allow for the ability to blast more than the default queue.
c

	IMPLICIT NONE
	INCLUDE '($SSDEF)'	! SYSTEM SERVICES DEFINITIONS
	INCLUDE '($SECDEF)'	! SECTIONS DEFINITIONS
C
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(QHDDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(PEXDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QEXDEF)/LIST'
	RECORD /PEXDEF/ EXPANDED_REGION
C
	INTEGER*4 SYS_STATUS	! SYSTEM SERVICE STATUS
	INTEGER*4 SYS$DGBLSC	! DELETE GLOBAL SECTION
	INTEGER*4 SYS$DELPRC	! DELETE PROCESS
	INTEGER*4 SYS$GETMSG	! TRANSLATE MESSAGE
	INTEGER*4 MSGLEN	! LENGTH OF A TRANSLATED MESSAGE
	CHARACTER*160 MESSAGE	! MESSAGE FOR TRANSLATED MESSAGE
	RECORD/QEXDEF/Q_BLOCK	! P0 expanded region ande exit block
	CHARACTER*1 IANS	! yes/no answer
	INTEGER*4 I		! LOOP VARIABLE
	INTEGER*4 C2		! CHARACTER COUNT FOR PROCESS NAMEN
	CHARACTER*16 SECTION_NAME  ! Current section name for queue
	INTEGER*2 SNLTH		! Length of queue section name


C
C PCB DEFINITION MACRO
C extracted from sys$library:lib.mlb ($PCBDEF) and converted 
c to fortran
c
	INTEGER*4 PCB$K_LENGTH
	PARAMETER(PCB$K_LENGTH=288)
	STRUCTURE/PCBDEF/
	 UNION
	 MAP
	    BYTE DUMMY(PCB$K_LENGTH)
	 END MAP
	 MAP
	    INTEGER*4 PCBDUMP(PCB$K_LENGTH/4)
	 ENDMAP
	 MAP
		INTEGER*4 PCB$L_SQFL
		INTEGER*4 PCB$L_SQBL
		INTEGER*2 PCB$W_SIZE
		BYTE PCB$B_TYPE	
		BYTE PCB$B_PRI	
		BYTE PCB$B_ASTACT
		BYTE PCB$B_ASTEN
		INTEGER*2 PCB$W_MTXCNT
		INTEGER*4 PCB$L_ASTQFL
		INTEGER*4 PCB$L_ASTQBL
		INTEGER*4 PCB$L_PHYPCB
		INTEGER*4 PCB$L_OWNER
		INTEGER*4 PCB$L_WSSWP
		INTEGER*4 PCB$L_STS
		UNION
		MAP
			INTEGER*4 PCB$L_WTIME
		END MAP
		MAP
			BYTE PCB$B_PRISAV
			BYTE PCB$B_PRIBSAV
			BYTE PCB$B_DPC
			BYTE PCB$B_AUTHPRI
		END MAP
		END UNION
		INTEGER*2 PCB$W_STATE
		BYTE PCB$B_WEFC	
		BYTE PCB$B_PRIB	
		INTEGER*2 PCB$W_APTCNT
		INTEGER*2 PCB$W_TMBU
		INTEGER*2 PCB$W_GPGCNT
		INTEGER*2 PCB$W_PPGCNT
		INTEGER*2 PCB$W_ASTCNT
		INTEGER*2 PCB$W_BIOCNT
		INTEGER*2 PCB$W_BIOLM
		INTEGER*2 PCB$W_DIOCNT
		INTEGER*2 PCB$W_DIOLM
		INTEGER*2 PCB$W_PRCCNT
		BYTE C1
		CHARACTER*7 PCB$T_TERMINAL
		INTEGER*4 PCB$L_EFWM
		INTEGER*4 PCB$L_EFCS
		INTEGER*4 PCB$L_EFCU
		INTEGER*4 PCB$L_EFC2P
		INTEGER*4 PCB$L_EFC3P
		INTEGER*4 PCB$L_PID
		INTEGER*4 PCB$L_EPID
		INTEGER*4 PCB$L_EOWNER	
		INTEGER*4 PCB$L_PHD
		BYTE C2
		CHARACTER*15 PCB$T_LNAME
		INTEGER*4 PCB$L_JIB
		INTEGER*4 PCB$Q_PRIV(2)
		INTEGER*4 PCB$L_ARB(12)
		UNION
		MAP
			INTEGER*4 PCB$L_UIC
		END MAP
		MAP
			INTEGER*2 PCB$W_MEM	
			INTEGER*2 PCB$W_GRP	
		END MAP
		END UNION
		INTEGER*4 PCB$L_XXXX(15)  ! UNKNOWN FILLER
		INTEGER*4 PCB$L_ACLFL	
		INTEGER*4 PCB$L_ACLBL	
		INTEGER*4 PCB$L_LOCKQFL	
		INTEGER*4 PCB$L_LOCKQBL	
		INTEGER*4 PCB$L_DLCKPRI	
		INTEGER*4 PCB$L_IPAST	
		INTEGER*4 PCB$L_DEFPROT	
		INTEGER*4 PCB$L_WAITIME	
		INTEGER*4 PCB$L_PMB
	 END MAP
	 END UNION
	 END STRUCTURE
C
	INTEGER*4 PCBNUM
	PARAMETER (PCBNUM=25)	! NUMBER OF PCB TO GET BACK
	RECORD /PCBDEF/PCB(PCBNUM)	! SOME PLACE TO STORE THE 
	INTEGER*4 FNDCNT		! NUMBER OF PCBS FOUND

c
c Make sure the turkey knows what we his is doing
c
	Type *,' If I continue, I will stop all queueing'
	type *,' and all routing. '
	type *,' Should I continue [y/n, default= N]: '
c
	READ(*,100,END=9000)IANS
100	FORMAT(A1)
	IF(IANS .EQ. 'Y' .OR. IANS .EQ. 'y')GO TO 200
	CALL SYS$EXIT(%VAL(SS$_NORMAL))
C
200	CONTINUE
	CALL OPR_LOG_MSG(SS$_NORMAL,' BLASTING THE MA QUEUE ',23)
C
C ATTACH TO THE QUEUE
C
	WRITE(*,250)
250	FORMAT('$Enter the QUEUE name'
	1	' [Default is logical- GBL$MA_Q_NAME]: ')
	READ(*,260,END=270)SNLTH,SECTION_NAME(1:SNLTH)
260	FORMAT(Q,A<SNLTH>)
270	CONTINUE
	IF(SNLTH .EQ. 0)THEN		! Default queue?
		SECTION_NAME='GBL$MA_Q_NAME'
		SNLTH=13
		SYS_STATUS=ATTACH_QE(Q_BLOCK)	! Try to attach to verify
	ELSE				! queue name specified, use it
		SYS_STATUS=ATTACH_QE(Q_BLOCK,SECTION_NAME(1:SNLTH))
	ENDIF
c
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' Unable to attach to queue: ',SECTION_NAME(1:SNLTH)
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C GET OUR OWN INFORMATION
C
	SYS_STATUS=DISPLAY_REGION(Q_BLOCK,
	1		EXPANDED_REGION)
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' Unable to get our process information'
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C REQUEST A FINAL QUEUE SHUTDOWN
C
	SYS_STATUS=SHUTDOWN_Q(Q_BLOCK)  ! REQUEST THE QUEUE SHUTDOWN
	IF( .NOT. SYS_STATUS)THEN
		TYPE *,' Unable to request final queue checkpoint and shutdown'
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
C
C NOW GET ALL THE PROCESSES THAT ARE CONNECTED TO THE QUEUE AND
C DO A DELETE PROCESS ON THEM (UNLESS IT IS US).
C
	SYS_STATUS=FIND_Q_PROCESSES(
	1	Q_BLOCK,PCB,%VAL(PCBNUM),FNDCNT)
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' Unable to get Process Information'
		TYPE *,' for connected processes'
		CALL SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	TYPE *,' FOUND: ',FNDCNT-1,' PROCESSES CONNECTED'
C
C NOW WE DELETE EVERYONE BUT OURSELVES
C
	DO 500 I=1,FNDCNT	! LOOP FOR NUMBER OF PROCESSES WE FOUND
	   IF( PCB(I).PCB$L_EPID .EQ. 
	1	EXPANDED_REGION.PEX$L_PID) GO TO 500 ! SKIP OURSELVES
	   C2=PCB(I).C2  ! get byte count of process name
	   WRITE(*,400)PCB(I).PCB$T_LNAME(1:C2+1)
400	   FORMAT(' Deleteing process: ',A<C2>)
	   WRITE(*,410)PCB(I).PCB$L_PID,PCB(I).PCB$L_EPID
410	   FORMAT(' PID: ',Z8.8,' EPID: ',Z8.8)
C
C	   DELETE THE PROCESS
C
	   SYS_STATUS=SYS$DELPRC(PCB(I).PCB$L_EPID,)
	   IF(.NOT. SYS_STATUS)THEN
		TYPE *,' Unable to delete this process'
		SYS_STATUS=SYS$GETMSG(%VAL(SYS_STATUS),
	1	   MSGLEN,MESSAGE)
		TYPE *,MESSAGE
	   ENDIF
500	CONTINUE
9000	CONTINUE
	CALL OPR_LOG_MSG(SS$_NORMAL,
	1	' QUEUE HAS BEEN BLASTED AS WELL AS THE PROCESSES',49)
	CALL SYS$EXIT(%VAL(SYS_STATUS))
	END

